CIRCUIT DESCRIPTION
A06B: CONVOLUTION, IMPEDANCE MODEL
ELEMENTS
  E1, 0-1 = Ql (TIME) 
  R1, 1-2 = 5000.  
  L1, 2-3 = 25.  
  C1, 1-4 = .001 
  R2, 3-4 = 3000.  
  R3, 3-5 = 2000.  
  R4, 4-0 = 8500.
  C2, 4-6 = .004 
  R5, 5-6 = 11000.  
  L2, 6-0 = 175 
  C3, 5-7 = .0025
  R6, 6-8 = 1000.

    KCV1, 7-8 = FCONVE(1001.)
    KCV2, 8-0 = FCONVE(1002.) 
    KCV3, 7-0 = FCONVE(1003.)


FUNCTIONS 
  Ql(T) = (10*T*DEXP(-.5*T)) 
  Q2(AA,BB) = (AA+BB) 
DEFINED PARAMETERS
  PVOLT1 = Q2(VRKCV1, EKCV1) 
  PVOLT2 = Q2 (VRKCV2, EKCV2) 
  PVOLT3 = Q2(VRKCV3, EKCV3) 
OUTPUTS 
  E1, PLOT 
  IRKCV1, IRKCV2, IRKCV3, PLOT 
  PVOLT1, PVOLT2, PVOLT3, PLOT 
  VR2, VR4 
RUN CONTROLS 
  INTEGRATION ROUTINE=RUK
  WRITE SIMUL8 DATA 
  PRINT B MATRIX 
  STOP TIME = 4.7 
  MAXIMUM STEP SIZE = 0.15
  IMPULSE RESPONSE BUFFER = 300 
  INPUT FUNCTION BUFFER = 900
END
