MODEL DESCRIPTION
MODEL HA 2700 (N-I-OUT-GND)
ELEMENTS
  EA1,   GND-3  = PAO*VRIN
  EA3,   GND-12 = TABLE 1 (VCA2)
  CIN,     N-I  = 1.E-12
  RIN,     N-I  = 1.E6
  CA1,     4-6  = 2280.E-6
  CA2,     5-GND= 45.E-12
  RA1,     3-4  = 100.
  RA2,     4-5  = 100.E3
  RA6,    12-OUT= 100.
  RA7,     6-GND= .028
DEFINED PARAMETERS
  PAO = 2.E5
FUNCTIONS
TABLE 1
  -20,-13, -13,-13, 13,13, 20,13

MODEL 2N2219 (B-E-C)
ELEMENTS
  CC, B1-C1 = 13.E-12
  CE, B1-E  = 22.E-12
  RB,  B-B1 = 50.
  RC,  C-C1 = 2.8
  JE, B1-E  = DIODE EQUATION (3.02E-14,40.)
  JC, B1-C1 = DIODE EQUATION (1.19E-13,38.)
  JN, C1-B1 = PAO*JE
  JI,  E-B1 = PAI*JC
DEFINED PARAMETERS
  PAO =.9927
  PAI = XAI (0.702*PAO)

MODEL 2N4405 (B-E-C)
ELEMENTS
  CE,  E-B1 = 55E-12
  CC, C1-B1 = 43.E-12
  RB, B1-B  = 20.
  RC, C1-C  = 1.4
  JE,  E-B1 = DIODE EQUATION (1.02E-13,39.)
  JC, C1-B1 = DIODE EQUATION (1.71E-13,38.)
  JN, B1-C1 = PAO*JE
  JI, B1-E  = PAI*JC
DEFINED PARAMETERS
  PAO = .9914
  PAI = XAI (0.6829*PAO)

CIRCUIT DESCRIPTION
A13: torquer closed-loop step response test circuit
     parameters for a 2% step increase from 88% point in displacement schedule
     Jensen, McNamee: Handbook of Circuit Analysis Languages and Techniques
     simplified, without radiation effects, etc.
ELEMENTS
  J57,  57-0  =  0
  JT,   73-0  = 0
  JDR,  72-0  = 0
  JR1,  73-82 = 0
  JR2,  83-0  = 0.
  JOT,  71-0  = 0
  O3,57-70-71-0 = MODEL HA 2700
  EC,    0-56 = TABLE C (TIME)
  R124, 56-57 = 23.7E3
  R125, 57-11 = 20000
  EA,    0-11 = XA (PDIS*1.843)
  R126, 70-0  = 10E3
  C105, 73-81 = 4700E-12
  R127, 81-70 = 800E3
  R128, 71-72 = 511
  R129T,80-79 = 95.
  R131, 70-82 = 66.5E3
  R132, 82-0  = 10.
  R133, 83-82 = 10E3
  RTORK,73-TI = 50
  LTORK,82-TI = .2
  CTORK,73-82 = .127E-6
  T4,72-73-74 = MODEL 2N4405
  T3,72-73-79 = MODEL 2N2219
  E13,   0-80 = 21
  E14,  78-0  = 21.
  RT,   74-78 = 60.
DEFINED PARAMETERS
  PX1  = .902
  PX2  = 0.
  DPX1 = PX2
  DPX2 = XXX ((-1./.03)*PX2+1760.*ILTORK)
  PDIS = PX1
  PSTP = XSTP (LOG10(XSTPSZ))
INITIAL CONDITIONS
  ILTORK = 0
  VCCT3  = -2.1E1
  VCCT4  = -2.09162E1
  VCTORK = 0
OUTPUTS
  VJ57,EA,EC,VJOT,VJDR,VJT,ILTORK,PDIS,VJR2,VJR1,PSTP
FUNCTIONS
  TABLE C
  0,-1.97, .01,-1.97, .01,-2.07, 1.,-2.07
RUN CONTROLS
  X PLOT DIMENSION = 0
  INTEGRATION ROUTINE = IMPLICIT
  STOP TIME = .45
  MINIMUM STEPSIZE = 1E-20
END
