MODEL DESCRIPTION
MODEL HA 2700 (N-I-OUT-GND)
ELEMENTS
  EA1,GND-3=Q2(PA,VCIN)
  EA3,GND-12=Q1(PSAT,P1,P3)
  EX,5-XI=QX(PGR,TABLEEX(PTG),5.E-8)
  CIN,N-I=1.E-12
  CA1,4-6=2280.E-6
  CA2,5-GND=45.E-12
  RIN,N-I=1.E6
  RI,11-GND=1.E-3
  RN,NN-GND=1.E-3
  RA1,3-4=100.
  RA2,4-5=100.E3
  RA6,12-OUT=100.
  RA7,6-GND=.028
  JI,I-11=0.
  JN,N-NN=0.
  JO,OUT-GND=0.
  JX,XI-GND=QX(PGR,TABLEJX(PTG),1.875E-11)
DEFINED PARAMETERS
  PGR=0.
  PGD=0.
  PNF=0.
  P1=0.
  P3=0.
  PSAT=TABLE 1(VJX)
  PTG=QTG(TIME,PGD)
  PAO=2.E5
  PAF=QAF(PAO,PNF)
  PA=QA(PAO,PAF,TABLE N(PTG))
FUNCTIONS
  Q1(AA,BB,CC)=(AA+BB*CC)
  Q2(AA,BB)   =(AA*BB)
  QX(AA,BB,CC)=(AA*BB*CC)
  QTG(AA,BB)  =(AA-BB)
  QAF(AA,BB)  =(AA/(1.+2.71E-18*AA*BB))
  QA(AA,BB,CC)=(AA-(AA-BB)*CC)
TABLE 1
  -20,-13, -13,-13, 13,13, 20,13
TABLE EX
  -1.E-6,0, 0,0, .01E-6,1, .3E-6,1, .31E-6,0, 1.E-6,0
TABLE JX
  -1E-6,0, .1E-6,0, .11E-6,1, .3E-6,1, .31E-6,.05, 2E-6,.05,
  2.01E-6,0, 1E-6,0
TABLE N
  -1E-6,0, 10E-6,0, 11E-6,1,20E-6,1

MODEL 2N2219 (B-E-C)
ELEMENTS
  CC,B1-C1=13.E-12
  CE,B1-E=22.E-12
  RB,B-B1=50.
  RC,C-C1=2.8
  JE,B1-E=DIODE EQUATION (3.02E-14,40.)
  JC,B1-C1=DIODE EQUATION (1.19E-13,38.)
  JN,C1-B1=PAN*JE
  JI,E-B1=PAI*JC
  JR,C1-B1=QR(PGR,TABLE R(PTG),8.5E-12)
DEFINED PARAMETERS
  PGR=0.
  PGD=0.
  PNF=0.
  PAO=.9927
  PAF=QAF(PAO,PNF)
  PAN=QAN(PAO,PAF,TABLE N(PTG))
  PAI=QAI(PAN)
  PTG=QTG(TIME,PGD)
FUNCTIONS
  QR(AA,BB,CC)=(AA*BB*CC)
  QAF(AA,BB)  =(AA/(1.+AA*2.051E-16*BB))
  QAN(AA,BB,CC)=(AA-(AA-BB)*CC)
  QAI(AA)=(0.702*AA)
  QTG(AA,BB)=(AA-BB)
TABLE R
  -1E-6,0, 0,0, .04E-6,1, .1E-6,0, 1E-6,0
TABLE N
  -1E-6,0, 10E-6,0, 11E-6,1, 20E-6,1

MODEL 2N4405 (B-E-C)
ELEMENTS
  CE,E-B1=55E-12
  CC,C1-B1=43.E-12
  RB,B1-B=20.
  RC,C1-C=1.4
  JE,E-B1=DIODE EQUATION (1.02E-13,39.)
  JC,C1-B1=DIODE EQUATION (1.71E-13,38.)
  JN,B1-C1=PAN*JE
  JI,B1-E=PAI*JC
  JR,B1-C1=QR(PGR,TABLE R(PTG),14.E-12)
DEFINED PARAMETERS
  PGR=0.
  PGD=0.
  PNF=0.
  PAO=.9914
  PAF=QAF(PAO,PNF)
  PAN=QAN(PAO,PAF,TABLE N(PTG))
  PAI=QAI(PAN)
  PTG=QTG(TIME,PGD)
FUNCTIONS
  QR(AA,BB,CC)=(AA*BB*CC)
  QAF(AA,BB)  =(AA/(1.+AA*4.566E-16*BB))
  QAN(AA,BB,CC)=(AA-(AA-BB)*CC)
  QAI(AA)=(.6829*AA)
  QTG(AA,BB)=(AA-BB)
TABLE R
  -1E-6,0, 0,0, .04E-6,1, .1E-3,.3, .3E-6,0, 1E-6,0
TABLE N
  -1E-6,0, 10E-6,0, 11E-6,1, 20E-6,1

CIRCUIT DESCRIPTION
A13Z: torquer closed-loop step response test circuit
     parameters for a 2% step increase from 88% point in displacement schedule
     Jensen, McNamee: Handbook of Circuit Analysis Languages and Techniques
ELEMENTS
  R125,57-11=20000
  J57,57-0=0
  C105,73-81=4700E-12
  E13,0-80=21
  E14,78-0=21.
  JR1,73-82=0
  JR2,83-0=0
  JT,73-0=0
  JDR,72-0=0
  JOT,71-0=0
  O3,57-70-71-0 = MODEL HA 2700
  R126,70-0=10E3
  R127,81-70=800E3
  R128,71-72=511
  R129T,80-79=95.
  R131,70-82=66.5E3
  R132,82-0=10.
  R133,83-82=10E3
  RT,74-78=60.
  RTORK,73-TI=50
  LTORK,82-TI=.2
  CTORK,73-82=.127E-6
  T4,72-73-74=MODEL 2N4405
  T3,72-73-79=MODEL 2N2219
  R124,56-57=23.7E3
  EC,0-56=TABLE C(TIME)
  EA,0-11=QA(PDIS)
DEFINED PARAMETERS
  PX1=.902
  PX2=0.
  DPX1=PX2
  DPX2=QXX(PX2,ILTORK)
  PDIS=PX1
  PSTP=XSTP(LOG10(XSTPSZ))
INITIAL CONDITIONS
  ILTORK=0
  VCCT3=-2.1E1
  VCCT4=-2.09162E1
  VCTORK=0
OUTPUTS
  VJ57,EA,EC,VJOT,VJDR,VJT,ILTORK,PDIS,VJR2,VJR1,PSTP
FUNCTIONS
  TABLE C
  0,-1.97, .01,-1.97, .01,-2.07, 1.,-2.07
  QA(AA)=(AA*1.843)
  QXX(AA,BB)=((-1./.03)*AA+1760.*BB)
RUN CONTROLS
  X PLOT DIMENSION = 0
  INTEGRATION ROUTINE = IMPLICIT
  STOP TIME = .45
  MINIMUM STEPSIZE = 1E-50
  MAXIMUM INTEGRATION PASSES = 1E6
END
