CSECT   BTFORM                          71.042  11.43.38
 
      SUBROUTINE BTFORM(NERROR)
 
C     NERROR = 2 IF AN IMPROPER TREE HAS BEEN ESTABLISHED
C
C     BTFORM SUBROUTINE
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'tapes.inc'

      COMMON /ELDATA/ EL,NELMTS,NELIMT,ELMNTS(300),FNODE(300),
     *                TNODE(300),V(600),CODE(300)
         CHARACTER*8  ELMNTS,FNODE,TNODE
         DIMENSION    LCODE(600)
         EQUIVALENCE (LCODE,CODE)
      COMMON /BMATRX/ MAXMTX,MAXBRS,NWORDS,BPACK(1500)
         INTEGER      BPACK
      COMMON /CNTRLS/ SKIP(46),BATRIX
      COMMON /SCNTBL/ NUP
 
C     THE PLUS AND PNEG CODES MUST BE EXTENDED FOR DIFFERENT WORD SIZE.
 
      INTEGER         PLUS(16), PNEG(16)
      CHARACTER*64    CPLUS,CPNEG
         EQUIVALENCE (CPLUS,PLUS),(CPNEG,PNEG)
      LOGICAL         LFIRST
      INTEGER         ONE,TWO
      INTEGER         TTEMP
      CHARACTER*8     TEMPF,TEMPT,TEMP
 
      DATA          FPOS,FNEG    /1.D0,-1.D0/
      DATA          DECMNT       /2.D0/
      DATA          ONE,TWO      /1,2/
      DATA          LFIRST  /.TRUE./
 
      IF (LFIRST) THEN
         LFIRST=.FALSE.
         DO 1 I=1,64
            CPLUS(I:I)=CHAR(0)
            CPNEG(I:I)=CHAR(0)
    1    CONTINUE
         CPLUS( 1: 1)=CHAR( 64)
         CPLUS( 5: 5)=CHAR( 16)
         CPLUS( 9: 9)=CHAR(  4)
         CPLUS(13:13)=CHAR(  1)
         CPLUS(18:18)=CHAR( 64)
         CPLUS(22:22)=CHAR( 16)
         CPLUS(26:26)=CHAR(  4)
         CPLUS(30:30)=CHAR(  1)
         CPLUS(35:35)=CHAR( 64)
         CPLUS(39:39)=CHAR( 16)
         CPLUS(43:43)=CHAR(  4)
         CPLUS(47:47)=CHAR(  1)
         CPLUS(52:52)=CHAR( 64)
         CPLUS(56:56)=CHAR( 16)
         CPLUS(60:60)=CHAR(  4)
         CPLUS(64:64)=CHAR(  1)
 
         CPNEG( 1: 1)=CHAR(192)
         CPNEG( 5: 5)=CHAR( 48)
         CPNEG( 9: 9)=CHAR( 12)
         CPNEG(13:13)=CHAR(  3)
         CPNEG(18:18)=CHAR(192)
         CPNEG(22:22)=CHAR( 48)
         CPNEG(26:26)=CHAR( 12)
         CPNEG(30:30)=CHAR(  3)
         CPNEG(35:35)=CHAR(192)
         CPNEG(39:39)=CHAR( 48)
         CPNEG(43:43)=CHAR( 12)
         CPNEG(47:47)=CHAR(  3)
         CPNEG(52:52)=CHAR(192)
         CPNEG(56:56)=CHAR( 48)
         CPNEG(60:60)=CHAR( 12)
         CPNEG(64:64)=CHAR(  3)
      END IF
 
      IF (BATRIX.NE.0)
     *   WRITE(iqqout,'(''0BTFORM: DEBUG OUTPUT.........''//)')
      LDOWN=NUP+ONE
 
C     CLEAR MATRIX AND CODE TABLES.
 
      DO 30 I=1,MAXMTX
   30 BPACK(I)=0
      DO 40 I=1,NELMTS
   40 CODE(I)=0.
 
C     SEARCH FOR LINK IN PARALLEL WITH A BRANCH.
 
   55 K=0
      DO 90 L=LDOWN,NELMTS
      TEMPF=FNODE(L)
      TEMPT=TNODE(L)
      N=0
      DO 85 I=1,NWORDS
      DO 80 J=1,MAXBRS
      N=N+ONE
      IF (FNODE(N).NE.TEMPF) GO TO 60
      IF (TNODE(N).NE.TEMPT) GO TO 80
 
C     PARALLEL ELEMENTS WITH OPPOSING CURRENT DIRECTIONS.
 
      TTEMP=PNEG(J)
      GO TO 70
   60 IF (FNODE(N).NE.TEMPT.OR.TNODE(N).NE.TEMPF) GO TO 80
 
C     PARALLEL ELEMENTS WITH SAME CURRENT DIRECTIONS.
 
      TTEMP=PLUS(J)
 
C     LOAD BRANCH CODE IN PACKED TABLE AND FLAG LINK FOR COMPLETED.
 
   70 M=K+I
      BPACK(M)=TTEMP
      CODE(L)=DECMNT
      GO TO 90
   80 IF (N.EQ.NUP) GO TO 90
   85 CONTINUE
   90 K=K+NWORDS
 
C     FIND GROUP OF BRANCHES TO COMPLETE LOOPS FOR REMAINING LINKS.
 
      K=ONE
      DO 300 L=LDOWN,NELMTS
      IF (CODE(L)) 300,100,300
  100 TEMPF=FNODE(L)
      TEMPT=TNODE(L)
 
C     CLEAR BRANCH CODES TO DECMNT FLAG.
 
      DO 110 N=1,NUP
  110 CODE(N)=DECMNT
 
C     INITIALIZE CODE FOR DEAD-ENDS SEARCH.
 
  120 DENDS=0.
 
C     CHOP OFF ALL DEAD-END BRANCHES.
 
      DO 160 N=1,NUP
      IF (CODE(N)) 125,160,125
  125 MASK=ONE
      TEMP=FNODE(N)
      GO TO 135
  130 MASK=TWO
      TEMP=TNODE(N)
 
C     SEE IF BRANCH NODE CONNECTED TO EITHER LINK NODE.
 
  135 IF (TEMP.EQ.TEMPF.OR.TEMP.EQ.TEMPT) GO TO (130,160),MASK
 
C     SEE IF CONNECTED TO ANY OTHER BRANCH NODE.
 
      DO 150 I=1,NUP
      IF (CODE(I).EQ.0..OR.I.EQ.N) GO TO 150
      IF (TEMP.EQ.FNODE(I).OR.TEMP.EQ.TNODE(I)) GO TO (130,160),MASK
  150 CONTINUE
 
C     NODE IS A DEAD END.
 
      DENDS=DECMNT
      CODE(N)=0.
  160 CONTINUE
 
C     CONTINUE SEARCH UNTIL NO MORE DEAD-END BRANCHES.
 
      IF (DENDS) 120,170,120
 
C     NOW HAVE ALL DEAD-END BRANCHES CHOPPED OFF.  THE REMAINING
C       NON-ZERO BRANCHES SHOULD FORM A COMPLETE LOOP FOR THIS LINK.
 
  170 TEMP=TEMPT
  180 DO 190 N=1,NUP
      IF (CODE(N).NE.DECMNT) GO TO 190
      IF (FNODE(N).EQ.TEMP) GO TO 200
      IF (TNODE(N).EQ.TEMP) GO TO 210
  190 CONTINUE
 
C     IF GET HERE, COMPLETE LOOP COULD NOT BE FOUND.
 
      NERROR=TWO
      WRITE (iqqout,191) ELMNTS(L)
  191 FORMAT ('0AN ERRONEOUS TREE BRANCH EXISTS IN THE PATH OF "',
     *        A6,'".',//)
      GO TO 400
 
C     CURRENTS ARE IN SAME DIRECTION.
 
  200 CODE(N)=FPOS
      IF (TNODE(N).EQ.TEMPF) GO TO 220
      TEMP=TNODE(N)
      GO TO 180
 
C     CURRENTS ARE OPPOSING EACH OTHER.
 
  210 CODE(N)=FNEG
      IF (FNODE(N).EQ.TEMPF) GO TO 220
      TEMP=FNODE(N)
      GO TO 180
 
C     NOW HAVE LOOP ESTABLISHED.
 
  220 CONTINUE
      NFIRST=K
      ITEMP=1
Cwrn  GO TO 700
 
      NX=1
      M=NFIRST
  810 DO 850 J=1,MAXBRS
      IF (ITEMP) 825,820,820
  820 IF (CODE(NX)) 830,845,835
  825 IF (CODE(NX)) 835,845,830
  830 TTEMP=PNEG(J)
      GO TO 840
  835 TTEMP=PLUS(J)
  840 BPACK(M)=IOR(BPACK(M),TTEMP)
  845 NX=NX+1
  850 IF (NX.GT.NUP) GO TO 870
      M=M+1
      GO TO 810
  870 GO TO 222
 
C     SEARCH FOR PARALLEL LINKS.
 
  222 IF (L-NELMTS) 230,320,320
  230 NSTART=L+ONE
      N=K+NWORDS
      DO 280 I=NSTART,NELMTS
      IF (CODE(I))280,240,280
  240 IF (FNODE(I).NE.TEMPF) GO TO 260
      IF (TNODE(I).NE.TEMPT) GO TO 280
      ITEMP = +1
      GO TO 270
  260 IF (TNODE(I).NE.TEMPF.OR.FNODE(I).NE.TEMPT) GO TO 280
      ITEMP = -1
  270 CODE(I)=DECMNT
Cwrn  ASSIGN 280 TO KWAY
      NFIRST=N
  700 NX=1
      M=NFIRST
  710 DO 750 J=1,MAXBRS
      IF (ITEMP) 725,720,720
  720 IF (CODE(NX)) 730,745,735
  725 IF (CODE(NX)) 735,745,730
  730 TTEMP=PNEG(J)
      GO TO 740
  735 TTEMP=PLUS(J)
  740 BPACK(M)=IOR(BPACK(M),TTEMP)
  745 NX=NX+1
  750 IF (NX.GT.NUP) GO TO 770
      M=M+1
      GO TO 710
  770 GO TO 280
  280 N=N+NWORDS
  300 K=K+NWORDS
  320 NSTART=ONE
      NEND=0
      DO 370 M=1,NWORDS
  340 NEND=NEND+MAXBRS
      IF (NEND.GT.NUP) NEND=NUP
 
C     WRITE TITLE LINE FOR NEW GROUP OF BRANCHES.
 
      IF(BATRIX.NE.0.) WRITE (iqqout,331) (ELMNTS(N),N=NSTART,NEND)
  331 FORMAT (1H0,8X,18A6)
      I=M
      DO 360 L=LDOWN,NELMTS
      J=ONE
      DO 350 N=NSTART,NEND
      LCODE(N*2)=LBITS(BPACK,I,J,MAXBRS,K)
  350 J=J+ONE
      IF(BATRIX.NE.0.)
     *   WRITE (iqqout,351) ELMNTS(L),(LCODE(N*2),N=NSTART,NEND)
  351 FORMAT (1H ,A5,18(4X,I2))
  360 I=I+NWORDS
  370 NSTART=NSTART+MAXBRS
  400 RETURN
 
      END
