CSECT   BVDSCN                          71.042  11.43.38
 
      SUBROUTINE BVDSCN
     *  (SIGN,FSTCOL,NCOLMS,ROWSUB,TRANSP,STLOC,NCHARS,NERROR)
 
C     SUBROUTINE TO SCAN AND WRITE EQUATION FOR BN7*EDOT OR B8N*JDOT.
C     SUBROUTINE TO SCAN AND WRITE EQUATION FOR B25*EDOT OR B25T*JDOT.
C
C     FSTCOL - ELEMENTS TABLE SUBSCRIPT TO FIRST SOURCE TO SCAN.
C     NCOLMS - NUMBER OF ELEMENTS IN THE SOURCE CLASS.
C     ROWSUB - ELEMENTS TABLE INDEX FOR VALUE BEING SCANNED FOR.
C     TRANSP - SCAN CURRENT SOURCES IF ON -- VOLTAGE SOURCES IF ZERO.
C     STLOC  - NEXT AVAILABLE CHARACTER POSITION IN BUFFER.
C     NCHARS - NUMBER OF BUFFER CHARACTERS USED BY BVDSCN.
C     NERROR - TWO IF REQUIRED SOURCE DERIVATIVE IS NOT GIVEN.
C
C     BVDSCN SUBROUTINE    JERRY PATTERSON    6/23/66
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'
	include 'tables.inc'
                       integer      matrix(1500)
                       equivalence (tablst( 649),matrix(1))

      INTEGER         SIGN,FSTCOL,ROWSUB,TRANSP,STLOC,STCHR,SGN,V
      COMMON /CNTRLS/ CTROLS(160)
      COMMON /ELDATA/ ELM,NELMTS,LELMTS,ELMNTS(300),EE(1200),
     *                CMPFLG(300),V(2,300)
         CHARACTER*8  ELMNTS,CMPFLG
      COMMON /BUFERS/ BUFF,BUFFER(1)
         CHARACTER*4  BUFFER
      COMMON /SCNTBL/ NBRANS
      COMMON /SDERIV/ SDR,NSDRIV,LSDRIV,DNAME(50),DVALUE(50),DVLCOD(50)
         CHARACTER*8  DNAME
      CHARACTER*8     BLANK,D,SRCNAM
 
      DATA BLANK      /' '/
      DATA D          /'D'/
 
      STCHR=STLOC
 
C     RETURN IF NO SCAN NECESSARY.
 
      IF (NCOLMS) 90,90,10
   10 K=FSTCOL
      IF (TRANSP) 15,12,15
 
C     SCANNING OUT VOLTAGE SOURCES.
 
   12 JFIRST=K
      IFIRST=ROWSUB-NBRANS
      GO TO 16
 
C     SCANNING OUT CURRENT SOURCES.
 
   15 JFIRST=K-NBRANS
      IFIRST=ROWSUB
   16 JLAST=JFIRST+NCOLMS-1
      DO 40 J=JFIRST,JLAST
      IF (TRANSP) 18,17,18
   17 IF (LBITS(MATRIX,IFIRST,J,NBRANS,SGN)) 20,40,20
   18 IF (LBITS(MATRIX,J,IFIRST,NBRANS,SGN)) 20,40,20
 
C     NON-ZERO ENTRY--FIND ITS DERIVATIVE IF NOT CONSTANT.
 
   20 CTROLS(84)=1.
      IF (V(2,K) .EQ. 1)   GO TO 40
      IF (NSDRIV.EQ.0) GO TO 30
 
C     SHIFT SOURCE NAME AND FIND IN DERIV TABLE IF POSSIBLE.
 
      SRCNAM='D'//ELMNTS(K)(1:5)
      DO 25 I=1,NSDRIV
   25 IF (DNAME(I).EQ.SRCNAM) GO TO 35
 
C     SOURCE DERIVATIVE NOT AVAILABLE.
 
   30 NERROR=2
      WRITE (iqqout,31) ELMNTS(K)
   31 FORMAT (40H0THE DERIVATIVE OF THE VARIABLE SOURCE ',A6,
     *        ''' HAS NOT BEEN SUPPLIED.'//)
      STOP 'BVDSCN: derivative not specified, run aborted'
 
C     ENTER DERIVATIVE TERM AND UPDATE DEPENDENCY TABLE.
 
   35 CALL CPYDP(SGN*SIGN,D,ELMNTS,K,BLANK,0,CMPFLG,BUFFER,STCHR,I,I)
   40 K=K+1
   90 NCHARS=STCHR-STLOC
      STLOC=STCHR
      RETURN
 
      END
