CSECT   BVPSCN                          71.042  11.43.38
 
       SUBROUTINE BVPSCN (K1,K2)
 
C      PROGRAM TO GENERATE THE FOLLOWING RESISTOR CIRCUIT EQUATIONS.
C        I5P=-B25T*G22D*(B24*V4+B27*E7)+B35T*I3+B85T*J8
C        V2P=-B25 *R55D*(B35T*I3+B85T*J8)-B24*V4-B27*E7
C      J.SENTS
C
C      K1=1   V2P EQUATIONS
C      K1=2   I5P EQUATIONS
C      K2=1   EQUATIONS FOR NON-SCANNABLE ROWS OR COLUMNS ONLY.
C      K2=0   EQUATIONS FOR ALL ROWS OR COLUMNS
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tables.inc'
                      integer      matrix(1500)
                      equivalence (tablst( 649),matrix(1))
                      equivalence (iqtabl(2797),ndep)

       COMMON /BUFERS/ BUFF,BUFFER(20)
          CHARACTER*4  BUFFER
       COMMON /SCNTBL/ NBRAN,NN(36),NCL(8),NX(9),IST(8),NY(9),NSRC(6)
       COMMON /ELDATA/ ELM,NEL,LEL,ELNAME(300),C(1200),CMPFLG(300)
          CHARACTER*8  ELNAME,CMPFLG
       INTEGER         STLOC,STCHR,SIGN
       CHARACTER*8     PRFX1,PRFX2
       CHARACTER*4     XIBCD,
     *                 VNAME(3),
     *                 BLNK,
     *                 RTEQAL
       CHARACTER*8
     *                 ASTRLP,
     *                 BCDV,
     *                 BCDI,
     *                 BLANK
       CHARACTER*8     C0
          INTEGER      I0(2)
          EQUIVALENCE (I0,C0)
 
       DATA            VNAME   /'V2P(','XI5P','('/,
     *                 BLNK    /' '/,
     *                 RTEQAL  /')='/
       DATA
     *                 ASTRLP  /'*('/,
     *                 BCDV    /'V'/,
     *                 BCDI    /'I'/,
     *                 BLANK   /' '/
       DATA            IS      /11/
       DATA            I0      /0,0/
 
   10  N1=K1
       IF(N1 .NE. 1) GO TO 20
 
C      SETUP FOR V2P SCAN
 
       IRECIP=0
       PRFX1=BCDI
       PRFX2=BCDV
       ITRNS1=1
       ITRNS2=0
       IST1=IST(3)
       LEN1=NCL(3)
       IST2=IST(8)
       LEN2=NCL(8)
       IST3=IST(4)
       LEN3=NCL(4)
       IST4=IST(7)
       LEN4=NCL(7)
       KSTRT1=IST(2)
       KLAST1=IST(2)+NCL(2)-1
       IF(K2 .NE. 0) KLAST1=IST(2)+NSRC(2)-1
       KSTRT2=IST(5)
       KLAST2=IST(5)+NCL(5)-1
       GO TO 30
 
C      SETUP FOR I5P SCAN
 
   20  IRECIP=1
       PRFX1=BCDV
       PRFX2=BCDI
       ITRNS1=0
       ITRNS2=1
       IST1=IST(4)
       LEN1=NCL(4)
       IST2=IST(7)
       LEN2=NCL(7)
       IST3=IST(3)
       LEN3=NCL(3)
       IST4=IST(8)
       LEN4=NCL(8)
       KSTRT1=IST(5)
       KLAST1=IST(5)+NCL(5)-1
       KSTRT2=IST(2)
       KLAST2=IST(2)+NCL(2)-1
       IF(K2 .NE. 0) KLAST1=IST(5)+NSRC(5)-1
   30  KNT=0
       BUFFER(1)=VNAME(N1)
       BUFFER(2)=BLNK
       IF (N1.NE.1) BUFFER(2)=VNAME(N1+1)
       BUFFER(3)=RTEQAL
       DO 90 K=KSTRT1,KLAST1
       NDEP=0
       KNT=KNT+1
       STLOC=6
       CALL CPY(XIBCD(KNT,3,1,NER),1,BUFFER,STLOC,3)
       STLOC=IS
       DO 60 L=KSTRT2,KLAST2
       STCHR=STLOC
       IF(N1 .NE. 1) GO TO 40
       NR=K
       NC=L
       GO TO 50
   40  NR=L
       NC=K
   50  IF (LBITS(MATRIX,NR-NBRAN,NC,NBRAN,SIGN) .EQ. 0) GO TO 60
       CALL CPYDP
     *   (-SIGN,BLANK,ELNAME,L,BLANK,IRECIP,CMPFLG,BUFFER,STLOC,
     *    NCHARS,NER)
       CALL CPY(ASTRLP,1,BUFFER,STLOC,2)
       CALL BV4SCN(1,PRFX1,L,ITRNS1,STLOC,NCHARS,IST1,LEN1,IST2,LEN2,
     *             0,0,0,0,NER)
       IF(NCHARS) 53,53,57
   53  STLOC=STCHR
       GO TO 60
   57  CALL CPY(RTEQAL,1,BUFFER,STLOC,1)
   60  CONTINUE
       INT=1
       IF(N1 .EQ. 1) INT=-INT
       CALL BV4SCN(INT,PRFX2,K,ITRNS2,STLOC,NCHARS,IST3,LEN3,IST4,LEN4,
     *             0,0,0,0,NER)
       IF(STLOC .EQ. IS) CALL CPY('0.',1,BUFFER,STLOC,2)
   90  CALL WTEQTN(C0,0,BUFFER,STLOC-1,BLANK,NER)
       RETURN
 
       END
