CSECT   BVSCAN                          71.042  11.43.38
 
      SUBROUTINE BVSCAN (SIGN,PREFIX,VECSUB,VECLEN,SUFFIX,TRANSP,
     *                  RECIP,IVECTR,STLOC,NCHAR,NERROR)
 
C      SUBROUTINE TO PERFORM SYMBOLIC MULTIPLICATION OF A PACKED
C      B-MATRIX AND A VECTOR BY SCANNING AND SELECTION.
C      J. SENTS   JAN.4,1966
C
C      WHERE SIGN - IS THE SIGN TO BE APPLIED TO EACH TERM OF THE PRO-
C                      DUCT  B(N,K)*V(K),K=1,M .INTEGER VALUES OF +1,-1,
C                      AND
C           TRANSP- INDICATES THAT MATRIX TRANSPOSE IS TO BE SCANNED.
C           PREFIX- CHARACTER (1 CHAR. LEFT ADJUSTED IN WORD) TO BE USED
C                       AS PREFIX FOR SYMBOLIC TERM RESULTING FROM MULT.
C                       IF PREFIX IS A WORD OF BLANKS, NO PREFIX IS USED
C           VECSUB- INTEGER SUBSCRIPT (RELATIVE TO VECTOR ADDRESS SPEC-
C                       IFIED) OF FIRST VECTOR LOCATION TO BE USED IN
C                       MULTIPLICATION.
C           VECLEN- THE NUMBER OF COLUMNS TO BE SCANNED IN THE VECTOR.
C           SUFFIX- CHARACTERS USED AS SUFFIX FOR SYMBOLIC TERMS RESULT-
C                       ING FROM MULT. ALL LEADING NON-BLANK CHARS. ARE
C                       USED AS THE PREFIX.
C           RECIP - RECIPROCAL MODE INDICATOR. RECIP= NON-ZERO INDICATES
C                       RECIP. MODE, RECIP=0 INDICATES NORMAL MODE.
C     IVECTR IS TABLE SUBSCRIPT OF ROW OR COLUMN TO BE SCANNED.
C           STLOC - CHARACTER ADDRESS(RELATIVE TO BUFFER ADDRESS) OF THE
C                   NEXT AVAILABLE LOCATION FOR A CHARACTER IN BUFFER.
C                   IT IS UPDATED BY THE ROUTINE.
C           NCHAR - THE NO. OF CHARACTERS WRITTEN IN THE BUFFER BY THE
C                   ROUTINE
C           NERROR- ERROR INDICATOR. NERROR=1 - NORMAL RETURN(NO ERRORS)
C                   NERROR =2 - DEPENDENCY TABLE OVERFLOW
C                   NERROR =3 - INVALID TERM IN EQUATION
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tables.inc'
                      integer      matrix(1500)
                      equivalence (tablst( 649),matrix(1))

      COMMON /ELDATA/ ELM,NELMTS,LELMTS,VECTOR(300),EE(300,4),
     *                COMPTB(300)
         CHARACTER*8  VECTOR,COMPTB
      COMMON /BUFERS/ BUFF,BUFFER(1)
         CHARACTER*8  BUFFER
      COMMON /SCNTBL/ MXBCOL
      INTEGER         SIGN,TRANSP,VECSUB,RECIP,STLOC,SGN,STCHR,
     *                VECLEN,SIGN1
      CHARACTER*8     PREFIX,SUFFIX
 
C      GET APPROPRIATE MATRIX COORDINATES.
 
       IF (TRANSP.NE.0) GO TO 12
 
C      LINK ROW TO BE SCANNED.
 
       NR=IVECTR-MXBCOL
       NC=VECSUB
       GO TO 15
 
C      BRANCH COLUMN TO BE SCANNED.
 
   12  NR=VECSUB-MXBCOL
       NC=IVECTR
 
C      RESET ERROR INDICATOR
 
   15  NERROR=1
 
C      ANY COLUMNS/ROWS TO SCAN
C      SAVE START CHARACTER LOCATION
 
       STCHR=STLOC
       IF (VECLEN) 100,100,16
   16  DO 40 N=1,VECLEN
 
C      GET INDICATED BITS FROM B-MATRIX AND CHECK FOR ZERO AND SIGNS
 
       SGN=SIGN*LBITS(MATRIX,NR,NC,MXBCOL,SIGN1)
       IF(SGN .NE.0) CALL CPYDP(SGN,PREFIX,VECTOR,VECSUB+N-1,SUFFIX,
     *                      RECIP,COMPTB,BUFFER,STLOC ,NCHAR,NERROR)
 
C      CHECK FOR ERRORS
 
       GO TO (20,100,100),NERROR
   20  IF(TRANSP .NE.0) GO TO 30
 
C      INCREMENT COLUMN NO.
 
       NC=NC+1
       GO TO 40
 
C      INCREMENT ROW NO.
 
   30  NR=NR+1
   40  CONTINUE
  100  NCHAR=STLOC-STCHR
       IF (NERROR.NE.1) STOP 'BVSCAN: NERROR.NE.1; run aborted'
       RETURN
 
       END
