CSECT   CAPEQS                          71.042  11.43.38
 
       SUBROUTINE CAPEQS (VARCPS,IERROR)
 
C      SUBROUTINE TO GENERATE TRANSIENT CAPACITOR EQUATIONS
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tables.inc'
                      integer      matrix(1500)
                      equivalence (tablst( 649),matrix(1))
                      equivalence (iqtabl(2797),ndep)

       COMMON /ELDATA/ ELM,NELMTS,LELMTS,ELMNTS(300),FNODE(300),
     *                 TNODE(300),VALU(300),SRTCDE(300),CMPFLG(300),
     *                 IVLCOD(300)
          CHARACTER*8  ELMNTS,FNODE,TNODE,SRTCDE,CMPFLG
       COMMON /BUFERS/ BUFF,BUFFER(20)
          CHARACTER*4  BUFFER
       COMMON /SCNTBL/ NBRNCH,NLINKS,B(35),NCLENT(8),MATSUB(9),
     *                 ISTART(8),NSCAN(6),B14,B25,B36,NSRC(6)
          EQUIVALENCE (ISTART(1),START1),(START4,ISTART(4))
          EQUIVALENCE (ISTART(2),START2),(ISTART(3),START3)
          EQUIVALENCE (ISTART(7),START7),(ISTART(8),START8)
       INTEGER         VARCAP,START1,START4,STLOC,VARCPS,TABL,STCHR
       INTEGER         START2,START3,START7,START8,B,B14,B25,B36
       DIMENSION       TABL(8)
          EQUIVALENCE (LAST1,TABL(1)),(LAST2,TABL(2)),(LAST3,TABL(3))
          EQUIVALENCE (LAST4,TABL(4)),(LAST5,TABL(5)),(LAST6,TABL(6))
          EQUIVALENCE (LAST7,TABL(7)),(LAST8,TABL(8))
       CHARACTER*4     XI1P(2),RTEQAL,XIBCD
       CHARACTER*8     EQUALS,CICOL1
       CHARACTER*8     V,ZERO,BLANK,EI
       CHARACTER*8     ASTER,PARENL,PARENR
       CHARACTER*8     XMS,XMSD
       CHARACTER*65    WCOMM
       INTEGER         SIGN
       CHARACTER*8     C8ZERO
       INTEGER         I4ZERO(2)
          EQUIVALENCE (I4ZERO,C8ZERO)
 
       DATA            I4ZERO /0,0/
       DATA            XMS /'XMS'/,XMSD/'XMSD'/
       DATA            EQUALS /'='/,CICOL1 /'C'/
       DATA            XI1P /'XI1P','('/,RTEQAL /')='/
       DATA            INT1 /1/,INT0 /0/
       DATA            V,ZERO,BLANK,EI /'V','0.',' ','I'/
       DATA            ASTER,PARENL,PARENR /'*','(',')'/
       DATA WCOMM  (1:32) /'I1PPRIME=-B14PRIME*S44D*(B24T*I2'/
       DATA WCOMM (33:64) /'+B34T*I3+B84T*J8)-B17PRIME*E7DOT'/
 
       NERROR = 1
       VARCAP = VARCPS
 
C      ESTABLISH LAST POSITIONS FOR EACH CLASS
 
       DO 10 K = 1, 8
   10  TABL(K) = NCLENT(K) + ISTART(K) - 1
 
C      CHECK FOR CLASS 1 ENTRIES AND SCAN FOR  V1 =  -B14V4 - B17E7 IF
C      THERE ARE ENTRIES
 
 8200  IF (NCLENT(1) .EQ. 0) GO TO 8300
       CALL WTSPTP (CICOL1,'V1=-B14*V4 - B17*E7',19,NERROR)
       CALL SCNEQS (  -1,START1,LAST1,V,0   ,START4,NCLENT(4),START7,
     *              NCLENT(7),0,0,0,0,NERROR)
 
C      CHECK FOR CLASS 4 ELEMENTS
 
       IF (NCLENT(4) .EQ. 0) GO TO 8260
       IF (B14 .NE. 0) GO TO 8500
 
C      SCAN OUT  I1 = -C11D*B17*E7DOT - WRITE OUT COMMENT
 
 8260  CALL WTSPTP (CICOL1,'I1=- C11D*B17*E7DOT',19,NERROR)
       KSTART=START1
       ASSIGN 8300 TO LWAY
 8265  DO 8290 NC1ENT =KSTART ,LAST1
          STLOC = 1
 
C      COPY C11 CURRENT INTO BUFFER WITH EQUALS SIGN SUFFIX
 
          CALL COPY (0,EI,ELMNTS(NC1ENT),EQUALS,BUFFER,STLOC,NCHAR)
          KODE = 6
          NDEP = 0
          STCHR=STLOC
 
C      COPY (+ OR - C  *) INTO BUFFER AND RESOLVE ANY DEPENDENCIES
 
 
          CALL CPYDP (-1,BLANK,ELMNTS,NC1ENT,ASTER,0,CMPFLG,BUFFER,
     *               STLOC,NCHARS,NERROR)
 
C      COPY A LEFT  PAREN INTO BUFFER
 
          CALL CPY (PARENL,1,BUFFER,STLOC,1)
 
C      SCAN OUT TERMS FOR B17*E7DOT
 
          CALL BVDSCN (+1,START7,NCLENT(7),NC1ENT,0,STLOC,NCHARS,
     *                NERROR)
 
C      IF NO TERMS WERE FOUND, WRITE OUT A ZERO AND PROCEED
 
          IF (NCHARS .EQ. 0) then
             STLOC=STCHR
             CALL CPY (ZERO,1,BUFFER,STLOC,2)
           else
             CALL CPY (PARENR,1,BUFFER,STLOC,1)
          end if
cwrn: print *,'CAPEQS:nc1ent,elmnts(nc1ent),kode,buffer(1)(1:stloc-1)='
cwrn: print *,nc1ent,elmnts(nc1ent),kode,buffer(1)(1:stloc-1)
C         CALL WTEQTN (ELMNTS(NC1ENT),KODE,BUFFER,
          CALL WTEQTN (ELMNTS(NC1ENT)(2:6),KODE,BUFFER,
     *                STLOC-1,BLANK,NERROR)
 8290  continue

       GO TO LWAY,(8300,8720)
 
C      CHECK FOR CLASS 4 AND SCAN OUT I4 IF ANY ENTRIES
 
 8300  IF (NCLENT(4) .EQ. 0) GO TO 8999
 
C      SCAN FOR I4 = B14T*I1+B24T*I2+B34T*I3+B84T*J8
 
 8305  CALL WTSPTP (CICOL1,'I4=B14T*I1+B24T*I2+B34T*I3+B84T*J8',34,
     *              NERROR)
       CALL SCNEQS(INT1  ,START4,LAST4,EI,INT1,START1,NCLENT(1),START2,
     *             NCLENT(2),START3,NCLENT(3),START8,NCLENT(8),NERROR)
 
C      GENERATE EQUATIONS FOR VARIABLE CAPACITOR BRANCHES
C      GENERATE DO LOOP FOR V4DOT = I4/C44D
C      TURN ON V4DOT COMPUTE FLAGS.
 
       CALL DOGEN(1,1,NCLENT(4),'V4DOT(N)=I4(N)/XC44D(N)',23,START4,
     *            NCLENT(4),9,0,C8ZERO,0,NER)
       GO TO 8999
 
C      B14 IS NOT ZERO - SEE IF MS IS DIAGONAL
 
 8500  IF (NSCAN(4) .GT. 0) GO TO 8700
 
C      MS IS DIAGONAL - SCAN I1P = -B14*S44D*(B24T*I2+B34T*I3+B84T*I8)
C      -B17*E7DOT
 
       CALL WTSPTP (CICOL1,
     *  'I1P=-B14*S44D*(B24T*I2+B34T*I3+B84T*J8)-B17*E7DOT',49,NERROR)
       ILAST1 = LAST1
       ASSIGN 8555 TO KWAY
 8505  CALL DOGEN(0,1,ILAST1-START1+1,'XI1P(N)=0.',10,0,0,0,0,
     *            C8ZERO,0,NERR)
       BUFFER(1)= XI1P(1)
       BUFFER(2)= XI1P(2)
       BUFFER(4)=RTEQAL
       BUFFER(5)=XI1P(1)
       BUFFER(6)=XI1P(2)
       BUFFER(8)=RTEQAL
       DO 8550 K = START1,ILAST1
       BUFFER (3) = XIBCD(K-START1+1,3  ,INT1,NERROR)
       BUFFER(7)=BUFFER(3)
 
C      SET UP DO LOOP TO SCAN ACROSS CLASS 4 ELEMENTS AND THEN DOWN ANY
C      CLASS 4 ENTRY
 
       DO 8530 L = START4,LAST4
       STLOC=30
       NCHARS=0
       NDEP=0
       IF (LBITS(MATRIX,K-NBRNCH,L,NBRNCH,SIGN)) 8520,8530,8520
 8520  CALL CPYDP (-SIGN,BLANK,ELMNTS,L,BLANK,INT1,CMPFLG,BUFFER,STLOC,
     *             NCHARS,NERROR)
       CALL CPY ('*(' ,INT1,BUFFER,STLOC,2)
       CALL BV4SCN(INT1,  EI,L,INT1,STLOC,NCHARS,START2,NCLENT(2),
     *             START3,NCLENT(3),START8,NCLENT(8),INT0,INT0,NERROR)
       CALL CPY(PARENR,INT1,BUFFER,STLOC,INT1)
 8530  IF (NCHARS.NE.0) CALL WTEQTN(C8ZERO,0,BUFFER,STLOC-1,BLANK,NERR)
       NDEP=0
       STLOC=30
       CALL BVDSCN (-1    ,START7,NCLENT(7),K       ,INT0,STLOC,NCHARS,
     *              NERROR)
 8550  IF (NCHARS.NE.0) CALL WTEQTN(C8ZERO,0,BUFFER,STLOC-1,BLANK,NERR)
       GO TO KWAY,(8555,8850)
 8555  IF (VARCAP .EQ. 0) GO TO 8650
 
C      HAVE VARIABLE CAPACITORS, WRITE OUT MS EQUATIONS
 
 8600  CALL WTSPTP(CICOL1,'MSD=S11D+B14*S44D*B14T',22,NERROR)
       CALL WTMXEQ(START1,NCLENT(1),START4,NCLENT(4),0,1,  XMSD,1,NER)
 
C      GENERATE DO LOOP FOR I1 = I1P/XMSD
 
 8650  CALL DOGEN(0,1,NCLENT(1),'I1(N)=XI1P(N)/XMSD(N)',21,START1,
     *            NCLENT(1),6,0,C8ZERO,0,NERROR)
       GO TO 8305
 
C      B14 IS NOT 0, MS IS NOT DIAGONAL - SCAN OUT I10 = -C11D0*B170*
C      E7DOT
 
 8700  IF (NSRC(1).EQ.NCLENT(1)) GO TO 8720
       KSTART =  START1   + NSRC(1)
       CALL WTSPTP (CICOL1,'I10=-C11D0*B170*E7DOT',21,NERROR)
       ASSIGN 8720 TO LWAY
       GO TO 8265
 
C      SCAN FOR I1P PRIME = - B14PRIME*S44D*(B24T*I2+B34T*I3+B84T*J8)
C      -B17PRIME*E7DOT
 
 8720  CALL WTSPTP (CICOL1,WCOMM,len(WCOMM),NERROR)
 
C      COMPUTE LAST NON-SCANNABLE ROW ENTRY
 
       ILAST1 =  START1   + NSRC(1) - 1
       ASSIGN 8850 TO KWAY
       GO TO 8505
 
C      CHECK FOR VARIABLE C
 
 8850  IF (VARCAP .EQ. 0) GO TO 8900
 
C      HAVE VARIABLE C, WRITE OUT MSPRIME EQUATIONS
 
       CALL WTSPTP(CICOL1,'MS''=S11D''+B14''*S44D*B14T''',25,NERROR)
       CALL WTMXEQ(START1,NSRC(1),START4,NCLENT(4),0,1,XMS,0,NER)
 
C      GENERATE LINSOL CALL TO PERFORM I1PRIME =XMSIPRIME*I1PPRIME
 
       CALL GN8INV (  XMS,3,1,NSRC(1))
 
C      GENERATE A DO LOOP TO LOAD LINSOL RESULTS INTO I1PRIME
 
 8870  CALL DOGEN(0,1,NSRC,'I1(N)=XI1P(N)',13,START1,NSRC,6,0,
     *            C8ZERO,0,NERROR)
       GO TO 8305
 
C      GENERATE A DOUBLE DO LOOP FOR MATRIX MULTIPLICATION  FOR
C      I1PRIME = XMSIPRIME*I1PPRIME
 
 8900  CALL DOGEN(0,1,NSRC(1),'I1(N)=0.',8,START1,NSRC(1),6,NSRC(1),
     *            'I1(N)=I1(N)+XMSI(N,N1)*XI1P(N1)',31,NERROR)
       GO TO 8305
 8999  IERROR = NERROR
       RETURN
 
       END
