CSECT   CAPINI                          71.042  11.43.38
 
       SUBROUTINE CAPINI (VARCPS,IERROR)
 
C      CEQINI SUBROUTINE TO GENERATE CAPACITOR EQUATIONS FOR
C      INITIALIZATION
C
C      UTILITY SUBROUTINES REQUIRED ARE -
C
C       1) WTMXEQ
C       2) GN8INV
C       3) DIMENS
C       4) WTSPTP
C       5) XIBCD  (FOR GN8INV AND DIMENS)
C       6) CPY
C       7) COPY
C       8) SHIFT
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
       COMMON /SCNTBL/ NBRNCH,NLINKS,NSRTCD,ISTCOD(17),NENTRY(17),
     *                 NCLENT(8),MATSUB(9),ISTART(8),NSCAN(6),B14,B25,
     *                 B36,NSRC(6)
          DIMENSION    ISCNTB(2)
          EQUIVALENCE (ISCNTB,NBRNCH),(ISTART(1),START1),
     *                (ISTART(4),START4)
          INTEGER      VARCPS,VARCAP,START1,START4,B14,B25,B36
       COMMON /ELDATA/ ELM,NELMTS,LELMTS,ELMNTS(300),FNODE(300),
     *                 TNODE(300),VALU(300),SRTCDE(300),CMPFLG(300),
     *                 IVLCOD(2,300)
          CHARACTER*8  ELMNTS,FNODE,TNODE,SRTCDE,CMPFLG
       CHARACTER*8     XMSI
       CHARACTER*8     CICOL1,XMSD,XI1P,XMS
 
       DATA            XMSI /'XMSI'/
       DATA            CICOL1,XMSD,XI1P,XMS /'C','XMSD','XI1P','XMS'/
       DATA            VARCAP /0/
       DATA            INT0,INT1,INT2,INT3 /0,1,2,3/
 
       NERROR = 1
 
C      CHECK FOR VARIABLE C
 
       IF (NCLENT(1) .EQ. 0) GO TO 100
       LAST1 = START1 + NCLENT(1) -1
       DO 50 K = START1, LAST1
   50  IF (IVLCOD(2,K) .NE. 1) VARCAP = 1
  100  IF (NCLENT(4) .EQ. 0) GO TO 105
       LAST4 = START4 + NCLENT(4) - 1
       DO 101 K = START4,LAST4
  101  IF (IVLCOD(2,K) .NE. 1) GO TO 104
       GO TO 105
  104  VARCAP = VARCAP + 2
 
C      IF B14 HAS NO ENTRIES, EXIT THIS ROUTINE
 
  105  IF (B14 .EQ. 0) GO TO 9000
 
C      IF MS IS NOT DIAGONAL, GENERATE A DIMENSION STATEMENT FOR A
C      SQUARE MATRIX, SIZE IS DEPENDENT ON NON-SCANNABLE ROWS IN CLASS 1
 
       IF (NSCAN(4) .EQ. 0) GO TO 8000
       CALL DIMENS (  XMS,INT0,NSRC(1))
 
C      IF THERE ARE ANY VARIABLE CAPACITORS IN THE NON-SCANNABLE ROWS OF
C      CLASS 1, GENERATE A DIMENSION STATEMENT FOR XMSI (NROWP X 1)
 
C      CALCULATE LIMITS OF CLASS 1 TO BE EXAMINED
 
  300  IF (VARCAP - 1) 600,400,550
  400  LCNSND = START1 + NSRC(1) - 1
       DO 500 K = START1, LCNSND
       IF ( IVLCOD(2,K) .NE. 1) GO TO 550
  500  CONTINUE
       GO TO 600
  550  CALL DIMENS (  XI1P,INT1,NSRC(1))
       GO TO 9000
 
C      NO VARIABLE C IN NON-SCANNABLE ROWS OF CLASS 1
 
C      GENERATE DIMENSION STATEMENT FOR XMSI (NROWP X NROWP)
 
  600  CALL WTSPTP(CICOL1,
     * ' MS EQS., MS NOT DIAGONAL, NO VARIABLE C IN SCANNABLE ROWS',
     *   58,NERROR)
       CALL DIMENS (XMSI,INT0,NSRC(1))
       CALL DIMENS (  XI1P,INT1,NSRC(1))
 
C      WRITE OUT MS MATRIX EQUATIONS FOR NON-SCANNABLE CLASS 1 ROWS
 
       CALL WTMXEQ (ISTART(1),NSRC(1),ISTART(4),NCLENT(4),INT0,INT1,
     *              XMS,INT0,NERROR)
       IF (NERROR .NE. 1) GO TO 9000
 
C      GENERATE STATEMENT TO INVERT XMS INTO XMSI
 
  700  CALL GN8INV (  XMS,INT3,INT2,NSRC(1))
       GO TO 9000
 
C      GENERATE DIMENSION STATEMENT FOR MS DIAGONAL (XMSD)
C      DIMENSION IS LENGTH OF CLASS 1
 
 8000  CALL DIMENS(  XMSD,INT1,NCLENT(1))
 
C      GENERATE DIMENSION STATEMENT FOR I1 PRIME (I1P)
C      DIMENSION IS LENGTH OF CLASS 1
 
       CALL DIMENS(  XI1P ,INT1,NCLENT(1))
 
C      IF NO CAPACITORS ARE VARIABLE, WRITE OUT MS EQUATIONS
 
       IF (VARCAP .NE. 0) GO TO 9000
 
C      NO VARIABLE CAPACITORS HAVE BEEN LOCATED, WRITE OUT MS EQUATIONS
 
       CALL WTSPTP(CICOL1,
     *   ' MS EQS., MS DIAGONAL, NO VARIABLE C',36,NERROR)
       CALL WTMXEQ (ISTART(1),NCLENT(1),ISTART(4),NCLENT(4),INT0,INT1,
     *              XMSD,INT1,NERROR)
 9000  IERROR = NERROR
       VARCPS = VARCAP
       RETURN
 
       END
