CSECT   CHGPRS                          71.042  11.43.38
 
      SUBROUTINE CHGPRS (IERROR,ISPLIT)
 
C      SUBROUTINE TO PROCESS CHANGES FOR STORED MODELS
C      CHANGES MAY BE ELEMENTS, TABLES,EQUATIONS, INITIAL CONDITIONS,
C      DEFINED PARAMETERS, DEFINED PARAMETER DERIVATIVES, AND SOURCE
C      DERIVATIVES
C
C      ARGUMENTS ARE BUFFER - SPLIT-OUT, DEBLANKED DATA  (DUMMEY)
C                    ISTART - STARTING POSITION IN BUFFER
C                    ILAST  - LAST DATA POSITION IN BUFFER
C                    IERROR - ERROR INDICATOR (ONE IMPLIES NORMAL)
C                    ISPLIT - NUMBER CHARACTERS IN MODEL CIRCUIT
C                               DESIGNATION
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'dfpram.inc'
                      character*8  dptabl
	include 'dfprmd.inc'
                      character*8  dpdtbl
	include 'values.inc'
                      character*8  valist

      COMMON /TBLES/  TABLE(200)
         CHARACTER*8  TABLE
      COMMON /MODATA/ ANAMES(3),CKTDES(4),PRJ(62),ANODES(25,2),NMDNOD,
     *                MDPRNT,SUPRES(10),EQUCHG(15,2),TBLCHG(15,2),
     *                NTBLCH,NEQUCH,NSUPRS,MDTAPE,MDLEN,MDUSED,IALL,
     *                KCHNGE,NTEMP,NMDCHR
         CHARACTER*8  CKTDES
      COMMON /BUFERS/ SPLTBF(72),BUFFER(72),PACKBF(12),START,LAST
         CHARACTER*8  SPLTBF,BUFFER,PACKBF
      COMMON /ICCOND/ TIC,NIC,LIC,TABLIC(100,2)
         CHARACTER*8  TABLIC

      CHARACTER*8     CHGPR
      CHARACTER*8     EQUAL
      CHARACTER*8     TMPLOC
      CHARACTER*8     ONE
         INTEGER      I4ONE(2)
         EQUIVALENCE (I4ONE,ONE)
      CHARACTER*8 ZERO
         INTEGER      I4ZERO(2)
         EQUIVALENCE (I4ZERO,ZERO)
      INTEGER         START
 
      DATA            CHGPR /'CHGPRS'/
      DATA            EQUAL /'='/
      DATA            ILIMIT /200/
      DATA            I4ONE /0,1/
      DATA            I4ZERO /0,0/
 
      IBEGIN = 1
      IPREFX = 0
      IERRS=1
      IDERIV = 0
 
C     CHECK FOR TABLE OR EQUATION CHANGE
 
   90 IF (ISEQCK(START,LAST,K,START).NE.0)
     *   GO TO (500,600,2000,600,2000,600,450), K
      GO TO 6000
  450 IDERIV = 1
 
C     DETERMINE CHANGE TYPE
 
  500 IF (IARGCK(BUFFER,START,ITYPE) .NE. 0)
     *   GO TO (600,3000,600,600,1100,3000,3000,600,600, 600,1100,
     *          1100,3000,3000,3000,600,600,600, 600) , ITYPE
 
C     IMPROPER CHANGE SPECIFICATION
 
  600 KERROR=54
      GO TO 9000
 
C     PROCESS ELEMENT,MUTUAL OR SOURCE DERIVATIVE CHANGE
 
 1100 CALL MDELCH(IDERIV,IPREFX,ISPLIT,IERRS,ITYPE)
      GO TO (9500,600), IERRS
 
C     PROCESS TABLE OR EQUATION CHANGE
 
 2000 CALL QTBLCH (K,IERRS)
      GO TO (9500,600), IERRS
 
C     DELIMIT AND STORE INITIAL CONDITION, DEFINED PARAMETER OR DEFINED
C     PARAMETER DERIVATIVE NAME
 
 3000 CALL DLIMIT (START,LAST,LIMTER,KLAST,NAMLEN)
      IF (LIMTER .NE. 5 .AND. LIMTER .NE. 7) GO TO 600
      CALL CPYSP(ZERO,0,BUFFER(START),NAMLEN,CKTDES,ISPLIT,TMPLOC,N)
      IF (N .EQ. 1) GO TO 3100
 
C     NAME IS TOO LONG, WRITE OUT ERROR MESSAGE
C         VARIABLE NAME EXCEEDS SIX CHARACTERS
 
      KERROR=3
      GO TO 9000
 
C     CHECK DATA ON CARD AND THEN PROCESS VALUE
 
 3100 START = KLAST + 1
 3110 IF (START .LE. LAST) GO TO 3200
      CALL GETCK (START,LAST,NOCARD)
      GO TO (3180,3150), NOCARD
 
C         INCOMPLETE SPECIFICATION PRIOR TO GROUP OR MODE CARD
 
 3150 KERROR=32
      GO TO 9000
 3180 IF (LIMTER .EQ. 5) GO TO 3200
      IF (BUFFER(START) .EQ. EQUAL) GO TO 3190
      CALL ERROR (CHGPR,1,2)
      GO TO 3200
 3190 START = START + 1
      LIMTER = 5
      GO TO 3110
 3200 CALL VLUPRS(IBEGIN,ILIMIT,LENTBL,IERRS)
      GO TO (3300,9100), IERRS
 3300 KWAY = 1
      IF (ITYPE .EQ. 2 .AND. IDERIV .EQ. 0) KWAY = 2
      IF (ITYPE .EQ. 2 .AND. IDERIV .EQ. 1) KWAY = 3
      IF (ITYPE .EQ. 15) KWAY = 3
      GO TO (4000,5000,6000), KWAY
 
C     CHECK INITIAL CONDITION STORAGE CONDITION
 
 4000 IF (NIC .LT. LIC) GO TO 4200
 
C         MORE THAN FIFTY INITIAL CONDITIONS HAVE BEEN SPECIFIED
 
 4100 KERROR=7
      GO TO 9000
 4200 IF(NIC .EQ. 0) GO TO 4500
 
C     SKIP I/C CHANGE SPECIFICATION IF ONE ALREADY EXISTS
 
      DO 4210 N=1,NIC
      IF(TABLIC(N,1) .EQ. TMPLOC) GO TO 4600
 4210 CONTINUE
 
C     I/C CHANGE SPECIFICATION IS UNIQUE SO ADD IT TO I/C TABLE
 
 4500 NIC = NIC + 1
      TABLIC(NIC,1) = TMPLOC
      TABLIC(NIC,2) = TABLE(2)
      IF (TABLE(1) .EQ. ONE) GO TO 9500
      KERROR=60
      GO TO 9000
 4600 CONTINUE
 
C     CALL ERROR (CHGPR,1,76)
 
      GO TO 9500
 
C     CHECK DEFINED PARAMETER STORAGE CONDITION
 
 5000 IF (NDP .LT. LDP) GO TO 5200
 
C    THE MAXIMUM OF 100 DEFINED PARAMETERS HAS BEEN EXCEEDED
 
      KERROR=8
      GO TO 9000
 5200 NDP = NDP + 1
      DPTABL(NDP,1) = TMPLOC
      DPTABL(NDP,2) = TABLE(1)
      DPTABL(NDP,3) = ZERO
      IF (TABLE(1) .NE. ONE) GO TO 7000
      DPTABL(NDP,3) = TABLE(2)
      GO TO 9500
 
C     CHECK DEFINED PARAMETER DERIVATIVE STORAGE CONDITION
 
 6000 IF (NDPD .LT. LDPD) GO TO 6200
 
C         THE MAXIMUM OF 100 DEFINED PARAMETER DERIVATIVES IS EXCEEDED
 
      KERROR=28
      GO TO 9000
 6200 NDPD = NDPD + 1
      DPDTBL(NDPD) = TMPLOC
 
C     STORE VARIABLE DATA
 
 7000 CALL STORE (VALIST,TMPLOC,1,TABLE(1),LENTBL,IERRS)
      GO TO 9500
 
C     SET ERROR INDICATORS AND FINAL DEBUG
 
 9000 CALL ERROR (  CHGPR ,2,KERROR)
 9100 IERRS=2
      GO TO 9600
 9500 KCHNGE = 2
 9600 IERROR=IERRS
      RETURN
 
      END
