CSECT   CKMONT
C       17 APR 73
 
      SUBROUTINE CKMONT
 
C     SUBROUTINE CKMONT - TO CHECK MONTE CARLO INPUT DATA (IF PRESENT)
C     FOR VALID ELEMENTS, SYSTEM FUNCTIONS, ETC.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
	include 'tapes.inc'

      DIMENSION       ICTRL(100),MCA(8,25)
      INTEGER         FINDV
      DOUBLE PRECISION MCRQST
      EQUIVALENCE    (AMCA(1,1),MCA(1,1))
      EQUIVALENCE    (ICTRL(1),CTRL(1)),(ICTRL(100),NERROR)
      COMMON /ADJDTA/ ISKIP(18),IMCDV,NMCDV,IMCIV,NMCIV,IMCST,NMCST
      COMMON /CNTRLS/ CTRL(120),MCRQST
      COMMON /MONTCA/ AMONTA,NMCA,LMCA,AMCA(4,25)
         CHARACTER*8  AMCA
      COMMON /MONTCB/ AMCB,NMCB,LMCB,MCB(4,1)
 
      IDEBUG=nint(ctrl(42))
      IF (nint(MCRQST).EQ.0) GO TO 50
      IF (NMCDV.le.0 .or. NMCIV.le.0 .or. NMCST.le.0) then
         NERROR=NERROR+2
         WRITE(iqqout,1014)
      end if
 
C     RETURN IF NO DATA HAS BEEN ENTERED
 
   50 IF (NMCST.LE.0) GO TO 700
 
C     CHECK DEPENDENT VARIABLES
 
      CALL DVCHCK (AMCA(1,1),NMCA,NERROR)
 
C      CHECK INDEPENDENT VARIABLES
 
      FINDV=4*NMCA+1
      LINDV=LMCA
      CALL IVCHCK (AMCA(1,1),FINDV,LINDV,NERROR,1)
      IF (IDEBUG.EQ.0) GO TO 700
      WRITE (iqqout,5000) IMCDV,NMCDV,IMCIV,NMCIV,IMCST,NMCST
      DO 510 I=1,NMCA
  510 WRITE (iqqout,5100) I,AMCA(1,I),(MCA(J,I),J=3,8)
      IST=4*NMCA+1
      DO 530 I=IST,LINDV
  530 WRITE (iqqout,5400) I,AMCA(I,1)
      WRITE (iqqout,5200)
      DO 550 I=1,NMCB
  550 WRITE (iqqout,5300) I,(MCB(J,I),J=1,4)

  700 RETURN

 5000 FORMAT ('0CKMONT DEBUG OUTPUT',/,
     *        '0IMCDV=',I4,2X,'NMCDV=',I4,2X,'IMCIV=',I4,2X,
     *        'NMCIV=',I4,2X,'IMCST=',I4,2X,'NMCST=',I4,//,
     *        '0CKMONT LISTING OF /MONTCA/',/)
 1014 FORMAT ('0DATA ERROR IN A MONTE CARLO RUN.'//)
 5100 FORMAT (1X,I4,'. ',A8,6(1X,I4))
 5200 FORMAT ('0CKMONT LISTING OF /MONTCB/',/)
 5300 FORMAT (1X,I4,'. ',4(1X,I4))
 5400 FORMAT (1X,I4,'. ',A8)
 
      END
