CSECT   CKSENS
C       17 APR 73
 
      SUBROUTINE CKSENS
 
C     SUBROUTINE CKSENS COMPARES DATA IN LABELED COMMON /SENS/ WITH
C     DATA IN LABELED COMMON /ELDATA/ TO MAKE SURE SENSITIVITY REQUESTS
C     ARE VALID
C
C     ADJOINT CURRENT SOURCES ARE INSERTED IN PARALLEL WITH DEPENDENT
C     VARIABLE RESISTORS AND CAPACITORS.  ADJOINT VOLTAGE SOURCES ARE
C     INSERTED IN SERIES WITH DEPENDENT VARIABLE INDUCTORS.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'tapes.inc'
	include 'dfpram.inc'
                      character*8 dptabl

      COMMON /ADJDTA/ ISNSDV,NSNSDV,ISNSIV,NSNSIV,ISETS,NSETS,
     .                IOPTDV,NOPTDV,IOPTIV,NOPTIV,IOPTST,NOPTST,
     .                IWCDV ,NWCDV ,IWCIV ,NWCIV ,IWCST ,NWCST
      COMMON /CHKCTL/ CKCTL(150)
      COMMON /CNTRLS/ CTRL(151)
         EQUIVALENCE (ICTRL(1),CTRL(1)),(NERROR,ICTRL(100))
         EQUIVALENCE (CTRL(131),OPRQST),(CTRL(140),AJRQST),
     *               (CTRL(141),SNRQST),(CTRL(151),WCRQST)
      COMMON /DPADD/  ADPAD,NADD,LADD,IADD(100)
      COMMON /DPSENS/ ALDP,NDPSN,LDPSN,DPSENS(3,33)
         CHARACTER*8  DPSENS
         EQUIVALENCE (IDPSNS(1,1),DPSENS(1,1))
      COMMON /ELDATA/ EL,NELMTS,NELMIT,ELMNTS(300),FNODE(300),
     *                TNODE(300),VALU(300),SRTCOD(300),CMPFLG(300),
     *                VALCOD(300),VALLO(300),VALHI(300),LIMSW
         CHARACTER*8  ELMNTS,FNODE,TNODE,SRTCOD
      COMMON /SENS/   ASENS,NSENS,NSRS,LINDV,LSENS,SENS(4,100),
     *                ISRS(2,100)
         CHARACTER*8  SENS
         dimension    ISENS(8,100)
         EQUIVALENCE (SENS(1,1),ISENS(1,1))
      COMMON /SENSC/  ASNSC,IHB

      INTEGER         FINDV
      DIMENSION       ICTRL(287),IDPSNS(6,33),IPOIN(2),ISRSS(100)
      CHARACTER*1     FN(2),FTPE
      CHARACTER*8     CSENS,CCMPR,SRTDAT
      CHARACTER*4     ASORT,CSORT,ESORT,J9COD
         EQUIVALENCE (IPOIN(1),SRTDAT),(IPOIN(2),ASORT)
      CHARACTER*8     ADJELS(100)
      DOUBLE PRECISION IZ1
         INTEGER      IIIZ1(2)
         EQUIVALENCE (IIIZ1,IZ1)
      CHARACTER*8     BLANK,CDP
      CHARACTER       SSENS*11,OOPT*12,WWST*10,ctemp*8
      LOGICAL         ldebug
 
      DATA            SSENS  /'SENSITIVITY'/
      DATA            OOPT   /'OPTIMIZATION'/
      DATA            WWST   /'WORST CASE'/
      DATA            FN     /'V','I'/
      DATA            J9COD  /'IN  '/
      DATA            CSORT  /'LL  '/,ESORT /'BB  '/
      DATA            BLANK  /' '/
      DATA            IIIZ1  /0,1/
 
      ldebug=ctrl(42).ne.0d0
      IF (nint(AJRQST).EQ.0) RETURN
      NRHOLD=NERROR
      IF (IHB+4*NSENS+1.gt.LSENS) then
         NERROR=NERROR+2
        WRITE(iqqout,1013)
      end if
 
C     INSERT INDEPENDENT VARIABLES IN ARRAY 'SENS'
 
      CALL INSIDV(NERROR)
      FINDV=4*NSENS+1
      IF (nint(SNRQST).EQ.0) GO TO 45
      IF (NSNSDV.GT.0.AND.NSNSIV.GT.0.AND.NSETS.GT.0) GO TO 45
      NERROR=NERROR+2
      WRITE (iqqout,1014) SSENS
   45 IF (nint(OPRQST).EQ.0) GO TO 50
      IF (NOPTDV.GT.0.AND.NOPTIV.GT.0.AND.NOPTST.GT.0) GO TO 50
      NERROR=NERROR+2
      WRITE (iqqout,1014) OOPT
   50 IF (nint(WCRQST).EQ.0) GO TO 60
      IF (NWCDV.GT.0.AND.NWCIV.GT.0.AND.NWCST.GT.0) GO TO 60
      NERROR=NERROR+2
      WRITE (iqqout,1014) WWST
   60 continue
 
C     FILL TABLE OF ELEMENTS TO INSERT ADJOINT SOURCES
 
      NSRS=0
      NADJEL=0
      DO 300 I=1,NSENS
      CCMPR=SENS(1,I)
      IF (CCMPR(1:1).NE.'J') GO TO 100
 
C     CHECK TO SEE IF DEPENDENT VARIABLE IS A J9 SOURCE
 
      DO 70 IX=1,NELMTS
   70 IF (CCMPR.EQ.ELMNTS(IX)) GO TO 80
      GO TO 300
   80 IF (SRTCOD(IX)(5:6).ne.J9COD(1:2)) then
         NERROR=NERROR+2
         WRITE (iqqout,1010) CCMPR
         GO TO 300
      end if
 
C     CHANGE DEPENDENT VARIABLE TO IJ9
 
   90 CSENS='I'//CCMPR(1:5)//'  '
      CCMPR=CSENS
      GO TO 265
  100 IF (CCMPR(1:1).NE.'P') GO TO 260
      DO 130 IX=1,NDPSN
      IDP=IX
      IF (CCMPR.EQ.DPSENS(1,IDP)) GO TO 140
  130 CONTINUE
      NERROR=NERROR+2
      WRITE (iqqout,1006) CCMPR
      GO TO 300
 
C     INSERT ALL ADJOINT SOURCES FOR DEFINED PARAMETERS
 
  140 JSTART=IDPSNS(3,IDP)
      JSTOP=JSTART+IDPSNS(4,IDP)-1
      ISENS(5,I)=NSRS+1
      ISENS(6,I)=0
      DO 250 IX=JSTART,JSTOP,2
      NSRS=NSRS+1
      CCMPR=DPSENS(IX,1)
      ctemp=csens
      CSENS=ctemp(2:6)//'   '
      DO 160 IY=1,NELMTS
  160 IF (CSENS.EQ.ELMNTS(IY)) GO TO 170
      NERROR=NERROR+2
      WRITE (iqqout,1007) CCMPR,SENS(1,I)
      GO TO 300

  170 CSENS=CCMPR
      IF (NADJEL.EQ.0) GO TO 200
      DO 190 IYY=1,NADJEL
      IY=IYY
  190 IF (CSENS.EQ.ADJELS(IY)) GO TO 210
 
C ***** NOT A DUPLICATE ELEMENT
 
  200 NADJEL=NADJEL+1
      ADJELS(NADJEL)=CSENS
      ISENS(6,I)=ISENS(6,I)+1
      ISRS(1,NSRS)=NADJEL
      GO TO 220
  210 ISRS(1,NSRS)=IY
      ISENS(6,I)=ISENS(6,I)+1
  220 NDEX=IX+1
 
C ***** FIND DEFINED PARAMETER IN TABLE 'DPTABL'
 
      CDP=DPSENS(NDEX,1)
      DO 230 IP=1,NDP
      IPDP=IP
      IF (CDP.EQ.DPTABL(IPDP,1)) GO TO 240
  230 CONTINUE
      NERROR=NERROR+2
      WRITE(iqqout,1009) CDP,SENS(1,I)
      GO TO 300
  240 ISRS(2,NSRS)=IPDP
  250 CONTINUE
 
C      CHECK FOR INDEPENDENT VARIABLE LIST
 
      CALL GPIV (IDP,I,NERROR)
      GO TO 300
  260 CSENS=SENS(1,I)
  265 NSRS=NSRS+1
      ISENS(5,I)=NSRS
      ISENS(6,I)=1
      ISRS(2,NSRS)=0
      IF (NADJEL.EQ.0) GO TO 280
      DO 270 IX=1,NADJEL
  270 IF (CSENS.EQ.ADJELS(IX)) GO TO 290
 
C ***** NOT A DUPLICATE SOURCE ELEMENT
 
  280 NADJEL=NADJEL+1
      ISRS(1,NSRS)=NADJEL
      ADJELS(NADJEL)=CSENS
      GO TO 300
  290 ISRS(1,NSRS)=IX
  300 CONTINUE

      IF (ldebug) then
         WRITE (iqqout,1092)
         DO 310 I=1,NADJEL
  310    WRITE (iqqout,1093) I,ADJELS(I)
         IF (NADD.LE.0) GO TO 315
         WRITE (iqqout,1099) (IADD(J),J=1,NADD)
      end if

  315 IF (NELMTS+NADJEL.gt.NELMIT) then
         NERROR=NERROR+2
         WRITE(iqqout,1008) NADJEL,NELMIT
      end if
      NEADJ=0
      NJADJ=0
      CALL DVCHCK (SENS(1,1),NSENS,NERROR)
      IF (NERROR.GT.NRHOLD) GO TO 580
 
C     INSERT ADJOINT SOURCES
 
      DO 570 IT=1,2
 
C     INSERT CURRENT SOURCES FIRST
 
      FTPE=FN(IT)
      DO 560 I=1,NADJEL
      CCMPR=BLANK
      CSENS=ADJELS(I)
      IF (CSENS(1:1).NE.FTPE) GO TO 560
      CCMPR(1:7)=CSENS(2:8)
      DO 460 IXX=1,NELMTS
      NELM=IXX
      IF (CCMPR.EQ.ELMNTS(NELM)) GO TO 480
  460 CONTINUE
  480 NELMTS=NELMTS+1
      FNODE(NELMTS)=FNODE(NELM)
      TNODE(NELMTS)=TNODE(NELM)
      VALU(NELMTS)=0.
      VALCOD(NELMTS)=IZ1
      VALLO(NELMTS)=0.
      VALHI(NELMTS)=0.
      ISRSS(I)=NELMTS
      GO TO (520,540),IT
 
C     HAVE A VOLTAGE SYSTEM FUNCTION
C     INSERT A CURRENT SOURCE
 
  520 ASORT=CSORT
      SRTCOD(NELMTS)=SRTDAT
 
C     FORMAT FOR ADJOINT CURRENT SOURCES
C     -----J$AXX  WHERE  01.LE.XX.LE.99
 
      NJADJ=NJADJ+1
      write (ELMNTS(NELMTS),'(''J$A'',i2.2)') njadj
      GO TO 560
 
C     HAVE A CURRENT SYSTEM FUNCTION
C     INSERT A VOLTAGE SOURCE
 
  540 ASORT=ESORT
      SRTCOD(NELMTS)=SRTDAT
 
C     FORMAT FOR ADJOINT VOLTABE SOURCES
C     -----E$AXX  WHERE  01.LE.X?.LE.99
 
      NEADJ=NEADJ+1
      write (ELMNTS(NELMTS),'(''E$A'',i2.2)') neadj
 
C     FORMAT FOR INSERTED NODES FOR ADJOINT VOLTAGE SOURCES
C     -----A$EXX  WHERE  XX(A$E)=XX(E$A)
 
      write (TNODE(NELM),'(''A$E'',i2.2)') neadj
      FNODE(NELMTS)=tnode(nelm)
  560 CONTINUE
  570 CONTINUE
 
C     INSERT VOLTAGE SOURCES FOR SECONDARY DEPENDENT CURRENT SOURCES
 
      CALL SDEPSR
 
C     CHECK INDEPENDENT VARIABLES
 
  580 CALL IVCHCK (SENS(1,1),FINDV,LINDV,NERROR,0)
 
C     FILL FIRST HALF OF SRTCOD WITH ORIGIONAL SEQUENCE NUMBERS
 
      DO 670 I=1,NELMTS
      SRTDAT=SRTCOD(I)
      IPOIN(1)=I
      SRTCOD(I)=SRTDAT
  670 CONTINUE
 
C     FILL ARRAY POINTERS IN ISENS
 
      DO 760 I=1,NSRS
      IX=ISRS(1,I)
      ISRS(1,I)=ISRSS(IX)
  760 CONTINUE
 
C     SAVE SENSITIVITY / ADJOINT RUN CONTROLS
 
      DO 780 I=142,150
  780 CKCTL(I)=IZ1
      IF (.not. ldebug) RETURN

C  FULIST:

      WRITE (iqqout,1090)
      DO 900 I=1,NELMTS
      SRTDAT=SRTCOD(I)
      WRITE (iqqout,1091) I,ELMNTS(I),FNODE(I),TNODE(I),VALU(I),
     .                    IPOIN(1),ASORT
  900 CONTINUE
      WRITE (iqqout,1094)
      DO 910 I=1,NSENS
      WRITE (iqqout,1095) I,SENS(1,I),(ISENS(J,I),J=3,8)
  910 CONTINUE
      ISTART=FINDV
      DO 914 I=ISTART,LINDV
  914 WRITE (iqqout,1098) I,SENS(I,1)
      WRITE (iqqout,1096)
      DO 920 I=1,NSRS
  920 WRITE (iqqout,1097) I,ISRS(1,I),ISRS(2,I)
      call DPSDBG
      RETURN

 1006 FORMAT('0THE DIFFERENTIAL OF THE DEFINED PARAMETER "',A6,
     *       '" HAS NOT BEEN SUPPLIED.',//)
 1007 FORMAT('0THE ELEMENT "',A6,'" FROM THE DEFINED PARAMETER "',
     *       A6,'" IS INVALID.',//)
 1008 FORMAT('0THE ',I4,' ADJOINT SOURCES IS CAUSING THE MAXIMUM',
     *       ' NUMBER OF ',I4,' ELEMENTS TO BE EXCEEDED.',//)
 1009 FORMAT('0THE DEFINED PARAMETER "',A6,'" FROM THE ADJOINT ',
     *       'DEPENDENT VARIABLE "',A6,'" HAS NOT BEEN SUPPLIED.',//)
 1010 FORMAT('0THE DEPENDENT VARIABLE "',A6,
     *       '" IS NOT A PRIMARY DEPENDENT CURRENT SOURCE.',//)
 1013 FORMAT('0INDEPENDENT VARIABLES FOR OPTIMIZATION AND WORST ',
     *       'CASE HAVE CAUSED CAPACITY OF ADJOINT TABLE TO ',
     *       'BE EXCEEDED.'//)
 1014 FORMAT('0DATA ERROR IN A ',A,' RUN.',//)
 1090 FORMAT('0CKSENS: LISTING OF COMMON /ELDATA/',/,
     *       '0INDES ELMNTS   FNODE    TNODE    VALU........',
     *       ' IPOIN.... ASORT   ',//)
 1091 FORMAT(1X,I5,1X,3(A8,1X),E12.6,1X,I4,6X,A4)
 1092 FORMAT('0CKSENS: LISTING OF ADJELS',/)
 1093 FORMAT(1X,I4,2H. ,A8)
 1094 FORMAT('0CKSENS: LISTING OF SENS',/)
 1095 FORMAT(1X,I4,1H.,1X,A8,6(1X,I4))
 1096 FORMAT('0CKSENS: LISTING OF ISRS',/)
 1097 FORMAT(1X,I4,1H.,2(1X,I4))
 1098 FORMAT(1X,I4,2H. ,A8)
 1099 FORMAT('0CKSENS: LISTING OF IADD',//(1X,20(1X,I4)))
 
      END
