CSECT   CPYDP                           71.042  11.43.38
 
       SUBROUTINE CPYDP (SIGN,PREFIX,TERMTB,TRMSUB,SUFFIX,RECIP,COMPTB,
     *                  BUFFER,STLOC,NCHAR,NERROR)
 
C      PROGRAM TO COPY A TERM(WITH SIGN,PREFIX AND SUFFIX) INTO EQUATION
C              BUFFER AND TO ENTER TERM INTO DEPENDENCY TABLE IF NOT YET
C              COMPUTED.
C      J. SENTS  JAN. 5,1966
C
C         SIGN- THE SIGN TO BE APPLIED TO THE SYMBOLIC TERM BEING COPIED
C       PREFIX- THE CHARACTER TO BE USED AS PREFIX OF SYMBOLIC TERM.
C       TERMTB- ADDRESS OF TABLE CONTAINING THE SYMBOLIC TERM TO BE
C                 COPIED.
C       TRMSUB- THE SUBSCRIPT OF THE PARTICULAR TERM IN TERMTB TO BE
C                 COPIED.
C       SUFFIX- THE CHARACTERS TO BE USED AS SUFFIX OF SYMBOLIC TERM.
C        RECIP- MODE INDICATOR.  RECIP= NON-ZERO INDICATES RECIPROCAL
C                  MODE, RECIP=0 INDICATES NORMAL MODE. RECIP MODE
C                  COPIES THE CORRESPONDING RECIPROCAL SYMBOLIC TERM
C                  INTO THE EQUATION.
C       COMPTB- ADDRESS OF TABLE CONTAINING COMPUTE FLAGS. THIS TABLE IS
C                  PARALLEL TO THE TABLE OF TERMS.
C       BUFFER- ADDRESS OF TABLE CONTAINING THE EQUATION INTO WHICH THE
C                  SYMBOLIC TERMS ARE COPIED.
C        STLOC- CHARACTER ADDRESS OF THE NEXT AVAILABLE LOCATION FOR
C                  STORAGE OF A CHARACTER IN THE EQUATION BUFFER.
C        NCHAR- THE TOTAL NO. OF CHARACTERS COPIED INTO THE BUFFER
C       NERROR- ERROR INDICATOR.  NERROR=1 - NORMAL (NO ERRORS)
C                  NERROR=2 - DEPENDENCY TABLE OVERFLOW
C                  NERROR=3 - INVALID TERM OR PREFIX SUPPLIED.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'tapes.inc'
	include 'tables.inc'
                      equivalence (iqtabl(2797),ndep)
                      equivalence (iqtabl(2798),ldep)
                      character*8  deptab(100)
                      equivalence (tablst(1400),deptab(1))
                      integer      typcod(100)
                      equivalence (tablst(1500),typcod(1))

      CHARACTER*4     BUFFER(*)
      INTEGER         SIGN,TRMSUB,RECIP,STLOC
      CHARACTER*8     TERMTB(*),COMPTB(*),PREFIX,SUFFIX
      DIMENSION       FCHRS(6),PCHRS(7),KODE(11),RECIPC(3)
         CHARACTER*1  FRSTCH,FCHRS,PCHRS,PRFX,RECIPC,IBLANK
      CHARACTER*8     BLANK,TERM,PREFX
         EQUIVALENCE (TERM,FRSTCH),(PREFX,PRFX),(BLANK,IBLANK)
      INTEGER         TPCODE
 
      DATA            BLANK /' '/
      DATA            KODE  /5,6,7,8,9,11,13,14,20,10,12/
      DATA            RECIPC /'G','S','H'/
      DATA            FCHRS  /'R','C','L','E','J','M'/
      DATA            PCHRS  /' ','I','V','G','D','S','H'/
 
       NERROR=1
       IRECIP=RECIP
       TERM = TERMTB(TRMSUB)
       DO 5 NR=1,6
       IF(FRSTCH .EQ. FCHRS(NR)) GO TO 15
    5  CONTINUE
       WRITE (iqqout,10) TERM
   10  FORMAT('0 THE FOLLOWING INVALID TERM HAS BEEN SUPPLIED TO ',
     *        '''CPYDP'',''',A6,1H'/// )
       GO TO 50
   15  PREFX=PREFIX
       DO 20 TPCODE=1,7
       IF(PRFX .EQ. PCHRS(TPCODE)) GO TO 25
   20  CONTINUE
       WRITE (iqqout,37) PREFIX
   37  FORMAT('0 THE FOLLOWING INVALID PREFIX HAS BEEN SUPPLIED ',
     *        'TO ''CPYDP'', ''',A1,1H'/// )
       GO TO 50
   25  IF(TPCODE .GT. 5 )  TPCODE=4
       GO TO (35,35,35,90,90,70), NR
   35  NBIAS=0
       IF(IRECIP .NE. 0)GO TO 60
       GO TO (80,130,130,130,40),TPCODE
   40  IF( NR .NE. 1 ) GO TO 130
       WRITE (iqqout,45) TERM
   45  FORMAT('0 ''CPYDP'' IS BEING REQUESTED TO GENERATE THE ',
     *        'FOLLOWING (INVALID) RESISTOR DERIVATIVE TERM IN AN ',
     *        'EQUATION ''',A6,1H'///)
 
C      SET ERROR INDICATOR TO CODE FOR INVALID TERM
 
   50  NERROR=3
   55  STOP 'CPYDP: invalid term (nerror=3), run aborted'
   60  PRFX = RECIPC(NR)
       TPCODE=4
       GO TO 130
   70  NBIAS=10
   75  TPCODE=1
   80  PREFX=BLANK
       GO TO 130
   90  NBIAS=5
       IF(TPCODE .LT. 4) GO TO 75
  130  CALL COPY(SIGN,PREFX,TERM,SUFFIX,BUFFER,STLOC,NCHAR)
 
C      DOES TYPE CODE GIVE POSITION OF FLAG IN COMPUTE FLAG WORD.
C      IS COMPUTE FLAG FOR THIS TERM ON
 
  135  IF (COMPTB(TRMSUB)(7-TPCODE:7-TPCODE) .NE. CHAR(0)) GO TO 150
       IF (NDEP.LT.ldep) GO TO 140
       NERROR=2
       WRITE (iqqout,137) TERM
  137  FORMAT('0 THE FOLLOWING TERM WILL CAUSE THE DEPENDENCY TABLE',
     *        ' TO OVERFLOW ''',A6,1H'///)
       GO TO 55
  140  NDEP=NDEP+1
       DEPTAB(NDEP)=TERM
       INDEX=TPCODE+NBIAS
       TYPCOD(NDEP)=KODE(INDEX)
       IF (TYPCOD(NDEP).EQ.20) GO TO 150
       IF (PRFX.NE.IBLANK) DEPTAB(NDEP)=PRFX//TERM(1:5)
 
C      IN RECIPROCAL MODE
 
  150  IF(IRECIP .EQ. 0) GO TO 200
       PREFX=BLANK
       IRECIP=0
       TPCODE=1
       GO TO 135
  200  RETURN
 
       END
