CSECT   DATACK                          71.042  11.43.38
 
       SUBROUTINE DATACK (MODIND)
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
C      SUBROUTINE TO CHECK VALUES FOR ALL ELEMENTS, DEFINED PARAMETERS,
C      DEFINED PARAMETER DERIVATIVES, MUTUALS, AND SOURCE DERIVATIVES.
C      DEFINED PARAMETER DERIVATIVES ARE ALSO CHECKED AGAINST RELATED
C      DEFINED PARAMETERS, AND A DEFINED PARAMETER IS CREATED AND SET TO
C      ZERO IF NOT FOUND. THE DEFINED PARAMETER TABLE IS MODIFIED SO
C      THAT ENTRIES COINCIDE WITH DEFINED PARAMETER DERIVATIVES.
C      MODIND IS THE MODE INDICATOR AS SET IN EXEC.
 
	include 'tapes.inc'
	include 'dfpram.inc'
                      character*8  dptabl
                      dimension    idptab(2*jqqram)
                      equivalence  (dptabl(1,2),idptab)
	include 'dfprmd.inc'
                      character*8  dpdtbl
	include 'dfprdp.inc'
	include 'values.inc'
                      character*8  valist

      COMMON /CNTRLS/ CTROLS(160)
      COMMON /ELDATA/ EL,NELMTS,LELMTS,ELMNTS(300),FNODE(300),
     *                TNODE(300),VALU(300),SRTCDE(300),CMPFLG(300),
     *                VALCOD(300)
         CHARACTER*8  ELMNTS,FNODE,TNODE
      COMMON /MUTUAL/ AU, NMUTL, LMUTL, AMUTBL(50,6)
         CHARACTER*8  AMUTBL
      COMMON /SDERIV/ SDR,NSDRIV,LSDRIV,SDRVTB(50,3)
         CHARACTER*8  SDRVTB
      COMMON /OUTPUT/ OU,NOUTPS,LOUTPS,OUTP(5,50)
         CHARACTER*8  OUTP
      COMMON /WPRAM/  NDPW,LDPW,WNAME(50)
         CHARACTER*8  WNAME
      DIMENSION       IMUTBL(100),IDRVTB(100),IVLCOD(600)
         EQUIVALENCE (AMUTBL(1,1),IMUTBL),(SDRVTB(1,3),IDRVTB)
         EQUIVALENCE (VALCOD,IVLCOD)
      CHARACTER*8     DUMIE(6),DUMMY
      CHARACTER*8     BLANK, FREQ
      CHARACTER*8     DATCK, TERMN8
      CHARACTER*8     ONE,ZERO
         INTEGER      IIONE (2)
         EQUIVALENCE (ONE,IIONE)
      DOUBLE PRECISION RZERO
         EQUIVALENCE (RZERO,ZERO)
 
      DATA            RZERO /0.D0/
      DATA            IIONE /0,1/
      DATA            DATCK /'DATACK'/, TERMN8 /'TERMN8'/
      DATA            BLANK /' '/, FREQ /'FREQ'/
 
C     CHECK CONVOLUTION KERNELS
 
      CALL CKCONV
      IF (nint(CTROLS(71)).EQ.0 .AND.
     *    nint(CTROLS(81)).NE.0) CALL ERROR(DATCK,1,92)
      IF (nint(CTROLS(71)).EQ.0) GO TO 51
      DO 22 I=1,NOUTPS
      IF (OUTP(3,I).EQ.BLANK) GO TO 22
      OUTP(3,I)=FREQ
      OUTP(4,I)=FREQ
   22 CONTINUE
   51 IF(NDPD.EQ.0)  GO TO 500
 
C     CHECK DEFINED PARAMETER DERIVATIVE TABLE FOR ENTRIES
C     THIS CHANGE IS MADE TO CORRECT FOR A COMPILER ERROR. (12/12/69)
C     DO 2500 K = 1, NDPD
 
      K=0
 2050 K=K+1
 
C     GET REQUIRED D.P. NAME
 
      DUMMY=DPDTBL(K) (2:6)
 
C     IF THERE ARE ANY ENTRIES IN THE D.P. TABLE, CHECK FOR THIS NAME
 
      IF (NDP .EQ. 0) GO TO 2200
C     DO 2100 L = 1, NDP
      L=0
 2100 L=L+1
C2100 IF (DPTABL(L,1) .EQ. DUMMY) GO TO 2400
      IF (DPTABL(L,1) .EQ. DUMMY) GO TO 2400
      IF(L.LT.NDP) GO TO 2100
 
C     D.P. ENTRY HAS TO BE CREATED IF THERE IS ROOM
 
 2200 IF (NDP .EQ. LDP) GO TO 2300
      CALL ERROR (DATCK,1,70)
 
C     UPDATE DP COUNT AND REPLACE DPD ENTRY OPPOSITE THAT POSITION
 
      NDP = NDP + 1
      DO 2250 JK = 1,3
 2250 DPTABL (NDP,JK) = DPTABL(K,JK)
      DPTABL (K,1) = DUMMY
      DPTABL (K,2) = ONE
      DPTABL (K,3)=ZERO
      DPTABL(K,5)= ZERO
      DPTABL(K,6)= ZERO
      GO TO 2500
 
C     NO ROOM IN D.P. TABLE - MESSAGE AND SET MASTER ERROR INDICATOR
 
 2300 CALL ERROR (DATCK,2,8)
      GO TO 2500
 
C     SET D.P. VALUE CODE TO A CONSTANT
 
 2400 DPTABL(L,2) = ONE
 
C     COUNTER L IS POSITION OF DP
C     COUNTER K IS POSITION OF DPD
 
      IF (L-K)2410,2500,2420
 
C     SAVE DPD DATA AND SWITCH
 
 2410 DUMIE(1) = DPDTBL(K)
      DPDTBL(K) = DPDTBL(L)
      DPDTBL(L) = DUMIE(1)
      GO TO 2500
 
C     SAVE DP DATA AND SWITCH
 
 2420 DO 2430 LMN=1,6
      DUMIE(LMN) = DPTABL(L,LMN)
      DPTABL(L,LMN) = DPTABL(K,LMN)
 2430 DPTABL(K,LMN) = DUMIE(LMN)
C2500 CONTINUE
 2500 IF(K.LT.NDPD) GO TO 2050
 
C     CHECK PARTIAL DEFINED PARAMETER DERIVATIVES FOR ERRORS
 
  500 IF(NDPDP.GT.0) CALL CKPDPD
 
C     SENSITIVITY CHECK
 
      CALL CKSENS
 
C     MONTE CARLO CHECK
 
      CALL CKMONT
 
C     CHECK ELEMENTS TABLE FOR ENTRIES
 
      IF (NELMTS .EQ. 0) GO TO 700
 
C     CHECK ELEMENTS TABLE FOR VARIABLE VALUE CODES (I.E., ICODE IS
C     GREATER THAN ONE).
 
      DO 600 K = 1, NELMTS
  600 IF (IVLCOD(K*2) .GT. 1) CALL CKVALU (ELMNTS(K))
 
C     CHECK MUTUAL TABLE FOR ENTRIES
 
  700 IF (NMUTL .EQ. 0) GO TO 1500
 
C     CHECK MUTUAL TABLE FOR VARIABLE VALUE CODE
 
      DO 800 K = 1, NMUTL
      IF(IMUTBL(K*2).GT.1) CALL CKVALU(AMUTBL(K,2))
 
C     CHECK TO SEE THAT INDUCTORS REFERENCED BY MUTUAL INDUCTANCE EXIST
 
      I=3
  750 IF(IVARCK(AMUTBL(K,I),IFIND).EQ.1) GO TO 770
      CALL ERROR(DATCK,2,75)
      WRITE (iqqout,790) AMUTBL(K,I),AMUTBL(K,2)
  770 I=I+1
  800 IF(I.EQ.4) GO TO 750
  790 FORMAT(2H0',A8,20H' IS REFERENCED BY ',A8,1H'///)
 
C     CHECK SOURCE DERIVATIVE TABLE FOR ENTRIES
 
 1500 IF (NSDRIV .EQ. 0) GO TO 2000
 
C     CHECK SOURCE DERIVATIVE TABLE FOR VARIABLE VALUE CODES
 
      DO 1550 K = 1, NSDRIV
 
C     THIS CHANGE ALLOWS DATACK TO CHECK THE CORRECT POSITION IN
C     SDRVTB FOR THE VALUE CODE OF SOURCE DERIVATIVES. (9/16/69)
C1550 IF (IDRVTB(K*3) .GT. 1) CALL CKVALU (SDRVTB(K,1))
 1550 IF (IDRVTB(K*2) .GT. 1) CALL CKVALU (SDRVTB(K,1))
 
C     CHECK FOR ALL REQUIRED SOURCES IN ELEMENTS TABLE
 
      IF (NELMTS .GT. 0) GO TO 1570
      CALL ERROR (DATCK,2,69)
      GO TO 2000
 
C     PEEL OUT THE SOURCE NAME
 
 1570 DO 1590 K = 1, NSDRIV
      DUMMY=SDRVTB(K,1) (2:6)
      DO 1580 M = 1, NELMTS
 1580 IF (DUMMY .EQ. ELMNTS(M)) GO TO 1590
      CALL ERROR (DATCK,2,69)
 1590 CONTINUE
 2000 IF (NDPD .EQ. 0) GO TO 3000
      DO 2600 K=1,NDPD
 2600 CALL CKVALU (DPDTBL(K))
 
C     CHECK DP TABLE FOR ENTRIES
 
 3000 IF (NDP .EQ. 0) GO TO 3600
      DO 3500 K = 1, NDP
 3500 IF (IDPTAB(K*2) .NE. 1) CALL CKVALU (DPTABL(K,1))
 
C     CHECK VARIABLES IN TERMINATION CONDITIONS
 
 3600 CALL FIND (VALIST,TERMN8,KSTART,KEND,KLEN)
      IF(KLEN.EQ.0) GO TO 3900
      K=KSTART+1
      DO 3700 I=K,KEND,2
      IF (IVARCK(VALIST(I),IFIND).EQ.1) GO TO 3700
      CALL ERROR(DATCK,2,75)
      WRITE (iqqout,3800) VALIST(I)
 3700 CONTINUE
 3800 FORMAT(2H0',A8,35H' APPEARS IN TERMINATE CONDITION(S)///)
 
C     CHECK TO MAKE SURE OUTPUT REQUESTS ARE VALID
C     HAVE OUTPUTS BEEN PREVIOUSLY DECLARED
 
 3900 IF(NOUTPS.GT.0) GO TO 4000
 
C     THERE ARE NO OUTPUTS
 
      CALL ERROR(DATCK,2,77)
      GO TO 4600
 4000 DO 4500 K=1,NOUTPS
      DO 4450 I=1,3,2
      IF(IVARCK(OUTP(I,K),IFIND).EQ.1) GO TO 4450
      IF(IWCHCK(OUTP(I,K)) .EQ. 1) GO TO 4450
      CALL ERROR(DATCK,2,76)
      WRITE (iqqout,4410) OUTP(I,K)
 4410 FORMAT(2H0',A8,1H'///)
 4450 CONTINUE
 4500 CONTINUE
      IF(NDPW .EQ. 0) GO TO 4600
      DO 4700 I=1,NDPW
 4700 CALL CKVALU(WNAME(I))
 4600 RETURN
 
      END
