CSECT   DNODES                          71.042  11.43.38
 
       SUBROUTINE DNODES (TABLE1,TABLE2, NODES,ITERM,IERROR)
 
C      SUBROUTINE TO PROCESS NODE INFORMATION
C                    TABLE1 CONTAINS NODE NAMES WITHOUT MODEL SUFFIX
C                    TABLE2 CONTAINS NODE NAMES WITH MODEL SUFFIX
C                     NODES IS THE NUMBER OF NODES IN TABLE1
C                    ITERM INDICATES TERMINATION MODE
C                        (1) EQUALS SIGN
C                        (2) RIGHT PARENTHESIS
C                    IERROR IS ONE FOR NO ERROR, TWO FOR ERROR
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
      COMMON /BUFERS/ SPLTBF(72),BUFFER(72),PACKBF(12),START,LAST
         CHARACTER*8  SPLTBF,BUFFER,PACKBF
      COMMON /MODATA/ ANAMES(3),CKTDES(4),PRJ(62),ANODES(25,2),NMDNOD,
     *                MDPRNT,SUPRES(10),EQUCHG(15,2),TBLCHG(15,2),
     *                NTBLCH,NEQUCH,NSUPRS,MDTAPE,MDLEN,MDUSED,IALL,
     *                KCHNGE,NTEMP,NMDCHR
         CHARACTER*8  CKTDES

      DIMENSION       TABLE1(*),TABLE2(*)
         CHARACTER*8  TABLE1,TABLE2
      INTEGER         START
         CHARACTER*8  XDPRS
 
      DATA            XDPRS /'DNODES'/
      DATA            MXNODS,INT0 /50,0/
      DATA            MXCPWD /6/
 
      NERROR = 1
      NNODES = 0
      ITERM = 1
      NODASH = 1
 
C      CHECK FOR DATA IN BUFFER
 
      IF (START .GT. LAST) GO TO 900
 
C      FIND THE NEXT DELIMITER
 
  100 CALL DLIMIT (START,LAST,LIMTER,LIMPOS,NCHARS)
 
C      CHECK DELIMITER FOR RIGHT PAREN, EQUALS, DASH OR NONE
 
      IF (LIMTER .GE. 4) GO TO 200
      KERROR = 11
      GO TO 4900
 
C      CHECK FOR BLANK NODE OR DASH ON BEGINNING OF CARD
 
  200 IF (NCHARS .GT. 0) GO TO 300
      IF (NODASH .EQ. 2) GO TO 700
  260 KERROR = 12
      GO TO 4900
 
C     CHECK FOR NODE NAME TOO LONG
 
  300 NAMLEN = NCHARS + NMDCHR
      IF (NAMLEN .LE. MXCPWD) GO TO 350
      KERROR = 3
      GO TO 4900
 
C      CHECK NODE TABLE LIMIT AND UPDATE TABLE COUNTER
 
  350 IF (NNODES .LT. MXNODS) GO TO 400
      KERROR = 13
      GO TO 4900
  400 NNODES = NNODES + 1
 
C      COPY THE NODE NAME INTO NODE TABLE ONE WITHOUT MODEL SUFFIX AND
C      INTO NODE TABLE TWO WITH SUFFIX
 
      CALL CPYSP (BUFFER(START),NCHARS,CKTDES,INT0,CKTDES,INT0,
     1 TABLE1 (NNODES),NWDS)
      CALL CPYSP (CKTDES,INT0,BUFFER(START),NCHARS,CKTDES,NMDCHR,
     1 TABLE2(NNODES),NWDS)
 
C      CHECK TERMINATION PROCEDURE AND GO ON
 
      NODASH = 1
      GO TO (260,260,260,500,600,700,800), LIMTER
 
C      RIGHT PAREN TERMINATION - SET START TO POSITION AFTER RIGHT PAREN
 
  500 START = LIMPOS + 1
      ITERM = 2
      GO TO 6000
 
C      EQUALS SIGN TERMINATION - SET START TO EQUALS POSITION
 
  600 START = LIMPOS
      GO TO 6000
 
C      DASH TERMINATION - UPDATE START POSITION AND CHECK FOR MORE DATA
C      ON CARD
 
  700 START = LIMPOS + 1
      NODASH = 1
      IF (START .LE. LAST) GO TO 100
      GO TO 900
 
C      NO TERMINATION CHARACTER WAS LOCATED - SET DASH INDICATOR AND
C      READ IN ANOTHER CARD
 
  800 NODASH = 2
  900 CALL GETCK (START,LAST,NOCARD)
      GO TO (100,950), NOCARD
  950 KERROR = 14
 4900 CALL ERROR (XDPRS,2,KERROR)
      NERROR = 2
 6000 NODES = NNODES
      IERROR = NERROR
      RETURN
 
      END
