CSECT   DVCHCK
C       29 MAR 73
 
      SUBROUTINE DVCHCK (SENS,NSENS,NERROR)
 
C     SUBROUTINE DVCHCK -
C        TO CHECK THE VALIDITY OF DEPENDENT VARIABLES.  THIS ROUTINE
C     MAY BE CALLED FOR ADJOINT OR MONTE CARLO PROCESSING.
C
C     CALLING SEQUENCE-
C        SENS(4,1) - TABLE OF DEPENDENT VARIABLES
C        NSENS - NUMBER OF DEPENDENT VARIABLES
C        NERROR - ERROR INDICATOR
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
	include 'tapes.inc'
	include 'dfpram.inc'
                      character*8  dptabl
      COMMON /ELDATA/ EL,NELMTS,NELMIT,ELMNTS(300),SPC(300,3),
     .                SRTCOD(300)
         CHARACTER*8  ELMNTS,SRTCOD
      INTEGER         FINDV,ONE
      DIMENSION       ITYPE(2,5)
      CHARACTER*8     BLANK
      CHARACTER*8     SENS(4,*)
      CHARACTER*8     CSENS,CCMPR
      CHARACTER*1     CIV(4),ELTYPE(5),LIST(4),SFCIV(4)
      CHARACTER*2     E7COD,J8COD
 
      DATA ITYPE      /1,1,0,1,1,0,1,0,0,1/
      DATA ONE        /1/
      DATA CIV        /'R','E','J','P'/
      DATA ELTYPE     /'R','L','C','J','E'/
      DATA LIST       /'V','I','P','J'/
      DATA SFCIV      /'I','I','V',' '/
      DATA            BLANK /' '/
      DATA            E7COD /'BB'/
      DATA            J8COD /'LL'/
 
      NLMTS=NELMTS
      DO 420 I=1,NSENS
      CSENS=SENS(1,I)
 
C     LOOK FOR VALID DEPENDENT VARIABLE TYPE
 
      DO 340 IXX=1,4
      IX=IXX
      IF (CSENS(1:1).EQ.LIST(IX)) GO TO 350
  340 CONTINUE
      NERROR=NERROR+2
      WRITE (iqqout,1000) CSENS
      GO TO 420

  350 CCMPR=CSENS
      GO TO (355,355,412,405),IX
  355 DO 360 IYY=1,5
      IY=IYY
      IF (CSENS(2:2).EQ.ELTYPE(IY)) GO TO 370
  360 CONTINUE
      NERROR=NERROR+2
      WRITE (iqqout,1001) CSENS
      GO TO 420
 
C     MAKE SURE ELEMENT TYPE AND SYSTEM FUNCTION TYPE ARE A VALID
C     COMBINATION
 
  370 IF (ITYPE(IX,IY).EQ.ONE) GO TO 390
      NERROR=NERROR+2
      WRITE (iqqout,1002) CSENS
      GO TO 420

  390 CCMPR=BLANK
      CCMPR(1:7)=CSENS(2:8)
 
C     SEE IF DEPENDENT VARIABLE ELEMENT IS IN ELEMENTS TABLE
 
  405 DO 410 IXX=1,NLMTS
  410 IF (CCMPR.EQ.ELMNTS(IXX)) GO TO 420
      NERROR=NERROR+2
      WRITE (iqqout,1003) CSENS
      GO TO 420
   
C     SEE IF DEPENDENT VARIABLE IS IN DEFINED PARAMETER TABLE
 
  412 DO 416 IXX=1,NDP
  416 IF (CSENS.EQ.DPTABL(IXX,1)) GO TO 420
      NERROR=NERROR+2
      WRITE (iqqout,1005) CSENS
  420 CONTINUE

      RETURN
 
      ENTRY IVCHCK(SENS,FINDV,LINDV,NERROR,MC)
 
C     SUBROUTINE IVCHCK
C        TO CHECK THE VALIDITY OF ALL INDEPENDENT VARIABLES FOR
C     ADJOINT OR MONTE CARLO DATA.   'IVCHCK' INSERTS THE NECESSARY
C     SYSTEM FUNCTIONS IN THE INDEPENDENT VARIABLE TABLE TO MAKE SURE
C     THEY WILL BE CALCULATED (SEE SUBROUTINE 'WRTADJ').
 
      NLMTS=NELMTS
      I=FINDV
  500 CSENS=SENS(I,1)
 
C     CHECK FOR DEFINED PARAMETER
 
      IF (CSENS(1:1).NE.'P') GO TO 605
      IF (MC.EQ.0) GO TO 580
 
C     MONTE CARLO INDEPENDENT VARIABLE
 
      DO 540 IXX=1,NDP
  540 IF (CSENS.EQ.DPTABL(IXX,1)) GO TO 560
 
C     INDEPENDENT VARIABLE NOT IN DEFINED PARAMETER TABLE
 
      NERROR=NERROR+2
      WRITE (iqqout,1004) CSENS
      I=I+2
      GO TO 620

  560 SENS(I+1,1)=DPTABL(ixx,1)
      SENS(I+2,1)=DPTABL(ixx,1)
      I=I+2
      GO TO 620
 
C     GET J0 AND J9 FOR DEFINED PARAMETER
 
  580 NR=NERROR
      CALL SDPRIV(SENS(I,1),NERROR)
      IF (NERROR.GT.NR) WRITE (iqqout,1012) SENS(I,1)
      I=I+2
      GO TO 620
 
C     SEE IF INDEPENDENT VARIABLE IS IN ELEMENTS TABLE
 
  605 DO 610 IX=1,NLMTS
      IF (CSENS.EQ.ELMNTS(IX)) GO TO 611
  610 CONTINUE
      NERROR=NERROR+2
      WRITE (iqqout,1004) CSENS
 
C     SEE IF INDEPENDENT VARIABLE IS A VALID TYPE
 
  611 DO 612 IIX=1,4
  612 IF (CSENS(1:1).EQ.CIV(IIX)) GO TO 613
  613 GO TO (616,614,615,620), IIX
 
C     A VOLTAGE SOURCE MUST BE AN INDEPENDENT SOURCE (E7)
 
  614 CONTINUE
      IF (SRTCOD(IX)(5:6).EQ.E7COD) GO TO 616
      NERROR=NERROR+2
      WRITE (iqqout,1011) CSENS
      GO TO 620
 
C     A CURRENT SOURCE MUST BE AN INDEPENDENT SOURCE (J8)
 
  615 IF (SRTCOD(IX)(5:6).EQ.J8COD) GO TO 616
      NERROR=NERROR+2
      WRITE (iqqout,1011) CSENS
      GO TO 620
 
C     PUT OUT SYSTEM FUNCTIONS AS INDEPENDENT VARIABLES
 
  616 continue
  617 CCMPR(2:7)=CSENS(1:6)
      CCMPR(1:1)=SFCIV(IIX)
      SENS(I,1)=CCMPR
  620 I=I+1
      IF (I.LE.LINDV) GO TO 500

      RETURN
 
 1000 FORMAT('0THE DEPENDENT VARIABLE "',A6,'" IS INVALID.'//)
 1001 FORMAT('0THE ELEMENT TYPE OF THE DEPENDENT VARIABLE "',A6,
     .       '" IS INVALID.'//)
 1002 FORMAT('0THE FUNCTION TYPE OF THE DEPENDENT VARIABLE "',A6,
     .       '" IS INVALID.'//)
 1003 FORMAT('0THE ELEMENT FROM THE DEPENDENT VARIABLE "',A6,
     .       '" IS INVALID.'//)
 1004 FORMAT('0THE INDEPENDENT VARIABLE "',A6,'" IS INVALID.'//)
 1005 FORMAT('0THE DEPENDENT VARIABLE "',A6,
     .       '" IS NOT IN THE DEFINED PARAMETER TABLE.'//)
 1011 FORMAT('0THE SOURCE "',A6,
     .       '" IS INVALID AS AN INDEPENDENT VARIABLE.'//)
 1012 FORMAT('0THE SECONDARY DEPENDENT SOURCE FOR THE INDEPENDENT ',
     .       'VARIABLE "',A6,'" HAS NOT BEEN SUPPLIED.'//)
 
      END
