CSECT   ELMPRS                          71.042  11.43.38
 
       SUBROUTINE ELMPRS
 
C      SUBROUTINE TO PROCESS ELEMENTS
C          WHERE - ISTART IS FIRST CHARACTER IN BUFFER
C                - ILAST IS LAST CHARACTER IN BUFFER
C                - IERROR IS ONE ON A NORMAL RETURN,
C                       GREATER THAN ONE FOR AN ERROR
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
      COMMON /BUFERS/ SPLTBF(72),BUFFER(72),PACKBF(12),START,LAST
         CHARACTER*8  SPLTBF,BUFFER,PACKBF
      COMMON /TBLES/  TABLE (200)
         CHARACTER*8  TABLE
      COMMON /MODATA/ ANAMES(3),CKTDES(4),PRJ(62),ANODES(25,2),NMDNOD,
     *                MDPRNT,SUPRES(10),EQUCHG(15,2),TBLCHG(15,2),
     *                NTBLCH,NEQUCH,NSUPRS,
     *                MDTAPE,MDLEN,MDUSED,IALL,KCHNGE,NTEMP,NMDCHR
         CHARACTER*8  CKTDES,ANODES
      COMMON /SCNTBL/ A(71)
      CHARACTER*8     TABLE1(71),TABLE2(50),DERIV(10),SPLIT(5),
     *                AMODEL(5)
         EQUIVALENCE (TABLE1(1),A(1)),(TABLE(1),ICODE)
      CHARACTER*8     ELPRFX(5)
      CHARACTER*8     TEMP,S,PREEFX
      INTEGER         START
      CHARACTER*8     ELMPR
      CHARACTER*8     PARENL
      CHARACTER*8     PREFXV
      CHARACTER*8     PREFXI
      CHARACTER*8     COMMA
      CHARACTER*8     EQUIV
      CHARACTER*8     D
      CHARACTER*8     G
      CHARACTER*8     XDIOD
      CHARACTER*8     FP4,SEVEN,TRTEEN,EIGHT,FRTEEN,SXTEEN
      INTEGER         III4(2)
         EQUIVALENCE (III4,FP4)
      INTEGER         III7(2)
         EQUIVALENCE (III7,SEVEN)
      INTEGER         III13(2)
         EQUIVALENCE (III13,TRTEEN)
      INTEGER         III8(2)
         EQUIVALENCE (III8,EIGHT)
      INTEGER         III14(2)
         EQUIVALENCE (III14,FRTEEN)
      INTEGER         III16(2)
         EQUIVALENCE (III16,SXTEEN)
 
      DATA            ELMPR /'ELMPRS'/
      DATA            PARENL /'('/
      DATA            PREFXV /'V'/
      DATA            PREFXI /'I'/
      DATA            COMMA /','/
      DATA            EQUIV /'='/
      DATA            D /'D'/
      DATA            G /'G'/
      DATA            XDIOD /'XDIODE'/
      DATA            NAMLIM /5/,ILIMIT /200/
      DATA            ELPRFX /'C','R','L','E','J'/
      DATA            III4 /0,4/
      DATA            III7 /0,7/
      DATA            III13 /0,13/
      DATA            III8 /0,8/
      DATA            III14 /0,14/
      DATA            III16 /0,16/
      DATA            DERIV /'D','E','R','I','V','A','T','I','V','E'/
      DATA            AMODEL /'M','O','D','E','L'/
 
      IERRS=1
   10 IBEGIN = 1
      IDERIV = 0
      KDERIV = 0
      ISPLIT = 0
 
C     DETERMINE RELATIVE POSITION OF = AND , ON CARD
C     WRITE ERROR MESSAGE AND RETURN IF NEITHER IS LOCATED
 
   20 ICOMMA = ICSCAN (BUFFER,START,LAST,COMMA,ICOMMA)
      IEQUAL = ICSCAN (BUFFER,START,LAST,EQUIV,IEQUAL)
      IF (ICOMMA .EQ. 0 .AND. IEQUAL .EQ.0) GO TO 35
      IF (ICOMMA .NE. 0 .AND. IEQUAL .EQ. 0) GO TO 70
      IF (ICOMMA .NE. 0 .AND. ICOMMA .LT. IEQUAL) GO TO 70
 
C     CHECK FOR D, THEN PROCESS DERIVATIVE
 
   30 IF(BUFFER(START) .NE. D) GO TO 35
 
C     SCAN OUT DERIVATIVE STRING
 
      IF (ISCANS(BUFFER,START,LAST,DERIV,1,10,KDERIV).EQ.0) GO TO 32
 
C     UPDATE STARTING POSITION
 
      START = START + 10
 
C     COMPUTE NAME LENGTH
 
   32 ISPLIT = IEQUAL - START
      IDERIV = 1
      GO TO 82
 
C     COMMA OR EQUAL SIGN MISSING OR INCORRECT DERIVATIVE SPECIFIED
 
   35 KERROR=51
      GO TO 440
 
C     STORE VARIABLE NAME SPLIT-OUT, IF EQUALS SIGN NOT PRESENT
 
   70 ISPLIT  = 0
 
C     THIS CHANGE PREVENTS A MODEL'S ELEMENT NAME FROM CONTAINING TOO
C     MANY CHARACTERS. (7/15/69)
C     IF (NMDCHR .NE. 0) GO TO 73
 
      IF(ICOMMA+NMDCHR-START-NAMLIM) 73,73,71
 
C     IF (ICOMMA - START -NAMLIM) 73,73,71
C     VARIABLE NAME EXCEEDS SIX CHARACTERS
 
   71 KERROR=3
      GO TO 440
   73 IEND = ICOMMA - 1
      DO 75 I = START, IEND
      ISPLIT = ISPLIT + 1
   75 SPLIT(ISPLIT) = BUFFER(I)
 
C     STORE PACKED NAME IN TEMPORARY LOCATION
 
   80 IF (ISPLIT .EQ. 0 .AND. ICOMMA .NE. 0 .AND. ICOMMA .LT. IEQUAL)
     1    ISPLIT = ICOMMA - START
      IF ( ISPLIT .EQ. 0 .AND. IEQUAL .NE. 0 .AND. IEQUAL .LT. ICOMMA)
     1     ISPLIT = IEQUAL - START
   82  CALL CPYSP(D,KDERIV,BUFFER(START),ISPLIT,CKTDES(1),NMDCHR,
     *            TEMP,NWDS)
 
C     CHECK FOR LENGTH GREATER THAN ONE
 
      IF  (NWDS .GT. 1) GO TO 71
 
C     ADJUST START CHARACTER AND PROCESS NODES IF ANY ARE AVAILABLE
 
      START = ICOMMA + 1
      IF (START .LT. LAST) GO TO 84
      CALL GETCK (START,LAST,NOCARD)
      GO TO (84,94), NOCARD
 
C     CHECK TO SEE IF ELEMENT IS SOURCE DERIVATIVE, THEN SKIP IF IT IS
 
   84 IF (IDERIV .NE. 0) GO TO 93
      CALL DNODES (TABLE1,TABLE2,NNODES,ITERM,IERRS)
      IF (ITERM .EQ. 1 .AND. IERRS .EQ. 1) GO TO 89
 
C     INCORRECT DELIMITER OR INSUFFICIENT DATA ON CARD
 
   85 KERROR=22
      GO TO 440
 
C     CHECK FOR A SINGLE NODE AND SUPPLY SECOND NODE IF NECESSARY
 
   89 IF (NNODES .GT. 1) GO TO 90
      NNODES = 2
      TABLE2(NNODES) = TEMP
      CALL CPYSP(D,0,SPLIT(1),ISPLIT,S,0,TABLE1(NNODES),N)
      IF(N.GT.1)GO TO 85
 
C     IF IN MODEL MODE, PERFORM NODE EXCHANGE
 
   90 IF (NMDCHR .EQ. 0) GO TO 92
      DO 91 IK = 1,2
      DO 91 KI = 1, NMDNOD
   91 IF (TABLE1(IK).EQ.ANODES(KI,1)) TABLE2(IK) = ANODES(KI,2)
   92 IEQUAL  = START
 
C     CHECK EQUALS POSITION AND GET CARD IF REQUIRED
 
   93 IF (IEQUAL .LT. LAST) GO TO 98
      CALL GETCK (START, LAST,NOCARD)
      GO TO (200,94), NOCARD
 
C     INCOMPLETE SPECIFICATION PRIOR TO GROUP OR MODE CARD
 
   94 KERROR=32
      GO TO 440
 
C     ADJUST START CHARACTER
 
   98 START = IEQUAL + 1
 
C     CHECK FOR MODEL SEQUENCE
 
  200 IF (ISCANS(BUFFER,START,LAST,AMODEL,1,5,MODEL) .EQ. 0) GO TO 300
 
C     HAVE MODEL ELEMENT, PROCESS MODEL DATA, SAVE ANY DATA ON CARD
C     AFTER MODEL ELEMENT DESCRIPTION
 
      IF (NMDCHR .EQ. 0) GO TO 250
      KERROR = 71
      GO TO 440
  250 CALL MODPRS (NNODES,TABLE1,ISPLIT,SPLIT,IERRS)
      GO TO 450
 
C     PROCESS VALUE
 
  300 IF(BUFFER(START) .NE. PARENL) GO TO 301
      CALL CMPEL(IBEGIN,ILIMIT,LENTBL,TEMP,IERRS)
      IF (IERRS .GT. 1) GO TO  450
      GO TO 390
  301 CALL VLUPRS(IBEGIN,ILIMIT,LENTBL,IERRS)
      IF (IERRS .GT. 1) GO TO  450
 
C     CHECK THE ELEMENT VALUE FOR DIODE EQUATION - IF IT IS, ADD THE
C     VOLTAGE OR CURRENT PREFIX, DEPENDING ON WHETHER ELEMENT IS E OR J
C     AND SUBSTITUTE XDIODE AS EQUATION NAME
 
      IF (TABLE(1) .NE. EIGHT) GO TO 380
      LENTBL = LENTBL + 3
      IBEGAN = IBEGIN - 1
      TABLE (2) = XDIOD
      DO 320 J = 3,LENTBL
  320 TABLE(J) = TABLE(J+1)
  325 PREEFX = PREFXV
      IF (SPLIT(1) .EQ. ELPRFX(4)) PREEFX = PREFXI
      IF (SPLIT(1).EQ. ELPRFX(5).OR.SPLIT(1).EQ.ELPRFX(4)) GO TO 350
 
C     SOURCE ELEMENT MISSING FOR TABLE OR DIODE EQUATION
 
      KERROR=52
      GO TO 440
  350 TABLE (IBEGAN) = FRTEEN
      IF (PREEFX .EQ. PREFXI) TABLE(IBEGAN) = TRTEEN
      CALL CPYSP(PREEFX,1,SPLIT(1),ISPLIT,CKTDES(1),NMDCHR,
     1           TABLE(IBEGAN + 1), NWDS)
      TABLE(IBEGAN+2)=SXTEEN
      CALL CPYSP(G,1,SPLIT(1),ISPLIT,CKTDES(1),NMDCHR,
     *           TABLE(IBEGAN+3),NWDS)
      GO TO 390
  380 IF ( TABLE(1) .NE. SEVEN) GO TO 390
      LENTBL=7
      IBEGAN = 4
      GO TO 325
 
C     STORE ELEMENT, DERIVATIVE OR MUTUAL DATA
 
  390 IF (TABLE(1).EQ.FP4)
     * CALL STCONV(TABLE,LENTBL,SPLIT,ISPLIT,TEMP,TABLE2,IDERIV,IERRS)
      CALL STRELM (TABLE,LENTBL,SPLIT,ISPLIT,TEMP,TABLE2,IDERIV,IERRS)
      IF(IERRS.EQ.2) GO TO 450
 
C     CHECK FOR MORE DATA ON CARD AND PROCESS IF FORMAT IS PROPER
 
  400 IF(START.GT.LAST) GO TO 450
      IF(BUFFER(START).NE.COMMA) GO TO 35
      START = START + 1
      IF (START .LT. LAST) GO TO 10
 
C     INCORRECT DELIMITER OR INSUFFICIENT DATA ON CARD
 
      KERROR=22
  440 CALL ERROR (ELMPR,2,KERROR)
      IERRS=2
  450 CONTINUE
      RETURN
 
      END
