CSECT   EQFORM                          71.042  11.43.38

C      PROGRAM TO FORM VALUE EQUATIONS FOR VARIABLE QUANTITIES
C      J. SENTS   5/3/66
 
       SUBROUTINE EQFORM (TERM ,ICMODE,TYPCOD)
 
C      TERM1 - IS THE NAME OF THE VARIABLE QUANTITY FOR WHICH EQUATION
C                  IS TO BE GENERATED.
C      ICMODE- INDICATES INITIAL CONDITION EQUATION MUST BE GENERATED
C                   IN ADDITION TO NORMAL VALUE EQUATIONS IF NON-ZERO.
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'
	include 'values.inc'
                       character*8  valist
                       integer      list(2*jqqval)
                       equivalence (list,valist)

       COMMON /CNTRLS/ CTROLS(160)
       COMMON /EQBUFR/ STCHR,BUFFER(220)
          CHARACTER*4  BUFFER
       CHARACTER*8     TERM,CTERM,PREFX,TNAME,SUFFIX,SOURCE
       INTEGER         CODE,STCHR,VALCOD,TYPCOD
       CHARACTER*8
     *                 ASTRSK,
     *                 B,
     *                 G,
     *                 Z,
     *                 BLANK,
     *                 EQUAL,
     *                 PARENL,
     *                 RTPREN,
     *                 COMMA,
     *                 XTABLE,
     *                 DTABLE
 
       DATA
     *                 ASTRSK /'*'/,
     *                 B      /'B'/,
     *                 G      /'G'/,
     *                 Z      /'Z'/,
     *                 BLANK  /' '/,
     *                 EQUAL  /'='/,
     *                 PARENL /'('/,
     *                 RTPREN /')'/,
     *                 COMMA  /','/,
     *                 XTABLE /'XTABLE'/,
     *                 DTABLE /'DTABLE'/
       DATA            KOUNT /1/,IDEBUG /0/
 
C      LOOK-UP TERM IN VALUE LIST AND GET IT'S POSITION SUBSCRIPTS
 
       CALL FIND(VALIST,TERM ,ISTSUB,NDSUB,LEN )
 
C      IS DEBUG OUTPUT REQUIRED
C      A TEST FOR CODES 1,3,4,16,17 COULD BE MADE BUT ISN'T NECESSARY
C      COPY TERM INTO BUFFER WITH '=' SUFFIX
 
       STCHR=1
       PREFX=BLANK
       IF(TYPCOD .EQ. 20) PREFX=G
       IF(TYPCOD .EQ. 22) GO TO 3
       CALL COPY(0,PREFX,TERM,EQUAL,BUFFER,STCHR,NCHAR)
 
C      CHECK TO SEE IF TERM WAS PRESENT IN VALUE LIST
 
    3  IF(LEN .NE. 0) GO TO 10
       IF(TYPCOD .EQ. 8 ) GO TO 8
       WRITE (iqqout,5 ) TERM
    5  FORMAT(11H-THE TERM ',A6,''' COULD NOT BE FOUND IN THE VALUE',
     *        ' LIST BY ''EQFORM'' -PROGRAM ERROR.'/// )
       STOP 'EQFORM: term not found, run aborted'
 
    8  CALL CPY('1./',1,BUFFER,STCHR,3)
       CTERM=TERM(2:6)
       CALL COPY(0,BLANK,CTERM,BLANK,BUFFER,STCHR,NCHAR)
       GO TO 500
   10  CODE= LIST(ISTSUB*2)
       GO TO (16,16,16,16,16,300,15,15,310, 310,350),CODE
   15  IF(TYPCOD .EQ. 20) GO TO 400
   16  ASSIGN 500 TO NWAY
 
C      VALUE ROUTINE
 
   20  ASSIGN 250 TO KWAY
 
C      CHECK VALUE TYPE
 
       VALCOD= LIST(ISTSUB*2)
       GO TO (30,50,60,100,200,250,60,100),VALCOD
 
C      GENERATE CONSTANT VALUE
C      CHECK FOR AND COPY ONLY NON-BLANK WORDS FROM CONSTANT INTO BUFFER
 
   30  DO 40 N=1,3
       N1=ISTSUB+N
       IF(VALIST(N1      ) .EQ. BLANK) GO TO 45
   40  CALL CPY(VALIST(N1      ),1,BUFFER,STCHR,6)
   45  ISTSUB=ISTSUB+4
 
C      RETURN TO CALLING ROUTINE
 
       GO TO KWAY,(160,250)
 
C      GENERATE DEFINED PARAMETER VALUE, ETAL.
 
   50  CALL COPY(0,BLANK,VALIST(ISTSUB+1),BLANK,BUFFER,STCHR,NCHAR)
       ISTSUB=ISTSUB+2
       GO TO KWAY,(90,160,250)
   60  ASSIGN 250 TO JWAY
 
C      GENERATE TABLE VALUE.
C      COPY TABLE FUNCTION NAME 'XTABLE' INTO BUFFER.
 
   70  TNAME=XTABLE
       IF(CODE .EQ. 7) TNAME=DTABLE
       CALL CPY(TNAME,1,BUFFER,STCHR,6)
 
C      COPY TABLE NAME INTO BUFFER WITH '(' PREFIX AND ',' SUFFIX.
 
   75  CALL COPY(0,PARENL,VALIST(ISTSUB+1),COMMA,BUFFER,STCHR,NCHAR)
       ASSIGN 90 TO KWAY
       ISTSUB=ISTSUB+2
       IF(  LIST(ISTSUB*2)   .EQ. 17 ) GO TO 200
 
C      COPY INDEPENDENT VARIABLE NAME INTO BUFFER.
 
       IF(CODE .NE. 7) GO TO 50
       CALL COPY(0,BLANK,VALIST(ISTSUB+1),COMMA,BUFFER,STCHR,NCHAR)
       ISTSUB=ISTSUB+2
       GO TO 50
 
C      SET START SUBSCRIPT TO POSITION OF EXPRESSION VALUE CODE IN LIST.
C      SET-UP RETURN TO THIS PORTION OF TABLE VALUE GENERATOR ROUTINE.
 
   90  CALL CPY(RTPREN,1,BUFFER,STCHR,1)
 
C      TRANSFER BACK TO CALLING ROUTINE.
 
       GO TO JWAY,(160,250,410)
  100  ASSIGN 250 TO LWAY
 
C      EQUATION VALUE GENERATOR ROUTINE.
C      COPY EQUATION NAME INTO BUFFER WITH '(' SUFFIX.
 
       CALL COPY(0,BLANK,VALIST(ISTSUB+1),PARENL,BUFFER,STCHR,NCHAR)
  115  ISTSUB=ISTSUB+2
       ASSIGN 160 TO JWAY
  120  ASSIGN 160 TO KWAY
       KODE=   LIST(ISTSUB*2)
 
C      CHECK FOR CONSTANT.
 
       IF(KODE .EQ. 1) GO TO 30
 
C      CHECK FOR TABLE VALUE.
 
       IF(KODE .EQ. 3) GO TO 70
 
C      CHECK FOR EXPRESSION VALUE
 
       IF(KODE .EQ. 17) GO TO 200
 
C      GO TO DEFINED PARAMETER VALUE GENERATOR ROUTINE.
 
       GO TO 50
 
C      CHECK FOR END OF EQUATION IN VALUE LIST.
 
  160  IF(ISTSUB .GT.  NDSUB) GO TO 170
       CALL CPY(COMMA,1,BUFFER,STCHR,1)
       GO TO 120
  170  CALL CPY(RTPREN,1,BUFFER,STCHR,1)
       GO TO LWAY,(250,410)
 
C      GENERATE EXPRESSION VALUE
 
  200  CALL CPY(VALIST(ISTSUB+2),1,BUFFER,STCHR,8*LIST(ISTSUB*2+2))
       ISTSUB=ISTSUB+LIST(ISTSUB*2+2)+2
       GO TO KWAY,(90,160,250)
  250  GO TO NWAY,(315,320,500)
  300  WRITE (iqqout,305)
  305  FORMAT('- VALUE EXPRESSION FOR TYPE 6 IS NOT CODED YET.',
     *        ' THE RUN CANNOT BE CONTINUED.'///)
       STOP 'EQFORM: value expression not coded yet, run aborted'
 
  310  ISTSUB=ISTSUB+1
 
C      SAVE START POSITION
 
       IST=ISTSUB
       NDSUB=NDSUB-2
       ASSIGN 315 TO NWAY
       GO TO 20
  315  IF(TYPCOD .EQ. 22) GO TO 600
       IF ((nint(CTROLS( 71)).EQ.0 .AND.
     *      nint(CTROLS(140)).EQ.0) .OR. CODE.NE.9)
     *      GO TO  3151
       CALL ACAJJ0(ICMODE,NDSUB,TERM)
       GO TO 500
 3151  IF(ICMODE .NE. 0) GO TO 317
       CALL COPY(0,ASTRSK,VALIST(NDSUB+2),BLANK,BUFFER,STCHR,NCHAR)
       GO TO 500
  317  CALL CPY('*G',1,BUFFER,STCHR,2)
       CALL COPY(0,BLANK,VALIST(NDSUB+2),BLANK,BUFFER,STCHR,NCHAR)
       CALL WTSPTP(BLANK,BUFFER,STCHR-1,NERR)
       STCHR=1
       CALL COPY(0,  B,TERM,EQUAL,BUFFER,STCHR,NCHAR)
       ISTSUB=IST
       ASSIGN 320 TO NWAY
       GO TO 20
  320  CALL CPY('*B',1,BUFFER,STCHR,2)
       CALL COPY(0,BLANK,VALIST(NDSUB+2),BLANK,BUFFER,STCHR,NCHAR)
       GO TO 500
 
C      GENERATE CIRCUIT EQUATION VALUE
 
  350  ISTSUB=ISTSUB+1
 
C      COPY EQUATION TERM WITH SIGN
 
  360  CALL COPY(LIST(ISTSUB*2+4),BLANK,VALIST(ISTSUB+1),BLANK,BUFFER,
     1 STCHR,NCHAR)
       ISTSUB=ISTSUB+3
 
C      CHECK FOR END OF CIRCUIT EQUATION
 
       IF(ISTSUB .LE. NDSUB) GO TO 360
       CALL ERASE(VALIST,TERM)
       GO TO 500
  400  ASSIGN 410 TO JWAY
       ASSIGN 410 TO LWAY
       IF(LIST(ISTSUB*2) .EQ. 8) GO TO 405
       CALL CPY('DIOT' ,1,BUFFER,STCHR,4)
       GO TO 75
  405  CALL CPY('DIOQ(',1, BUFFER,STCHR,5)
       GO TO 115
  410  STCHR=STCHR-1
       SOURCE=VALIST(ISTSUB-1)(2:6)
       CALL COPY(0,COMMA,SOURCE,COMMA,BUFFER,STCHR,NCHAR)
       SUFFIX=RTPREN
       IF(CODE .EQ. 8) SUFFIX=COMMA
       CALL COPY(0,B,SOURCE,SUFFIX,BUFFER,STCHR,NCHAR)
       IF(CODE .EQ. 8) CALL COPY(0,Z,SOURCE,RTPREN,BUFFER,STCHR,NCHAR)
  500  CALL WTSPTP(BLANK,BUFFER,STCHR-1,NERR)
  600  IF(KOUNT .GT. IDEBUG) RETURN
       KOUNT=KOUNT+1
       RETURN
 
       END
