CSECT   GENER8                          72.110  00.39.08
 
      SUBROUTINE GENER8 (NERROR,IELMTS)
 
C     THIS IS AN EXECUTIVE ROUTINE THAT WILL CHECK AND GENERATE ALL DATA
C       INTO INITIAL CONDITIONS EQUATIONS (IF REQUIREQ) AND/OR TRANSIENT
C         EQUATIONS.  IF NO CIRCUIT IS GIVEN, THE ROUTINE WILL BE USED
C           FOR THE SOLUTION OF SIMULTANEOUS EQUATIONS.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'
	include 'dfpram.inc'
                      character*8  cptabl(jqqram,4)
                      integer      iptabl(2*jqqram,4)
                      equivalence (cptabl,dptabl)
                      equivalence (iptabl,dptabl)
	include 'dfprmd.inc'
                      character*8  dpdtbl
	include 'values.inc'
                      character*8  valist
	include 'tables.inc'
                      character*8  vecelm(300),tablst
                      equivalence (tablst(1601),vecelm(1))

      COMMON /HEAD  / HE,NHEADS,LHEADS,HEADNG( 9,11)
         CHARACTER*8  HE,HEADNG
      COMMON /ELDATA/ EL,NELMTS,LELMTS,ELTAB(300,9)
         CHARACTER*8  EL,ELTAB
         real*8       RELTAB(300,9)
         EQUIVALENCE (RELTAB,ELTAB)
         integer      ieltab(600,9)
         equivalence (ieltab,eltab)
      COMMON /OUTPUT/ OU,NOUTPS,LOUTPS,OUTPTS(5,100)
         CHARACTER*8  OU,OUTPTS
      COMMON /ICCOND/ TIC,NIC,LIC,TABLIC(100,2)
         CHARACTER*8  TIC,cTBLIC(100,2)
         equivalence (ctblic,tablic)
      COMMON /SDERIV/ SDR,NSDRIV,LSDRIV,SDRVTB(50,3)
         CHARACTER*8  SDR,cDRVTB(50,3)
         equivalence (sdrvtb,cdrvtb)
         integer      idrvtb(100,3)
         equivalence (idrvtb,sdrvtb)
      COMMON /MUTUAL/ AMUT,NMUTL,LMUTL,AMUTBL(50,6)
         CHARACTER*8  AMUT,cMUTBL(50,6)
         equivalence (cmutbl,amutbl)
         integer      imutbl(100,6)
         equivalence (imutbl,amutbl)
      COMMON /CNTRLS/ CNTRL(160)
         DOUBLE PRECISION ICRQST,ITRQST
         EQUIVALENCE (ICRQST,CNTRL(10)),
     *               (ITRQST,CNTRL(34)),(DEBUG,CNTRL(46)),
     *               (XTRNIC,CNTRL(55)),(CNTRL(71),XAC)
      COMMON /CHKCTL/ CHKTBL(160)
         integer      ichktb(320)
         equivalence (ichktb,chktbl)

      CALL SETUP(NERROR)
      IF (NERROR .GT. 1) RETURN
      IF (nint(XTRNIC).NE.0) GO TO 100
      IF (nint(ICRQST) .EQ. 0) GO TO 100
      CALL ICEQS(NERROR)
      IF (NERROR .GT. 1) RETURN
      CALL ICTEQS
      IF (nint(ITRQST) .NE. 0) GO TO 110
  100 CALL CFONTR
      CALL TRNEQS(NERROR)
      IF (NERROR .GT. 1) RETURN
  110 CALL WRTOUT
      IF (nint(XAC) .NE. 0) CALL ACPREP
      IELMTS=NELMTS

      IF (nint(DEBUG).EQ.0) GO TO 55
 
      WRITE (iqqout,5)
    5 FORMAT('1GENER8: DEBUG OUTPUT ("WRITE DEBUG"):'//)
 
COMMON /HEAD  / HE,NHEADS,LHEADS,HEADNG( 9,11)

      IF (NHEADS .GT. 0)
     *   WRITE(iqqout,10)HE,NHEADS,LHEADS,
     *   ((HEADNG(N,M),N=1,9),M=1,NHEADS)
   10    FORMAT('0****',A8,'****  N=',I6,', L=',I6//(2H ',9A8,1H') )
 
COMMON /ELDATA/ EL,NELMTS,LELMTS,ELTAB(300,9)

      IF (NELMTS .GT. 0) THEN
         WRITE (iqqout,20) EL,NELMTS,LELMTS
   20    FORMAT('0****',A8,'****  N=',I6,', L=',I6//
     *   ' ELEMENTS FNODE    TNODE      FP-VALUE   ',
     *   'SCODE',9X,'CMPFLG',11X,'VALCODE     VAL-LOW   ',
     *   '  VAL-HIGH           VECELM'//)
         DO 11 N=1,NELMTS
            WRITE (iqqout,21)
     *     (ELTAB(N,M),M=1,3),
     *      RELTAB(N,4),
     *      ieltab(2*m-1,5),ELTAB(N,5)(5:6),
C CMPFLG:
C    *      iELTAB(2*N-1,6),ieltab(2*n,6),
     *      ichar(eltab(n,6)(1:1)),ichar(eltab(n,6)(2:2)),
     *      ichar(eltab(n,6)(3:3)),ichar(eltab(n,6)(4:4)),
     *      ichar(eltab(n,6)(5:5)),ichar(eltab(n,6)(6:6)),
     *      ichar(eltab(n,6)(7:7)),ichar(eltab(n,6)(8:8)),
C VALCODE:
     *      iELTAB(2*n-1,7),iELTAB(2*n,7),
C VALLOW,VALHI:
     *      RELTAB(n,8),reltab(n,9),
C /TABLES/ .... VECELM:
     *      ichar(vecelm(n)(1:1)),ichar(vecelm(n)(2:2)),
     *      ichar(vecelm(n)(3:3)),ichar(vecelm(n)(4:4)),
     *      ichar(vecelm(n)(5:5)),ichar(vecelm(n)(6:6)),
     *      ichar(vecelm(n)(7:7)),ichar(vecelm(n)(8:8))
   11    CONTINUE
      END IF
   21       FORMAT (1X,
     *              3(A,1X),
     *              1P,1E12.4,1x,
     *              i2,1X,A,1x,
     *              8i3,1x,
     *              2i3,1x,
     *              2E12.4,1x,
     *              8i3)
 
COMMON /OUTPUT/ OU,NOUTPS,LOUTPS,OUTPTS(5,100)

      IF (NOUTPS .GT. 0)
     *   WRITE(iqqout,30) OU,NOUTPS,LOUTPS,
     *   ((OUTPTS(N,M),N=1,5),M=1,NOUTPS)
   30    FORMAT('0****',A8,'****  N=',I6,' , L=',I6/
     *   '0XQTY   XLABEL YQTY  YLABEL NPLOT'//
     *   (1X,5(A6,1X)))
 
COMMON /ICCOND/ TIC,NIC,LIC,TABLIC(100,2)

      IF (NIC .GT. 0)
     *   WRITE (iqqout,40) TIC,NIC,LIC,
     *   (cTBLIC(N,1),tablic(n,2),N=1,NIC)
   40    FORMAT('0****',A8,'****  N=',I6,' , L=',I6/
     *   '0VARIABLE  VALUE'//
     *   (1X,A8,2X,1p,D15.8))
 
COMMON /MUTUAL/ AMUT,NMUTL,LMUTL,AMUTBL(50,6)

      IF (NMUTL .GT. 0)
     *   WRITE(iqqout,60) AMUT,NMUTL,LMUTL,
     *   (imutbl(2*n-1,1),imutbl(2*n,1),
     *   cmutbl(n,2),cmutbl(n,3),cmutbl(n,4),
     *   amutbl(n,5),
     *   imutbl(2*n-1,6),imutbl(2*n,6),n=1,nmutl)
   60    FORMAT('0****',A8,'****  N=',I6,', L=',I6//
     *   ' VALUE CODE',9X,'MUTUALS    FROM-L     TO- L      F-P VALUE',
     *   9X,'AMUTBL(N,6)'//
     *   (1X,2i8,3(3X,A8),3X,1p,D15.8,3X,2i8))
 
COMMON /SDERIV/ SDR,NSDRIV,LSDRIV,SDRVTB(50,3)

      IF (NSDRIV .GT. 0)
     *   WRITE(iqqout,70) SDR,NSDRIV,LSDRIV,
     *   (cDRVTB(N,1),sdrvtb(n,2),
     *   idrvtb(2*n-1,3),idrvtb(2*n,3),N=1,NSDRIV)
   70    FORMAT('0****',A8,'****  N=',I6,', L=',I6/
     *   '0SDRIV      F-P VALUE',9X,'VALUE CODE'//
     *   (1X,A8,3X,1p,D15.8,3X,2i8))
 
COMMON /DFPRAM/ DPT,NDP,LDP,DPTABL(100,4)

      IF (NDP .GT. 0)
     *   WRITE(iqqout,80) DPT,NDP,LDP,
     *   (cPTABL(N,1),
     *   iptabl(2*n-1,2),iptabl(2*n,2),
     *   dptabl(n,3),
     *   iptabl(2*n-1,4),iptabl(2*n,4),N=1,NDP)
   80    FORMAT('0****',A8,'****  N=',I6,', L=',I6/
     *   '0PRAM',7X,'VALUE CODE',9X,'F-P VALUE',10X,'DPTABL(N,4)'//
     *   (1X,A8,3X,2i8,3X,1p,D15.8,3X,2i8))
 
COMMON /DFPRMD/ DPDT,NDPD,LDPD,DPDTBL(100)

      IF (NDPD.GT.0)
     *   WRITE(iqqout,90)DPDT,NDPD,LDPD,(DPDTBL(N),N=1,NDPD)
   90    FORMAT('0****',A8,'****  N=',I6,', L=',I6/'0DRIV-PRAM'//
     *   (1X,A8))
 
      CALL DMPLST(VALIST)
 
      CALL DMPLST(TABLST)
 
      WRITE (iqqout,50) (N,CNTRL(N),ichktb(2*N-1),
     *   ichktb(2*n),N=1,160)
   50    FORMAT ('0         CNTRL TABLE',8X,'CHKTBL TABLE'//
     *   (1X,I3,3X,1P,1D16.9,1X,2i8))
 
   55 CONTINUE

      RETURN
 
      END
