CSECT   GETARG                          71.042  11.43.38
 
       SUBROUTINE GETARG (ISTSUB,NDSUB,TERM,KODE,LOC,MODE)
 
C      PROGRAM TO INTERROGATE THE INDEPENDENT VARIABLES OF A VALUE
C      SPECIFICATION AND SINGLE-OUT ANY ARGUMENTS (VARIABLES) WHICH HAVE
C      NOT BEEN COMPUTED.
C      J. SENTS   6/1/66
C
C
C      ISTSUB - SUBSCRIPT OF START OF VALUE SPECIFICATION IN VALUE LIST.
C      NDSUB  - SUBSCRIPT OF LAST WORD IN VALUE LIST.
C      TERM   - NAME OF VARIABLE DEFINED BY VALUE IN VALUE LIST.
C      KODE   - ARGUMENT TYPE CODE OF ARGUMENT NOT YET COMPUTED.
C      LOC    - RELATIVE POSITION SUBSCRIPT OF ARGUMENT CODE IN 'VALIST'
C      MODE   - INDICATOR TO SIGNAL THE START OF AN ARGUMENT LIST SCAN
C                  AND WHETHER ANY ARGUMENTS REMAIN TO BE PROCESSED.
C                 MODE MUST=0 TO START SCAN AND TO TERMINATE SCAN
C                 MODE = 1 UPON EXIT IF LAST ARGUMENT HASN'T BEEN COMPTD
C                 MODE = 2 TO CONTINUE ARGUMENT SCAN
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'values.inc'
                       character*8  valist
                       integer      list(2*jqqval)
                       equivalence (valist,list)

       CHARACTER*8     TERM
 
       LOC1=LOC
       IF(MODE .NE. 0) GO TO 1155
       MODE=1
 1000  KODE0=LIST(ISTSUB*2)
       GO TO (1180,1010,1020,1050,1180,1030,1020,1050,1060,1060,1070 ),
     *        KODE0
 
C      DEFINED PARAMETER VALUE
 
 1010  LOC1=0
       GO TO 1100
 
C      TABLE VALUE
 
 1020  LOC1=2
       GO TO 1100
 
C      TABLE * TABLE VALUE
 
 1030  IF(LIST(ISTSUB*2+2) .NE. 4)GO TO 1020
 1040  LOC1=5
       GO TO 1100
 
C      EQUATION VALUE
 
 1050  LOC1=2
       IF(LIST(ISTSUB*2+2) .EQ. 3) LOC1=LOC1+2
 
C      ENTER CONTINUE MODE
 
 1055  MODE=2
       GO TO 1100
 
C      SECONDARY DEPENDENT SOURCE VALUE
 
 1060  KODE1=LIST(ISTSUB*2+1)
       GO TO (1040,1070,1080,1080,1090 ) , KODE1
 
C      DEFINED PARAMETER ARGUMENT VALUE
 
 1070  LOC1=1
       GO TO 1055
 
C      TABLE OR EQUATION ARGUMENT VALUE
 
 1080  LOC1=3
       GO TO 1055
 
C      SKIP OVER EXPRESSION ARGUMENT VALUE TO PRI. SOURCE TERM
 
 1090  LOC1=LIST(ISTSUB*2+2)+3
 1100  K=ISTSUB+LOC1
       IF(K .GE. NDSUB  )GO TO 1180
       IF(LIST(K*2) .NE. 3) GO TO 1120
 1110  LOC1=LOC1+2
       GO TO 1100
 
C      STORE TERM AND CODE FOR OUTPUT
 
 1120  KODE=LIST(K*2)
       TERM=VALIST(K+1)
 1150  CALL COMPCK( TERM  , KODE  , 0 , KOUT)
 
C
 
       IF(KOUT .EQ. 0)  GO TO 1200
       IF(MODE .EQ. 0)  GO TO 1200
 1155  IF( KODE0       .NE. 11)  GO TO 1160
       LOC1=LOC1+3
       GO TO 1100
 1160  IF(KODE  .NE. 1) GO TO 1170
       LOC1=LOC1+4
       GO TO 1100
 1170  IF(KODE .EQ. 17) LOC1=LOC1+LIST(K*2+1)
       GO TO 1110
 1180  MODE=0
       GO TO 1210
 1200  LOC=LOC1
 1210  RETURN
 
       END
