CSECT   GETNUM                          71.042  11.43.38
 
       SUBROUTINE GETNUM (ITABLE,LENROW,NERROR)
 
C      PROGRAM TO EXAMINE A-MATRIX ENTRY CARDS AND EXTRACT DATA
C      DATA IS STORED IN ITABLE AS FOLLOWS
C
C        ITABLE(1) - CARD TYPE
C        ITABLE(2) - ROW INDEX OF LHS OF EQUALS
C        ITABLE(3) - COLUMN INDEX OF LHS OF EQUALS IF AVAILABLE
C        ITABLE(4) - SIGN OF RHS OR BX OR GX TERM OF RHS OF EQUALS
C        ITABLE(5) - INDEX NUMBER OF X,GX OR BX TERM
C
C        TYPES ARE
C                1 - A(1,10)=+1.
C                2 - A(10,1)=-1./X(32)
C                3 - A(15,30)=-GX(22)
C                4 - A(2,NICSV1)=A(2,NICSV1)+BX(5)
C                5 - A(2,63)=A(2,63)-GX(60)
C                6 - A(7,NICSV1)=A(7,NICSV1)+X(2)
C                7 - AVI(8)=VX(13)
C                8 - UNRECOGNIZABLE A-MATRIX CARD
C
C      LENROW IS ROW LENGTH OF A-MATRIX
C      NERROR IS ERROR INDICATOR - 1 FOR NORMAL, 2 FOR ERROR CONDITION
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
       COMMON /BUFERS/ BUF,ISTART,ILAST,BUFFER(72),BLNKBF(72)
          CHARACTER*8  BUFFER,BLNKBF
 
       DIMENSION ITABLE(*),KPATRN(68),KPOSIT(13),ISTRNG(7)
       DIMENSION LSTART(7),LLAST(7),IPOSIT(13)
       CHARACTER*8 DELMTR(9)
       CHARACTER*8 BCDNEG
 
       DATA LSTART /1,6,15,24,37,50,62/,
     *      LLAST /5,14,23,36,49,61,68/
       DATA KPATRN/6,1,3,2,5,
     *             6,1,3,2,5,4,9,1,2,
     *             6,1,3,2,5,7,9,1,2,
     *             6,1,3,2,5,6,1,3,2,8,9,1,2,
     *             6,1,3,2,5,6,1,3,2,7,9,1,2,
     *             6,1,3,2,5,6,1,3,2,9,1,2,
     *             6,1,2,5,9,1,2/
      DATA LLMTRS /13/,ILMTRS /9/,NSTRNG /7/
      DATA ISTRNG /5,9,9,13,13,12,7/
      DATA DELMTR /'(',')',',','/','=','A','G','B','X'/
      DATA BCDNEG /'-'/
 
C      SCAN DELIMITERS ON CARD
 
       NLMTRS = 0
       DO 400 I=ISTART,ILAST
       DO 300 J=1,ILMTRS
       IF (DELMTR(J) .NE. BLNKBF(I)) GO TO 300
       NLMTRS = NLMTRS + 1
       IF (NLMTRS .LE. LLMTRS) GO TO 250
  230  ITABLE(1) = 8
       GO TO 9000
  250  KPOSIT(NLMTRS) = I
       IPOSIT (NLMTRS) = J
       GO TO 400
  300  CONTINUE
  400  CONTINUE
       ITYPE = 0
 
C      CHECK FOR POSSIBLE CORRECT NUMBER OF DELIMITERS IN STRING
 
       DO 500 I=1,NSTRNG
       ITYPE = ITYPE + 1
       IF (NLMTRS .EQ. ISTRNG(I)) GO TO 600
  500  CONTINUE
       GO TO 8900
 
C      TEST SEQUENCE OF DELIMITERS
 
  600  IF(NLMTRS .EQ.9 .AND. IPOSIT(6) .EQ. 7) ITYPE = 3
       IF(NLMTRS .EQ. 13 .AND. IPOSIT(10) .EQ. 7) ITYPE = 5
       KSTART = LSTART (ITYPE)
       KLAST = LLAST (ITYPE)
       LPOSIT = 0
       DO 700 I=KSTART,KLAST
       LPOSIT = LPOSIT + 1
       IF (KPATRN(I) .NE. IPOSIT(LPOSIT)) GO TO 8900
  700  CONTINUE
       ITABLE(4) = +1
       IF(ITYPE.EQ.7) GO TO 2100
       I = 5
       IF (ITYPE .GT. 3) I = 9
       LPOSIT = KPOSIT(I) + 1
       IF (BLNKBF(LPOSIT) .EQ. BCDNEG) ITABLE(4) = -1
 
C      CONVERT AND STORE ROW INDEX
 
  800  KSTART = KPOSIT(2) + 1
       NCHARS = KPOSIT(3) - KSTART
       IF (NCHARS .EQ. 0) GO TO 5000
       ITABLE(2) = NBCDI(BLNKBF(KSTART),NCHARS,KERROR)
       IF (KERROR .NE. 1) GO TO 9000
 
C      IF TYPE 4, ASSIGN PROPER SIGN TO ROW INDEX AND STORE AS INTEGER
 
       GO TO (2000,2000,2000,2100,2000,2100,2100) ,ITYPE
 
C      CONVERT AND STORE COLUMN INDEX
 
 2000  KSTART = KPOSIT(3) + 1
       NCHARS = KPOSIT(4) - KSTART
       IF (NCHARS .EQ. 0) GO TO 5000
       ITABLE(3) = NBCDI(BLNKBF(KSTART),NCHARS,KERROR)
       IF (KERROR .NE. 1) GO TO 9000
 
C      ITABLE(6) = ITABLE(4) * (((ITABLE(2)-1)*LENROW) + ITABLE(3))
 
       IF (ITYPE .EQ. 1) GO TO 3000
 
C      CONVERT AND STORE INDEX NUMBER OF X, GX OR BX TERM
 
 2100  LPOSIT = 8
       IF (ITYPE .EQ. 5.OR.ITYPE.EQ.4) LPOSIT=12
       IF(ITYPE.EQ.6) LPOSIT=11
       IF(ITYPE.EQ.7) LPOSIT=6
       KSTART = KPOSIT(LPOSIT) + 1
       NCHARS = KPOSIT(LPOSIT+1) - KSTART
       IF (NCHARS .EQ. 0) GO TO 5000
 2500  ITABLE(5) = NBCDI(BLNKBF(KSTART),NCHARS,KERROR)
 3000  ITABLE(1) = ITYPE
 
C      CHECK MAGNITUDE OF ROW AND COLUMN
 
       IF (ITABLE(2) .GT. LENROW) GO TO 5000
 4000  IF (ITYPE .EQ. 4.OR.ITYPE.GE.6) GO TO 9000
       IF (ITABLE(3) .LE. LENROW) GO TO 9000
 5000  KERROR = 2
       GO TO 9000
 
C      UNRECOGNIZABLE CARD
 
 8900  ITABLE (1) = 8
 9000  NERROR = KERROR
       RETURN
 
       END
