CSECT   GNLOCA                          71.042  11.43.38
 
      SUBROUTINE GNLOCA (IROW,ICOL,LENROW,NZA,IA,LNLOCA,NLOCA,KERROR)
 
C     PROGRAM TO GENERATE THE LOCA AND IA VECTORS FOR THE SPARSE MATRIX.
C     ARGUMENTS ARE:
C        IROW   - ROW IN A-MATRIX WHERE NON-ZERO ELEMENT EXISTS.
C        ICOL   - COLUMN IN A-MATRIX WHERE NON-ZERO ELEMENT EXISTS.
C        LENROW - NUMBER OF ROWS IN A-MATRIX.
C        IA     - ARRAY OF LENGTH=LENROW,WHICH HAS THE INDICES OF LOCA
C                 WHERE EVERY N ROW STARTS.
C        NLOCA  - ARRAY WHICH HAS THE LOCATIONS OF THE NON-ZERO ELEMENTS
C                 OF THE A-MATRIX, ORIENTED ROW-WISE.
C        KERROR - NORMALLY 1, EQUAL TO 2 IF ERROW CONDITION EXISTS
C        NZA    - THE NUMBER OF NON-ZERO ELEMENTS IN THE A-MATRIX.
C        LNLOCA - LENGTH OF ARRAY NLOCA
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
	include 'tapes.inc'

      INTEGER*2      NLOCA(*),IA(*)
 
C     INITIALIZE IA AND NLOCA WITH TYPE 1 ELEMENTS ON DIAGONAL OF THE
C     A-MATRIX.
 
      KERROR=1
      IF( NZA.NE.0 ) GO TO 200
      NZA = LENROW
      DO 100 I=1,NZA
      IA(I) = I
      NLOCA(I) = I
  100 CONTINUE
 
C     IS NON-ZERO IN LOCA
 
  200 IEND = NZA
      IF(IROW.LT.LENROW) IEND = IA(IROW+1) - 1
      ISTART = IA(IROW)
      DO 210 I=ISTART,IEND
      IF( NLOCA(I).GE.ICOL ) GO TO 220
 
C     ADD ELEMENT POSITION TO NLOCA
 
  210 CONTINUE
      I=IEND+1
      GO TO 225
  220 IF( NLOCA(I).EQ.ICOL ) GO TO 900
  225 ISTART = I + 1
      NZA = NZA + 1
      IF( NZA.GT.LNLOCA ) GO TO 850
      M=NZA
      DO 230 I=ISTART,NZA
      M=M-1
      NLOCA(M+1) = NLOCA(M)
  230 CONTINUE
      NLOCA(ISTART-1)=ICOL
      IF( IROW.EQ.LENROW) GO TO 900
      ISTART = IROW + 1
      DO 240 I = ISTART,LENROW
      IA(I) = IA(I) + 1
  240 CONTINUE
      GO TO 900
  850 KERROR = 2
      WRITE (iqqout  ,860)
  860 FORMAT(52H TABLE CONTAINING SPARSE MATRIX DATA HAS OVERFLOWED.//
     * 29H SIMULATION HAS BEEN DELETED.//)
      STOP 'GNLOCA: sparse matrix table overflow, run aborted'
  900 RETURN
 
      END
