CSECT   GROW                            71.042  11.43.38
 
      SUBROUTINE   GROW (IERROR,N,NZA,NZC,IA,IP,LOCA)
 
C     THIS SUBROUTINE RECEIVES AS INPUTS N,NZA,IP, AND LOCA AND
C     FORMS IA,LOCA, AND NZC FOR FUTURE USE BY SUBROUTINE SOLVE .
C     USAGE:
C        CALL   GROW(IERROR,N,NZA,NZC,IA,IP,LOCA)
C     WHERE:
C        IERROR - ERROR INDICATOR; =1 NORMAL RETURN , =2 ABNORMAL
C                 RETURN.
C        N      - ORDER OF MATRIX A, AND DIMENSION OF IA AND IP
C        NZA    - NUMBER OF NON-ZERO ELEMENTS OF MATRIX A
C        NZC    - ON ENTRY IT IS DIMENSION OF LOCA.  ON RETURN IT WILL
C                 CONTAIN THE ACTUAL NUMBER NEEDED.  IF IT EXCEEDS THE
C                 DIMENSION, IERROR WILL BE SET TO 2.
C        IA     - ARRAY OF LENGTH N CONTAINING INDICES OF LOCA WHERE
C                 EVERY N ROW STARTS.
C        IP     - THE ROW PERMUTATION OF THE MATRIX A.
C        LOCA   - ARRAY OF LENGTH NZC,WHICH HAS THE LOCATIONS OF THE
C                 NON-ZERO ELEMENTS OF ARRAY A, ORIENTED ROW WISE
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
	include 'tapes.inc'

      INTEGER*2      IA(*),IP(*),LOCA(*)
 
      LIMIT = NZC
      IERROR = 1
      IF( N.LE.1 ) RETURN
      NZC = NZA
 
C        MODIFYING LOCA FOR GROWTH AND DETERMINING NZC.
 
      DO 200 I=2,N
      M1 = IP(I)
      ISTRT = IA( M1 ) - 1
  110 ISTRT = ISTRT + 1
  115 IEND = NZC
      IF( M1.LT.N ) IEND = IA( M1+1 ) - 1
      IF( ISTRT.GT.IEND ) GO TO 200
      INTEGR=LOCA(ISTRT)
      J  = IABS(INTEGR)
      IF( J.GE.I ) GO TO 200
      MJ = IP(J)
      JEND = NZC
      M2 =  IA( MJ ) - 1
      IF( MJ.LT.N ) JEND = IA( MJ+1 ) - 1
      K =  J
  120 JSTRT = M2 + 1
      IF( JSTRT.GT.JEND ) GO TO 110
      K = K + 1
      DO 130 M2 =JSTRT,JEND
      INTEGR=LOCA(M2)
      IF( IABS(INTEGR   ).GE.K ) GO TO 140
  130 CONTINUE
      GO TO 110
  140 K = IABS(INTEGR)
      L=K
      DO 150 NDX = ISTRT,IEND
      M3 = NDX
      INTEGR=LOCA(NDX)
      IF( L-IABS(INTEGR   ) ) 160,120,150
  150 CONTINUE
      M3 = M3 + 1
  160 IF( NZC.GE.LIMIT ) GO TO 220
      NZC = NZC + 1
      IF( M3.GE.NZC ) GO TO 190
      IA(M1) = IA(M1) - 1
      DO 170 NDX=M1,N
  170 IA(NDX) = IA(NDX) + 1
      M4 = M3 + 1
      M5 = NZC + 1
      DO 180 NDX=M4,NZC
      M5 = M5 - 1
  180 LOCA( M5 ) = LOCA( M5-1)
  190 LOCA(M3) = +L
      GO TO 115
  200 CONTINUE
      RETURN
 
  220 WRITE (iqqout,225)
  225 FORMAT(52H TABLE CONTAINING SPARSE MATRIX DATA HAS OVERFLOWED.//
     *       29H SIMULATION HAS BEEN DELETED.//)
      STOP 'GROW: sparse matrix table overflow, run aborted'
 
      END
