CSECT   ICCHCK                          71.042  11.43.38
C       7 MAY 73
 
      SUBROUTINE ICCHCK (NTNRPH,NERROR)
 
C     THIS SUBROUTINE WILL MAKE ALL CHECKS ON THE CIRCUIT MATRIX THAT
C       ARE REQUIRED TO AVOID ATTEMPTING TO SOLVE AN INPROPER MATRIX AND
C         SET 'NTNRPH' TO ZERO IF NEWTON-RAPHSON EQUATIONS ARE NOT
C           REQUIRED--B95=B85=B05=B96=B27=0.OR DO NOT EXIST.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'tapes.inc'
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      equivalence (iqtabl(1296),nwords)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))

      COMMON /ELDATA/ EL,NELMTS,NELIMT,ELMNTS(300),XX(300,3),
     .                SRTCOD(300),ICMPFL(2,300),IVLCOD(2,300)
         CHARACTER*8  SRTCOD,ELMNTS
      COMMON /SCNTBL/ NBRANS,NLINKS,LEN,ISTCOD(17),LENCOD(17),MATSUB(25)
         EQUIVALENCE (NCL,MATSUB),(IST,MATSUB(18))
      DIMENSION       NCL(8),IST(8),IE7L(4),IJ8L(4)
      CHARACTER*8     DAND
      CHARACTER*8     CFL
         EQUIVALENCE (ICFL,CFL)
      CHARACTER*8     XMASK
      LOGICAL         LFIRST
 
      DATA            IE7L /1,2,3,5/
      DATA            IJ8L /12,14,15,16/
      DATA            IJPDEP /12/,ILLINK /9/,IRLINK /11/
      DATA            LFIRST /.TRUE./
 
C     DATA XMASK /ZFF00000000000000/
 
      IF (LFIRST) THEN
         LFIRST=.FALSE.
         XMASK(1:1)=CHAR(255)
         XMASK(2:2)=CHAR(  0)
         XMASK(3:3)=CHAR(  0)
         XMASK(4:4)=CHAR(  0)
         XMASK(5:5)=CHAR(  0)
         XMASK(6:6)=CHAR(  0)
         XMASK(7:7)=CHAR(  0)
         XMASK(8:8)=CHAR(  0)
      END IF
 
C     NO CURRENT SOURCE MAY CONNECT A LOOP WITH A CAPACITOR ELEMENT.
 
      NERROR=1
 
C     SEE IF B94, B84 AND B04 ARE ZERO.
 
      IF (NCL(4).EQ.0.OR.NCL(8).EQ.0) GO TO 35
      J1BRNH=IST(4)-1
      JLBRNH=J1BRNH+NCL(4)
      DO 30 J=1,4
      I=IJ8L(J)
      IF (LENCOD(I)) 90,30,11
   11 M1LINK=MATSUB(I)
      MLLINK=M1LINK+NWORDS*LENCOD(I)-1
      DO 25 I=M1LINK,MLLINK,NWORDS
      JELTAB=J1BRNH
   15 JFIRST=JELTAB+1
      IF (ISCNER(MATRIX,NWORDS,MXCODS,I,I,JFIRST,JLBRNH,1,0,IELTAB,
     *           JELTAB,K,K,K)) 20,25,20
 
C     ENTRY FOUND--SET ERROR CODE, WRITE MESSAGE AND CONTINUE SCAN.
 
   20 NERROR=2
      K=IELTAB+NBRANS
CX    WRITE (iqqout,1000) ELMNTS(K),ELMNTS(JELTAB)
      CALL ICRRR(ELMNTS(K),ELMNTS(JELTAB),SRTCOD(K),SRTCOD(JELTAB))
C1000 FORMAT (6H0THE ',A6,39H' ELEMENT COMPLETES A LOOP CONTAINING ',A6,
CX   153H' WHICH WILL PROHIBIT AN INITIAL CONDITIONS SOLUTION.///)
      IF (JELTAB.LT.JLBRNH) GO TO 15
   25 CONTINUE
   30 CONTINUE
 
C     NO INDUCTOR MAY CONNECT A LOOP WITH A VOLTAGE SOURCE
C     SEE IF B37 IS ZERO.
 
   35 IF (NCL(3).EQ.0.OR.NCL(7).EQ.0) GO TO 60
      M1LINK=MATSUB(ILLINK)
      MLLINK=M1LINK+NWORDS*LENCOD(ILLINK)-1
      DO 55 J=1,4
      I=IE7L(J)
      IF (LENCOD(I)) 90,55,36
   36 JELTAB=ISTCOD(I)-1
      JLBRNH=JELTAB+LENCOD(I)
      DO 50 I=M1LINK,MLLINK,NWORDS
   40 JFIRST=JELTAB+1
      IF (ISCNER(MATRIX,NWORDS,MXCODS,I,I,JFIRST,JLBRNH,1,0,IELTAB,
     *           JELTAB,K,K,K)) 45,50,45
   45 NERROR=2
      K=IELTAB+NBRANS
CX    WRITE(iqqout,1000) ELMNTS(K),ELMNTS(JELTAB)
      CALL ICRRR(ELMNTS(K),ELMNTS(JELTAB),SRTCOD(K),SRTCOD(JELTAB))
      IF (JELTAB.LT.JLBRNH) GO TO 40
   50 CONTINUE
   55 CONTINUE
 
C     ALL VARIABLE CAPACITORS AND INDCUTORS MUST BE SCANABLE.
 
   60 DO 70 I=1,6
      IF (I.EQ.2.OR.I.EQ.5.OR.NCL(I).EQ.0) GO TO 70
      M1LINK=IST(I)
      MLLINK=M1LINK+NCL(I)-1
      DO 65 J=M1LINK,MLLINK
      IF (IVLCOD(2,J).EQ.1) GO TO 65
      ICFL=ICMPFL(1,J)
      CFL=DAND(CFL,XMASK)
      IF(ICFL.EQ.0) GO TO 65
      NERROR=2
      WRITE (iqqout,2000) ELMNTS(J)
 2000 FORMAT ('0THE VARIABLE ELEMENT (',A6,') COMPLETES A LOOP',
     .        ' CONTAINING AN ELEMENT OF THE SAME TYPE WHICH',
     .        ' PROHIBITS AN IC SOLUTION'//)
   65 CONTINUE
   70 CONTINUE
 
C     CHECK ANY R, J, E OR P DEPENDENT ON IR, IL OR VC.
 
      CALL VGENR8(I)
      IF (NERROR+I.NE.2) STOP 'ICCHCK: nerror+i .ne. 2, run aborted'
 
C     DETERMINE IF NEWTON-RAPHSON EQUATIONS ARE REQUIRED.
 
      NTNRPH=7

C     B95, B85 AND B05.
 
      IF (NCL(5).EQ.0.OR.NCL(8).EQ.0) GO TO 74
      I1BRNH=IST(5)
      ILBRNH=I1BRNH+NCL(5)-1
      DO 72 J=1,4
      I=IJ8L(J)
      IF (LENCOD(I)) 90,72,71
   71 M1LINK=MATSUB(I)
      MLLINK=M1LINK+NWORDS*LENCOD(I)-1
      IF (ISCNER(MATRIX,NWORDS,MXCODS,M1LINK,MLLINK,I1BRNH,ILBRNH,1,0,
     *           K,K,K,K,K)) 90,72,90
   72 CONTINUE
 
C     B96.
 
   74 IF (LENCOD(IJPDEP).EQ.0.OR.NCL(6).EQ.0) GO TO 76
      I1BRNH=IST(6)
      ILBRNH=I1BRNH+NCL(6)-1
      M1LINK=MATSUB(IJPDEP)
      MLLINK=M1LINK+NWORDS*LENCOD(IJPDEP)-1
      IF (ISCNER(MATRIX,NWORDS,MXCODS,M1LINK,MLLINK,I1BRNH,ILBRNH,1,0,
     *           K,K,K,K,K)) 90,76,90
 
C     B27.
 
   76 IF (NCL(2).EQ.0.OR.NCL(7).EQ.0) GO TO 90
      M1LINK=MATSUB(IRLINK)
      MLLINK=M1LINK+NWORDS*LENCOD(IRLINK)-1
      DO 80 J=1,4
      I=IE7L(J)
      IF (LENCOD(I)) 90,80,77
   77 I1BRNH=ISTCOD(I)
      ILBRNH=I1BRNH+LENCOD(I)-1
      IF (ISCNER(MATRIX,NWORDS,MXCODS,M1LINK,MLLINK,I1BRNH,ILBRNH,1,0,
     *           K,K,K,K,K)) 90,80,90
   80 CONTINUE
      NTNRPH=0

   90 RETURN
 
      END
