CSECT   ICPRS                           71.042  11.43.38
 
      SUBROUTINE ICPRS
 
C      ICPRS READS INITIAL CONDITIONS FROM DEBLANKED BUFFER AND STORES
C      THE NAME AND FLOATING POINT VALUE INTO TABLIC.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
      COMMON /ICCOND/ TBL,NIC,LIC,TABLIC(100,2)
         CHARACTER*8  TABLIC
      COMMON /BUFERS/ SPLTBF(72),BLNKBF(72),PACKBF(12),LSTPRE,LASTCR
         CHARACTER*8  SPLTBF,BLNKBF,PACKBF
      COMMON /MODATA/ ANAMES(3),CKTDES(4),PRJ(62),ANODES(25,2),NMDNOD,
     1 MDPRNT,SUPRES(10),EQUCHG(15,2),TBLCHG(15,2),NTBLCH,NEQUCH,NSUPRS,
     2 MDTAPE,MDLEN,MDUSED,IALL,KCHNGE,NTEMP,NMDCHR
         CHARACTER*8  CKTDES
      COMMON /TBLES/  TABLE(200)
         DIMENSION    ITABLE(400)
         EQUIVALENCE (TABLE,ITABLE)
         CHARACTER*8  TABLE
      CHARACTER*8     XICPRS
      CHARACTER*8     EQUSGN
      CHARACTER*8     CHARI
      CHARACTER*8     CHARV
      CHARACTER*8     SUFFIX,PKNAME
 
      DATA             XICPRS /'ICPRS'/
      DATA             EQUSGN /'='/
      DATA             CHARI /'I'/
      DATA             CHARV /'V'/
      DATA             MAXCRL /6 /
 
  120 KSKIP = 0
 
C     CHECK FIRST CHARACTER FOR 'V' OR 'I'
 
      IF (BLNKBF(LSTPRE) .EQ. CHARV .OR. BLNKBF(LSTPRE) .EQ. CHARI)
     *    GO TO 180
 
C     INITIAL CONDITION LACKS A 'V' OR 'I' PREFIX
 
      KERROR=1
      GO TO 890
  180 IF(ICSCAN(BLNKBF,LSTPRE,LASTCR,EQUSGN,IEQUAL).GT.0) GO TO 190
 
C     EQUAL SIGN MISSING
 
      KERROR=2
      GO TO 890
 
C     PEEL OUT I.C. NAME AND CHECK LENGTH  (FROM BLNKBF)  TO = SIGN
 
  190 NAMLNT = IEQUAL - LSTPRE
      IF(NAMLNT+NMDCHR.LE.MAXCRL)GO TO 250
 
C     VARIABLE NAME EXCEEDS SIX CHARACTERS
 
      KERROR=3
      GO TO 890
  250 CALL CPYSP(BLNKBF(LSTPRE),NAMLNT,CKTDES,NMDCHR,SUFFIX,0,PKNAME,
     1           NAMELT)
 
C     SEARCH INITIAL CONDITIONS TABLE TO SEE IF NAME IS ALREADY PRESENT
 
      IF(NIC.EQ.0)GO TO 351
      DO 350 I = 1,NIC
      IF(TABLIC(I,1).NE.PKNAME) GO TO 350
      IF ( NMDCHR.EQ.0 ) GO TO 300
      KSKIP = 1
      CALL ERROR ( XICPRS, 1, 76 )
 
C     NO ERROR MESSAGE NO. 76 YET   ?????
 
      GO TO 351
 
C     REDUNDANT VOLTAGE OR CURRENT SPECIFICATION
 
  300 KERROR=4
      GO TO 890
  350 CONTINUE
  351 IBEGIN=1
      LSTPRE=IEQUAL+1
      IF(LSTPRE.LE.LASTCR) GO TO 355
 
C     NO VALUE SPECIFICATION FOLLOWS EQUALS
 
      KERROR=5
      GO TO 890
 
C     ENTER VALUE PROCESSOR TO EXTRACT IC VALUE
 
  355 CALL VLUPRS ( IBEGIN, 200, IDUMMY, IERROR )
      IF((IERROR.EQ.1).AND.(IBEGIN.EQ.3).AND.(ITABLE(2).EQ.1)) GO TO 125
 
C     INCORRECT VALUE SPECIFICATION
 
      KERROR=6
      GO TO 890
 
C     IS THERE ROOM IN I.C. TABLE
 
  125 IF(NIC.LT.LIC) GO TO 500
 
C     MORE THAN FIFTY INITIAL CONDITIONS HAVE BEEN SPECIFIED
 
      KERROR=7
      GO TO 890
  500 IF ( KSKIP.NE.0 ) GO TO 510
      NIC = NIC + 1
      TABLIC(NIC,1) = PKNAME
      TABLIC(NIC,2) = TABLE(2)
  510 LSTPRE=LSTPRE+1
      IF (LSTPRE .LT. LASTCR ) GO TO 120
      GO TO 1000
  890 CALL ERROR ( XICPRS,2,KERROR)
 1000 RETURN
 
      END
