CSECT   ICRRR
 
      SUBROUTINE ICRRR(EL1,EL2,CNEL1,CNEL2)
 
C     SUBROUTINE TO DETERMINE IF ADJOINT SOURCE IS CAUSING TROUBLE
C     ARGUMENT LIST
C     'EL1' AND 'EL2' ARE ELEMENTS CAUSING PROBLEM
C     'NEL1' AND 'NEL2' ARE ORIGIONAL INDICIES OF 'EL1' AND 'EL2'
C     (HIGH ORDER BYTES OF 'SRTCOD')
 
      IMPLICIT DOUBLE PRECISION (A-H,J,O-Z)
 
	include 'tapes.inc'

      CHARACTER*8     EL1,EL2,CNEL1,CNEL2
      COMMON /SENS/   ASNS,NSENS,NSRS,LINDV,LSENS,SENS(4,100),
     .                ISRS(2,100)
         DIMENSION    ISENS(8,1)
         EQUIVALENCE (ISENS(1,1),SENS(1,1))
         CHARACTER*8  SENS
      COMMON /CNTRLS/ CTRL(139),AJRQST
      CHARACTER*8     ESRCE,JSRCE,DANDJ,DANDE
 
      DATA            ESRCE,JSRCE /'E$A     ','J$A     '/
 
      READ(CNEL1,'(I4,4X)') NEL1
      READ(CNEL2,'(I4,4X)') NEL2
 
C     IS THERE ADJOINT DATA
 
   10 IF(AJRQST.EQ.0.D0) GO TO 500
 
C     MASK OFF FIRST THREE CHARACTERS AND SEE IF 'J$A' OR 'E$A'
 
      DANDJ=EL1(1:3)
      DANDE=EL2(1:3)
      IF(DANDJ.NE.JSRCE.AND.DANDE.NE.ESRCE) GO TO 500
 
C     THIS IS AN ADJOINT SOURCE CAUSING TROUBLE
 
      IPR=0
 
C     FIND DEPENDENT VARIABLE THAT CAUSED ADJOINT SOURCE TO BE INSERTED
 
      DO 200 I=1,NSENS
      I1=ISENS(5,I)
      I2=I1+ISENS(6,I)-1
      DO 160 II=I1,I2
 
C     'IK' IS ORIGIONAL SEQUENCE NUMBER OF ADJOINT SOURCE
 
      IK=ISRS(1,II)
      IF(IK.NE.NEL1.AND.IK.NE.NEL2) GO TO 160
      IPR=1
      WRITE (iqqout,5000) SENS(1,I)
  160 CONTINUE
  200 CONTINUE
      IF(IPR.NE.0) GO TO 800
 
C     WRITE ORIGIONAL SCEPTRE ERROR MESSAGE
 
  500 WRITE (iqqout,5100) EL1,EL2
  800 RETURN
 
 5000 FORMAT('0THE ADJOINT DEPENDENT VARIABLE ''',A6,''' IS CAUSING',
     .       ' A CAPACITOR-CURRENT SOURCE CUT SET OR AN INDUCTOR-',
     .       'VOLTAGE SOURCE LOOP'/'0SIMULATION WILL BE DELETED.'///)
 5100 FORMAT('0THE ''',A6,''' ELEMENT COMPLETES A LOOP CONTAINING ''',
     .        A6,''' WHICH WILL PROHIBIT AN INITIAL CONTITIONS ',
     .       'SOLUTION.'///)
 
      END
