CSECT   ICTEQS                          72.110  00.39.08
 
       SUBROUTINE ICTEQS
 
C      PROGRAM TO GENERATE EQUATIONS TO CONVERT INITIAL CONDITIONS TO
C           TRANSIENT STATE VARIABLE INITIAL CONDITIONS.
C       J. SENTS   7/20/66
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'
	include 'tables.inc'
                      equivalence (iqtabl(1296),nwords)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(2797),ndep)
                      character*8  vecelm(300)
                      equivalence (tablst(1601),vecelm(1))

      COMMON /ELDATA/ ELM,NEL,LEL,ELNAME(300),XX(1200),CMPFLG(300),
     *                VALCOD(300),VALLO(300),VALHI(300),LIMSW
         CHARACTER*8  ELNAME,CMPFLG
      COMMON /SCNTBL/ NBRAN,NLINK,NSRTCD,NSTCLS(17),LNCLS(17),NCLN(8),
     *                NBST(9),NS(8),NSCN(6),NB14,NB25,NB36
         EQUIVALENCE  (NS(2),NS2),(NS(3),NS3),(NS(4),NS4),(NS(5),NS5),
     *                (NS(6),NS6),(NS(7),NS7),(NS(8),NS8),(NS(1),NS1)
      COMMON /BUFERS/ BUFF,BUFFER(220)
         CHARACTER*4  BUFFER
      COMMON /CNTRLS/ A(33),ITRQST
         DOUBLE PRECISION ITRQST
      COMMON /NCL25/  NCL2C,NCL5C
      COMMON /ICDEPD/ DEPEND
      CHARACTER*8     IFLAG,DOR,PRFX
      CHARACTER*4     BRAKTS(2),EQXI3(2),EQXV4(2),EQX(4),YI3IC(2),
     *                YV4IC(2)
         EQUIVALENCE (XV4IC,YV4IC(1)),(XI3IC,YI3IC(1))
         EQUIVALENCE (EQX(1),EQXI3(1)),(EQX(3),EQXV4(1))
      DIMENSION       ELMTAB(300,9),SCNDAT(90)
         EQUIVALENCE (ELMTAB(1,1),ELNAME(1)),(SCNDAT(1),NBRAN)
      DIMENSION       NCD(6),XM(2)
         CHARACTER*8  XM
         EQUIVALENCE (ND1,NCD(1)),(ND3,NCD(3)),(ND4,NCD(4)),
     *               (ND6,NCD(6)),(ND2,NCD(2)),(ND5,NCD(5))
         EQUIVALENCE (XM(1),XMLIC),(XM(2),XMCIC)
      CHARACTER*8     ICFLAG
      CHARACTER*8     IVFLAG
      INTEGER         STLOC,SIGN
      INTEGER         ZERO
      CHARACTER*4     XIBCD
      LOGICAL         LFIRST
      CHARACTER*8
     *   BLANK,
     *   IPRFX,
     *   VPRFX,
     *   EQUAL,
     *   ASTRSK,
     *   RTPEQ,
     *   ASTLP,
     *   XI3IC,
     *   XMLIC,
     *   XV4IC,
     *   XMCIC,
     *   S8200,
     *   S1156,
     *   S1158
 
      DATA
     *   BLANK   /' '/,
     *   IPRFX   /'I'/,
     *   VPRFX   /'V'/,
     *   EQUAL   /'='/,
     *   ASTRSK  /'*'/,
     *   RTPEQ   /')='/,
     *   ASTLP   /'*('/,
     *   XI3IC   /'XI3IC'/,
     *   XMLIC   /'XMLIC'/,
     *   XV4IC   /'XV4IC'/,
     *   XMCIC   /'XMCIC'/,
     *   S8200   /' 8200'/,
     *   S1156   /' 1156'/,
     *   S1158   /' 1158'/
      DATA
     *   EQXI3   /'=XI3','IC'/,
     *   EQXV4   /'=XV4','IC'/,
     *   BRAKTS  /'(   ',')='/
      DATA       ZERO /0/
      DATA LFIRST /.TRUE./
 
      IF (LFIRST) THEN
         LFIRST=.FALSE.
         DO 1 I=1,8
            ICFLAG(I:I)=CHAR(0)
            IVFLAG(I:I)=CHAR(0)
    1    CONTINUE
         ICFLAG(5:5)=CHAR(15)
         IVFLAG(4:4)=CHAR(15)
      END IF
 
      DO 25 N=1,6
   25 NCD(N)=NS(N)+NCLN(N)-1
      IS1516=NSTCLS(15)
      IF (LNCLS(15).EQ.0) IS1516=NSTCLS(16)
 
C      GENERATE RESISTOR CURRENT EQUATIONS IF ANY.
 
      IF(nint(DEPEND).NE.0) GO TO 35
      IF (NCLN(2)) 26,28,26
   26 DO 27 N=NS2,ND2
   27 CMPFLG(N)=DOR(CMPFLG(N),ICFLAG)
   28 IF (NCLN(5)) 31,33,31
   31 DO 30 N=NS5,ND5
   30 CMPFLG(N)=DOR(CMPFLG(N),ICFLAG)
   33 IF (NCL2C   .EQ. 0) GO TO 29
      CALL WTSPTP(BLANK,'DO 1156 N=1,NCL2C',17,N)
      CALL WTSPTP(S1156,'I2(N)=V2(N)/XR22D(N)',20,N)
   29 IF (NCL5C   .EQ. 0) GO TO 35
      CALL WTSPTP(BLANK,'DO 1158 N=1,NCL5C',17,N)
      CALL WTSPTP(S1158,'I5(N)=V5(N)/XR55D(N)',20,N)
   35 IF(NB36 .EQ. 0) GO TO 110
      CALL DIMENS(XMLIC,0,NCLN(3))
      CALL DIMENS(XI3IC,1,NCLN(3))
 
C     XMLIC=L33D+B36*L66D*B36T
 
      CALL WTMXEQ(NS3,NCLN(3),NS6,NCLN(6),0,0,XMLIC,0,NX)
 
C     XI3IC=L33D*I3(0)-B36*L66D(I6(0)+B26T*I2+B96T*J9+(B86T*J8+B06T*J0)
 
      DO 36 J=1,2
      BUFFER(J)=YI3IC(J)
   36 BUFFER(J+2)=BRAKTS(J)
      DO 50 N3=NS3,ND3
      NDEP=0
      STLOC=10
      CALL CPY(XIBCD(N3-NS3+1,3,1,NX),1,BUFFER,STLOC,3)
      STLOC=15
      CALL CPYDP
     *   (0,BLANK,ELNAME,N3,ASTRSK,ZERO,CMPFLG,BUFFER,STLOC,N,NX)
      CALL COPY(0,IPRFX,ELNAME(N3),BLANK,BUFFER,STLOC,NCH)
      DO 40 N6=NS6,ND6
      IF(LBITS(MATRIX,N3-NBRAN,N6,NBRAN,SIGN) .EQ. 0) GO TO 40
      CALL CPYDP
     * (-SIGN,BLANK,ELNAME,N6,BLANK,ZERO,CMPFLG,BUFFER,STLOC,NCH,NX)
      CALL CPY(ASTLP,1,BUFFER,STLOC,2)
      CALL COPY(+1,IPRFX,ELNAME(N6),BLANK,BUFFER,STLOC,NCH)
 
C     SCAN FOR B26T*I2+B96T*J9+(B86T*J8+B06T*J0)
 
      CALL BV4SCN
     * (+1,IPRFX,N6,1,STLOC,NCH,NS2,NCLN(2),NSTCLS(12),LNCLS(12),
     *  IS1516,LNCLS(15)+LNCLS(16),0,0,NX)
      CALL CPY(RTPEQ,1,BUFFER,STLOC,1)
   40 CONTINUE
   50 CALL WTEQTN(BLANK,0,BUFFER,STLOC-1,BLANK,NX)
      NCL=3
      NCLL=3
   55 CALL GN8INV(XM(NCL-2),5,1,NCLN(NCL))
 
C     LOAD INDUCTOR LINK CURRENTS FROM XI3IC VECTOR.
 
      DO 56 K=1,3
   56 BUFFER(K)=BLANK
      DO 57 J=4,5
      BUFFER(J)=EQX(NCLL+J-6)
   57 BUFFER(J+2)=BRAKTS(J-3)
      NDEP=0
      NST=NS(NCL)
      ND=NST+NCLN(NCL)-1
      IFLAG=ICFLAG
      IF (NCL.EQ.4) IFLAG=IVFLAG
      DO 60 NN=NST,ND
      STLOC=1
      PRFX=VPRFX
      IF(NCL .EQ. 3) PRFX=IPRFX
      CALL COPY(0,PRFX,ELNAME(NN),BLANK,BUFFER,STLOC,NCH)
      STLOC=22
      CALL CPY(XIBCD(NN-NST+1,3,1,NX),1,BUFFER,STLOC,3)
      CMPFLG(NN)=DOR(CMPFLG(NN),IFLAG)
   60 CALL WTEQTN(BLANK,0,BUFFER,25,BLANK,NX)
      IF(NCL .EQ. 4) GO TO 200
  110 IF(NCLN(6) .EQ. 0) GO TO 150
 
C     I6=B26T*I2+B36T*I3+B96T*J9+(B86T*J8+B06T*J0)
 
      DO 130 N6=NS6,ND6
      NDEP=0
      STLOC=1
      CALL COPY(0,IPRFX,ELNAME(N6),EQUAL,BUFFER,STLOC,NCH)
      CALL BV4SCN
     * (+1,IPRFX,N6,1,STLOC,NCH,NS2,NCLN(2),NS3,NCLN(3),NSTCLS(12),
     *  LNCLS(12),IS1516    ,LNCLS(15)+LNCLS(16),NX)
      IF (NCH .EQ. 0) CALL CPY('0.',1,BUFFER,STLOC,2)
  130 CALL WTEQTN('I'//ELNAME(N6)(1:5),6,BUFFER,STLOC-1,BLANK,NX)
  150 IF(NB14 .EQ. 0) GO TO 200
      CALL DIMENS(XMCIC,0,NCLN(4))
      CALL DIMENS(XV4IC,1,NCLN(4))
 
C     XMCIC=C44D+B14T*C11D*B14
 
      CALL WTMXEQ(NS4,NCLN(4),NS1,NCLN(1),1,0,XMCIC,0,NX)
 
C     XV4IC=C44D*V4(0)-B14T*C11D(V1(0)+B15*V5+B17*E7)
 
      DO 155 J=1,2
      BUFFER(J)=YV4IC(J)
  155 BUFFER(J+2)=BRAKTS(J)
      DO 180 N4=NS4,ND4
      NDEP=0
      STLOC=10
      CALL CPY(XIBCD(N4-NS4+1,3,1,NX),1,BUFFER,STLOC,3)
      STLOC=15
      CALL CPYDP
     *  (0,BLANK,ELNAME,N4,ASTRSK,ZERO,CMPFLG,BUFFER,STLOC,NCH,NX)
      CALL COPY(0,VPRFX,ELNAME(N4),BLANK,BUFFER,STLOC,NCH)
      DO 160 N1=NS1,ND1
      IF(LBITS(MATRIX,N1-NBRAN,N4,NBRAN,SIGN) .EQ. 0) GO TO 160
      CALL CPYDP
     *   (-SIGN,BLANK,ELNAME,N1,BLANK,ZERO,CMPFLG,BUFFER,STLOC,NCH,NX)
      CALL CPY(ASTLP,1,BUFFER,STLOC,2)
      CALL COPY(+1,VPRFX,ELNAME(N1),BLANK,BUFFER,STLOC,NCH)
 
C     SCAN FOR B15*V5+B17*E7
 
      CALL BV4SCN
     *  (+1,VPRFX,N1,0,STLOC,NCH,NS5,NCLN(5),NS7,NCLN(7),0,0,0,0,NX)
      CALL CPY(RTPEQ,1,BUFFER,STLOC,1)
  160 CONTINUE
  180 CALL WTEQTN(BLANK,0,BUFFER,STLOC-1,BLANK,NX)
      NCL=4
      NCLL=5
 
C     GENERATE CALL TO INVERS AND LOAD CAPACITOR VOLTAGES FROM XV4IC.
 
      GO TO 55
  200 IF(NCLN(1) .EQ. 0) GO TO 250
      DO 220 N1=NS1,ND1
      NDEP=0
      STLOC=1
      CALL COPY(0,VPRFX,ELNAME(N1),EQUAL,BUFFER,STLOC,NCH)
      CALL BV4SCN
     * (-1,VPRFX,N1,0,STLOC,NCH,NS4,NCLN(4),NS5,NCLN(5),NS7,
     *  NCLN(7),0,0,NX)
      IF(NCH .EQ. 0) CALL CPY('0.',1,BUFFER,STLOC,2)
  220 CALL WTEQTN('V'//ELNAME(N1)(1:5),7,BUFFER,STLOC-1,BLANK,NX)
 
C     PUT OUT SYSTEM FUNCTIONS REQUIRED FOR DC OPTIONS
 
      CALL WRTADJ
  250 CALL WTSPTP(BLANK,
     * 'CALL OUTIC(NCL4C,SVVOLT,V4,NCL3C,SVCRNT,I3,NDPD,SVPRAM,PRAMTR)',
     * 62,N)
      IF (nint(ITRQST).NE.0) GO TO 950
      CALL WTSPTP
     * (BLANK,'CALL XLOAD(V1IC,V1ICT,V1,NCL1C,I3IC,I3ICT,I3,NCL3C,'//
     * 'V4IC,V4ICT,V4,NCL4C,I6IC,I6ICT,I6,NCL6C,XPIC,XPICT,PRAMTR,'//
     * 'NDPD,1,NWAY)',121,N)
      GO TO 970
  950 CALL WTSPTP(BLANK,
     * 'CALL XSAVDC(V2IC,V2,NCL2C,V5IC,V5,NCL5C,V8IC,V8,NCL8C,1)',56,N)
  970 CALL WTSPTP(S8200,'CONTINUE',8,N)
 
C     RESTORE THE TRANSIENT DATA.
 
      IF (nint(ITRQST).NE.0) RETURN
C     READ (iqqutb,999)
      READ (iqqbin)
     *     NEL,
     *   ((ELMTAB(ND,NX),ND=1,NEL),NX=1,9),
     *    (SCNDAT(ND),ND=1,90),
     *     nwords,NN,
     *    (MATRIX(ND),ND=1,NN),
     *    (VECELM(ND),ND=1,NEL)
C 999 FORMAT(5Z16)
      RETURN
 
      END
