CSECT   IEQUTN                          71.042  11.43.38
 
      SUBROUTINE IEQUTN (NICSV,NERROR)
 
C     SUBROUTINE TO GENERATE AND WRITE ALL EQUATIONS REQUIRED TO SET UP
C       THE A+C(Y(N)) AND Q(Y(N))+S MATRICIES.  THE B55, B25 AND B52,
C         AND B27 SCANS WILL BE DONE IN THIS SUBROUTINE.  IEQUNJ WILL
C           BE CALLED FROM THIS SUBROUTINE TO GENERATE THE EQUATIONS
C             INVOLVING ANY CURRENT SOURCE.
C
C     ERROR CODE ON CAUSED BY LOWER-LEVEL SUBROUTINE(S).
C
C     IEQUTN SUBROUTINE    JERRY PATTERSON    5/13/66
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      equivalence (iqtabl(1296),nwords)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(2797),ndep)
                      equivalence (iqtabl(3200),nmax)

      COMMON /ELDATA/ EL,NELMTS,NELIMT,ELMNTS(300),XX(300,4),VALCOD(300)
         CHARACTER*8  ELMNTS,VALCOD
      COMMON /SCNTBL/ NBRANS,NLINKS,LEN,ISTCOD(17),LENCOD(17),MATSUB(25)
         DIMENSION    NCL(8),IST(8)
         EQUIVALENCE (NCL(1),MATSUB(1)),(IST(1),MATSUB(18))
      COMMON /BUFERS/ BUFF,BUFFER(101)
         CHARACTER*4  BUFFER
      COMMON /CNTRLS/ SKIP(139),AJRQST
      CHARACTER*4     BUFFSP(100)
         EQUIVALENCE (BUFFER(101),BUFFSP(1))
      DIMENSION       IE7L(4),LINK(2)
         EQUIVALENCE (LINK(1),IRLKL)
      CHARACTER*8     PT1 ,BLANK ,COMENT ,SLASH
      CHARACTER*4     XIBCD
      CHARACTER*8     S5
 
      DATA            PT1 /'1.'/,BLANK /' '/,COMENT /'C'/,SLASH /'/'/
      DATA            IE7L /1,2,3,5/
      DATA            LINK /11,12/
 
C       SKELETON OF A SOLUTION VECTOR IN BUFFSP.
 
   10 ITOCHR=1
      CALL CPY('A(DDD,DDD)=1./',1,BUFFER,ITOCHR,14)
      ITOCHR=1
      CALL CPY('A(DDD,NICSV1)=A(DDD,NICSV1)',1,BUFFSP,ITOCHR,27)
      NAMAT=1
 
C     RECIPROCATE CLASS 5 RESISTORS IF ANY.
 
      IF (NCL(5)) 90,50,15
   15 CALL WTSPTP(COMENT,'STORE THE RECIPROCAL OF EACH BRANCH'//
     .            ' RESISTOR ON DIAGONAL OF A55',63,JAB)
 
C     COMPUTE BOUNDARIES OF CLASS 5 IN ELEMENTS TABLE.
 
      I1RBR=IST(5)
      ILRBR=I1RBR+NCL(5)-1
 
C      COPY DIAGONAL SUBSCRIPTS
C      ARE THERE ANY DEPENDENCIES
 
   19 DO 20 I=I1RBR,ILRBR
 
C     COPY DIAGONAL SUBSCRIPTS.
 
      ITOCHR=3
      CALL CPY(XIBCD(NAMAT,3,1,JAB),1,BUFFER,ITOCHR,3)
      CALL CPY(BUFFER,3,BUFFER,ITOCHR+1,3)
 
C     RESOLVE DEPENDENCIES AND WRITE EQUATION(S).
 
      NDEP=0
      ITOCHR=15
      CALL CPYDP
     . (0,BLANK,ELMNTS,I,BLANK,0,VALCOD,BUFFER,ITOCHR,IMAT,JAB)
      CALL WTEQTN(BLANK,0,BUFFER,ITOCHR-1,BLANK,JAB)
   20 NAMAT=NAMAT+1
   22 IF(NCL(2)) 90,50,25
 
C     GENERATE EQUATIONS FOR A25 AND A52.
 
   25 CALL WTSPTP(COMENT,'A25=B25 AND A52=-B25T*G22',25,JAB)
 
C     COMPUTE SUBSCRIPT BOUNDARIES IN MATRIX.
 
      M1LINK=MATSUB(IRLKL)
      MLLINK=M1LINK+NWORDS*LENCOD(IRLKL)-1
      DO 40 I=M1LINK,MLLINK,NWORDS
      JELTAB=I1RBR
   30 JFIRST=JELTAB
      IF (ISCNER(MATRIX,NWORDS,MXCODS,I,I,JFIRST,ILRBR,1,0,IELTAB,
     *           JELTAB,IMAT,JMAT,KSIGN)) 90,40,35
 
C     COMPUTE SUBSCRIPTS OF ENTRY AND WRITE STATEMENT.
 
   35 ITOCHR=3
      S5=XIBCD(NAMAT,3,1,JAB)
      CALL CPY(S5,1,BUFFER,ITOCHR,3)
      JELTAB=JELTAB+1
      CALL CPY(XIBCD(JELTAB-I1RBR,3,1,JAB),1,BUFFER,ITOCHR+1,3)
      ITOCHR=12
      CALL COPY(KSIGN,BLANK,PT1,BLANK,BUFFER,ITOCHR,IMAT)
      CALL WTSPTP(BLANK,BUFFER,ITOCHR-1,JAB)
 
C     REVERSE SUBSCRIPTS, CHANGE SIGN AND LOAD CLASS 2 RESISTOR.
 
      ITOCHR=3
      CALL CPY(BUFFER(1),7,BUFFER,ITOCHR,3)
      CALL CPY(S5,1,BUFFER,ITOCHR+1,3)
      ITOCHR=12
      CALL COPY(-KSIGN,BLANK,PT1,SLASH,BUFFER,ITOCHR,IMAT)
      NDEP=0
      IELTAB=IELTAB+NBRANS
      CALL CPYDP
     . (0,BLANK,ELMNTS,IELTAB,BLANK,0,VALCOD,BUFFER,ITOCHR,IMAT,JAB)
      CALL WTEQTN(BLANK,0,BUFFER,ITOCHR-1,BLANK,JAB)
 
C     CONTINUE WITH THIS ROW IF NECESSARY WITH INCREMENTED COLUMN.
 
      IF (JELTAB-ILRBR) 30,30,40
   40 NAMAT=NAMAT+1
   50 IF(NMAX.LT.NELMTS ) CALL WTSPTP(COMENT,'KEY2',4,JAB)
      IF(NCL(5))90,55,51
 
C     GENERATE EQUATIONS PERTAINING TO CURRENT SOURCES IF NECESSARY.
 
   51 IF (NCL(8).GT.0) CALL IJEQTN(I1RBR,ILRBR,NAMAT,JAB)
 
C     UPDATE SOLUTION VECTORS OF LINK RESISTORS AND PRIMARY DEPENDENT
C       CURRENT SOURCES WITH ANY SOURCE VOLTAGES IN THEIR LOOPS.
 
   55 IF (NCL(7)) 90,85,56
   56 NAMAT=NCL(5)+1
      CALL WTSPTP(COMENT,'AV2=-B27*E7 AND AV9=-B97*E7',27,JAB)
      DO 80 J=1,2
      I=LINK(J)
      IF (LENCOD(I)) 90,80,58
   58 M1LINK=MATSUB(I)
      MLLINK=M1LINK+NWORDS*LENCOD(I)-1
 
C     SCAN CLASS 2 OR 9 ROWS.
 
      DO 75 I=M1LINK,MLLINK,NWORDS
 
C     SCAN ROW FOR EACH VOLTAGE SOURCE CODE.
 
      DO 70 M=1,4
      JMAT=IE7L(M)
      IF (LENCOD(JMAT)) 90,70,60
   60 JELTAB=ISTCOD(JMAT)-1
      JLAST=JELTAB+LENCOD(JMAT)
   65 JFIRST=JELTAB+1
      IF (ISCNER(MATRIX,NWORDS,MXCODS,I,I,JFIRST,JLAST,1,0,IELTAB,
     *           JELTAB,IMAT,JMAT,KSIGN)) 90,70,66
 
C     ENTRY FOUND.
 
   66 ITOCHR=3
      CALL CPY(XIBCD(NAMAT,3,1,JAB),1,BUFFSP,ITOCHR,3)
      CALL CPY(BUFFSP,3,BUFFSP,ITOCHR+11,3)
      ITOCHR=28
      NDEP=0
      CALL CPYDP(-KSIGN,BLANK,ELMNTS,JELTAB,BLANK,0,VALCOD,BUFFSP,
     *           ITOCHR,IMAT,JAB)
      CALL WTEQTN(BLANK,0,BUFFSP,ITOCHR-1,BLANK,JAB)
 
C     CONTINUE SCAN IF NOT LAST COLUMN OF CODE
 
      IF (JELTAB-JLAST) 65,70,70
   70 CONTINUE
   75 NAMAT=NAMAT+1
   80 CONTINUE
   85 CALL ISOLVE(NICSV,JAB)
   90 NERROR=JAB
      IF(AJRQST .EQ. 0.D0) RETURN
      LENCOD(3)=LENCOD(16)
      NCL(7)=NCL(7)+LENCOD(3)
      RETURN
 
      END
