CSECT   IJEQTN                          71.042  11.43.38
 
      SUBROUTINE IJEQTN (I1RBRL,ILRBRL,NAMATX,NERROR)
 
C     SUBROUTINE TO WRITE ALL INITIAL CONDITION EQUATIONS WITH CURRENT
C       SOURCES IN THE MATRIX OF COEFFICIENTS AND SOLUTION VECTOR FOR
C         CLASS 5.
C
C     NERROR NOT EQUAL TO ONE IMPLIES ERROR IN LOWER-LEVEL, UTILITY
C       SUBROUTINE (EXCEPT--NERROR = 10).
C
C     NERROR = 10 IF CLASS 9 ELEMENT THAT CLASS 0 SOURCE IS DEPENDENT
C       UPON ACCORDING TO VALUE LIST IS NOT IN ELEMENTS TABLE.
C
C     IJEQTN SUBROUTINE
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'
	include 'values.inc'
                      character*8  valist
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      equivalence (iqtabl(1296),nwords)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(2797),ndep)

      COMMON /ELDATA/ EL,NELMTS,NELIMT,ELMNTS(300),XX(300,4),VALCOD(300)
         CHARACTER*8  ELMNTS,VALCOD
      COMMON /SCNTBL/ NBRANS,NLINKS,LEN,ISTCOD(17),LENCOD(17),MATSUB(25)
      COMMON /BUFERS/ BUFF,BUFFER(101)
         CHARACTER*4  BUFFER,BUFFSP
         DIMENSION    BUFFSP(100)
         EQUIVALENCE (BUFFER(101),BUFFSP)
      COMMON /CNTRLS/ SKIP(139),AJRQST
      DIMENSION       JCODL(4)
         EQUIVALENCE (JCODL(1),JPDEPL),(JCODL(2),JRDEPL),
     *               (JCODL(3),JINDPL),(JCODL(4),JSDEPL)
      CHARACTER*8     BLANK ,COMENT ,G ,B ,ONE
      CHARACTER*8     XIBCD*4,S9
 
      DATA            BLANK /' '/,COMENT /'C'/,G /'G'/,
     *                B /'B'/,ONE /'1.'/
      DATA            JCODL /12,14,15,16/
 
      NAMAT=NAMATX
      I1RBR=I1RBRL
      ILRBR=ILRBRL
 
C     B95 FOR B95T*Q99 AND -B95T*G99.
 
      IF (LENCOD(JPDEPL)) 90,35,15
 
C     GET SUBSCRIPT BOUNDARIES FOR CLASS 9.
 
   15 M1LINK=MATSUB(JPDEPL)
      MLLINK=MATSUB(JPDEPL)+NWORDS*LENCOD(JPDEPL)-1
      CALL WTSPTP(COMENT,'SCAN B95 FOR B95T*Q99 AND -B95T*G99',35,JAB)
      DO 30 I=M1LINK,MLLINK,NWORDS
      JELTAB=I1RBR
   20 JFIRST=JELTAB
      IF (ISCNER(MATRIX,NWORDS,MXCODS,I,I,JFIRST,ILRBR,1,0,IELTAB,
     *    JELTAB,IMAT,JMAT,KSIGN)) 90,30,25
 
C     COMPUTE SUBSCRIPTS OF ENTRY AND WRITE B95T*Q99 EQUATION.
 
   25 ITOCHR=3
      S9=XIBCD(NAMAT,3,1,JAB)
      CALL CPY(S9,1,BUFFER,ITOCHR,3)
      JELTAB=JELTAB+1
      CALL CPY(XIBCD(JELTAB-I1RBR,3,1,JAB),1,BUFFER,ITOCHR+1,3)
      ITOCHR=12
      CALL COPY(KSIGN,BLANK,ONE,BLANK,BUFFER,ITOCHR,IMAT)
      CALL WTSPTP(BLANK,BUFFER,ITOCHR-1,JAB)
 
C     REVERSE SUBSCRIPTS, CHANGE SIGN AND LOAD NAME OF SOURCE.
 
      ITOCHR=3
      CALL CPY(BUFFER,7,BUFFER,ITOCHR,3)
      CALL CPY(S9,1,BUFFER,ITOCHR+1,3)
      ITOCHR=12
      NDEP=0
      IELTAB=IELTAB+NBRANS
      CALL CPYDP(-KSIGN,G,ELMNTS,IELTAB,BLANK,0,VALCOD,BUFFER,ITOCHR,
     *           IMAT,JAB)
      CALL WTEQTN(BLANK,0,BUFFER,ITOCHR-1,BLANK,JAB)
 
C     UPDATE SOLUTION VECTOR WITH BTERM.
 
      ITOCHR=3
      CALL CPY(BUFFER,3,BUFFSP,ITOCHR,3)
      CALL CPY(BUFFER,3,BUFFSP,ITOCHR+11,3)
      ITOCHR=28
      CALL COPY(KSIGN,B,ELMNTS(IELTAB),BLANK,BUFFSP,ITOCHR,IMAT)
      CALL WTSPTP(BLANK,BUFFSP,ITOCHR-1,JAB)
 
C     CONTINUE IN ROW IF NECESSARY.
 
      IF (JELTAB-ILRBR) 20,20,30
   30 NAMAT=NAMAT+1
 
C     EQUATIONS FOR SECONDARY DEPENDENT SOURCES.
 
   35 IF (LENCOD(JSDEPL)) 90,65,40
   40 CALL WTSPTP(COMENT,'COMPLETION OF A59 FOR B05T*ALPHA*G99',36,JAB)
      IF (nint(AJRQST) .NE. 0) CALL WTSPTP(BLANK,
     *   ' IF(XADJNT.NE.0.D0)GO TO 8055',29,JAB)
      M1LINK=MATSUB(JSDEPL)
      MLLINK=M1LINK+NWORDS*LENCOD(JSDEPL)-1
      I1JEL9=ISTCOD(JPDEPL)
      ILJEL9=I1JEL9+LENCOD(JPDEPL)-1
 
C     RESET SKELETON INFORMATION IN BUFFER.
 
      ITOCHR=12
      CALL CPY(BUFFER,1,BUFFER,ITOCHR,10)
      DO 60 I=M1LINK,MLLINK,NWORDS
      JELTAB=I1RBR
   45 JFIRST=JELTAB
      IF (ISCNER(MATRIX,NWORDS,MXCODS,I,I,JFIRST,ILRBR,1,0,IELTAB,
     *    JELTAB,IMAT,JMAT,KSIGN)) 90,60,50
   50 IELTAB=IELTAB+NBRANS
      JELTAB=JELTAB+1
 
C     FIND SUBSCRIPT OF JP THIS JS IS DEPENDENT UPON IF NECESSARY.
 
      IF (JFIRST.GT.I1RBR) GO TO 55
      CALL FIND(VALIST,ELMNTS(IELTAB),IMAT,JMAT,J)
 
C     SEARCH ELEMENTS TABLE FOR LOCATION OF THIS JP.
 
      NAMAT=NAMATX
      DO 52 J=I1JEL9,ILJEL9
      IF (VALIST(JMAT).EQ.ELMNTS(J)) GO TO 54
   52 NAMAT=NAMAT+1
 
C     CLASS 9 SOURCE FROM VALUE LIST NOT IN ELEMENTS TABLE.
 
      NERROR=10
      WRITE (iqqout,1001) VALIST(JMAT),ELMNTS(IELTAB)
 1001 FORMAT (2H0',A6,14H' UPON WHICH ',A6,''' IS DEPENDENT CANNOT',
     . ' BE FOUND IN THE CLASS 9 SECTION OF THE ELEMENTS TABLE.'///)
      STOP 'IJEQTN: source not in elements table, run aborted'
 
C     LOAD NCL5+NCL2+N9 LOCATION IN COLUMN POSITIONS.
 
   54 ITOCHR=7
      CALL CPY(XIBCD(NAMAT,3,1,JAB),1,BUFFER,ITOCHR,3)
      CALL CPY(BUFFER,7,BUFFER,ITOCHR+8,3)
 
C     COPY N5 POSITION OF THIS JS IN ROW POSITIONS.
 
   55 ITOCHR=3
      CALL CPY(XIBCD(JELTAB-I1RBR,3,1,JAB),1,BUFFER,ITOCHR,3)
      CALL CPY(BUFFER,3,BUFFER,ITOCHR+8,3)
 
C     RESOLVE DEPENDENCIES FOR JS ELEMENT AND WRITE EQUATION(S).
 
      ITOCHR=22
      NDEP=0
      CALL CPYDP(-KSIGN,G,ELMNTS,IELTAB,BLANK,0,VALCOD,BUFFER,ITOCHR,
     *           IMAT,JAB)
      CALL WTEQTN(BLANK,21,BUFFER,ITOCHR-1,BLANK,JAB)
 
C     WRITE SOLUTION VECTOR WITH B-MATRIX SIGN AND 'B' PREFIX.
 
      ITOCHR=3
      CALL CPY(BUFFER,3,BUFFSP,ITOCHR,3)
      CALL CPY(BUFFER,3,BUFFSP,ITOCHR+11,3)
      ITOCHR=28
      CALL COPY(KSIGN,B,ELMNTS(IELTAB),BLANK,BUFFSP,ITOCHR,IMAT)
      CALL WTSPTP(BLANK,BUFFSP,ITOCHR-1,JAB)
 
C     CONTINUE THIS JS ROW IF NECESSARY.
 
      IF (JELTAB.LE.ILRBR) GO TO 45
   60 CONTINUE
      IF(nint(AJRQST) .NE. 0) CALL JCXT
 
C     UPDATE SOLUTION VECTOR OF BRANCH ELEMENTS WITH
C       INDEPENDENT AND RESISTOR DEPENDENT CURRENT SOURCES.
 
   65 IF (LENCOD(JRDEPL)+LENCOD(JINDPL).NE.0)
     *   CALL WTSPTP(COMENT,'UPDATE AV5 WITH B85T*J8',23,JAB)
      DO 85 J=2,3
      I=JCODL(J)
      IF (LENCOD(I)) 90,85,70
   70 M1LINK=MATSUB(I)
      MLLINK=MATSUB(I)+NWORDS*LENCOD(I)-1
      DO 80 I=M1LINK,MLLINK,NWORDS
      JELTAB=I1RBR-1
   75 JFIRST=JELTAB+1
      IF (ISCNER(MATRIX,NWORDS,MXCODS,I,I,JFIRST,ILRBR,1,0,IELTAB,
     *    JELTAB,IMAT,JMAT,KSIGN)) 90,80,76
   76 IELTAB=IELTAB+NBRANS
      ITOCHR=3
      CALL CPY(XIBCD(JELTAB+1-I1RBR,3,1,JAB),1,BUFFSP,ITOCHR,3)
      CALL CPY(BUFFSP,3,BUFFSP,ITOCHR+11,3)
      ITOCHR=28
      NDEP=0
      CALL CPYDP(KSIGN,BLANK,ELMNTS,IELTAB,BLANK,0,VALCOD,BUFFSP,
     *           ITOCHR,IMAT,JAB)
      CALL WTEQTN(BLANK,0,BUFFSP,ITOCHR-1,BLANK,JAB)
      IF (JELTAB.LT.ILRBR) GO TO 75
   80 CONTINUE
   85 CONTINUE
   90 NERROR=JAB
      RETURN
 
      END
