CSECT   IMPMTD
C       22 MAR 73
 
      SUBROUTINE IMPMTD
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
C     SUBROUTINE TO DETERMINE IF PROBLEM SHOULD BE SOLVED USING EITHER
C     THE DIFFERENCED OR SYMBOLIC JACOBIAN.
 
	include 'dfprmd.inc'
	include 'tables.inc'
                      equivalence (iqtabl(3200),nmax)

      COMMON /CNTRLS/ CTRL(150)
      COMMON /ELDATA/ EL,NELMTS
      COMMON /SCNTBL/ NBRANS,NLINKS,LENTBL,ISTART(17),LNCLAS(17),
     *                NCL(17),ISTCL(8),NSCAN(6), NN(3),NSCNEL(6),
     *                MSTART(3),MNUMBR(3)
      COMMON /MUTUAL/ AU,NMUTL,LMUTL,MLVCOD( 50),MLNAME(50),
     *                MLFROM(2,50),MLTO(2,50)
         CHARACTER*8  MLVCOD,MLNAME
      COMMON /BMATRX/ MAXMTX,MXCODS,NWORDS,MATRIX(1)
      COMMON /CHKCTL/ CHKTBL(70)
      DOUBLE PRECISION FP01
         INTEGER      IIFP01(2)
         EQUIVALENCE (IIFP01,FP01)
 
      DATA            IIFP01 /0,1/
 
C     HAS DIFFERENCED JACOBIAN BEEN REQUESTED?
 
      IF(CTRL(61).NE.1D0) GO TO 100
 
C     ESTABLISH IMPLICIT INTEGRATION CONTROLS FOR
C     USING THE DIFFERENCED JACOBIAN.
 
   50 CTRL(61)=1D0
      CHKTBL(61)=FP01
      IF(CTRL(54).EQ.1D0) RETURN
      CTRL(54)=-1D0
      RETURN
 
C     HAS THE SYMBOLIC JACOBIAN BEEN REQUESTED?
 
  100 IF(CTRL(62).NE.1D0) GO TO 200
 
C     ESTABLISH IMPLICIT INTEGRATION CONTROLS FOR USING
C     THE SYMBOLIC JACOBIAN.
 
  110 CTRL(62)=1D0
      CHKTBL(62)=FP01
      IF(CTRL(54).NE.1D0) GO TO 120
      CTRL(54)=2D0
      IF (NMAX.GE.NELMTS) CTRL(54)=1D0
      RETURN
  120 CTRL(54)=-2D0
      IF(NMAX.GE.NELMTS) CTRL(54)=-1D0
      RETURN
 
C     ARE NUMBER OF DERIVATIVES LESS THAN ELEVEN?
 
  200 NDFEQN=NDPD+NCL(3)+NCL(4)
      IF(NDFEQN  .LT.11  ) GO TO 50
 
C         IF THERE IS AN ADJOINT REQUEST AND ANY JX,J0 OR EY'S
C         USE DIFFERENCE JACOBIAN
 
      IF(CTRL(140).EQ.0.D0) GO TO 210
      IF(LNCLAS(1).GT.0.OR.LNCLAS(14).GT.0.OR.LNCLAS(16).GT.0) GO TO 50
 
C     ARE THE NUMBER OF DERIVATIVES GREATER THAN FIFTY?
 
  210 IF(NDFEQN  .GT.50  ) GO TO 110
 
C     HAS IC VIA IMPLICIT INTEGRATION BEEN REQUESTED?
 
  220 IF(CTRL(55).EQ.1D0) GO TO 50
 
C     ARE THERE ANY DEFINED PARAMETER DERIVATIVES?
 
  230 IF (NDPD.GT.0) GO TO 50
 
C     INITIALIZE PROGRAM VARIABLES.
 
  240 ISTCL1=ISTCL(1)-NBRANS
      IEDCL1=ISTCL1+NCL(1)-1
      ISTCL2=ISTCL(2)-NBRANS
      IEDCL2=ISTCL2+NCL(2)-1
      ISTCL3=ISTCL(3)-NBRANS
      IEDCL3=ISTCL3+NCL(3)-1
      ISTCL4=ISTCL(4)
      IEDCL4=ISTCL4+NCL(4)-1
      ISTCL5=ISTCL(5)
      IEDCL5=ISTCL5+NCL(5)-1
      ISTCL6=ISTCL(6)
      IEDCL6=ISTCL6+NCL(6)-1
 
C     ARE THERE ANY LINK OR BRANCH RESISTORS?
 
      IF(NCL(2).EQ.0.OR.NCL(5).EQ.0) GO TO 500
 
C     ANY BRANCH CAPACITORS OR NUMBER OF LINK RESISTORS
C     LESS THAN 2
 
      IF(NCL(4).EQ.0.OR.NCL(2).LT.2) GO TO 400
 
C         IF ANY COLUMN OF B25 HAS MORE THAN ONE ENTRY OF
C         WHICH AT LEAST ONE IS ALSO IN LOOP WITH C TREE
C         BRANCH USE DIFFERENCED JACOBIAN.
 
      DO 350 J=ISTCL5,IEDCL5
      NTRE=0
      ICR=0
      DO 350 I=ISTCL2,IEDCL2
      IF(LBITS(MATRIX,I,J,NBRANS,ISIGN)) 310,350,310
  310 NTRE=NTRE+1
      IF(NTRE.GT.1.AND.ICR.NE.0) GO TO 50
      DO 330 K=ISTCL4,IEDCL4
      IF(LBITS(MATRIX,I,K,NBRANS,ISIGN)) 320,330,320
  320 ICR=1
      IF(NTRE.GT.1) GO TO 50
      GO TO 350
  330 CONTINUE
  350 CONTINUE
 
C         IF ANY ROW OF B25 HAS MORE THAN ONE ENTRY OF WHICH
C         AT LEAST ONE IS IN A CUTSET WITH A L LINK USE
C         THE DIFFERENCED JACOBIAN.
 
  400 IF(NCL(3).EQ.0.OR.NCL(5).LT.2) GO TO 500
      DO 450 I=ISTCL2,IEDCL2
      NTRE=0
      ICR=0
      DO 450 J=ISTCL5,IEDCL5
      IF(LBITS(MATRIX,I,J,NBRANS,ISIGN)) 410,450,410
  410 NTRE=NTRE+1
      IF(NTRE.GT.1.AND.icr.NE.0) GO TO 50
      DO 430 K=ISTCL3,IEDCL3
      IF(LBITS(MATRIX,K,J,NBRANS,ISIGN)) 420,430,420
  420 ICR=1
      IF(NTRE.GT.1) GO TO 50
      GO TO 450
  430 CONTINUE
  450 CONTINUE
 
C         IF ANY ROW OF B14 HAS MORE THAN ONE ENTRY USE
C         THE DIFFERENCED JACOBIAN.
 
  500 IF(NCL(1).EQ.0.OR.NCL(4).LT.2) GO TO 600
      DO 550 I=ISTCL1,IEDCL1
      NTRE=0
      DO 550 J=ISTCL4,IEDCL4
      IF(LBITS(MATRIX,I,J,NBRANS,ISIGN)) 520,550,520
  520 IF(NTRE.EQ.1) GO TO 50
      NTRE=1
  550 CONTINUE
 
C         IF ANY COLUMN OF B36 HAS MORE THAN ONE ENTRY USE
C         THE DIFFERENCED JACOBIAN.
 
  600 IF(NCL(3).LT.2.OR.NCL(6).EQ.0) GO TO 700
      DO 650 J=ISTCL6,IEDCL6
      NTRE=0
      DO 650 I=ISTCL3,IEDCL3
      IF(LBITS(MATRIX,I,J,NBRANS,ISIGN)) 620,650,620
  620 IF(NTRE.EQ.1) GO TO 50
      NTRE=1
  650 CONTINUE
 
C         IF THERE IS MUTUAL INDUCTANCE BETWEEN TWO INDUCTORS
C         IN THE SAME CUTSET USE THE DIFFERENCED JACOBIAN.
 
  700 IF(NMUTL.EQ.0) GO TO 110
      IF(MNUMBR(1).LT.2) GO TO 800
      MST3=MSTART(1)
      MED3=MST3+MNUMBR(1)-1
      DO 750 M=MST3,MED3
      I=MLFROM(2,M)+ISTCL3-1
      DO 750 J=1,NBRANS
      IF(LBITS(MATRIX,I,J,NBRANS,ISIGN)) 720,750,720
  720 KI=MLTO(2,M)+ISTCL3-1
      IF(LBITS(MATRIX,KI,J,NBRANS,ISIGN).NE.0) GO TO 50
  750 CONTINUE
 
C         IF AN INDUCTOR IS MUTUALLY COUPLED TO MORE THAN
C         TWO INDUCTORS USE THE DIFFERENCED JACOBIAN.
 
  800 IF(NMUTL.LE.2) GO TO 110
      MEND=NMUTL-2
      MXNUM=0
      DO 850 M=1,MEND
      ITIME=0
      L1=MLFROM(2,M)
  810 NUM=0
      MST=M+1
      DO 820 J=MST,NMUTL
      IF(MLFROM(2,J).NE.L1.AND.MLTO(2,J).NE.L1)GO TO 820
      IF(NUM.EQ.2) GO TO 50
      NUM=NUM+1
  820 CONTINUE
      MXNUM=MAX(MXNUM,NUM)
      IF(ITIME.EQ.1) GO TO 850
      L1=MLTO(2,M)
      ITIME=1
      GO TO 810
  850 CONTINUE
 
C         IF THERE IS MUTUAL COUPLING BETWEEN MORE THAN TWO
C         INDUCTORS USE DIFFERENCED JACOBIAN.
 
      IF(MXNUM.EQ.0) GO TO 110
      DO 950 M=1,MEND
      L1=MLFROM(2,M)
      L2=MLTO(2,M)
      KSKIP=0
      MST=M+1
  910 DO 930 J=MST,NMUTL
      IF(J.EQ.KSKIP) GO TO 930
      IF(MLFROM(2,J).NE.L2) GO TO 920
      L2=MLTO(2,J)
      KSKIP=J
      GO TO 940
  920 IF(MLTO(2,J).NE.L2) GO TO 930
      L2=MLFROM(2,J)
      KSKIP=J
      GO TO 940
  930 CONTINUE
      GO TO 950
  940 IF(L2.EQ.L1) GO TO 50
      GO TO 910
  950 CONTINUE
      GO TO 110
 
      END
