CSECT   INDEQS                          71.042  11.43.38
 
      SUBROUTINE INDEQS (VARINS,VARMLS,NERROR)
 
C     SUBROUTINE TO WRITE INDUCTOR EQUATIONS INCLUDING ANY MUTUALS.
C
C     VARINS INDICATES VARIABLE INDUCTOR STATUS.
C
C       0 - NO VARIABLE L.
C       1 - VARIABLE CLASS3 ONLY.
C       2 - VARIABLE CLASS 6 ONLY.
C       3 - VARIABLE CLASS 3 AND 6.
C
C     VARMLS ON IF VARIABLE MUTUAL INDUCTANCE.
C
C     INDEQS SUBROUTINE     JERRY PATTERSON    8/24/66
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z), INTEGER (I-N)
 
	include 'tables.inc'
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(2797),ndep)

      INTEGER VALCOD,VARINS,VARMLS,VARIND,VARMUT,B36
      COMMON /ELDATA/ ELM,NELMTS,NN,ELMNTS(300),Z(1200),CMPFLG(300),
     *                VALCOD(2)
         CHARACTER*8  ELMNTS,CMPFLG
      COMMON /SCNTBL/ NBRANS,NZ(36),NCL(17),IST(8),NSCAN(8),B36,
     *                NSSS(9),NM33
         EQUIVALENCE (IST(3),IST3),(IST(6),IST6)
      COMMON /MUTUAL/ AU,NMUTL
      COMMON /BUFERS/ BUFF,BUFFER(1)
         CHARACTER*4  BUFFER

      CHARACTER*4 XIBCD
      CHARACTER*8 BLANK,COMENT,V,C,XML
      CHARACTER*8 XMLD
      CHARACTER*8 ASTPL,PR,EQUALS,D
 
      DATA        BLANK /' '/,COMENT /'C'/,V /'V'/,C /'I'/,XML /'XML'/
      DATA        XMLD  /'XMLD'/
      DATA        ASTPL /'*('/,PR /')'/,EQUALS /'='/,D /'D'/
      DATA        ISTRT1 /1/
 
      NERROR=1
      IF (NCL(3)+NCL(6).EQ.0) RETURN
      CALL WTSPTP(COMENT,
     * 'COMPUTE V6, I6, V3 AND I3DOT FOR ANY INDUCTOR AND',49,N)
      CALL WTSPTP(COMENT,'   MUTUAL TERMS INVOLVED',24,N)
      CALL WTSPTP(COMENT,BLANK,6,N)
      CALL WTSPTP(COMENT,'I6=B36T*I3+B86T*J8',18,N)
      CALL WTSPTP(COMENT,
     * 'XML=L33D+B36*L66D*B36T+M36*B36T+B36*M63+B36*M66*B36T+M33P',57,N)
      CALL WTSPTP(COMENT,
     * 'V3P=(-B34*V4-B35*V5-B37*E7-B36*L66D*B86T*J8DOT',46,N)
      CALL WTSPTP(COMENT,'   -M36*B86T*J8DOT-B36*M66*B86T*J8DOT)',38,N)
      CALL WTSPTP(COMENT,'I3DOT=V3/XML IF NO MUTUAL INDUCTANCE',36,N)
      CALL WTSPTP(COMENT,
     * 'I3DOT=XMLI*V3P IF NO VARIABLE L''S OR M''S',40,N)
      CALL WTSPTP(COMENT,'I3DOT=XML(**(-1))*V3P OTHERWISE',31,N)
      CALL WTSPTP(COMENT,
     * 'V6=(L66D*(B36T*I3DOT+B86T*J8DOT)+M66*(B36T*I3DOT+B86T*J8DOT)',
     * 60,N)
      CALL WTSPTP(COMENT,'   +M63*I3DOT)',14,N)
      CALL WTSPTP(COMENT,'V3=-B34*V4-B35*V5-B36*V6-B37*E7',31,N)
      CALL WTSPTP(COMENT,BLANK,6,N)
      VARIND=VARINS
      VARMUT=VARMLS
      ILAST3=IST3+NCL(3)-1
      ILAST6=IST6+NCL(6)-1
      IF (B36) 40,5,40
 
C     B36 IS ZERO--GET I6=B86T*J8 IF NECESSARY.
 
    5 IF (NCL(6).NE.0) CALL SCNEQS(1,IST6,ILAST6,C,1,IST(8),NCL(8),
     *                             0,0,0,0,0,0,N)
 
C     GET CLASS 3 VECTORS IF NECESSARY.
 
   20 IF (NCL(3)) 21,120,21
 
C     LOAD V3 WITH -B34*V4-B35*V5-B37*E7.
 
   21 CALL SCNEQS(-1,IST3,ILAST3,V,0,IST(4),NCL(4),IST(5),NCL(5),IST(7),
     *            NCL(7),0,0,N)
      IF (NM33) 25,22,25
 
C     I3DOT=V3/L33D SINCE NO MUTUAL.
 
   22 CALL DOGEN(1,1,NCL(3),'I3DOT(N)=V3(N)/XL33D(N)',23,IST3,NCL(3),9,
     *           0,BLANK,0,N)
      GO TO 120
 
C     LOAD V3 VALUES INTO V3P VECTOR.
 
   25 CALL DOGEN(0,1,NCL(3),'V3P(N)=V3(N)',12,0,0,0,0,BLANK,0,N)
 
C     UPDATE V3P WITH ANY -M36*(B86T*J8DOT).
 
      CALL VMUTUL(1)
 
C     SEE IF ANY VARIABLE L OR M.
 
      IF (VARIND+VARMUT) 30,26,30
 
C     GENERATE DO LOOP FOR I3DOT(N)=XMLI(N,N)*V3P(N).
 
   26 CALL DOGEN(0,1,NCL(3),'I3DOT(N)=0.',11,IST3,NCL(3),9,NCL(3),
     *           'I3DOT(N)=I3DOT(N)+XMLI(N,N1)*V3P(N1)',36,N)
      GO TO 120
 
C     LOAD XML WITH L33D.
 
   30 CALL WTMXEQ(IST3,NCL(3),IST6,NCL(6),0,0,XML,0,N)
 
C     UPDATE XML WITH M33 IF ANY.
 
      CALL XMLMUT(1)
 
C     GET LINSOL SOLUTION AND LOAD RESULTS FROM V3P INTO I3DOT.
 
      CALL GN8INV(XML,3,1,NCL(3))
      CALL DOGEN(0,1,NCL(3),'I3DOT(N)=V3P(N)',15,IST3,NCL(3),9,0,BLANK,
     *           0,N)
  120 KWAY=1
      IF (NCL(6)) 11,160,11
 
C     CLEAR V6 VECTOR TO ZEROES.
 
   11 CALL DOGEN(0,1,NCL(6),'V6(N)=0.',8,0,0,0,0,V,0,N)
 
C     V6=L66D*(B86T*J8DOT).
 
      DO 15 J=IST6,ILAST6
      ITOCHR=1
      NDEP=0
      CALL COPY(0,V,ELMNTS(J),EQUALS,BUFFER,ITOCHR,NCHAR)
      CALL CPYDP(0,BLANK,ELMNTS,J,BLANK,0,CMPFLG,BUFFER,ITOCHR,NCHAR,N)
      CALL CPY(ASTPL,1,BUFFER,ITOCHR,2)
      NCHAR=0
      GO TO (14,13),KWAY
 
C     LOAD B36T*I3DOT INTO V6.
 
   13 CALL BVSCAN(1,D,IST3,NCL(3),BLANK,1,0,J,ITOCHR,NCHAR,N)
 
C     LOAD B86T*J8DOT INTO V6.
 
   14 CALL BVDSCN(1,IST(8),NCL(8),J,1,ITOCHR,NCHARS,N)
      CALL CPY(PR,1,BUFFER,ITOCHR,1)
      IF (NCHAR+NCHARS.NE.0)
     *   CALL WTEQTN(BLANK,0,BUFFER,ITOCHR-1,BLANK,N)
   15 CMPFLG(J)(4:4)=CHAR(255)
 
C     UPDATE V6 WITH ANY MUTUAL TERMS.
 
      DO 16 J=3,5
   16 CALL VMUTUL(J)
  160 GO TO (100,45),KWAY
 
C     B36 ENTRIES--GET I6=B36T*I3DOT+B86T*J8DOT.
 
   40 CALL SCNEQS(1,IST6,ILAST6,C,1,IST3,NCL(3),IST(8),NCL(8),0,0,0,0,N)
 
C     V3P=-B34*V4-B35*V5-B37*E7-B36*L66D*B86T*J8DOT.
 
      CALL DOGEN(0,1,NCL(3),'V3P(N)=0.',9,0,0,0,0,BLANK,0,N)
      CALL CPY('V3P(   )=',1,BUFFER,ISTRT1,9)
      DO 60 I=IST3,ILAST3
      ITOCHR=5
      CALL CPY(XIBCD(I-IST3+1,3,1,N),1,BUFFER,ITOCHR,3)
      NDEP=0
      ITOCHR=ISTRT1
 
C     GET -B34*V4-B35*V5-B37*E7 PORTION.
 
      CALL BV4SCN(-1,V,I,0,ITOCHR,NCHAR,IST(4),NCL(4),IST(5),NCL(5),
     *            IST(7),NCL(7),0,0,N)
 
C     GET -B36*L66D*B86T*J8DOT PORTION FOR ALL CLASS 6 ELEMENTS.
 
   51 DO 55 J=IST6,ILAST6
      NCHAR=ITOCHR
      IF (LBITS(MATRIX,I-NBRANS,J,NBRANS,N)) 50,55,50
   50 CALL CPYDP(-N,BLANK,ELMNTS,J,BLANK,0,CMPFLG,BUFFER,ITOCHR,NCHARS,
     *           NCHARS)
      CALL CPY(ASTPL,1,BUFFER,ITOCHR,2)
      CALL BVDSCN(1,IST(8),NCL(8),J,1,ITOCHR,NCHARS,N)
      CALL CPY(PR,1,BUFFER,ITOCHR,1)
   55 IF (NCHARS.EQ.0) ITOCHR=NCHAR
   60 IF (ITOCHR.NE.ISTRT1) CALL WTEQTN(BLANK,0,BUFFER,ITOCHR-1,BLANK,N)
 
C     LOAD V3P WITH ANY MUTUALS.
 
      CALL VMUTUL(1)
      CALL VMUTUL(2)
 
C     SEE IF XML IS DIAGONAL AND NO MUTUALS.
 
      IF (NMUTL+NSCAN(6)) 70,65,70
 
C     LOAD XMLD IF NO VARIABLE L.
 
   65 IF (VARIND.NE.0)
     *    CALL WTMXEQ(IST3,NCL(3),IST6,NCL(6),0,0,XMLD,1,N)
 
C     LOAD I3DOT WITH V3P/XMLD.
 
      CALL DOGEN(0,1,NCL(3),'I3DOT(N)=V3P(N)/XMLD(N)',23,IST3,NCL(3),9,
     *           0,BLANK,0,N)
      GO TO 400
 
C     LOAD I3DOT WITH XMLI*V3P IF NO VARIABLE L OR M.
 
   70 IF (VARIND+VARMUT) 75,71,75
   71 CALL DOGEN(0,1,NCL(3),'I3DOT(N)=0.',11,IST3,NCL(3),9,NCL(3),
     *           'I3DOT(N)=I3DOT(N)+XMLI(N,N1)*V3P(N1)',36,N)
      GO TO 400
 
C     GET NON-DIAGONAL XML.
 
   75 CALL WTMXEQ(IST3,NCL(3),IST6,NCL(6),0,0,XML,0,N)
 
C     UPDATE XML WITH MUTUAL ENTRIES.
 
      CALL XMLMUT(0)
 
C     LINSOL FOR XML AND V3P AND LOAD RESULTS FROM V3P INTO I3DOT.
 
      CALL GN8INV(XML,3,1,NCL(3))
      CALL DOGEN(0,1,NCL(3),'I3DOT(N)=V3P(N)',15,IST3,NCL(3),9,0,
     *           BLANK,0,N)
 
C     V6=L66D*(B36T*I3DOT+B86T*J8DOT).
 
  400 KWAY=2
      GO TO 11
 
C     GET CLASS 3 VECTOR--V3=-B34*V4-B35*V5-B6*V6-B37*E7.
 
   45 CALL SCNEQS(-1,IST3,ILAST3,V,0,IST(4),NCL(4),IST(5),NCL(5),IST(6),
     *            NCL(6),IST(7),NCL(7),N)
  100 RETURN
 
      END
