CSECT   INDINI                          71.042  11.43.38
 
      SUBROUTINE INDINI(VARINS,VARMLS,IERROR)
 
C      SUBROUTINE TO INITIALIZE FOR INDUCTOR EQUATIONS
C
C     VARINS AND VARMLS DENOTE VARIABLE INDUCTANCE AND MUTUAL INDUCTANCE
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
      INTEGER         VARIND,VARINS,START3,START6,VARMUT,VARMLS,
     *                B14,B25,B36
      COMMON /ELDATA/ ELM,NELMTS,LELMTS,ELMNTS(300),FNODE(300),
     *                TNODE(300),VALU(300),SRTCDE(300),CMPFLG(300),
     *                IVLCOD(2,300)
         CHARACTER*8  ELMNTS,FNODE,TNODE,SRTCDE,CMPFLG
      COMMON /SCNTBL/ NBRNCH,NLINKS,NSRTCD,ISTCOD(17),NENTRY(17),
     *                NCLENT(8),MATSUB(9),ISTART(8),NSCAN(6),B14,B25,
     *                B36,NSRC(6),MSTART(3),MNUMBR(3)
         EQUIVALENCE (START3,ISTART(3)),(START6,ISTART(6))
      COMMON /MUTUAL/ AMUT,NMUTL,LMUTL,AMUTBL(50,6)
         DIMENSION    MCFLG(2,50)
         EQUIVALENCE (MCFLG(1,1),AMUTBL(1,1))
      CHARACTER*8 XMLI
      CHARACTER*8 XML
      CHARACTER*8 V3P
      CHARACTER*8 XMLD
 
      DATA        XMLI /'XMLI'/
      DATA        XML  /'XML'/
      DATA        V3P  /'V3P'/
      DATA        XMLD /'XMLD'/
      DATA        VARIND,INT1/0,1/,INT2,INT0/2,0/,INT3/3/,VARMUT/0/
 
      NERROR = INT1
      IF (NCLENT(3)+NCLENT(6)) 10,9000,10
 
C     CHECK FOR VARIABLE M
 
   10 IF (NMUTL) 20,40,20
   20 DO 30 K=1,NMUTL
   30 IF (MCFLG(2,K).NE.1) VARMUT=INT1
 
C     CHECK FOR VARIABLE L
 
   40 IF (NCLENT(3)) 45,100,45
   45 LAST3=START3+NCLENT(3)-INT1
      DO 50 K=START3,LAST3
   50 IF (IVLCOD(2,K).NE.INT1) GO TO 200
  100 IF (NCLENT(6)) 105,500,105
  105 LAST6=START6+NCLENT(6)-INT1
      DO 150 K=START6,LAST6
  150 IF (IVLCOD(2,K).NE.INT1) GO TO 200
      GO TO 500
  200 VARIND=INT3
 
C     CHECK FOR B36 = 0
 
  500 IF (B36) 1000,505,1000
 
C     NO XML REQUIRED IF NO M33 SINCE I3DOT(N)=V3(N)/XL33D(N).
 
  505 IF (MNUMBR(1)) 4000,9000,4000
 
C     CHECK FOR XML DIAGONAL AND NO MUTUAL INDUCTANCE
 
 1000 IF (NMUTL+NSCAN(6)) 4000,2000,4000
 
C     GENERATE A DIMENSION STATEMENT FOR XMLD AND V3P
 
 2000 CALL DIMENS (  XMLD,INT1,NCLENT(3))
      CALL DIMENS(  V3P,INT1,NCLENT(3))
      IF (VARIND) 9000,3000,9000
 
C     WRITE XML MATRIX EQUATIONS INTO XMLD
 
 3000 CALL WTMXEQ (START3,NCLENT(3),START6,NCLENT(6),INT0,INT0,  XMLD,
     *             INT1,NERROR)
      GO TO 9000
 
C     GENERATE DIMENSION STATEMENT FOR XML (NCLENT(3),NCLENT(3))
 
 4000 CALL DIMENS(  XML,INT0,NCLENT(3))
 
C     CHECK FOR VARIABLE M OR L
 
      IF (VARIND+VARMUT) 5000,6000,5000
 
C     GENERATE A DIMENSION STATEMENT FOR V3P (NCLENT(3)
 
 5000 CALL DIMENS (  V3P,INT1,NCLENT(3))
      GO TO 9000
 
C     GENERATE DIMENSION STATEMENTS FOR XMLI (NCLENT(3),NCLENT(3) AND
C     V3P(NCLENT(3)
 
 6000 CALL DIMENS (XMLI,INT0,NCLENT(3))
      CALL DIMENS (  V3P,INT1,NCLENT(3))
 
C     WRITE ML MATRIX EQUATIONS FOR XML
 
      CALL WTMXEQ (START3,NCLENT(3),START6,NCLENT(6),INT0,INT0,  XML,
     *             INT0,NERROR)
      CALL XMLMUT(INT0)
 
C     GENERATE STATEMENT TO INVERT XML INTO XMLI
 
      CALL GN8INV (  XML,INT3,INT2,NCLENT(3))
C
 
 9000 IERROR = NERROR
      VARMLS=VARMUT
      VARINS=VARIND
      RETURN
 
      END
