CSECT   INSIDV
C       4 APR 73
 
      SUBROUTINE INSIDV(NERROR)
 
C     SUBROUTINE INSIDV - INSERTS INDEPENDENT VARIABLES FROM COMMON
C     /SENSC/ INTO TABLE SENS FO COMMON /SENS/.  'INSIDV' ALSO CHECKS
C     OPTIMIZATION ADN WORST CASE INDEPENDENT VARIABLES TO MAKE SURE
C     THEY HAVE BOUNDS.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
	include 'tapes.inc'
	include 'dfpram.inc'
                      character*8  dpnams(jqqram)
                      real*8       dplow(jqqram),dphi(jqqram)
                      equivalence (dpnams(1),dptabl(1,1))
                      equivalence (dplow(1),dptabl(1,5))
                      equivalence (dphi(1),dptabl(1,6))

      COMMON /ADJDTA/ ISNSDV,NSNSDV,ISNSIV,NSNSIV,ISETS,NSETS,
     .                IOPTDV,NOPTDV,IOPTIV,NOPTIV,IOPTST,NOPTST,
     .                IWCDV ,NWCDV ,IWCIV ,NWCIV ,IWCST ,NWCST
      COMMON /DPSENS/ ALDP,NDPSN,LDPSN,DPSENS(3,33)
         CHARACTER*8  DPSENS
      COMMON /DPADD/  DPAD,NADD,LADD,IADD(100)
      COMMON /SENS/   ASENS,NSENS,NSRS,LINDV,LSENS,SENS(4,100),
     .                ISRS(2,100)
         CHARACTER*8  SENS
      COMMON /SENSC / ASNSC,NSNC,LSNCIV,HOLDBF(100)
         CHARACTER*8  HOLDBF
      COMMON /ELDATA/ EL,NELMTS,NELMIT,ELMNTS(300),SPACE1(300,6),
     .                VALLO(300),VALHI(300)
         CHARACTER*8  ELMNTS
      DIMENSION       IDPSNS(6,33)
         EQUIVALENCE (IDPSNS(1,1),DPSENS(1,1))
      DIMENSION       ISENS(8,100)
         EQUIVALENCE (SENS(1,1),ISENS(1,1))
      INTEGER         FIV,FPIV
      CHARACTER*1     C(8),ALPHP,CS(8)
      CHARACTER*8     CSENS,CHECK,CDP
         EQUIVALENCE (CS(1),CSENS)
         EQUIVALENCE (C(1),CHECK)
 
      DATA            ALPHP /'P'/
 
      IIV=4*NSENS+1
      LINDV=IIV-1
 
C     INSERT INDEPENDENT VARIABLES IN 'SENS'
 
      DO 50 I=1,NSNC
      LINDV=LINDV+1
      SENS(LINDV,1)=HOLDBF(I)
   50 CONTINUE
      IF(NSNSIV.NE.0) ISNSIV=4*NSENS+ISNSIV
      IF(NOPTIV.NE.0) IOPTIV=4*NSENS+IOPTIV
      IF(NWCIV .NE.0) IWCIV =4*NSENS+IWCIV
 
C     FILL BASE REGISTERS FOR DEPENDENT VARIABLES
 
      IOFST=4*NSENS
      DO 120 J=1,NSENS
  120 ISENS(3,J)=ISENS(3,J)+IOFST
  150 CONTINUE
      IF(NOPTIV.EQ.0) GO TO 200
 
C     CHECK FOR BOUNDS ON OPTIMIZATION INDEPENDENT VARIABLES
 
      ISTART=IOPTIV
      ISTOP=IOPTIV+NOPTIV-1
      IRET=1
      GO TO 400
  200 IF(NWCIV.EQ.0) GO TO 220
 
C     CHECK FOR BOUNDS ON WORST CASE INDEPENDENT VARIABLES
 
      ISTART=IWCIV
      ISTOP=IWCIV+NWCIV-1
      IRET=2
      GO TO 400
  220 RETURN
  400 DO 500 I=ISTART,ISTOP
      CHECK=SENS(I,1)
      IF(C(1).EQ.ALPHP) GO TO 430
      DO 410 IE=1,NELMTS
  410 IF(CHECK.EQ.ELMNTS(IE)) GO TO 420
      GO TO 500
  420 IF(VALLO(IE).NE.VALHI(IE)) GO TO 500
      NERROR=NERROR+1
      WRITE(iqqout,1000) CHECK
      GO TO 500
  430 DO 440 IP=1,NDP
  440 IF(CHECK.EQ.DPNAMS(IP)) GO TO 450
      GO TO 500
  450 IF(DPLOW(IP).NE.DPHI(IP)) GO TO 500
      NERROR=NERROR+1
      WRITE(iqqout,1000) CHECK
  500 CONTINUE
      GO TO (200,220),IRET
 
 
      ENTRY GPIV(IDP,ISN,NERROR)
 
C     SUBROUTINE GPIV - TO PROCESS DEFINED PARAMETER ADJOINT DEPENDENT
C     VARIABLES, AND PICK OUT FUNCTIONS OF VARIABLES IN THE
C     INDEPENDENT VARIABLE LIST
 
      LPIV=IDPSNS(6,IDP)
      IF(LPIV.LE.0) GO TO 700
      FPIV=IDPSNS(5,IDP)
      LPIV=LPIV+FPIV-1
      FIV=ISENS(3,ISN)
      LIV=ISENS(4,ISN)+FIV-1
      NHOLD=NADD
      ISENS(7,ISN)=NADD+1
      ISENS(8,ISN)=ISENS(4,ISN)
       ISW=0
 
C     START OF LOOP THROUGH ADJOINT INDEPENDENT VARIABLES
 
      IS=FIV
      ISIV=IS
  520 NADD=NADD+1
      IADD(NADD)=0
      CSENS=SENS(ISIV,1)
      IF(CS(1).NE.ALPHP) GO TO 530
      ISIV=ISIV+2
      GO TO 650
 
C     LOOK FOR MATCH IN INDEPENDENT VARIABLE LISTS
 
  530 DO 540 IP=FPIV,LPIV,2
  540 IF(CSENS.EQ.DPSENS(IP,1)) GO TO 560
 
C     NO MATCH IF INDEPENDENT VARIABLE LISTS
 
      GO TO 650
  560 CDP=DPSENS(IP+1,1)
      ISW=1
 
C     LOOK FOR DEFINED PARAMETER FACTOR IN DEFINED PARAMETER TABLE
 
      DO 580 IPR=1,NDP
  580 IF(CDP.EQ.DPNAMS(IPR)) GO TO 600
 
C     DEFINED PARAMETER FACTOR NOT IN DEFINED PARAMETER TABLE
 
      NERROR=NERROR+2
      WRITE(iqqout,1100) CDP,DPSENS(1,IDP)
      GO TO 650
  600 IADD(NADD)=IPR
  650 IS=IS+1
      ISIV=ISIV+1
 
C     END OF LOOP THROUGH ADJOINT INDEPENDENT VARIABLES
 
      IF(IS.LE.LIV) GO TO 520
      IF(ISW.NE.0) GO TO 700
 
C     NO MATCH IN INDEPENDENT VARIABLE LISTS, RESET POINTERS
 
      NADD=NHOLD
      ISENS(7,ISN)=0
      ISENS(8,ISN)=0
  700 RETURN
 
 1000 FORMAT(1X,51HTHE OPTIMIZATION OR WORST CASE DEPENDENT VARIABLE ',
     .A6,28H' HAS NOT BEEN GIVEN BOUNDS.///)
 1100 FORMAT(1X,23HTHE DEFINED PARAMETER ',A6,
     .       25H' FROM THE DIFFERENTIAL ',A6,
     .       24H' HAS NOT BEEN SUPPLIED.///)
 
      END
