CSECT   ISCNER                          71.042  11.43.38
 
      FUNCTION ISCNER(MATRIX,NWORDS,MXCODS,IFIRST,ILAST,JFIRST,JLAST,
     *                NSERCH,ROWCOL,IELTAB,JELTAB,IMAT,JMAT,KSIGN)
 
C     MATRIX-MATRIX CONTAINING SCAN DATA.
C     NWORDS-NO. OF WORDS REQUIRED FOR EACH ROW.
C     MXCODS-NO. OF COLUMN CODES PER MACHINE WORD.
C     IFIRST,ILAST-BOUNDARIES OF ROWS TO BE SEARCHED.
C     JFIRST,JLAST-BOUNDARIES OF COLUMNS TO BE SEARCHED.
C     NSERCH-NUMBER OF NON-ZERO ENTRIES TO BE SEARCHED FOR.
C     ROWCOL-ON CONDITION PRODUCES COLUMN-WISE SCANNING.
C
C     MATRIX COORDINATES ARE RETURNED IN IMAT AND JMAT.
C     TABLE LINK AND BRANCH INDEXES RETURNED IN IELTAB AND JELTAB.
C     VALUE OF ENTRY (-1,0,+1) RETURNED IN KSIGN.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
      INTEGER ROWCOL
      INTEGER MATRIX(*)
 
      ISCNER=0
      JFIRS1=JFIRST-1
      IF (NSERCH) 100,100,15
 
C     FIRST COLUMN OF FIRST WORD AND LAST COLUMN OF LAST WORD.
 
   15 JSTAR1=MOD(JFIRS1,MXCODS)+1
      JEND1=MOD(JLAST-1,MXCODS)+1
      IF (ROWCOL) 60,20,60
 
C     NWDPLK HAS ONE LESS THAN NUMBER OF WORDS REQUIRED FOR EACH ROW.
 
   20 NWDPLK=0
      K=(JLAST-JFIRST)-(MXCODS+1-JSTAR1)
      IF (K) 30,25,25
 
C     MORE THAN ONE WORD PER ROW.
 
   25 NWDPLK=K/MXCODS+1
 
C     SCAN ROWS.
 
   30 JEL=JFIRST
      DO 55 K=IFIRST,ILAST,NWORDS
         ISTART=K+JFIRS1/MXCODS
         IEND=ISTART+NWDPLK
 
C     SCAN THIS ROW RANGE.
 
         JSTART=JSTAR1
         JEND=MXCODS
         DO 50 I=ISTART,IEND
            IF (I.EQ.IEND) JEND=JEND1
 
C     SCAN COLUMN FOR THIS ROW.
 
            DO 40 J=JSTART,JEND
               KXK=JEL
               IF (LBITS(MATRIX,I,J,MXCODS,KSIGN)) 35,40,35
   35          ISCNER=ISCNER+1
               IELTAB=(I-1)/NWORDS+1
               JELTAB=KXK
               IF (ISCNER.EQ.NSERCH) GO TO 100
   40       JEL=JEL+1
   50    JSTART=1
   55 CONTINUE
 
      GO TO 100
 
C     SCAN COLUMN-WISE.
 
   60 ISTART=IFIRST+JFIRS1/MXCODS
      J=JSTAR1
      DO 85 K=JFIRST,JLAST
         IF (J-MXCODS) 70,70,65
   65    J=1
         ISTART=ISTART+1
   70    DO 80 I=ISTART,ILAST,NWORDS
            KXK=K
            IF (LBITS(MATRIX,I,J,MXCODS,KSIGN)) 45,80,45
   45       ISCNER=ISCNER+1
            IELTAB=(I-1)/NWORDS+1
            JELTAB=KXK
            IF (ISCNER.EQ.NSERCH) GO TO 100
   80    CONTINUE
   85 J=J+1
 
  100 RETURN
 
      END
