CSECT   ISEQCK                          71.042  11.43.38
 
       FUNCTION ISEQCK (LOW,LAST,INFOR,LOC)
 
C     ROUTINE TO TEST FOR SPECIAL SEQUENCES
C     LOW    - STARTING CHAR. IN BLNKBF
C     LAST   - LAST CHAR. IN BLNKBF
C     INFOR  - RESULS CODE OF SEQUENCE CHECK
C                  1 NO SEQUENCE DETECTED
C                  2 - DIODE
C                  3 - EQUATION
C                  3 - TABLE
C                  4 - DIODE TABLE
C                  5 - EQUATION OR FUNCTION
C                  6 - DIODE EQUATION
C                  7 - DERIVATIVE
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
      COMMON /BUFERS/ SPLTBF(72),BLNKBF(72)
         CHARACTER*8  SPLTBF,BLNKBF
      CHARACTER*8     SEQ(26)
      CHARACTER*8     DERIVD(10)
      CHARACTER*8     FREQ(3)
      CHARACTER*8     BCDM
 
      DATA SEQ       /'D','I','O','D','E','T','A','B','L','E',
     *                'E','Q','U','A','T','I','O','N',
     *                'F','U','N','C','T','I','O','N'/
      DATA DERIVD
     *               /'D','E','R','I','V','A','T','I','V','E'/
      DATA            BCDM /'M'/
      DATA            FREQ /'R','E','Q'/
 
      NDIODE=0
      INFO=1
      IX=LOW-1
      NCHAR=LAST-LOW+1
      IF(NCHAR.LT.5) GO TO 45
 
C     TEST FOR 'DERIVATIVE'
 
      DO 10 I=1,10
      IXT=IX+I
   10 IF(BLNKBF(IXT).NE.DERIVD(I)) GO TO 15
      BLNKBF(IXT)=DERIVD(1)
   12 INFO=7
      GO TO 55
 
C     TEST FOR 'DIODE'
 
   15 DO 20 I=1,5
      IXT=IX+I
   20 IF(BLNKBF(IXT).NE.SEQ(I)) GO TO 25
      NDIODE=1
      IX=IX+5
 
C     TEST FOR 'TABLE'
 
   25 IXT=IX
      DO 30 I=6,10
      IXT=IXT+1
   30 IF(BLNKBF(IXT).NE.SEQ(I)) GO TO 35
      BLNKBF(IXT)=SEQ(6)
   27 INFO=3
      GO TO 55
 
C     TEST FOR 'EQUATION'
 
   35 IXT=IX
      DO 40 I = 11,18
      IXT=IXT+1
   40 IF (BLNKBF(IXT) .NE. SEQ(I)) GO TO 65
      BLNKBF(IXT)=SEQ(12)
   37 INFO=5
      GO TO 55
 
C     TEST FOR 'FUNCTION'
 
   65 IXT=IX
      DO 75 I=19,26
      IXT=IXT+1
   75 IF (BLNKBF(IXT) .NE. SEQ(I)) GO TO 45
      BLNKBF(IXT)=SEQ(19)
      GO TO 37
   45 IXT=IX+1
 
C     TEST FOR 'D'
 
      IF(BLNKBF(IXT).EQ.DERIVD(1)) GO TO 12
 
C     TEST FOR 'T'
 
      IF(BLNKBF(IXT).NE.SEQ(6)) GO TO 53
      IF(BLNKBF(IXT+1).EQ.SEQ(2).AND.BLNKBF(IXT+2).EQ.BCDM.AND.
     1 BLNKBF(IXT+3).EQ.SEQ(5)) GO TO 55
      GO TO 27
 
C     TEST FOR 'Q'
 
   53 IF(BLNKBF(IXT).EQ.SEQ(12)) GO TO 37
 
C     TEST FOR 'F'
 
      IF(BLNKBF(IXT) .NE. SEQ(19)) GO TO 55
 
C     IS IT 'FREQ'
 
      IF(NCHAR .LT. 4) GO TO 37
      DO 54 I=1,3
      IF(BLNKBF(IXT+I) .NE. FREQ(I)) GO TO 37
   54 CONTINUE
   55 INFOR=INFO+NDIODE
      IF (INFO .NE. 1) LOC = IXT
      ISEQCK = INFOR
      RETURN
 
      END
