CSECT   ISOLVE
C       5 APR 73
 
      SUBROUTINE ISOLVE (NICSV,NERROR)
 
C     THIS SUBROUTINE WILL GENERATE STATEMENTS TO CALL THE LINEAR
C       EQUATION SOLVING ROUTINE, COMPARE THE NEW RESULTS WITH PREVIOUS
C         RESULTS FOR CONVERGENCE AND LOAD THE (VOLTAGE) STATE VARIABLE
C           LOCATIONS WITH THE NEW RESULTS.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tables.inc'
                      equivalence (iqtabl(2797),ndep)
                      character*8  deptab(100)
                      equivalence (tablst(1400),deptab(1))
                      integer      itpcod(200)
                      equivalence (iqtabl(2999),itpcod(1))
                      equivalence (iqtabl(3200),nmax)

      COMMON /ELDATA/ ELM,NELMTS,LELMTS,ELMNTS(300),ZZ(1200),
     .                CMPFLG(300),VALCOD(2,300)
         CHARACTER*8  ELMNTS,CMPFLG
      COMMON /SCNTBL/ NN(3),ISTCOD(17),LENCOD(17),NCL(17),ISTCL(8)
      COMMON /NCL25/  NCL2C,NCL5C
      COMMON /BUFERS/ BUFF,BUFFER(1)
         CHARACTER*4  BUFFER
      COMMON /CNTRLS/ SKIP(43),WTSIM8
      COMMON /ICDEPD/ DEPEND
      DIMENSION       ISUBSV(3)
      INTEGER         VALCOD
      CHARACTER*4     XIBCD,DAND*8,DOR*8
      CHARACTER*8     BLANK,COMENT,Z ,EQUAL ,
     *                S8058,S1112,
     *                S1113,S1114,S1115
      CHARACTER*8     ICFLAG
      CHARACTER*8     ELFLAG
      LOGICAL         LFIRST
 
      DATA            BLANK /' '/,COMENT /'C'/,Z /'Z'/,EQUAL /'='/,
     .                S8058 /' 8058'/,S1112 /' 1112'/,
     .                S1113 /' 1113'/,S1114 /' 1114'/,S1115 /' 1115'/
      DATA ISUBSV     /7,11,12/
      DATA            LFIRST /.TRUE./
 
C     ICFLAG:  /Z000000000F000000/
C     ELFLAG:  /ZFFFFFFFFFF00FFFF/
      IF (LFIRST) THEN
         LFIRST=.FALSE.
         DO 1 I=1,8
            ICFLAG(I:I)=CHAR(  0)
            ELFLAG(I:I)=CHAR(255)
    1    CONTINUE
         ICFLAG(5:5)=CHAR(15)
         ELFLAG(6:6)=CHAR( 0)
      END IF
 
C     SOLVE EQUATIONS.
C     SAVE CHANGED STATE VARIABLES.
 
      CALL WTSPTP(COMENT,'SAVE CHANGED STATE VARIABLES',28,N)
      ITOCHR=1
      CALL CPY('AVI(DDD)=V',1,BUFFER,ITOCHR,10)
      KOUNT=1
      DO 4 I=1,3
      N=ISUBSV(I)
      IF(LENCOD(N)) 10,4,2
   2  JSTART=ISTCOD(N)
      JEND=JSTART+LENCOD(N)-1
      DO 3 J=JSTART,JEND
      ITOCHR=5
      CALL CPY(XIBCD(KOUNT,3,1,N),1,BUFFER,ITOCHR,3)
      ITOCHR=11
      CALL COPY(0,BLANK,ELMNTS(J),BLANK,BUFFER,ITOCHR,JAB)
      CALL WTSPTP(BLANK,BUFFER,ITOCHR-1,N)
    3 KOUNT=KOUNT+1
    4 CONTINUE
   10 CALL WTSPTP(COMENT,
     . 'OBTAIN A SOLUTION FOR THE SET OF EQUATIONS',42,JAB)
      CALL WTSPTP(BLANK,
     . 'CALL INVERS(1HA,A,NICSV,NICSV1,KWAY)',36,JAB)
      CALL WTSPTP(BLANK,
     . 'IF (KWAY.NE.0) RETURN',21,JAB)
      CALL WTSPTP(COMENT,
     . 'TEST FOR CONVERGENCE OF ALL TERMS AND LOAD NEW VALUES',53,JAB)
      CALL WTSPTP(BLANK,
     . 'NFLAG=0',7,JAB)
      CALL WTSPTP(BLANK,
     . 'DO 8058 N=1,NICSV',17,JAB)
      IF(NMAX.LT.NELMTS) CALL WTSPTP(COMENT,'KEY3',4,JAB)
      CALL WTSPTP(BLANK,
     . 'B(N)=A(N,NICSV1)-AVI(N)',23,JAB)
      CALL WTSPTP(  S8058,
     . 'IF(DABS(B(N)) .GT. XICRER*DABS(A(N,NICSV1))+XICAER) NFLAG=7',
     . 59,JAB)
 
C     LOAD NEW VALUES IN STATE VARIABLES.
 
      CALL WTSPTP(COMENT,
     . 'LOAD THE NEW VALUES INTO SAVE LOCATIONS',39,JAB)
      NAMAT=1
      IF(NMAX.LT.NELMTS) CALL WTSPTP(COMENT,'KEY4',4,JAB)
      DO 41 J=1,3
      I=ISUBSV(J)
      IF (LENCOD(I)) 90,41,15
   15 I1LINK=ISTCOD(I)
      ILLINK=I1LINK+LENCOD(I)-1
      DO 40 I=I1LINK,ILLINK
      ITOCHR=1
      CALL COPY(0,Z,ELMNTS(I),EQUAL,BUFFER,ITOCHR,JAB)
      IST=ITOCHR
      CALL CPY('B('  ,1,BUFFER,ITOCHR,2)
      CALL CPY(XIBCD(NAMAT,3,1,JAB),1,BUFFER,ITOCHR,3)
      NCHARS=ITOCHR
      IF (VALCOD(2,I) .NE. 8) GO TO 30
      CALL CPY(')'  ,1,BUFFER,ITOCHR,1)
      CALL WTSPTP(BLANK,BUFFER,ITOCHR-1,JAB)
   30 ITOCHR=1
      CALL CPY('V',1,BUFFER,ITOCHR,1)
      ITOCHR=IST
      CALL CPY('A',1,BUFFER,ITOCHR,1)
      ITOCHR=NCHARS
      CALL CPY(',NICSV1)',1,BUFFER,ITOCHR,8)
      CALL WTSPTP(BLANK,BUFFER,ITOCHR-1,JAB)
   40 NAMAT=NAMAT+1
   41 CONTINUE
      IF(DEPEND.EQ.0.D0) GO TO 56
      IF(   NCL(5).EQ.0) GO TO 43
      IST5=ISTCL (5)
      IEND5=IST5+NCL(5)-1
      DO 42 J=IST5,IEND5
   42 CMPFLG(J)=DOR(CMPFLG(J),ICFLAG)
 
C     IBM IDIOTIC BUG
C  43 IF(   NCL(2).EQ.0) GO TO 47
 
   43 IF(NCL(2).LE.0) GO TO 46
      IST=ISTCL(2)
      IEND=IST+NCL(2)-1
      DO 44 J=IST,IEND
   44 CMPFLG(J)=DOR(CMPFLG(J),ICFLAG)
      DO 45 I=IST ,IEND
      NDEP=1
      DEPTAB(1)=ELMNTS(I)
      ITPCOD(1)=5
      CALL COMPCK(DEPTAB,ITPCOD,0,N)
      IF(N.NE.0) GO TO 45
      CALL WTEQTN(BLANK,0,BUFFER,0,BLANK,N)
      CMPFLG(I)=DAND(CMPFLG(I),ELFLAG)
   45 CONTINUE
   46 IF(NCL2C.LE.0) GO TO 47
      CALL WTSPTP(BLANK,
     . 'DO 1114 N=1,NCL2C',17,JAB)
      CALL WTSPTP(S1114,
     . 'I2(N)=V2(N)/XR22D(N)',20,JAB)
C  47 IF(   NCL(5).EQ.0) GO TO 54
   47 IF(NCL5C.LE.0) GO TO 54
      CALL WTSPTP(BLANK,
     . 'DO 1115 N=1,NCL5C',17,JAB)
      CALL WTSPTP(S1115,
     . 'I5(N)=V5(N)/XR55D(N)',20,JAB)
   54 IF(NCL(2).EQ.0) GO TO 56
      DO 55 I=IST ,IEND
      NDEP=1
      DEPTAB(1)=ELMNTS(I)
      ITPCOD(1)=5
      CALL COMPCK(DEPTAB,ITPCOD,0,N)
      IF(N.EQ.0) CALL WTEQTN(BLANK,0,BUFFER,0,BLANK,N)
   55 CONTINUE
   56 IF( NMAX.LT.NELMTS ) CALL WTSPTP (COMENT,'KEY5',4,JAB)
   57 IF (WTSIM8) 60,70,60
   60 CALL WTSPTP(BLANK,
     . 'IF(XICPRT.EQ.0.D0) WRITE (NOUTTP,1112) XICPAS',45,JAB)
      CALL WTSPTP(S1112,
     . 'FORMAT (1H0,11X,6HPASS =,D13.5)',31,JAB)
      IF(NMAX.LT.NELMTS) CALL WTSPTP(COMENT,'KEY6',4,JAB)
      CALL WTSPTP(BLANK,
     & 'IF (XICPRT.EQ.0.D0) WRITE (NOUTTP,1113) '//
     & '(SVVNAM(N),A(N,NICSV1),N=1,NICSV)', 73,JAB)
      CALL WTSPTP(S1113,'FORMAT (12X,A6,1H=,1P,D14.7)',28,JAB)
   70 CALL WTSPTP(COMENT,
     . 'CONTINUE SOLUTION IF ANY TERM HAS NOT CONVERGED',47,JAB)
      CALL WTSPTP(BLANK, 'IF (NFLAG.NE.0) GO TO 8042',26,JAB)
   90 NERROR=JAB
  100 RETURN
      END
