CSECT   JB04EQ                          72.110  00.39.08
 
      SUBROUTINE JB04EQ (IERR)
 
C       THIS SUBROUTINE GENERATES THE DATA NECESSARY TO PRODUCE THE
C         EQUATIONS FOR THE SECONDARY CURRENT SOURCES.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'tapes.inc'
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(3200),nmax)

      COMMON /ELDATA/ EL,NELMTS,LELMTS,ELMNT(2)
         CHARACTER*8  ELMNT
      COMMON /SPARSE/ LNLOCA,NROWS,NZA,NLOCA(200)
      COMMON /SCNTBL/ NBRAN,NLINK,NSRTCD,ISTSCL(17),NSCL(17),NCL(17),
     *                ISTCL(8)
      COMMON /CMPTAB/ ICMPFG(300)
      COMMON /BUFERS/ BUF(1)
         CHARACTER*8  BUF
      INTEGER         TABLE(5),ROW,COL,ROW2,COL2
      INTEGER*2       NLOCA
      CHARACTER*4     XIBCD
      CHARACTER*8     PRSORC,
     *                CHARS
 
      DATA CHARS      /'GW(   )='/
 
C     ARE THERE ANY BRANCH CAPACITORS?
 
      IF(NCL(4).EQ.0) RETURN
 
C     ARE THERE ANY SECONDARY CURRENT SOURCES?
 
      IF(NSCL(16).EQ.0) RETURN
 
C     SET ROW POINTER TO THE FIRST SECONDARY CURRENT SOURCE
 
      ROW = ISTSCL(16)-NBRAN
 
C     SET COL POINTER TO THE FIRST BRANCH CAPACITOR
 
   10 COL = ISTCL(4)
 
C     DOES THIS BRANCH CAPACITOR CLOSE THIS CURRENT SOURCE?
 
   20 IF(LBITS(MATRIX,ROW,COL,MXCODS,KSIGN)) 30,100,30
 
C     HAS THIS CURRENT SOURCE BEEN DONE BEFORE?
 
   30 IF(ICMPFG(ROW+NBRAN).EQ.1) GO TO 60
 
C     SET UP A PARAMETER FOR JSREQN
 
      BUF(1) = CHARS
      ISF = 1
      IST = 4
      CALL CPY(XIBCD(ROW+NBRAN,3,1,IERR),ISF,BUF(1),IST,3)
 
C     SET UP AN EQUATION OF THE FORM GX(J INDEX)=DIOQ(...)
 
      ISTCHR = 9
      CALL JSREQN(ELMNT(ROW+NBRAN),PRSORC,BUF(1),ISTCHR,IERR)
 
C     INDICATE THIS CURRENT SOURCE HAS BEEN DONE
 
      ICMPFG(ROW+NBRAN) = 1
      LIMIT1 = ISTSCL(17)
      LIMIT2 = ISTSCL(17)+NSCL(17)-1
      DO 40 ROW2=LIMIT1,LIMIT2
      IF(PRSORC.EQ.ELMNT(ROW2)) GO TO 50
   40 CONTINUE
 
C     THE PRIMARY SOURCE WAS NOT FOUND IN THE ELEMENTS LIST
 
      WRITE (iqqout,6) PRSORC
    6 FORMAT(34H PRIMARY CURRENT SOURCE NOT FOUND ,A8)
      STOP 'JB04EQ: primary current source not found, run aborted'
 
C     ADJUST ROW2 TO THIS PRIMARY CURRENT SOURCE'S ROW IN THE B-MATRIX
 
   50 ROW2 = ROW2-NBRAN
 
C     HAS THIS CURRENT SOURCE BEEN DONE BEFORE?
 
      IF(ICMPFG(ROW2+NBRAN).EQ.1) GO TO 60
 
C     SET UP A PARAMETER FOR JSREQN
 
      BUF(1) = CHARS
      ISF = 1
      IST = 4
      CALL CPY(XIBCD(ROW2+NBRAN,3,1,IERR),ISF,BUF(1),IST,3)
 
C     SET UP AN EQUATION OF THE FORM GX(J INDEX)=DIOQ(...)
 
      ISTCHR = 9
      CALL JSREQN(ELMNT(ROW2+NBRAN),PRSORC,BUF(1),ISTCHR,IERR)
 
C     INDICATE THIS CURRENT SOURCE HAS BEEN DONE
 
      ICMPFG(ROW2+NBRAN) = 1
      ICMPFG(COL)=1
 
C     COL2 POINTS TO THE FIRST BRANCH CAPACITOR IN THIS PRIMARY CURRENT
C     SOURCE'S ROW
 
   60 COL2 = ISTCL(4)
 
C     DOES THIS BRANCH CAPACITOR CLOSE THIS CURRENT SOURCE?
 
   70 IF(LBITS(MATRIX,ROW2,COL2,MXCODS,LSIGN)) 80,90,80
 
C     ADD THIS ENTRY TO THE GROWING SUM FOR THIS CURRENT SOURCE
 
   80 ITYPE = 5
      LTAB = 5
      TABLE(1) = ROW+NBRAN
      TABLE(2) =-(COL-NCL(7)+NCL(3))*KSIGN*LSIGN
      TABLE(3) = COL2-NCL(7)+NCL(3)
      TABLE(4) = ROW2+NBRAN
      TABLE(5) = COL
      CALL STOEQN(ITYPE,LTAB,TABLE,IERR)
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *  CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,NLOCA(1),
     *              LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
 
C     INCREMENT TO NEXT BRANCH CAPACITOR
 
   90 COL2 = COL2+1
 
C     HAVE ALL BRANCH CAPACITORS BEEN SCANNED?
 
      IF(COL2.LT.ISTCL(4)+NCL(4)) GO TO 70
 
C     INCREMENT TO NEXT BRANCH CAPACITOR
 
  100 COL = COL+1
 
C     HAVE ALL BRANCH CAPACITORS BEEN SCANNED?
 
      IF(COL.LT.ISTCL(4)+NCL(4)) GO TO 20
 
C     INCREMENT TO NEXT PRIMARY CURRENT SOURCE
 
      ROW = ROW+1
 
C     HAVE ALL OF THE PRIMARY CURRENT SOURCES BEEN PROCESSED?
 
      IF(ROW+NBRAN.LT.ISTSCL(16)+NSCL(16)) GO TO 10
      RETURN
 
      END
