CSECT   JB24EQ                          72.110  00.39.08
      SUBROUTINE JB24EQ (IERR)
 
C     THIS SUBROUTINE GENERATES THE DATA NECESSARY TO PRODUCE THE
C        EQUATIONS FOR THE CAPACITORS AND RESISTORS.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(3200),nmax)

      COMMON /ELDATA/ EL,NELMTS
      COMMON /SPARSE/ LNLOCA,NROWS,NZA,NLOCA(200)
      COMMON /SCNTBL/ NBRAN,NLINK,NSRTCD,ISTSCL(17),NSCL(17),NCL(17),
     *                ISTCL(8)
      COMMON /CMPTAB/ ICMPFG(300)
      INTEGER         TABLE(5),ROW,COL,COL2
      INTEGER*2       NLOCA
 
      DATA            IFOUND /0/
 
C     ARE THERE ANY BRANCH CAPACITORS?
 
      IF(NCL(4).EQ.0) RETURN
 
C     ARE THERE ANY LINK RESISTORS?
 
      IF(NCL(2).EQ.0) RETURN
 
C     SET ROW AND COLUMN POINTERS TO 1ST LINK RESISTOR AND BRANCH
C     CAPACITOR, RESPECTIVELY.
 
      ROW = ISTCL(2)-NBRAN
 
C     ESTABLISH INDEX TO THIS ROW'S LINK RESISTOR
 
      IND = ROW+NBRAN
   10 COL = ISTCL(4)
   20 IF(LBITS(MATRIX,ROW,COL,MXCODS,KSIGN)) 30,80,30
 
C     SET A FLAG TO CAUSE ANOTHER SUBROUTINE TO COMPUTE THE R-SUM FOR
C     THIS ROW OF THE B-MATRIX.
 
   30 ICMPFG(IND) = 1
      ICMPFG(COL)=1
      ITYPE = 3
      LTAB = 4
      TABLE(1) = IND
      TABLE(2) = -(COL-NCL(7)+NCL(3))
      TABLE(3) = COL-NCL(7)+NCL(3)
      TABLE(4) = COL
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *   CALL GNLOCA(TABLE(3),TABLE(3),NROWS,NZA,NLOCA(1),
     *               LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
      CALL STOEQN(ITYPE,LTAB,TABLE,IERR)
 
C     WERE THERE ANY PRIOR ENTRIES IN THIS ROW?
 
      IF(IFOUND.EQ.0) GO TO 70
 
C     SET THE SECOND POINTER TO THE FIRST BRANCH CAPACITOR
 
      COL2 = ISTCL(4)
 
C     IS THIS BRANCH CAPACITOR ALSO CLOSED BY THE LINK RESISTOR?
 
   40 IF(LBITS(MATRIX,ROW,COL2,MXCODS,LSIGN)) 50,60,50
   50 TABLE(2) = -(COL-NCL(7)+NCL(3))*KSIGN*LSIGN
      TABLE(3) = COL2-NCL(7)+NCL(3)
      TABLE(4) = COL
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *   CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *               NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
      TABLE(2) = -(COL2-NCL(7)+NCL(3))*KSIGN*LSIGN
      TABLE(3) = COL-NCL(7)+NCL(3)
      TABLE(4) = COL2
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *  CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *              NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
 
C     INCREMENT SECONDARY BRANCH CAPACITOR POINTER BY ONE
 
   60 COL2 = COL2+1
 
C     SCAN ALL BRANCH CAPACITORS UP TO THE PRESENT ONE
 
      IF(COL2.LT.COL) GO TO 40
 
C     A BRANCH CAPACITOR HAS BEEN FOUND
 
   70 IFOUND = 1
 
C     INCREMENT PRIMARY BRANCH CAPACITOR POINTER
 
   80 COL = COL+1
 
C     HAVE ALL THE BRANCH CAPACITORS BEEN PROCESSED?
 
      IF(COL.LT.ISTCL(4)+NCL(4)) GO TO 20
 
C     RESET THE BRANCH CAPACITOR FOUND INDICATOR
 
      IFOUND = 0
 
C     INCREMENT THE LINK RESISTOR AND ROW POINTERS BY ONE
 
      IND = IND+1
      ROW = ROW+1
C     HAVE ALL THE LINK RESISTORS BEEN PROCESSED?
 
      IF(IND.LT.ISTCL(2)+NCL(2)) GO TO 10
      RETURN
 
      END
