CSECT   JB34EQ                          72.110  00.39.08
 
      SUBROUTINE JB34EQ (IERR)
 
C     THIS SUBROUTINE GENERATES THE DATA NECESSARY TO PRODUCE THE
C        EQUATIONS FOR THE CAPACITORS AND INDUCTORS.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(3200),nmax)

      COMMON /ELDATA/ EL,NELMTS,LELMTS,ELMNT(2)
         CHARACTER*8  ELMNT
      COMMON /SPARSE/ LNLOCA,NROWS,NZA,NLOCA(200)
      COMMON /SCNTBL/ NBRAN,NLINK,NSRTCD,ISTSCL(17),NSCL(17),NCL(17),
     *                ISTCL(8)
      COMMON /CMPTAB/ ICMPFG(300)
      COMMON /INDUCT/ INDUC(300),NINDUC(300),MCHAIN(100),MBACK(100)
      INTEGER         TABLE(3),ROW,COL,ROW2
      INTEGER*2       NLOCA,INDUC,NINDUC,MCHAIN,MBACK
 
C     ARE THERE ANY LINK INDUCTORS?
 
      IF(NCL(3).EQ.0) RETURN
 
C     ARE THERE ANY BRANCH CAPACITORS?
 
      IF(NCL(4).EQ.0) RETURN
      COL = ISTCL(4)
   10 ROW = ISTCL(3)-NBRAN
   20 IF(LBITS(MATRIX,ROW,COL,MXCODS,KSIGN)) 30,40,30
 
C     AN ENTRY IS NECESSARY IN THE W-MATRIX.
 
   30 ITYPE = 4
      LTAB = 3
      TABLE(1) = COL
      TABLE(2) = (COL-NCL(7)+NCL(3))*KSIGN
      TABLE(3) = ROW-NCL(1)-NCL(2)
      ICMPFG(COL)=1
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *   CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *               NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
      CALL STOEQN(ITYPE,LTAB,TABLE,IERR)
      IF(INDUC(ROW+NBRAN).EQ.0) GO TO 39
      MUT = INDUC(ROW+NBRAN)
   33 ROW2 = MBACK(MUT)-NBRAN
 
C     WRITE EQUATIONS IF IT IS COUPLED TO AN INDUCTOR
 
      IF(ROW2) 39,39,34
   34 IF(LBITS(MATRIX,ROW2,COL,MXCODS,LSIGN)) 39,35,39
   35 IF(MCHAIN(MUT)) 40,40,37
 
C     PROCESS THE NEXT MUTUALLY COUPLED INDUCTOR
 
   37 MUT = MCHAIN(MUT)
      GO TO 33
 
C     GENERATE EQUATIONS TO STORE THE SYMMETRIC ENTRY IN THE W-MATRIX
 
   39 TABLE(1) = ROW+NBRAN
      TABLE(2) = -(ROW-NCL(1)-NCL(2))*KSIGN
      TABLE(3) = COL-NCL(7)+NCL(3)
      ICMPFG(ROW+NBRAN)=1
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *  CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *              NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
 
C     INCREMENT PRIMARY LINK INDUCTOR POINTER
 
   40 ROW = ROW+1
 
C     HAVE ALL THE INDUCTORS BEEN PROCESSED?
 
      IF(ROW+NBRAN.LT.ISTCL(3)+NCL(3)) GO TO 20
 
C     INCREMENT THE CAPACITOR POINTER BY ONE
 
      COL = COL+1
 
C     HAVE ALL THE CAPACITORS BEEN PROCESSED?
 
      IF(COL.LT.ISTCL(4)+NCL(4)) GO TO 10
      RETURN
 
      END
