CSECT   JB35EQ                          72.110  00.39.08
 
      SUBROUTINE JB35EQ (IERR)
 
C     THIS SUBROUTINE GENERATES THE DATA NECESSARY TO PRODUCE THE
C        EQUATIONS FOR THE RESISTORS AND INDUCTORS
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(3200),nmax)

      COMMON /ELDATA/ EL,NELMTS,LELMTS,ELMNT(2)
         CHARACTER*8  ELMNT
      COMMON /SPARSE/ LNLOCA,NROWS,NZA,NLOCA(200)
      COMMON /SCNTBL/ NBRAN,NLINK,NSRTCD,ISTSCL(17),NSCL(17),NCL(17),
     *                ISTCL(8)
      COMMON /CMPTAB/ ICMPFG(300)
      COMMON /MUTUAL/ AU,NMUTL,LMUTL,MVL(50),MNAME(50),MFROM(50),MTO(50)
         CHARACTER*8  MNAME,MFROM,MTO,MVL
         EQUIVALENCE (IFROM(1,1),MFROM(1)),(ITO(1,1),MTO(1))
      COMMON /INDUCT/ INDUC(300),NINDUC(300),MCHAIN(100),MBACK(100)
      INTEGER         TABLE(4),ROW,ROW2,COL,IFROM(2,50),ITO(2,50)
      INTEGER*2       NLOCA,INDUC,NINDUC,MCHAIN,MBACK
 
      DATA IFOUND /0/
 
C     ARE THERE ANY LINK INDUCTORS?
 
      IF(NCL(3).EQ.0) RETURN
 
C     INITIALIZE SPECIAL INDUCTOR TABLES TO ZERO
 
      DO 1 I=1,300
      INDUC(I) = 0
    1 NINDUC(I) = 0
      DO 2 I=1,100
      MCHAIN(I) = 0
    2 MBACK(I) = 0
 
C     CHECK EACH INDUCTOR TO SEE IF IT IS MUTUALLY COUPLED
 
      IFIRST = 1
    3 GO TO (4,5),IFIRST
    4 IFIRST = 2
 
C     SCAN THE INDUCTORS
 
      J = ISTCL(3)
      K = J + NCL(3)-1
      ISTART = 1-ISTCL(3)
      GO TO 6
    5 IFIRST = 1
      J = ISTCL(6)
      K = J + NCL(6)-1
      ISTART = 1 + NCL(3) - ISTCL(6)
 
    6 DO 13 I=J,K
 
         DO 8 L=1,NMUTL
            IF (ISTART+I .NE. IFROM(2,L)) GO TO 8
            INDUC(I) = L
            MBACK(L+50) = I
            NINDUC(I) = NINDUC(I) + 1
            IOLD = L
CWRN        L = L + 1
            L8=L+1
CWRN        DO 7 M=L,NMUTL
            DO 7 M=L8,NMUTL
               IF (ISTART+I .NE. IFROM(2,M)) GO TO 7
               MCHAIN(IOLD) = M
               MBACK(M+50) = I
               NINDUC(I) = NINDUC(I) + 1
               IOLD = M
    7       CONTINUE
CWRN        L = 1
            L10 = 1
            GO TO 10
    8    CONTINUE
 
    9    DO 12 L=1,NMUTL
            IF (ISTART+I .NE. ITO(2,L)) GO TO 12
            INDUC(I) = L + 50
            MBACK(L) = I
            NINDUC(I) = NINDUC(I) + 1
            IOLD = L + 50
CWRN        L = L + 1
            L10 = L + 1
            GO TO 10
   12    CONTINUE
 
         GO TO 13
 
CWRN0    DO 11 M=L,NMUTL
   10    DO 11 M=L10,NMUTL
            IF (ISTART+I .NE. ITO(2,M)) GO TO 11
            MCHAIN(IOLD) = M + 50
            MBACK(M) = I
            NINDUC(I) = NINDUC(I) + 1
            IOLD = M + 50
   11    CONTINUE
 
   13 CONTINUE
 
      GO TO (14,3),IFIRST
 
C     ARE THERE ANY BRANCH RESISTORS?
 
   14 IF(NCL(5).EQ.0) RETURN
      ITYPE = 3
      LTAB = 4
 
C     SET ROW AND COLUMN POINTERS TO 1ST LINK INDUCTOR AND BRANCH
C     RESISTOR, RESPECTIVELY.
 
      COL = ISTCL(5)
   15 ROW = ISTCL(3)-NBRAN
   20 IF(LBITS(MATRIX,ROW,COL,MXCODS,KSIGN)) 21,80,21
   21 ICMPFG(COL) = 1
      IF(INDUC(ROW+NBRAN).EQ.0) GO TO 30
 
C     IS THIS INDUCTOR MUTUALLY COUPLED TO ANOTHER LINK IN THIS CUT SET?
 
      MUT = INDUC(ROW+NBRAN)
   23 ROW2 = MBACK(MUT)-NBRAN
      IF(ROW2) 30,30,24
   24 IF(LBITS(MATRIX,ROW2,COL,MXCODS,LSIGN)) 30,25,30
   25 IF(MCHAIN(MUT)) 35,35,27
 
C     PROCESS THE NEXT MUTUALLY COUPLED INDUCTOR
 
   27 MUT = MCHAIN(MUT)
      GO TO 23
   30 TABLE(1) = COL
      TABLE(2) = -(ROW-NCL(1)-NCL(2))
      TABLE(3) = ROW-NCL(1)-NCL(2)
      TABLE(4) = ROW+NBRAN
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *   CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *               NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
      CALL STOEQN(ITYPE,LTAB,TABLE,IERR)
      ICMPFG(ROW+NBRAN)=1
 
C     WERE THERE ANY PRIOR ENTRIES IN THIS COL?
 
   35 IF(IFOUND.EQ.0) GO TO 70
 
C     SET THE SECOND POINTER TO THE FIRST LINK INDUCTOR
 
      ROW2 = ISTCL(3)-NBRAN
   40 IF(LBITS(MATRIX,ROW2,COL,MXCODS,LSIGN)) 50,60,50
   50 TABLE(1) = COL
      TABLE(2) = -(ROW-NCL(1)-NCL(2))*KSIGN*LSIGN
      TABLE(3) = ROW2-NCL(1)-NCL(2)
      TABLE(4) = ROW+NBRAN
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *   CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *               NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
      TABLE(2) = -(ROW2-NCL(1)-NCL(2))*KSIGN*LSIGN
      TABLE(3) = ROW-NCL(1)-NCL(2)
      TABLE(4) = ROW2+NBRAN
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *   CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *               NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
 
C     INCREMENT SECONDARY LINK INDUCTOR POINTER BY ONE
 
   60 ROW2 = ROW2+1
 
C     SCAN ALL LINK INDUCTORS UP TO THE PRESENT ONE
 
      IF(ROW2.LT.ROW) GO TO 40
 
C     A LINK INDUCTOR HAS BEEN FOUND
 
   70 IFOUND = 1
 
C     INCREMENT PRIMARY LINK INDUCTOR POINTER
 
   80 ROW = ROW+1
 
C     HAVE ALL THE LINK INDUCTORS BEEN PROCESSED?
 
      IF(ROW+NBRAN.LT.ISTCL(3)+NCL(3)) GO TO 20
 
C     RESET THE LINK INDUCTOR FOUND INDICATOR
 
      IFOUND = 0
 
C     INCREMENT THE BRANCH RESISTOR POINTER BY ONE
 
      COL = COL+1
 
C     HAVE ALL THE BRANCH RESISTORS BEEN PROCESSED?
 
      IF(COL.LT.ISTCL(5)+NCL(5)) GO TO 15
      RETURN
 
      END
