CSECT   JB94EQ                          72.110  00.39.08
 
      SUBROUTINE JB94EQ (IERR)
 
C       THIS SUBROUTINE GENERATES THE DATA NECESSARY TO PRODUCE THE
C         EQUATIONS FOR THE PRIMARY CURRENT SOURCES.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(3200),nmax)

      COMMON /ELDATA/ EL,NELMTS,LELMTS,ELMNT(2)
         CHARACTER*8  ELMNT
      COMMON /SPARSE/ LNLOCA,NROWS,NZA,NLOCA(200)
         INTEGER*2    NLOCA
      COMMON /SCNTBL/ NBRAN,NLINK,NSRTCD,ISTSCL(17),NSCL(17),NCL(17),
     *                ISTCL(8)
      COMMON /CMPTAB/ ICMPFG(300)
      COMMON /BUFERS/ BUF(1)
         CHARACTER*8  BUF
      INTEGER         TABLE(4),ROW,COL
      CHARACTER*8     PRSORC,CHARS
      CHARACTER*4     XIBCD
 
      DATA
     *   CHARS     /'GW(   )='/
 
C     ARE THERE ANY BRANCH CAPACITORS?
 
      IF(NCL(4).EQ.0) RETURN
 
C     ARE THERE ANY PRIMARY CURRENT SOURCES?
 
      IF(NSCL(17).EQ.0) RETURN
 
C     SET ROW POINTER TO THE FIRST PRIMARY CURRENT SOURCE
 
      ROW = ISTSCL(17)-NBRAN
 
C     SET COL POINTER TO THE FIRST BRANCH CAPACITOR
 
   10 COL = ISTCL(4)
 
C     DOES THIS BRANCH CAPACITOR CLOSE THIS CURRENT SOURCE?
 
   20 IF(LBITS(MATRIX,ROW,COL,MXCODS,KSIGN)) 30,50,30
 
C     HAS THIS CURRENT SOURCE BEEN DONE BEFORE?
 
   30 IF(ICMPFG(ROW+NBRAN).EQ.1) GO TO 40
 
C     SET UP A PARAMETER FOR JSREQN
 
      BUF(1) = CHARS
      ISF = 1
      IST = 4
      CALL CPY(XIBCD(ROW+NBRAN,3,1,IERR),ISF,BUF(1),IST,3)
 
C     SET UP AN EQUATION OF THE FORM GX(J INDEX)=DIOQ(...)
 
      ISTCHR = 9
      CALL JSREQN(ELMNT(ROW+NBRAN),PRSORC,BUF(1),ISTCHR,IERR)
 
C     INDICATE THIS CURRENT SOURCE HAS BEEN DONE
 
      ICMPFG(ROW+NBRAN) = 1
      ICMPFG(COL)=1
 
C     ADD THIS ENTRY TO THE GROWING SUM FOR THIS CURRENT SOURCE
 
   40 ITYPE = 3
      LTAB = 4
      TABLE(1) = ROW+NBRAN
      TABLE(2) =-(COL-NCL(7)+NCL(3))
      TABLE(3) = COL-NCL(7)+NCL(3)
      TABLE(4) = COL
      CALL STOEQN(ITYPE,LTAB,TABLE,IERR)
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *   CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *               NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
 
C     INCREMENT TO NEXT BRANCH CAPACITOR
 
   50 COL = COL+1
 
C     HAVE ALL BRANCH CAPACITORS BEEN SCANNED?
 
      IF(COL.LT.ISTCL(4)+NCL(4)) GO TO 20
 
C     INCREMENT TO NEXT PRIMARY CURRENT SOURCE
 
      ROW = ROW+1
 
C     HAVE ALL OF THE PRIMARY CURRENT SOURCES BEEN PROCESSED?
 
      IF(ROW+NBRAN.LT.ISTSCL(17)+NSCL(17)) GO TO 10
      RETURN
 
      END
