CSECT   JBXEQ                           72.110  00.39.08
 
      SUBROUTINE JBXEQ (IERR)
 
C       THIS SUBROUTINE GENERATES THE DATA NECESSARY TO PRODUCE THE
C         EQUATIONS FOR THE LINEARLY DEPENDENT CURRENT SOURCE ENTRIES
C           IN THE JACOBIAN.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'tapes.inc'
	include 'tables.inc'
                      equivalence (iqtabl(3200),nmax)

      COMMON /ELDATA/ EL,NELMTS,LELMTS,ELMNT(2)
         CHARACTER*8  ELMNT
      COMMON /SPARSE/ LNLOCA,NROWS,NZA,NLOCA(200)
         INTEGER*2    NLOCA
      COMMON /SCNTBL/ NBRAN,NLINK,NSRTCD,ISTSCL(17),NSCL(17),NCL(17),
     *                ISTCL(8)
      COMMON /CMPTAB/ ICMPFG(300)
      COMMON /BUFERS/ BUF(1)
         CHARACTER*8  BUF
      CHARACTER*4     XIBCD
      INTEGER         TABLE(5),ROW,COL,ROW2,COL2,ROW3,COL3
      CHARACTER*8
     *   CHARS,
     *   RESIST, C8TEMP
 
      DATA
     *   CHARS /'GW(   )='/
      DATA ITYPE/5/, LTAB/5/
 
C     ARE THERE ANY LINEARLY DEPENDENT CURRENT SOURCES?
 
      IF(NSCL(14).EQ.0) RETURN
 
C     SET ROW POINTER TO THE FIRST LINEARLY DEPENDENT CURRENT SOURCE
 
      ROW = ISTSCL(14)-NBRAN
 
C     SET COL POINTER TO THE FIRST BRANCH CAPACITOR MINUS ONE
 
   10 COL = ISTCL(4)-1
 
C     SET UP A PARAMETER FOR JSREQN
 
      BUF(1) = CHARS
      ISF = 1
      IST = 4
      CALL CPY(XIBCD(ROW+NBRAN,3,1,JERR),ISF,BUF(1),IST,3)
 
C     SET UP AN EQUATION OF THE FORM GX(J INDEX)=VALUE
 
      ISTCHR = 9
      CALL JSREQN(ELMNT(ROW+NBRAN),RESIST,BUF(1),ISTCHR,JERR)
 
C     INDICATE THIS CURRENT SOURCE HAS BEEN DONE
 
      ICMPFG(ROW+NBRAN) = 1
 
C     SHIFT THE 'I' OUT OF THE FIRST POSITION
 
      C8TEMP = RESIST
      RESIST = C8TEMP(2:6)
 
C     FIND THE RESISTOR ON WHICH THIS CURRENT SOURCE IS LINEARLY
C     DEPENDENT
 
      DO 20 INDX=1,NELMTS
      IF(RESIST.EQ.ELMNT(INDX)) GO TO 30
   20 CONTINUE
 
C     THE RESISTOR WAS NOT FOUND IN THE ELEMENTS LIST
 
      WRITE (iqqout,6) RESIST
    6 FORMAT(20H RESISTOR NOT FOUND ,A8)
      STOP 'JBXEQ: resistor not found, run aborted'
 
C     IS THIS RESISTOR A LINK OR A BRANCH?
 
   30 IF(INDX-NBRAN) 110,110,40
 
C     SET ROW2 TO THIS LINK RESISTOR'S ROW IN THE B-MATRIX
 
   40 ROW2 = INDX-NBRAN
 
C     SCAN FOR THE BRANCH CAPACITORS IN THE SAME LOOP AS THIS LINEARLY
C     DEPENDENT CURRENT SOURCE
 
      NUM = NCL(4)
   55 IF(JSCAN(0,ROW,COL,NUM,ISIGN)) 180,180,60
 
C     SCAN FOR THE BRANCH CAPACITORS IN THE SAME LOOP AS THIS LINK RES.
C     COL2 POINTS TO THE FIRST BRANCH CAPACITOR IN THIS LINEARLY
C     DEPENDENT CURRENT SOURCE'S ASSOCIATED LINK RESISTOR ROW MINUS ONE
C     BECAUSE THE JSCAN FUNCTION INCREMENTS TO THE NEXT COL. IMMEDIATELY
 
   60 COL2 = ISTCL(4)-1
      NUM2 = NCL(4)
      N = 1
   65 IF(JSCAN(0,ROW2,COL2,NUM2,JSIGN)) 70,70,90
 
C     SCAN FOR THE BRANCH RESISTORS IN THE SAME LOOP AS THIS LINK RES.
 
   70 NUM2 = NCL(5)
   75 IF(JSCAN(0,ROW2,COL2,NUM2,KSIGN)) 55,55,80
 
C     SCAN FOR THE LINK INDUCTORS IN THE SAME CUT SET AS THIS BRANCH R.
 
   80 ROW3 = ISTCL(3)-1-NBRAN
      NUM3 = NCL(3)
      N = 2
   85 IF(JSCAN(1,ROW3,COL2,NUM3,LSIGN)) 75,75,100
 
C     INDICATE AN RSUM IS NEEDED FOR THIS LINK RESISTOR ROW
 
   90 ICMPFG(ROW2+NBRAN) = 1
 
C     ADD THIS ENTRY TO THE GROWING SUM FOR THIS CURRENT SOURCE
C     RETURN TO BRANCH CAPACITOR SCAN AFTER STORING DATA
 
      TABLE(1) = ROW+NBRAN
      TABLE(2) = -(COL-NCL(7)+NCL(3))*ISIGN*JSIGN
      TABLE(3) = COL2-NCL(7)+NCL(3)
      TABLE(4) = ROW2+NBRAN
      TABLE(5) = COL
      GO TO 170
 
C     INDICATE AN RSUM IS NEEDED FOR THIS LINK RESISTOR ROW
 
  100 ICMPFG(ROW2+NBRAN) = 1
 
C     ADD THIS ENTRY TO THE GROWING SUM FOR THIS CURRENT SOURCE
C     RETURN TO LINK INDUCTOR SCAN AFTER STORING DATA
 
      TABLE(1) = ROW+NBRAN
      TABLE(2) = -(COL-NCL(7)+NCL(3))*ISIGN*KSIGN*LSIGN
      TABLE(3) = ROW3+NBRAN-ISTCL(3)+1
      TABLE(4) = ROW2+NBRAN
      TABLE(5) = COL
      GO TO 170
 
C     SCAN FOR THE BRANCH CAPACITORS IN THE SAME LOOP AS THIS LINEARLY
C     DEPENDENT CURRENT SOURCE
 
  110 NUM = NCL(4)
  115 IF(JSCAN(0,ROW,COL,NUM,ISIGN)) 180,180,120
 
C     SCAN FOR THE LINK RESISTORS IN THE SAME CUT SET AS THIS BRANCH RES
C     SET SECONDARY COL POINTER TO THE BRANCH RESISTOR
 
  120 COL2 = INDX
 
C     ROW2 POINTS TO THE FIRST LINK RESISTOR POSITION MINUS ONE IN THIS
C     BRANCH RESISTOR'S COLUMN BECAUSE THE JSCAN FUNCTION INCREMENTS TO
C     THE NEXT COLUMN IMMEDIATELY UPON ENTRY
 
      ROW2 = ISTCL(2)-NBRAN-1
      NUM2 = NCL(2)
  125 IF(JSCAN(1,ROW2,COL2,NUM2,JSIGN)) 140,140,130
 
C     SCAN FOR THE BRANCH CAPACITORS IN THE SAME LOOP AS THIS LINK RES.
 
  130 COL3 = ISTCL(4)-1
      NUM3 = NCL(4)
      N = 3
  135 IF(JSCAN(0,ROW2,COL3,NUM3,KSIGN)) 125,125,150
 
C     SCAN FOR THE LINK INDUCTORS IN THE SAME CUT SET AS THIS BRANCH R.
 
  140 NUM3 = NCL(3)
      N = 4
  145 IF(JSCAN(1,ROW2,COL2,NUM3,LSIGN)) 115,115,160
 
C     INDICATE AN RSUM IS NEEDED FOR THIS BRANCH RESISTOR COLUMN
 
  150 ICMPFG(ROW2+NBRAN)=1
 
C     ADD THIS ENTRY TO THE GROWING SUM FOR THIS CURRENT SOURCE
C     RETURN TO BRANCH CAPACITOR SCAN AFTER STORING DATA
 
      TABLE(1) = ROW+NBRAN
      TABLE(2) = -(COL-NCL(7)+NCL(3))*ISIGN*JSIGN*KSIGN
      TABLE(3) = COL3-NCL(7)+NCL(3)
      TABLE(4) = ROW2+NBRAN
      TABLE(5) = COL
      GO TO 170
 
C     ADD THIS ENTRY TO THE GROWING SUM FOR THIS CURRENT SOURCE
C     RETURN TO LINK INDUCTOR SCAN AFTER STORING DATA
 
  160 TABLE(1) = ROW+NBRAN
      TABLE(2) = (COL-NCL(7)+NCL(3))*ISIGN*LSIGN
      TABLE(3) = ROW2+NBRAN-ISTCL(3)+1
      TABLE(4) = NELMTS+1
      TABLE(5) = COL
  170 CALL STOEQN(ITYPE,LTAB,TABLE,IERR)
      ICMPFG(COL)=1
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *   CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *               NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),JERR)
 
C     RESUME SCAN WHERE INTERRUPTED
 
      GO TO (65,85,135,145),N
 
C     INCREMENT TO NEXT LINEARLY DEPENDENT CURRENT SOURCE
 
  180 ROW = ROW+1
 
C     HAVE ALL OF THE LINEARLY DEPENDENT CURRENT SOURCES BEEN PROCESSED?
 
      IF(ROW+NBRAN.LT.ISTSCL(14)+NSCL(14)) GO TO 10
      RETURN
 
      END
