CSECT   JBYEQN                          72.110  00.39.08
 
       SUBROUTINE JBYEQN (IERR)
 
C      THIS SUBROUTINE WRITES THE EQUATIONS FOR THE LINEARLY DEPENDENT
C      VOLTAGE SOURCES.
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
	include 'values.inc'
                       character*8  valist
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(3200),nmax)

       COMMON /ELDATA/ EL,NELMTS,LELMTS,ELMNT(1)
          CHARACTER*8  ELMNT
       COMMON /SPARSE/ LNLOCA,NROWS,NZA,NLOCA(1)
          INTEGER*2    NLOCA
       COMMON /SCNTBL/ NBRAN,NLINK,NSRTCD,ISTSCL(17),NSCL(17),NCL(17),
     *                 ISTCL(8)
       COMMON /CMPTAB/ ICMPFG(1)
       COMMON /BUFERS/ BUF(1)
          CHARACTER*8  BUF
       INTEGER         TABLE(5)
       CHARACTER*8     C8TEMP,DUMY,VSOURC,
     *                 CHARS
       CHARACTER*4     XIBCD
 
       DATA CHARS      /'GW(   )='/
 
      IERR=1
      IF(NSCL(1).EQ.0.OR.NCL(2).EQ.0) RETURN
      ISTCHR=1
      CALL CPY(CHARS,1,BUF,ISTCHR,8)
      IF(NCL(3).EQ.0.OR.NCL(5).EQ.0) GO TO 500
      ISTCL2=ISTCL(2)
      IEDCL2=ISTCL2+NCL(2)-1
      JEY=ISTSCL(1)-1
      JEYEND=JEY+NSCL(1)
  100 JEY=JEY+1
 
C     ANY MORE LINEARLY DEPENDENT VOLTAGE SOURCES?
 
      IF(JEY.GT.JEYEND) GO TO 500
 
C     FIND LINEARLY DEPENDENT VOLTAGE SOURCE IN VALUE LIST
 
      CALL FIND (VALIST,ELMNT(JEY),ISTSUB,NDSUB,LEN)
      VSOURC=VALIST(NDSUB)
 
C     SHIFT CHARACTER V FROM SOURCE
 
      C8TEMP = VSOURC
      VSOURC = C8TEMP(2:6)
      DO 150 NDPRES=ISTCL2,IEDCL2
      IF(ELMNT(NDPRES).EQ.VSOURC) GO TO 160
  150 CONTINUE
      GO TO 100
  160 NUMCL3=NCL(3)
      LNKIND=ISTCL(3)-1-NBRAN
  170 IF(JSCAN(1,LNKIND,JEY,NUMCL3,IBY3))100,100,180
  180 IBRRES=ISTCL(5)-1
      NBRRES=NCL(5)
      NDPRP=NDPRES-NBRAN
  190 IF(JSCAN(0,NDPRP ,IBRRES,NBRRES,IB25)) 270,270,200
  200 LKIND=ISTCL(3)-1-NBRAN
      NMCL3=NCL(3)
  210 IF(JSCAN(1,LKIND,IBRRES,NMCL3,IB35)) 190,190,220
 
C     IS COMPUTE FLAG FOR COEIFFICIENT OF LDVS. TURNED ON
 
  220 IF(ICMPFG(JEY).NE.0) GO TO 250
      ICMPFG(JEY)=1
      ISTCHR=4
      CALL CPY(XIBCD(JEY,3,1,NERR),1,BUF,ISTCHR,3)
      ISTCHR=9
      CALL JSREQN(ELMNT(JEY),DUMY,BUF,ISTCHR,NERR)
 
C     COPY EQUATION DATA TO IDATA TABLE
 
  250 TABLE(1)=JEY
      TABLE(2)=IBY3*IB25*IB35*(LNKIND-ISTCL(3)+1+NBRAN)
      TABLE(3)=LKIND-ISTCL(3)+1+NBRAN
      TABLE(4)=IBRRES
      TABLE(5)=LNKIND+NBRAN
      IF(NMAX.LT.NELMTS)
     *   CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *               NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),NERR)
      ICMPFG(IBRRES)=1
      ICMPFG(LNKIND+NBRAN)=1
      CALL STOEQN(5,5,TABLE,NERR)
      GO TO 210
 
C     DOES INDEPENDENT RESISTOR CLOSE LDVS
 
  270 IF(LBITS(MATRIX,NDPRP,JEY,MXCODS,ISIGN)) 170,280,170
  280 JCL4=ISTCL(4)-1
      NCL4=NCL(4)
  285 IF(JSCAN(0,NDPRP,JCL4,NCL4,IB24)) 170,170,290
 
C     IS COMPUTE FLAG FOR COEIFFICIENT OF LDVS. TURNED ON
 
  290 IF(ICMPFG(JEY).NE.0) GO TO 300
      ICMPFG(JEY)=1
      ISTCHR=4
      CALL CPY(XIBCD(JEY,3,1,NERR),1,BUF,ISTCHR,3)
      ISTCHR=9
      CALL JSREQN(ELMNT(JEY),DUMY,BUF,ISTCHR,NERR)
 
C     COPY EQUATION DATA TO IDATA TABLE
 
  300 TABLE(1)=JEY
      TABLE(2)=IBY3*IB24     *(LNKIND-ISTCL(3)+1+NBRAN)
      TABLE(3)=JCL4-ISTCL(4)+1+NCL(3)
      TABLE(4)=NELMTS+1
      TABLE(5)=LNKIND+NBRAN
      ICMPFG(LNKIND+NBRAN)=1
      IF(NMAX.LT.NELMTS)
     *   CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *               NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),NERR)
      CALL STOEQN(5,5,TABLE,NERR)
      GO TO 285
 
C     ANY BRANCH CAPACITORS?
 
  500 IF(NCL(4).EQ.0) RETURN
      ISTCL2=ISTCL(2)
      IEDCL2=ISTCL2+NCL(2)-1
      JEY=ISTSCL(1)-1
      JEYEND=JEY+NSCL(1)
  600 JEY=JEY+1
 
C     ANY MORE LINEARLY DEPENDENT VOLTAGE SOURCES?
 
      IF(JEY.GT.JEYEND) RETURN
 
C     FIND LINEARLY DEPENDENT VOLTAGE SOURCE IN VALIST
 
      CALL FIND(VALIST,ELMNT(JEY),ISTSUB,NDSUB,LEN)
      VSOURC=VALIST(NDSUB)
 
C     REMOVE CHARACTER V
 
      C8TEMP=VSOURC
      VSOURC=C8TEMP(2:6)
      DO 620   NDPRES=ISTCL2,IEDCL2
      IF(ELMNT(NDPRES) .EQ.VSOURC) GO TO 630
  620 CONTINUE
      GO TO 600
  630 JCL4=ISTCL(4)-1
      NCL4=NCL(4)
      LDVSLK=0
      NDPRP=NDPRES-NBRAN
  640 IF(JSCAN(0,NDPRP ,JCL4,NCL4,JB24)) 600,600,650
  650 LNKRES=ISTCL2-1-NBRAN
      NCL2=NCL(2)
  660 IF(JSCAN(1,LNKRES,JEY,NCL2,IBYLR)) 665,665,670
  665 IF(LDVSLK.EQ.1) GO TO 640
      GO TO 600
  670 IF(LNKRES.EQ.NDPRP) GO TO 660
      ICL4=ISTCL(4)-1
      MCL4=NCL(4)
      LDVSLK=1
  680 IF(JSCAN(0,LNKRES,ICL4,MCL4,JB4LR)) 660,660,690
 
C     HAS COMPUTE FLAG FOR LDVS. BEEN SET
 
  690 IF(ICMPFG(JEY).EQ.1) GO TO 750
      ICMPFG(JEY)=1
      ISTCHR=4
      CALL CPY(XIBCD(JEY,3,1,NERR),1,BUF,ISTCHR,3)
      ISTCHR=9
      CALL JSREQN(ELMNT(JEY),DUMY,BUF,ISTCHR,NERR)
  750 TABLE(1)=JEY
      TABLE(2)=(JB4LR*JB24*IBYLR)*(ICL4-ISTCL(4)+1+NCL(3))
      TABLE(3)=JCL4-ISTCL(4)+1+NCL(3)
      TABLE(4)=LNKRES+NBRAN
      TABLE(5)=ICL4
      NDX=LNKRES+NBRAN
      ICMPFG(ICL4)=1
      ICMPFG(NDX         )=1
      IF(NMAX.LT.NELMTS)
     *   CALL GNLOCA(     TABLE(2) ,TABLE(3),NROWS,NZA,
     *               NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),NERR)
      CALL STOEQN(5,5,TABLE,NERR)
      GO TO 680
 
      END
