CSECT   JM34EQ                          72.110  00.39.08
 
      SUBROUTINE JM34EQ (IERR)
 
C     THIS SUBROUTINE GENERATES THE DATA NECESSARY TO PRODUCE THE
C        EQUATIONS FOR THE CAPACITORS AND MUTUALLY COUPLED INDUCTORS
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(3200),nmax)

      COMMON /ELDATA/ EL,NELMTS,LELMTS,ELMNT(2)
         CHARACTER*8  ELMNT
      COMMON /SPARSE/ LNLOCA,NROWS,NZA,NLOCA(200)
      COMMON /SCNTBL/ NBRAN,NLINK,NSRTCD,ISTSCL(17),NSCL(17),NCL(17),
     *                ISTCL(8)
      COMMON /INDUCT/ INDUC(300),NINDUC(300),MCHAIN(100),MBACK(100)
      INTEGER         TABLE(5),ROW,COL,ROW2
      INTEGER*2       NLOCA,INDUC,NINDUC,MCHAIN,MBACK,MUT
 
C     ARE THERE ANY LINK INDUCTORS?
 
      IF(NCL(3).EQ.0) RETURN
 
C     ARE THERE ANY BRANCH CAPACITORS?
 
      IF(NCL(4).EQ.0) RETURN
 
C     SET ROW AND COLUMN POINTERS TO 1ST LINK INDUCTOR AND BRANCH
C     CAPACITOR, RESPECTIVELY.
 
      COL = ISTCL(4)
   10 ROW = ISTCL(3)-NBRAN
   20 IF(LBITS(MATRIX,ROW,COL,MXCODS,KSIGN)) 30,90,30
   30 IF(NINDUC(ROW+NBRAN)) 90,90,40
   40 MUT = INDUC(ROW+NBRAN)
   45 MUTL = MUT
      IF(MUT.GT.50) MUTL = MUT-50
   50 ROW2 = MBACK(MUT)-NBRAN
      IF(ROW2) 70,70,55
 
C     IS THIS INDUCTOR IN A CUT SET WITH THIS CAPACITOR?
 
   55 IF(LBITS(MATRIX,ROW2,COL,MXCODS,LSIGN)) 70,60,70
 
C     AN ENTRY IS NECESSARY IN THE W-MATRIX.
 
   60 ITYPE = 7
      LTAB = 5
      TABLE(1) = ROW+NBRAN
      TABLE(2) = -(ROW-NCL(1)-NCL(2))*KSIGN
      TABLE(3) = COL-NCL(7)+NCL(3)
      TABLE(4) = -MUTL
      TABLE(5) = ROW2+NBRAN
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *   CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *               NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
      CALL STOEQN(ITYPE,LTAB,TABLE,IERR)
      TABLE(2) = (ROW2-NCL(1)-NCL(2))*KSIGN
      TABLE(4) = MUTL
 
C     STORE DATA FOR SPARSE METHOD IF USING VECTOR NOTATION
 
      IF(NELMTS.GT.NMAX)
     *  CALL GNLOCA(IABS(TABLE(2)),TABLE(3),NROWS,NZA,
     *              NLOCA(1),LNLOCA-2*NROWS,NLOCA(2*NROWS+1),IERR)
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
 
C     IS THERE YET ANOTHER INDUCTOR MUTUALLY COUPLED TO THIS ONE?
 
   70 IF(MCHAIN(MUT)) 90,90,80
 
C     PROCESS THE NEXT MUTUALLY COUPLED INDUCTOR
 
   80 MUT = MCHAIN(MUT)
      GO TO 45
 
C     INCREMENT PRIMARY LINK INDUCTOR POINTER
 
   90 ROW = ROW+1
 
C     HAVE ALL THE LINK INDUCTORS BEEN PROCESSED?
 
      IF(ROW+NBRAN.LT.ISTCL(3)+NCL(3)) GO TO 20
 
C     INCREMENT THE BRANCH CAPACITOR POINTER BY ONE
 
      COL = COL+1
 
C     HAVE ALL THE BRANCH CAPACITORS BEEN PROCESSED?
 
      IF(COL.LT.ISTCL(4)+NCL(4)) GO TO 10
      RETURN
 
      END
