CSECT   JSCAN                           71.042  11.43.38
 
      FUNCTION JSCAN (IDIR,ISTART,JSTART,NUM,ISIGN)
 
C     THIS FUNCTION SCANS A PARTICULAR ROW OR COLUMN OF THE B-MATRIX
C       UNTIL IT EITHER FINDS A NONZERO ENTRY (RETURN 1) OR REACHES
C         THE LIMIT OF THE SCAN (RETURN 0).
C     IDIR - 0 FOR ROW SCAN, 1 FOR COLUMN SCAN
C     ISTART - ROW INDEX OF FIRST ENTRY SCANNED MINUS ONE
C     JSTART - COLUMN INDEX OF FIRST ENTRY SCANNED MINUS ONE
C     NUM - NUMBER OF ENTRIES TO BE SCANNED
C     ISIGN - VALUE OF ENTRY IN B-MATRIX (+1,-1)
C     NOTE ISTART, JSTART, AND NUM ARE CHANGED DURING EACH EXECUTION
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
 
C     NUMBER OF ENTRIES LEFT IS ONE LESS
 
   10 NUM = NUM-1
 
C     HAS THE SCAN LIMIT BEEN REACHED?
 
      IF (NUM) 70,20,20
 
C     WHICH DIRECTION IS THIS SCAN?
 
   20 IF (IDIR) 40,30,40
 
C     ROW SCAN
 
   30 JSTART = JSTART+1
      GO TO 50
 
C     COLUMN SCAN
 
   40 ISTART = ISTART+1
 
C     IS THIS ENTRY NONZERO?
 
   50 IF (LBITS(MATRIX,ISTART,JSTART,MXCODS,ISIGN)) 60,10,60
 
C     INDICATE A NONZERO ENTRY FOUND
 
   60 JSCAN = 1
      RETURN
 
C     SCAN LIMIT HAS BEEN REACHED
 
   70 JSCAN = 0
      RETURN
 
      END
