CSECT   JSREQN                          71.042  11.43.38
C  29 MARCH 73
 
      SUBROUTINE JSREQN (TERM,PRSORC,BUFFER,ISTCHR,IERROR)
 
C     PURPOSE: GENERATE CURRENT SOURCE EQUATIONS FOR THE JACOBIAN
C     ARGUMENTS ARE:
C              TERM - DOUBLE-WORD VARIABLE ; CURRENT SOURCE NAME
C              BUFFER - DOUBLE-WORD TABLE  ; THE VALUE    IS STORED
C                       IN THIS TABLE.
C              ISTCHR - SINGLE-WORD INTEGER ; STARTING LOCATION IN THE
C                       BUFFER TABLE FOR THE VALUE.
C              IERROR - SINGLE-WORD INTEGER; THE ERROR INDICATOR
C                        = 1 , NORMAL RETURN
C                        = 2 , ABNORMAL RETURN
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
	include 'tapes.inc'
	include 'values.inc'
                      character*8  valist
                      integer      list(2*jqqval)
                      equivalence (list(1),valist(1))

      COMMON /CNTRLS/ CTROLS(139),XADJRQ
      CHARACTER*8
     *   XTABLE                 ,
     *   BLANK                  ,
     *   PARENL          ,
     *   COMMA           ,
     *   PARENR          ,
     *   DIOTB(2)                          ,
     *   DUMTAB(3)                                    ,
     *   ASTRSK               ,
     *   BUFFER(*),TERM,PRSORC,FWORD
 
      DATA
     *   XTABLE     /'XTABLE  '/,
     *   BLANK      /'        '/,
     *   PARENL     /'('/,
     *   COMMA      /','/,
     *   PARENR     /')'/,
     *   DIOTB      /'DIOT(   ','DIOG(   '/,
     *   DUMTAB     /',BJDUM,G','JDUM,ZJD','UM      '/,
     *   ASTRSK     /'     *'/
 
C     INITIALIZE ERROR CODE
 
      IERROR=1
      IARGCD=0
 
C     LOOK-UP TERM IN VALUE LIST AND GET IT'S POSITION SUBSCRIPTS.
 
      CALL FIND(VALIST,TERM,ISTSUB,NDSUB,LEN)
 
C     WAS TERM IN THE VALUE LIST?
 
      IF(LEN.GT.0) GO TO 50
      WRITE(iqqout,20) TERM
   20 FORMAT('-THE TERM ',A6,' COULD NOT BE FOUND IN THE VALUE ',
     *       'LIST BY ''JSREQN'' -PROGRAM ERROR.'///)
      STOP 'JSREQN: term not found in value list, run aborted'
 
   50 IVALCD=LIST(ISTSUB*2)
      IVALSV=IVALCD
  160 GO TO (200,230,240,255,250,600,180,180,190,190,600),IVALCD
  170 IARGCD=LIST(ISTSUB*2)
      IF(IARGCD.EQ. 1) GO TO 200
      IF(IARGCD.EQ. 3) GO TO 240
      IF(IARGCD.EQ.17) GO TO 250
      GO TO 230
 
C     COPY THE NAME 'DIOT(' OR 'DIOQ(' INTO THE BUFFER
 
  180 CALL CPY(DIOTB(IVALCD-6),1,BUFFER,ISTCHR,5)
      IF(IVALCD.EQ.8)ISTSUB=ISTSUB+2
      IF(IVALCD.EQ.7) GO TO 230
      GO TO 170
  190 PRSORC=VALIST(NDSUB)
      NDSUB=NDSUB-2
      ISTSUB=ISTSUB+1
      IVALCD=LIST(ISTSUB*2)
      GO TO 160
 
C     COPY CONSTANT INTO BUFFER
 
  200 DO 210 N=1,3
      N1=ISTSUB+N
      IF(VALIST(N1).EQ.BLANK) GO TO 220
  210 CALL CPY(VALIST(N1),1,BUFFER,ISTCHR,6)
  220 ISTSUB=ISTSUB+4
      GO TO 260
 
C     GENERATE DEFINED PARAMETER VALUE, ETAL
 
  230 CALL COPY(0,BLANK,VALIST(ISTSUB+1),BLANK,BUFFER,ISTCHR,NCHAR)
      IF(IARGCD.EQ.3.OR.IVALCD.EQ.3)
     *   CALL COPY(0,BLANK,PARENR,BLANK,BUFFER,ISTCHR,NCHAR)
      ISTSUB=ISTSUB+2
      GO TO 260
 
C     COPY TABLE FUNCTION NAME INTO BUFFER
 
  240 CALL CPY(XTABLE,1,BUFFER,ISTCHR,6)
 
C     COPY TABLE NAME WITH PREFIX '(' AND SUFFIX ',' .
 
      CALL COPY(0,PARENL,VALIST(ISTSUB+1),COMMA,BUFFER,ISTCHR,NCHAR)
      ISTSUB=ISTSUB+2
 
C     IS THE SECOND ARGUMENT AN EXPRESSION
 
      IF(LIST(ISTSUB*2).NE.17) GO TO 230
 
C     COPY EXPRESSION INTO BUFFER
 
  250 CALL CPY(VALIST(ISTSUB+2),1,BUFFER,ISTCHR,8*LIST(ISTSUB*2+2))
      IF(IARGCD.EQ.3.OR.IVALCD.EQ.3)
     *   CALL COPY(0,BLANK,PARENR,BLANK,BUFFER,ISTCHR,NCHAR)
      ISTSUB=ISTSUB+LIST(ISTSUB*2+2)+2
      GO TO 260
 
C     COPY EQUATION NAME INTO BUFFER
 
  255 CALL COPY(0,BLANK,VALIST(ISTSUB+1),PARENL,BUFFER,ISTCHR,NCHAR)
      ISTSUB=ISTSUB+2
      GO TO 170
  260 IF(IVALCD.NE.7.AND.IVALCD.NE.8) GO TO 350
      IF(ISTSUB.GE.NDSUB) GO TO 400
 
C     COPY COMMA INTO BUFFER
 
  320 CALL CPY(COMMA,1,BUFFER,ISTCHR,1)
      GO TO 170
  350 IF(ISTSUB.LT.NDSUB) GO TO 320
      IF(IVALCD.EQ.4) GO TO 450
      GO TO 500
 
C     COPY CURRENT SOURCE NAME INTO BUFFER
 
  400 CALL COPY(0,COMMA,TERM,BLANK,BUFFER,ISTCHR,NCHAR)
 
C     COPY DUMMY ARGUMENTS INTO BUFFER
 
      IF(IVALCD.EQ.8) GO TO 450
      NCHARS=6
      CALL CPY(DUMTAB,1,BUFFER,ISTCHR,NCHARS)
 
C     COPY ')' INTO BUFFER
 
  450 CALL CPY(PARENR,1,BUFFER,ISTCHR,1)
  500 FWORD=BLANK
      IF (nint(XADJRQ).EQ.0 .OR.
     *   (IVALSV.NE.9 .AND. IVALSV.NE.10)) GO TO 550
      CALL WTPDRV(BLANK,'IF(XADJNT .EQ. 0.D0)',20,1,NERR)
      FWORD=ASTRSK
  550 CALL WTPDRV(FWORD,BUFFER,ISTCHR-1,1,NERR)
  600 RETURN
 
      END
