CSECT   LCSUM                           72.110  00.39.08
 
      SUBROUTINE LCSUM(IERR)
 
C     THIS SUBROUTINE GENERATES THE NECESSARY EQUATION DATA TO PRODUCE
C     JACOBIAN CAPACITOR AND INDUCTOR SUMS
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
      COMMON /SCNTBL/ NBRAN,NLINK,NSRTCD,ISTSCL(17),NSCL(17),NCL(17),
     *                ISTCL(8)
      COMMON /CMPTAB/ ICMPFG(300)
      COMMON /BUFERS/ IFLAG(440)
      INTEGER         TABLE(2)
 
      DATA            ITYPE /1/,LTAB /2/
 
C     ANY C BRANCHES?
 
      IF (NCL(4).EQ.0) GO TO 500
 
C     INITIALIZE FLAGS TABLE
 
      NCL4=NCL(4)
      DO 100 I=1,NCL4
  100 IFLAG(I)=0
      ISTCL4=ISTCL(4)
 
C     ANY C LINKS
 
      IF (NCL(1).EQ.0) GO TO 300
      ISTCL1=ISTCL(1)
      IEDCL1=ISTCL1+NCL(1)-1
 
C     FIND THE C BRANCHES IN THE SAME LOOPS AS C LINKS
 
      DO 200 NDXCL1=ISTCL1,IEDCL1
      NDXCL4=ISTCL4-1
      NCL4=NCL(4)
      IROW=NDXCL1-NBRAN
      NUM=0
 
C     DOES C BRANCH CLOSE THE C LINK
 
  110 IF (JSCAN(0,IROW,NDXCL4,NCL4,ISIGN)) 200,200,120
  120 NUM=NUM+1
      NCL4P=NDXCL4-ISTCL(4)+1
 
C     DOES MORE THAN ONE C BRANCH CLOSE C LINK
 
      IF (NUM.GT.1) GO TO 170
      ISAVE=NCL4P
 
C     HAS  C BRANCH SUM BEEN PREVIOUSLY ELIMINATED
 
      IF (IFLAG(NCL4P).LT.0) GO TO 110
 
C     ADD C LINK TO C BRANCH SUM
 
      IFLAG(NCL4P)=IFLAG(NCL4P)+1
      ICMPFG(NDXCL1)=NDXCL4
 
C     CONTINUE C LINK SCAN
 
      GO TO 110
 
C     INDICATE THAT C BRANCH DOES NOT USE C LINKS IN SUM
 
  170 IFLAG(NCL4P)=-1
      IFLAG(ISAVE)=-1
 
C     CONTINUE SCAN OF C LINKS
 
      GO TO 110
 
C     HAVE ALL C LINKS BEEN SCANNED
 
  200 CONTINUE
 
C     GENERATE EQUATION DATA FOR C BRANCH SUMS
 
  300 IEDCL4=ISTCL4+NCL(4)-1
      DO 450 NDXCL4=ISTCL4,IEDCL4
 
C     IS COMPUTE FLAG FOR C BRANCH ON
 
      IF (ICMPFG(NDXCL4).EQ.0) GO TO 450
 
C     STORE DATA FOR C BRANCH
 
      TABLE(1)=NDXCL4
      TABLE(2)=NDXCL4
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
      IFLGPT=NDXCL4-ISTCL4+1
 
C     ARE ANY C LINKS ADDED TO C BRANCH SUM
 
      IF (IFLAG(IFLGPT)) 450,450,320
  320 continue
      DO 400 I=ISTCL1,IEDCL1
 
C     IS THIS C LINK USED IN SUM?
 
      IF (ICMPFG(I).NE.NDXCL4) GO TO 400
 
C     STORE DATA FOR C LINK
 
      TABLE(2)=I
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
 
C     ANY MORE C LINKS
 
  400 CONTINUE
 
C     ANY MORE C BRANCHES
 
  450 CONTINUE
 
C     ANY L LINKS?
 
  500 IF (NCL(3).EQ.0) RETURN
 
C     INITIALIZE FLAGS TABLE
 
      NCL3=NCL(3)
      DO 600 I=1,NCL3
  600 IFLAG(I)=0
      ISTCL3=ISTCL(3)
 
C     ANY L BRANCHES
 
      IF (NCL(6).EQ.0) GO TO 800
      ISTCL6=ISTCL(6)
      IEDCL6=ISTCL6+NCL(6)-1
      NXCL3=ISTCL3-1-NBRAN
 
C     FIND THE L LINKS IN THE L BRANCH CUTSETS
 
      DO 700 ICOL  =ISTCL6,IEDCL6
      NDXCL3=NXCL3
      NCL3=NCL(3)
      NUM=0
 
C     DOES L LINK CLOSE THE L BRANCH
 
  610 IF (JSCAN(1,NDXCL3,ICOL,NCL3,ISIGN)) 700,700,620
  620 NUM=NUM+1
      NCL3P=NDXCL3-NXCL3
 
C     DOES MORE THAN ONE L LINK CLOSE THE L BRANCH
 
      IF (NUM.GT.1) GO TO 670
      ISAVE=NCL3P
 
C     HAS  L LINK   SUM BEEN PREVIOUSLY ELIMINATED
 
      IF (IFLAG(NCL3P).LT.0) GO TO 610
 
C     ADD L BRANCH TO L LINK SUM
 
      IFLAG(NCL3P)=IFLAG(NCL3P)+1
      ICMPFG(ICOL)=NDXCL3+NBRAN
 
C     CONTINUE L BRANCH SCAN
 
      GO TO 610
 
C     INDICATE THAT L LINK DOES NOT USE L BRANCHES IN SUM
 
  670 IFLAG(NCL3P)=-1
      IFLAG(ISAVE)=-1
 
C     CONTINUE SCAN OF L BRANCHES
 
      GO TO 610
 
C     HAVE ALL L BRANCHES BEEN SCANNED?
 
  700 CONTINUE
 
C     GENERATE EQUATION DATA FOR L LINK SUMS
 
  800 IEDCL3=ISTCL3+NCL(3)-1
      DO 950 NDXCL3=ISTCL3,IEDCL3
 
C     IS COMPUTE FLAG FOR L LINK ON
 
      IF (ICMPFG(NDXCL3).EQ.0) GO TO 950
 
C     STORE DATA FOR L LINK
 
      TABLE(1)=NDXCL3
      TABLE(2)=NDXCL3
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
      IFLGPT=NDXCL3-ISTCL3+1
 
C     ARE ANY L BRANCHES ADDED TO L LINK SUM?
 
      IF (IFLAG(IFLGPT)) 950,950,820
  820 continue
      DO 900 I=ISTCL6,IEDCL6
 
C     IS THIS L BRANCH USED IN SUM?
 
      IF (ICMPFG(I).NE.NDXCL3) GO TO 900
 
C     STORE DATA FOR L BRANCH
 
      TABLE(2)=I
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
 
C     ANY MORE L BRANCHES
 
  900 CONTINUE
 
C     ANY MORE L LINKS
 
  950 CONTINUE
 
C     RETURN
 
      RETURN
 
      END
