CSECT   LRDEQS                          72.110  00.39.08
 
      SUBROUTINE LRDEQS
 
C     THIS SUBROUTINE WILL GENERATE ALL STATEMENTS REQUIRED FOR THE
C       SOLUTION OF V2, I2, V5 AND I5 WHEN THE CIRCUIT CONTAINS ANY
C         LINEAR RESISTOR DEPENDENT SOURCES.  THE RESISTORS THAT THESE
C           SOURCES ARE DEPENDENT UPON MAY BE CONSTANT OR VARIABLE.
C
C     LRDEQS SUBROUTINE    JERRY PATTERSON    8/3/66
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tables.inc'
                      equivalence (iqtabl(2797),ndep)

      INTEGER         VALCOD,VARRES,B25
      COMMON /ELDATA/ ELM,NELMTS,NELIMT,ELMNTS(300),EE(1200),
     *                CMPFLG(300),VALCOD(2,300)
         CHARACTER*8  ELMNTS,CMPFLG
      COMMON /SCNTBL/ NBRANS,NN(2),ISTCOD(17),LENCOD(17),NCL(17),
     *                IST(8),NSCAN(7),B25
         EQUIVALENCE (IST2,IST(2)),(IST5,IST(5))
      COMMON /BUFERS/ BUFF,BUFFER(1)
         CHARACTER*4  BUFFER
      COMMON /CNTRLS/ SKIP(48),ISTNUM
         EQUIVALENCE (SKIP(34),XIR)
      CHARACTER*4     DO,XIBCD
      CHARACTER*8     XSTNUM,X2AND5,
     *   FIRSTN          ,
     *   SECN1            ,
     *   ZEROPT       ,
     *   BLANK       ,
     *   COMENT      ,
     *   S9000           ,
     *   V           ,
     *   C           ,
     *   XMRG           ,
     *   XI2V5P           ,
     *   XMRGI
 
      DATA
     *   FIRSTN /' N=1,'/,
     *   SECN1  /' N1=1,'/,
     *   ZEROPT /'0.'/,
     *   BLANK  /' '/,
     *   COMENT /'C'/,
     *   S9000  /' 9000'/,
     *   V      /'V'/,
     *   C      /'I'/,
     *   XMRG   /'XMRG'/,
     *   XI2V5P /'XI2V5P'/,
     *   XMRGI /'XMRGI'/
      DATA DO /'DO'/
      DATA ISTCR1 /1/
 
   10 N2AND5=NCL(2)+NCL(5)
      ILAST2=IST2+NCL(2)-1
      ILAST5=IST5+NCL(5)-1
      X2AND5=XIBCD(N2AND5,3,1,N)
 
C     DIMENSION XMRG(N2AND5,N2AND5).
 
      CALL DIMENS(XMRG,0,N2AND5)
 
C     CHECK FOR ANY VARIABLE RESISTORS.
 
      VARRES=0
      IF (NCL(2)) 110,115,110
  110 DO 11 I=IST2,ILAST2
   11 IF (VALCOD(2,I).NE.1) GO TO 14
  115 IF (NCL(5)) 120,125,120
  120 DO 12 I=IST5,ILAST5
   12 IF (VALCOD(2,I).NE.1) GO TO 14
 
C     CONSTANT RESISTORS ONLY--DIMENSION XMRGI(N2AND5,N2AND5).
 
  125 CALL DIMENS(XMRGI,0,N2AND5)
 
C     SET UP MRG MATRIX EQUATIONS.
 
      CALL MRGEQS
 
C     GET THE MATRIX INVERTED SINCE NO VARIABLE RESISTORS.
 
      CALL GN8INV(XMRG,4,2,N2AND5)
      GO TO 15
 
C     VARIABLE RESISTANCE IN CIRCUIT.
 
   14 VARRES=1
 
C     DO LOOP FOR CLEARING XI2V5P.
 
   15 CALL DIMENS(XI2V5P,1,N2AND5)
 
C     STATEMENT TO INCREMENT PASS NO.
 
      CALL WTSPTP (COMENT,'TRANSIENT EQUATIONS',19,NERROR)
      IF(XIR.EQ.0D0)
     *  CALL WTSPTP(S9000,'XPASNO=XPASNO+1.',16,N)
 
C     TECHNIQUE FOR STAYING UNDER 100 EXECUTABLE FORTRAN STATEMENTS.
C     SCAN OUT XI2V5P FOR (-B27*E7-B24*V4) AND (B85T*I3+B85T*J8)
C     EXCLUDING ALL RESISTOR DEPENDENT SOURCES.
 
      CALL CPY('XI2V5P(   )=',1,BUFFER,ISTCR1,12)
      ISUB=1
      CALL WTSPTP(COMENT,
     *     'XI2V5P=-B27*E7-B24*V4 AND B35T*I3+B85T*J8 EXCLUDING'//
     *     ' RES. DEP.''S',63,N)
      DO 25 J=2,5,3
      IF (NCL(J)) 16,25,16
   16 IFIRST=IST(J)
      ILAST=IFIRST+NCL(J)-1
      DO 20 I=IFIRST,ILAST
      NDEP=0
      ITOCHR=8
      CALL CPY(XIBCD(ISUB,3,1,N),1,BUFFER,ITOCHR,3)
      ITOCHR=ISTCR1
      IF (J.EQ.5) GO TO 17
 
C     I2 SCAN.
 
      CALL BV4SCN(-1,V,I,0,ITOCHR,NCHARS,LENCOD(1)+1,NCL(7)-LENCOD(1),
     *            IST(4),NCL(4),0,0,0,0,N)
      GO TO 18
 
C     V5 SCAN.
 
   17 CALL BV4SCN(1,C,I,5,ITOCHR,NCHARS,IST(3),NCL(3),IST(8)+
     *            LENCOD(14),NCL(8)-LENCOD(14),0,0,0,0,N)
   18 IF (ITOCHR.EQ.ISTCR1) CALL CPY(ZEROPT,1,BUFFER,ITOCHR,2)
      CALL WTEQTN(BLANK,0,BUFFER,ITOCHR-1,BLANK,N)
   20 ISUB=ISUB+1
   25 CONTINUE
      IF (VARRES) 41,27,41
   27 CALL WTSPTP(COMENT,
     * 'NO VARIABLE RESISTORS--LOAD I2 AND V5 WITH XMRGI*XI2V5P',55,N)
      BUFFER(1)=DO
      KWAY=1
  270 I=-1
  275 I=I+3
      IF (NCL(I)) 28,280,28
   28 ISTNUM=ISTNUM+10
      XSTNUM=XIBCD(ISTNUM,4,1,N)
      ITOCHR=4
      CALL CPY(XSTNUM,2,BUFFER,ITOCHR,4)
      CALL CPY(FIRSTN,1,BUFFER,ITOCHR,6)
      CALL CPY(XIBCD(NCL(I),3,1,N),1,BUFFER,ITOCHR,3)
      CALL WTSPTP(BLANK,BUFFER,16,N)
  280 GO TO (285,450,700),KWAY
  285 IF (NCL(I)) 290,40,290
  290 IF (I.EQ.5) GO TO 30
      CALL WTSPTP(BLANK,'I2(N)=0.',8,N)
      GO TO 32
   30 CALL WTSPTP(BLANK,'V5(N)=0.',8,N)
      CALL WTSPTP(BLANK,'N2=N+NCL2C',10,N)
   32 ITOCHR=8
      CALL CPY(SECN1,1,BUFFER,ITOCHR,6)
      CALL CPY(X2AND5,1,BUFFER,ITOCHR,3)
      CALL WTSPTP(BLANK,BUFFER,16,N)
      IF (I.EQ.5) GO TO 35
      CALL WTSPTP(XSTNUM,'I2(N)=I2(N)+XMRGI(N,N1)*XI2V5P(N1)',34,N)
      GO TO 40
   35 CALL WTSPTP(XSTNUM,'V5(N)=V5(N)+XMRGI(N2,N1)*XI2V5P(N1)',35,N)
   40 IF (I-5) 275,70,275
 
C     GENERATE MRG MATRIX EQUATIONS WITH VARIABLE RESISTANCE.
 
   41 CALL MRGEQS
      CALL GN8INV(XMRG,4,1,N2AND5)
 
C     LOAD I2 AND V5 VECTORS DIRECTLY FROM XI2V5P VECTOR.
 
      CALL WTSPTP(COMENT,
     *     'VARIABLE RESISTORS--LOAD I2 AND V5 DIRECTLY'//
     *     ' FROM LINSOL RESULTS',63,N)
      BUFFER(1)=DO
      KWAY=2
      GO TO 270
  450 IF (NCL(I)) 455,60,455
  455 IF (I.EQ.5) GO TO 50
      CALL WTSPTP(XSTNUM,'I2(N)=XI2V5P(N)',15,N)
      GO TO 60
   50 CALL WTSPTP(BLANK,'N1=N+NCL2C',10,N)
      CALL WTSPTP(XSTNUM,'V5(N)=XI2V5P(N1)',16,N)
   60 IF (I.NE.5) GO TO 275
 
C     DO LOOPS FOR V2=I2*XR22D AND I5=V5/XR55D.
 
   70 KWAY=3
      GO TO 270
  700 IF (NCL(I)) 705,80,705
  705 IF (I.EQ.5) GO TO 75
      CALL WTSPTP(XSTNUM,'V2(N)=I2(N)*XR22D(N)',20,N)
      GO TO 80
   75 CALL WTSPTP(XSTNUM,'I5(N)=V5(N)/XR55D(N)',20,N)
   80 IF (I.NE.5) GO TO 275
 
C     TURN ON CLASS 2 AND 5 I AND V COMPUTE FLAGS.
 
      IF (NCL(2)) 81,83,81
   81 DO 82 I=IST2,ILAST2
      CMPFLG(I)(4:4)=CHAR(255)
   82 CMPFLG(I)(5:5)=CHAR(255)
   83 IF (NCL(5)) 84,90,84
   84 DO 85 I=IST5,ILAST5
      CMPFLG(I)(4:4)=CHAR(255)
   85 CMPFLG(I)(5:5)=CHAR(255)
   90 RETURN
 
      END
