CSECT   MDEDIT                          72.110  00.39.08
 
      SUBROUTINE MDEDIT (MODIND,LASTCR)
 
C      MODEL EDITOR MAINTAINS TWO LIBRARY TAPES OF MODEL DESCRIPTIONS.
C      A TEMPORARY LIBRARY TAPE WHICH IS CREATED EACH TIME MODEL EDITOR
C      IS CALLED (IF SPECIFIED) AND,
C      A PERMANENT LIBRARY TAPE WHICH CAN BE CREATED OR EDITED
C      A PRINTOUT IS GIVEN PER RUN CONSISTING OF
C      A LISTING OF THE TEMPORARY LIBRARY TAPE
C      A LISTING OF THE ADDITIONS MADE TO THE PERMANENT LIBRARY TAPE
C      AN OPTIONAL PRINT-OUT OF THE ENTIRE PERMANENT LIBRARY TAPE CAN
C      BE OBTAINED IF THE 'PRINT' OPTION IS SPECIFIED ON THE MODEL
C      DESCRIPTION CARD.

C      IOUTTP = IBSYS/SCEPTRE OUTPUT
C      INTAPE = IBSYS/SCEPTRE INPUT
C      LIBTPE = SCEPTRE PERMANENT MODEL LIBRARY*
C      INOUTP = SCEPTRE TEMPORARY MODEL LIBRARY
C      IUTTPE = MODEL EDIT UTILITY *
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)

	include 'tapes.inc'
	include 'values.inc'
                      parameter (jqq002=(jqqval-4)/2)
                      character*8  indext(jqq002)
                      character*8  indexp(jqq002)
                      equivalence (valist(5),indexp(1))
                      equivalence (valist(5+jqq002),indext(1))

      COMMON /CNTRLS/ ICNTRL(99),IERROR
      COMMON /MODATA/ ANAMES(3),CKTDES(4),PRJ(62),ANODES(25,2),NMDNOD,
     *                MDPRNT,SUPRES(10),EQUCHG(15,2),TBLCHG(15,2),
     *                NTBLCH,NEQUCH,NSUPRS,
     *                MDTAPE,MDLEN,MDUSED,IALL,KCHNGE,IHEADT,NMDCHR
      COMMON /SAVER/  EW,NEWGRP
      COMMON /BUFERS/ SPLTBF(72),BLNKBF(72),PACKBF(12)
         CHARACTER*8  SPLTBF,BLNKBF,PACKBF
      COMMON /SCNTBL/ NAMEPK(3),ITEMPB(10)
         CHARACTER*8  MEDIT,NAMEPK,ITEMPB
      DOUBLE PRECISION RNDEXP (996), RNDEXT(996), RTEMPB(10)
      EQUIVALENCE    (RNDEXP(1),INDEXP(1)),(RNDEXT(1),INDEXT(1)),
     *               (RTEMPB(1),ITEMPB(1))
      CHARACTER*8     FIRSTR(7),PRINTR(5)
      CHARACTER*8     MASTER(6),PERM(9),TEMP(9),DLETE(6),COMMA,BLANKS
 
      DATA MEDIT  /'MDEDIT'/
      DATA FIRSTR /'I','N','I','T','I','A','L'/
      DATA PRINTR /'P','R','I','N','T'/
      DATA MASTER /'M','A','S','T','E','R'/
      DATA  PERM  /'P','E','R','M','A','N','E','N','T'/
      DATA TEMP   /'T','E','M','P','O','R','A','R','Y'/
      DATA DLETE  /'D','E','L','E','T','E'/
      DATA COMMA,BLANKS /',',' '/
      DATA INDP,INITL,IPRINT,NPERMX,NTEMPX,IPTRP,IPTRT,IHEADP/8*0/
 
    2 FORMAT (72A1,8X)
    3 FORMAT (3A6,D12.4,50X)
    6 FORMAT (10A8)
      REWIND iqqlbm
      REWIND iqqlbt
      REWIND iqqutl
      NMDCHR=-1
      NEWGRP=1
      NTRESP=0
      NTREST=0
      LOW=1
      CALL DLIMIT (LOW,LASTCR,INFO,LOC,NCHAR)
      IF (INFO.EQ.7) GO TO 19
      IF (INFO.NE.3) GO TO 18
 
C     TEST FOR  'INITIAL' SEQUENCE
 
   14 DO 12 I=1,7
      IX=LOC+I
   12 IF (BLNKBF(IX).NE.FIRSTR(I)) GO TO 15
      INITL=1
      GO TO 16
 
C     TEST FOR 'PRINT' SEQUENCE
 
   15 DO 13 I=1,5
      IX=LOC+I
   13 IF (BLNKBF(IX).NE.PRINTR(I)) GO TO 18
      IPRINT=1
   16 LOC=IX+1
      IF (LOC.EQ.LASTCR) GO TO 19
      IF (BLNKBF(LOC).EQ.COMMA) GO TO 14
   18 KERROR=37
      GO TO 72
 
C     IF INITL IS OFF -
C     READ PERMANENT LIBRARY (iqqlbm) INTO STORAGE AND
C     COPY MODEL DATA TO TEMPORARY LIBRARY TAPE (iqqlbt)
 
   19 ITRAN=2
      IF (IPRINT.EQ.1) GO TO 51
   21 ITRAN=1
   20 CALL GETCK (ISTART,LASTCR,NOCARD)
 
C      IS THIS A MODE CARD
 
      IF (NEWGRP.GE.0) GO TO 30
      MODIND=IABS(NEWGRP)
      NMDCHR=0
      GO TO 75
 
C      CARD IS NOT A MODE CARD
C      IS THIS A MODEL HEADER CARD ?
 
   30 IF (PACKBF(1)(1:5).NE.'MODEL') GO TO 35
 
C      GET MODEL NAME ('N' CHARACTERS TO NEXT '(' )
C      BEGINNING OF MODEL NAME SHOULD BE AT BLKNBF(6)
 
      J1 = 6
      CALL DLIMIT (J1,LASTCR,INFO,J2,IPREFX)
      IF (INFO.EQ.3) GO TO 36
   42 KERROR=22
      GO TO 72
   36 IF (IPREFX.LE.18) GO TO 39
      KERROR=58
      GO TO 72
   39 IF (IPREFX.LE.0) GO TO 42
      DO 38 I = 1,3
   38 NAMEPK(I) = BLANKS
      CALL CPYSP (BLNKBF(J1),IPREFX,' ',0,' ',0,NAMEPK,NAMELT)
 
C      DETERMINE MODEL LIBRARY SPECIFICATION
C      CHECK FOR PERM,MASTER OR PERMANENT CHARACTER SEQUENCE
 
      INDP=0
      J2=J2+1
      IF (ISCANS(BLNKBF,J2,LASTCR,PERM  ,1,4,KOMPAR).NE.0) GO TO 50
      IF (ISCANS(BLNKBF,J2,LASTCR,MASTER,1,6,KOMPAR).NE.0) GO TO 50
 
C     TEST FOR DELETE FROM THE PERMANENT LIBRARY
 
      IF (ISCANS(BLNKBF,J2,LASTCR,DLETE ,1,6,KOMPAR).NE.0) GO TO 51
      GO TO 60
   50 INDP=1
   51 IF ((NPERMX.GT.0).OR.(INITL.EQ.1)) GO TO 66
      READ (iqqlbm,3) (ITEMPB(L1),L1=1,3),RTEMPB(4)
      IHEADP = nint(RTEMPB(4))
      L1 = 1
      DO 63 J=1,IHEADP
         L2=L1+3
         READ (iqqlbm,3) (INDEXP(I),I=L1,L2-1),RNDEXP(L2)
         L1 = L2+1
CX 63 NPERMX=NPERMX+INDEXP(L2)
   63 NPERMX=NPERMX+nint(RNDEXP(L2))
      DO 65 J=1,NPERMX
         READ (iqqlbm,6) ITEMPB
   65 WRITE (iqqlbt,6) ITEMPB
   66 GO TO (64,21),ITRAN
   64 IF (INDP.EQ.1) GO TO 70
 
C     DELETE MODEL
 
      LUCKEY=INDSRH (DLETE,INDEXP,IHEADP,NAMEPK)
      NTRESP=1
      GO TO 20
 
C     PERMANENT LIBRARY ENTRY HAS BEEN DETECTED
 
   70 IF (INDSRH(PERM,INDEXP,IHEADP,NAMEPK).NE.0) GO TO 20
      IPTRP = IHEADP*4
      GO TO 31
 
C      IS MODEL ALREADY IN APPROPRIATE INDEX
 
   60 INDP=0
      IF (INDSRH(TEMP,INDEXT,IHEADT,NAMEPK).NE.0) GO TO 20
      IPTRT = IHEADT*4
      GO TO 32
   72 CALL ERROR (MEDIT,2,KERROR)
      GO TO 20
 
C      CARD IS NOT A MODEL HEADER CARD
C      IS SKIP INDICATOR ON ?
 
   35 IF (IERROR.NE.1) GO TO 20
 
C      STORE CARD ON APPROPRIATE AUXILLARY TAPE
 
      IF (INDP .EQ. 0 ) GO TO 32
   31 WRITE (iqqlbt,2) (SPLTBF(I),I=1,72)
 
C      INCREASE APPROPRIATE INDEX
 
      RNDEXP(IPTRP)=RNDEXP(IPTRP)+1.
      NPERMX= NPERMX+1
      NTRESP=1
      GO TO 20
   32 WRITE (iqqutl,2) (SPLTBF(I),I=1,72)
 
C      INCREASE APPROPRIATE INDEX
 
      RNDEXT(IPTRT)=RNDEXT(IPTRT)+1.
      NTEMPX = NTEMPX +1
      NTREST=1
      GO TO 20
 
C      ARE THERE ANY PERMANENT LIBRARY INDEX ENTRIES
 
   75 IF (IERROR.NE.1) GO TO 100
      IF ((IPRINT.NE.0).OR.(NTRESP.NE.0))
     *   CALL WRTTPE (PERM,iqqlbm,iqqlbt,IHEADP,INDEXP,NTRESP,IPRINT)
 
C      ANY TEMPORARY MODELS
 
   95 CALL WRTTPE (TEMP,iqqlbt,iqqutl,IHEADT,INDEXT,NTREST,IPRINT)
  100 RETURN
 
      END
