CSECT   MDELCH                          71.042  11.43.38
 
       SUBROUTINE MDELCH (KDERIV,KPREFX,KSPLIT,IERROR,KTYPE)
 
C      SUBROUTINE TO PROCESS AND STORE ELEMENT, MUTUAL AND SOURCE
C      DERIVATIVE MODEL CHANGES
C                    KDERIV - NON-ZERO INDICATES SOURCE DERIVATIVE
C                    KPREFX - INDICATES PREFIX (D) IS REQUIRED FOR
C                                 SOURCE DERIVATIVE NAME
C                    KSPLIT - INDICATES THE NUMBER OF MODEL CHARACTERS
C                                 IN CKTDES TABLE
C                    IERROR - ERROR INDICATOR ( 1 IS NORMAL,
C                                               2 IS ERROR CONDITION)
C                    KTYPE  - QUANTITY TYPE AS DETERMINED IN MODEL
C                                 CHANGE PROCESSOR -  5 IMPLIES R,L,C
C                                                    10 IMPLIES DJ,DE
C                                                    11 IMPLIES J,E
C                                                    12 IMPLIES M
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
      COMMON /TBLES/  TABLE(200)
         DIMENSION    ITABLE(400)
         EQUIVALENCE (TABLE,ITABLE)
         CHARACTER*8  TABLE
      COMMON /BUFERS/ SPLTBF(72),BUFFER(72),PACKBF(12),START,LAST
         CHARACTER*8  SPLTBF,BUFFER,PACKBF
      COMMON /MODATA/ ANAMES(3),CKTDES(4),PRJ(62),ANODES(25,2),NMDNOD,
     *                MDPRNT,SUPRES(10),EQUCHG(15,2),TBLCHG(15,2),
     *                NTBLCH,NEQUCH,NSUPRS,MDTAPE,MDLEN,MDUSED,IALL,
     *                KCHNGE,NTEMP,NMDCHR
         CHARACTER*8  CKTDES
      INTEGER         START
      CHARACTER*8
     *   EQUALS      ,
     *   D
      CHARACTER*8
     *   XDIOD            ,
     *   PREFXV      ,
     *   PREFXI      ,
     *   J
      CHARACTER*8     SPLIT,PREFIX,TEMP1,TMPLOC
 
      DATA NAMLIM /5/
      DATA ILIMIT /200/
      DATA
     *   EQUALS /'='/,
     *   D      /'D'/
C      THIS CORRECTION WAS MADE TO CORRECT A TYPOGRAPHICAL ERROR.  ANY
C      CHANGE TO A CURRENT DEPENDENT DIODE WOULD RESULT IN AN ERROR.
C      (10/20/69)
C     DATA XDIOD/'XDIODE'/,PREFXV/1HV/,PREVXI/1HI/,J/1HJ/
      DATA
     *   XDIOD  /'XDIODE'/,
     *   PREFXV /'V'/,
     *   PREFXI /'I'/,
     *   J      /'J'/
 
      IBEGIN = 1
      IDERIV = KDERIV
      IPREFX = KPREFX
      IERRS=1
 
C     DELIMIT NAME AND COPY INTO TEMPORARY LOCATION
 
  500 IF (ICSCAN(BUFFER,START,LAST,EQUALS,KLAST) .EQ. 0)KLAST = LAST +1
      NAMLEN = KLAST - START
      CALL CPYSP (D,IPREFX,BUFFER(START),NAMLEN,CKTDES,KSPLIT,TMPLOC,
     *            NWORDS)
      PREFIX=PREFXV
      IF(BUFFER(START).NE.J) PREFIX=PREFXI
      CALL CPYSP(PREFIX,1,BUFFER(START),NAMLEN,CKTDES,KSPLIT,TEMP1,
     *           NWORDS)
      IF(NWORDS.GT.1) GO TO 580
      IF (NWORDS .GT. 1) GO TO 580
      IF (KTYPE .NE. 5 .AND. KTYPE .NE. 11) GO TO 700
      IF (NAMLIM - IPREFX - NAMLEN - KSPLIT) 580, 700, 700
 
C         VARIABLE NAME EXCEEDS SIX CHARACTERS
 
  580 KERROR=3
      GO TO 2900
 
C     STORE STARTING POSITION IN BUFFER AS SPLIT ARGUMENT FOR STORE
C     ELEMENT DATA SUBROUTINE
 
  700 SPLIT = BUFFER (START)
 
C     CHECK DATA LENGTH ON CARD AND GET MORE IF NECESSARY
 
      START = KLAST + 1
  705 IF (START .LE. LAST) GO TO 800
      CALL GETCK( START, LAST, NOCARD)
      GO TO (750, 710), NOCARD
 
C         INCOMPLETE SPECIFICATION PRIOR TO GROUP OR MODE CARD
 
  710 KERROR=32
      GO TO 2900
 
C     CHECK FIRST CHARACTER FOR EQUALS SIGN
 
  750 IF (BUFFER (START) .NE. EQUALS) GO TO 800
      START = START + 1
      GO TO 705
 
C     PROCESS VALUE
 
  800 CALL VLUPRS (IBEGIN,ILIMIT,LENTBL,IERRS)
      GO TO (810,3000), IERRS
 
C     MODIFY VALUE TABLE FOR DIODE TABLE OR DIODE EQUATION
 
  810 IF (ITABLE(2).NE.8) GO TO 830
      LENTBL=LENTBL+1
      IBEGIN=IBEGIN-1
      TABLE(2)=XDIOD
      DO 820 JDUM=3,LENTBL
  820 TABLE(JDUM)=TABLE(JDUM+1)
      GO TO 840
  830 IF(ITABLE(2).NE.7) GO TO 850
      LENTBL=5
      IBEGIN=4
  840 ITABLE(IBEGIN*2)=13
      IF(SPLIT.EQ.J) ITABLE(IBEGIN*2)=14
      TABLE(IBEGIN+1)=TEMP1
 
C     STORE DATA
 
  850 CALL STRELM (TABLE,LENTBL,SPLIT,NAMLEN,TMPLOC,BUFFER,IDERIV,
     *            IERRS)
      GO TO 3000
 
C     SET ERROR INDICATOR
 
 2900 CALL ERROR('MDELCH',2,KERROR)
      IERRS=2
 3000 IERROR = IERRS
      RETURN
 
      END
