CSECT   MODPRS                          72.110  00.39.08
 
      SUBROUTINE MODPRS (NNODES,BNODES,ISPLIT,SPLIT,IERROR)
 
C      MMODIF SUBROUTINE TO PROCESS MODEL MODIFICATIONS SUPPLIED BY USER
C
C      SUBROUTINE TO SET UP MODEL COMMON
C                      NNODES - THE NUMBER OF NODES IN TABLE1
C                      BNODES - TABLE OF NODES ALREADY LOCATED
C                      ISPLIT - NUMBER CHARACTERS IN SPLIT TABLE
C                      SPLIT  - CIRCUIT DESIGNATION OF MODEL
C                      IERROR - ERROR RETURN (NORMAL RETURN = 1)
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'

      COMMON /BUFERS/ SPLTBF(72),BUFFER(72),PACKBF(12),START,LAST
         CHARACTER*8  SPLTBF,BUFFER,PACKBF
      COMMON /SAVER/  GRP,NEWGRP,ISTSAV,ILTSAV,JSKIP,SAVE(72)
         CHARACTER*8  SAVE
      COMMON /MODATA/ ANAMES(3),CKTDES(4),PRJ(62),ANODES(25,2),NMDNOD,
     *                MDPRNT,SUPRES(10),EQUCHG(15,2),TBLCHG(15,2),
     *                NTBLCH,NEQUCH,NSUPRS,MDTAPE,MDLEN,MDUSED,IALL,
     *                KCHNGE,NTEMP,NMDCHR
         CHARACTER*8  ANAMES,CKTDES,ANODES
      CHARACTER*8     SPLIT(*),BNODES(*)
      INTEGER         START
      CHARACTER*8     BLANK,COMMA
      CHARACTER*8     MODPR
 
      DATA MXCKTL /4/, MXMDNM /3/, LBDFLT /0/
      DATA MODPR /'MODPRS'/
      DATA BLANK /' '/,COMMA /','/
 
      ICHNGE = 1
 
C     CLEAR OUT MODEL NAME TABLE
 
      DO 10 L = 1,3
   10 ANAMES(L) = BLANK
      NMDCHR = 0
 
C     UPDATE START CHARACTER AND CHECK POSITION
 
   50 START = START + 5
      IF (START .LE. LAST) GO TO 60
 
C     GET MORE DATA
 
      CALL GETCK (START,LAST,NOCARD)
      GO TO (60,55), NOCARD
 
C         INCOMPLETE SPECIFICATION PRIOR TO GROUP OR MODE CARD
 
   55 KERROR = 22
      GO TO 295
 
C     STORE SPLIT-OUT NAME IN MODEL COMMON
 
   60 IF (ISPLIT .LE. MXCKTL) GO TO 70
 
C         MODEL CIRCUIT DESIGNATION EXCEEDS FOUR CHARACTERS
 
      KERROR = 59
      GO TO 295
 
C     PERFORM STORAGE
 
   70 DO 71 K = 1, ISPLIT
   71 CKTDES(K) = SPLIT(K)
 
C     CHECK THE NUMBER OF NODES AND STORE
 
      IF (NNODES .GT. 1) GO TO 80
 
C         INSUFFICIENT MODEL NODES SPECIFIED
 
      KERROR = 57
      GO TO 295
 
C     PERFORM NODE STORAGE AND ESTABLISH MODEL NODE COUNTER
 
   80 DO 81 I = 1, NNODES
   81 ANODES (I,2) = BNODES(I)
      NMDNOD = NNODES
 
C     DELIMIT MODEL NAME
 
      CALL DLIMIT(START,LAST,LIMTER,LIMPOS,NAMLEN)
      IF(LIMTER .EQ. 7 .OR. LIMTER .EQ. 3 .OR. LIMTER .EQ. 1) GO TO 85
 
C         INCORRECT DELIMITER OR INSUFFICIENT DATA ON CARD
 
      KERROR = 22
      GO TO 295
   85 IF (LIMTER .EQ. 3) ICHNGE = 2
 
C     COPY NAME INTO COMMON AND CHECK LENGTH
 
      CALL CPYSP(BUFFER(START),NAMLEN,CKTDES,0,CKTDES,0,ANAMES,NWDS)
      IF (NWDS .LE. MXMDNM) GO TO 200
 
C         MODEL NAME EXCEEDS EIGHTEEN CHARACTERS
 
      KERROR = 58
      GO TO 295
 
C     ESTABLISH MODEL TAPE AS TEMPORARY LIBRARY TAPE AND INITIALIZE
C     UPDATE START CHARACTER
 
  200 START = LIMPOS + 1
      MDTAPE = iqqlbm
      iqqmdl=iqqlbm
      IF (LBDFLT .EQ. 0) MDTAPE = iqqlbt
      IF(LBDFLT.EQ.0) iqqmdl=iqqlbt
      MDPRNT = 1
      NSUPRS = 0
      NTBLCH = 0
      NEQUCH = 0
      MDUSED = 0
      IALL = 1
  205 KCHNGE = 1
 
C     PROCESS ANY MODEL CHANGES
 
      GO TO (250,210),ICHNGE
  210 CALL MMODIF (IERROR,ISPLIT)
      GO TO (250,300), IERROR
 
C     SAVE ANY DATA LEFT ON CARD
 
  250 IF (START .GT. LAST) GO TO 270
      IF (BUFFER(START).NE. COMMA) GO TO 255
      START = START + 1
      GO TO 250
  255 ISTSAV = START
      ILTSAV = LAST
      DO 260 I = ISTSAV, ILTSAV
  260 SAVE(I) = BUFFER(I)
      GO TO 290
 
C     RESET SAVE INDICATORS
 
  270 ISTSAV = 0
      ILTSAV = 0
 
C     STORE MODEL LENGTH INDICATOR AND SET GROUP INDICATOR TO HEADING
 
  290 NMDCHR = ISPLIT
      MDLEN = 0
      MDUSED = 0
      NEWGRP = 1
      GO TO 300
  295 MDPRNT = 0
      CALL ERROR(MODPR,2,KERROR)
      IERROR = 2
  300 CONTINUE
      RETURN
 
      END
