CSECT   MRGEQS                          71.042  11.43.38
 
      SUBROUTINE MRGEQS
 
C     THIS SUBROUTINE WILL GENERATE THE MATRIX EQUATIONS FOR MRG
C       WHEN THE CIRCUIT HAS RESISTOR DEPENDENT SOURCES.
C
C     MRGEQS SUBROUTINE    JERRY PATTERSON    8/2/66
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'
	include 'values.inc'
                      character*8  valist
	include 'tables.inc'
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(2797),ndep)

      COMMON /ELDATA/ ELM,NELMTS,NELIMT,ELMNTS(300),EE(1200),
     *                CMPFLG(300)
         CHARACTER*8  ELMNTS,CMPFLG
      COMMON /SCNTBL/ NBRANS,NN(2),ISTCOD(17),LENCOD(17),NCL(17),
     *                IST(8),NSCAN(7),B25
         EQUIVALENCE (IST2,IST(2)),(IST5,IST(5))
         INTEGER      B25
      COMMON /BUFERS/ BUFF,BUFFER(438)
         CHARACTER*4  BUFFER
      COMMON /CNTRLS/ SKIP(48),ISTNUM
      COMMON /EQBUFR/ STCHR,BUFFEQ
         INTEGER      STCHR
         CHARACTER*4  BUFFEQ(1)
      DIMENSION       ITYPE(2,2),N2OR5(2),SIGN(2),ISTCR1(2)
      CHARACTER*8     XIBCD*4,XSTNUM,XSUB,DEPNAM,
     *   SIGN   ,
     *   BLANK  ,
     *   COMENT ,
     *   AST    ,
     *   SECN1  ,
     *   ONEPT
 
      DATA
     *   IRECIP /0/,
     *   IST15  /15/,
     *   ISTCR1 /2*1/,
     *   ISTCR4 /4/,
     *   ITYPE  /0,-1,-1,1/
      DATA
     *   SIGN   /'+','-'/,
     *   BLANK  /' '/,
     *   COMENT /'C'/,
     *   AST    /'*'/,
     *   SECN1  /' N1=1,'/,
     *   ONEPT  /'1.'/
 
C     STATEMENTS FOR CLEARING XMRG MATRIX.
 
      ISTNUM=ISTNUM+10
      CALL WTSPTP(COMENT,'CLEAR XMRG MATRIX TO ZEROES',27,N)
 
C     TECHNIQUE FOR STAYING UNDER 100 EXECUTABLE FORTRAN STATEMENTS.
 
      XSTNUM=XIBCD(ISTNUM,4,1,N)
      CALL CPY('DO      N=1,',1,BUFFER,ISTCR1,12)
      CALL CPY(XSTNUM,1,BUFFER,ISTCR4,4)
      CALL CPY(XIBCD(NCL(2)+NCL(5),4,1,N),1,BUFFER,ISTCR1,4)
      CALL WTSPTP(BLANK,BUFFER,16,N)
      CALL CPY(SECN1,1,BUFFER,ISTCR4,6)
      CALL WTSPTP(BLANK,BUFFER,16,N)
      CALL WTSPTP(XSTNUM,'XMRG(N,N1)=0.',13,N)
 
C     MATRIX CLEARED BEFORE CALLED-LOAD R22D AND G55D ON DIAGONAL.
 
      ILAST2=IST2+NCL(2)-1
      ILAST5=IST5+NCL(5)-1
      N2OR5(1)=NCL(2)
      N2OR5(2)=NCL(5)
      ISUB=1
      CALL CPY('XMRG(   ,   )=',1,BUFFER,ISTCR1(2),14)
      CALL WTSPTP(COMENT,'LOAD DIAGONAL WITH R22D AND G55D',32,N)
      DO 20 J=2,5,3
      IF (NCL(J)) 11,20,11
   11 IFIRST=IST(J)
      ILAST=IFIRST+NCL(J)-1
      DO 15 I=IFIRST,ILAST
      ITOCHR=6
      CALL CPY(XIBCD(ISUB,3,1,N),1,BUFFER,ITOCHR,3)
      CALL CPY(BUFFER,6,BUFFER,ITOCHR+1,3)
      ITOCHR=ISTCR1(2)
      NDEP=0
      CALL CPYDP(0,BLANK,ELMNTS,I,BLANK,IRECIP,CMPFLG,BUFFER,ITOCHR,N,N)
      CALL WTEQTN(BLANK,0,BUFFER,ITOCHR-1,BLANK,N)
   15 ISUB=ISUB+1
   20 IRECIP=6
 
C     LOAD B25 AND B25 TRANSPOSE IF NECESSARY.
 
      IF (B25) 21,35,21
   21 CALL WTSPTP(COMENT,'LOAD B25 AND-B25T ENTRIES',25,N)
      DO 30 I=IST2,ILAST2
      XSUB=XIBCD(I-IST2+1,3,1,N)
      DO 25 J=IST5,ILAST5
      IF (LBITS(MATRIX,I-NBRANS,J,NBRANS,KSIGN)) 22,25,22
   22 ITOCHR=6
      CALL CPY(XSUB,1,BUFFER,ITOCHR,3)
      IXTO=ITOCHR
      CALL CPY(XIBCD(J-IST5+NCL(2)+1,3,1,N),1,BUFFER,ITOCHR+1,3)
      CALL COPY(KSIGN,BLANK,ONEPT,BLANK,BUFFER,ITOCHR+6,N)
      CALL WTSPTP(BLANK,BUFFER,17,N)
 
C     SWITCH SIGN AND SUBSCRIPTS FOR SYMETRICAL TERM.
 
      CALL CPY(BUFFER,10,BUFFER,ITOCHR-3,3)
      CALL CPY(XSUB,1,BUFFER,IXTO+1,3)
      CALL COPY(-KSIGN,BLANK,ONEPT,BLANK,BUFFER,IXTO+6,N)
      CALL WTSPTP(BLANK,BUFFER,17,N)
   25 CONTINUE
   30 CONTINUE
 
C     ZOT IN RESISTOR DEPENDENT SOURCES.
 
   35 CALL WTSPTP(COMENT,'ADD IN ALL RESISTOR DEPENDENT SOURCES',37,N)
      CALL CPY('XMRG(   ,   )',1,BUFFER,IST15,13)
 
C     VOLTAGE SOURCES FIRST--THEN CURRENT SOURCES.
 
      KSOURC=1
      DO 85 K=1,14,13
      IF (LENCOD(K).EQ.0.OR.N2OR5(KSOURC).EQ.0) GO TO 85
      JFIRST=ISTCOD(K)
      JLAST=JFIRST+LENCOD(K)-1
      GO TO (40,42),KSOURC
 
C     VOLTAGE SOURCES.
 
   40 MFIRST=IST2
      MLAST=ILAST2
      GO TO 44
   42 MFIRST=IST5
      MLAST=ILAST5
   44 DO 80 J=JFIRST,JLAST
 
C     FIND SOURCE IN VALUE LIST.
 
      CALL FIND (VALIST,ELMNTS(J),IFIRST,ILAST,N)
 
C     GET NAME OF DEPENDENT RESISTOR.
 
      DEPNAM=VALIST(ILAST)(2:6)
      JSUB=1
 
C     FIND POSITION OF RESISTOR IN CLASS 2 OR CLASS 5 AND SET THE
C       ARGUMENT TYPE CODE FOR RESOLVING OF DEPENDENCY BY EQFORM.
 
      KWAY=ITYPE(KSOURC,1)
      DO 50 N=2,5,3
      IF (NCL(N)) 46,50,46
   46 IFIRST=IST(N)
      ILAST=IFIRST+NCL(N)-1
      DO 48 I=IFIRST,ILAST
      IF (ELMNTS(I).EQ.DEPNAM) GO TO 55
   48 JSUB=JSUB+1
   50 KWAY=ITYPE(KSOURC,2)
      WRITE (iqqout,51) DEPNAM,ELMNTS(J)
   51 FORMAT (2H0',A5,9H' WHICH ',A5,''' IS DEPENDENT UPON IS NOT IN',
     *        ' THE CLASS 2 OR 5 SECTION OF ELEMENTS--PROGRAM ERROR'//)
      STOP 'MRGEQS: program error, run aborted'
 
C     LOAD COLUMN SUBSCRIPTS WITH POSITION OF DEPENDENT RESISTOR.
 
   55 ITOCHR=10
      CALL CPY(XIBCD(JSUB,3,1,N),1,BUFFER,ITOCHR,3)
      CALL CPY(BUFFER,10,BUFFER,ITOCHR+11,3)
 
C     GET CONSTANT MULTIPLICATION FACTOR OF DEP. SOURCE.
 
      STCHR=1
      CALL EQFORM(ELMNTS(J),0,22)
      NDEP=0
 
C     LEAVE ONE CHARACTER FOR APPROPRIATE SIGN OF SCAN.
 
      ILAST=IST15+1
      IF (KWAY.GE.0) CALL CPYDP(0,BLANK,ELMNTS,I,AST,KWAY,CMPFLG,
     *                          BUFFER,ILAST,N,N)
      CALL CPY(BUFFEQ,1,BUFFER,ILAST,STCHR-1)
 
C     ENTER ALL RESISTORS IN LOOP WITH THIS SOURCE.
 
      ISUB=1
      IF (KSOURC.EQ.2) ISUB=ISUB+NCL(2)
      DO 75 I=MFIRST,MLAST
      GO TO (60,65),KSOURC
 
C     B27T SCAN.
 
   60 IF (LBITS(MATRIX,I-NBRANS,J,NBRANS,KSIGN)) 70,75,70
 
C     B85 SCAN.
 
   65 IF (LBITS(MATRIX,J-NBRANS,I,NBRANS,KSIGN)) 66,75,66
   66 KSIGN=-KSIGN
 
C     INSERT B-MATRIX RESISTOR POSITION IN ROW SUBSCRIPTS.
 
   70 IXTO=I+ITOCHR-7-I
      CALL CPY(XIBCD(ISUB,3,1,N),1,BUFFER,IXTO,3)
      IXTO=I+ITOCHR+7-I
      CALL CPY(BUFFER,6,BUFFER,IXTO,3)
      IF (KSIGN.NE.1) KSIGN=2
      IXTO=I+ITOCHR+15-I
      CALL CPY(SIGN(KSIGN),1,BUFFER,IXTO,1)
      CALL WTEQTN(BLANK,0,BUFFER,ILAST-1,BLANK,N)
   75 ISUB=ISUB+1
   80 CONTINUE
   85 KSOURC=2
      RETURN
 
      END
