CSECT   MUTSCN                          71.042  11.43.38
 
      SUBROUTINE MUTSCN(NERROR)
 
C     THIS ROUTINE WILL REPLACE ALL FROM AND TO REFERENCE INDUCTORS WITH
C       THEIR RESPECTIVE MUTUAL TABLE SUBSCRIPTS.  THE MUTUAL TABLE IS
C         THEN ARRANGED IN M33, M36 AND M66 ORDER WITH STARTING INDEX
C           AND NUMBER OF ENTRIES STORED IN MSTART AND MNUMBR OF
C             /SCNTBL/ FOR EACH CLASS.
C
C     NERROR IS SET TO 2 IF A REFERENCE INDUCTOR CANNOT BE FOUND IN
C       THE ELEMENTS TABLE.
C
C     THE BASE NUMBER TO WHICH THE MUTUAL TABLE SUBSCRIPT MUST BE
C       ADDED FOR THE ELEMENTS TABLE SUBSCRIPT ARE IN MCLS3 AND MCLS6.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'

      COMMON /ELDATA/ EL,NELMTS,NELIMT,ELMNTS(300)
         CHARACTER*8  ELMNTS
      COMMON /SCNTBL/ NBRANS,NN(36),NCL(17),IST(8),NNN(15),MSTART(3),
     *                MNUMBR(3),MCLS3,MCLS6
         DIMENSION    MCLASS(6)
         EQUIVALENCE (MCLASS,MSTART)
         DIMENSION    MCLSN(2)
         EQUIVALENCE (MCLSN,MCLS3)
      COMMON /MUTUAL/ AU,NMUTL,LMUTL,MLVCOD(2,50),MLNAME(50),
     *                MLFROM(2,50),MLTO(2,50),MLVALU(50),MLCFLG(50)
         CHARACTER*8  MLNAME,MLCFLG,MLVALU,MLNODE
         CHARACTER*8  M8FROM(50),M8TO(50),M8VCOD(50)
         CHARACTER*4  MLVCOD
         DIMENSION    MLNODE(50,2),MLNOD(2,50,2)
         EQUIVALENCE (MLFROM,MLNODE),(MLFROM,MLNOD)
         EQUIVALENCE (M8FROM,MLFROM),(M8TO,MLTO),(M8VCOD,MLVCOD)
C     DUMMY SORT LIST:
      CHARACTER*8    CDUMMY(1)
      CHARACTER*8    SRTMSK
      LOGICAL        LFIRST
 
      DATA LFIRST /.TRUE./
 
C     DATA SRTMSK /ZFFFFFFFF/
 
      IF (LFIRST) THEN
         LFIRST=.FALSE.
         SRTMSK(1:4)=CHAR(  0)//CHAR(  0)//CHAR(  0)//CHAR(  0)
         SRTMSK(5:8)=CHAR(255)//CHAR(255)//CHAR(255)//CHAR(255)
      END IF
 
      NERR=1
      IF (NMUTL) 90,90,10
   10 MCLS3=IST(3)-1
      MCLS6=IST(6)-1-NCL(3)
 
C     SUBSTITUTE MUTUAL SUBSCRIPTS FOR REFERENCE INDUCTORS.
 
      DO 50 I=1,NMUTL
      DO 40 J=1,2
 
C     FIND INDUCTOR IN ELEMENTS TABLE.
 
      DO 25 N=3,6,3
      IF (NCL(N).EQ.0) GO TO 25
      MFIRST=IST(N)
      MLAST=MFIRST+NCL(N)-1
      DO 20 M=MFIRST,MLAST
   20 IF (ELMNTS(M).EQ.MLNODE(I,J)) GO TO 30
   25 CONTINUE
 
C     IF GET HERE, REFERENCE INDUCTOR NOT IN ELEMENTS TABLE.
 
      NERR=2
      WRITE (iqqout,26) MLNODE(I,J),MLNAME(I)
   26 FORMAT(25H0THE REFERENCE INDUCTOR ',A6,6H FOR ',A6,
     .       ' CANNOT BE FOUND IN THE ELEMENTS TABLE'//)
      STOP 'MUTSCN: inductor not in elements table, run aborted'
 
C     LOAD APPROPRIATE SUBSCRIPT.
 
   30 N=N/3
      MLNOD (2,I,J)=M-MCLSN(N)
   40 CONTINUE
 
C     SWITCH SUBSCRIPTS IF NECESSARY TO MAKE ANY M63 A M36.
 
      IF (MLFROM(2,I).LE.NCL(3).OR.MLTO(2,I).GT.NCL(3)) GO TO 50
      M=MLFROM(2,I)
      MLFROM(2,I)=MLTO(2,I)
      MLTO(2,I)=M
   50 CONTINUE
 
C     SORT MUTUAL TABLES ON TO AND FROM NODES FOR M33 OR M36 AND M66.
C     SORT TO NODES--THEN FROM NODES.
 
      CALL SORT
     . (M8TO,NMUTL,5,SRTMSK,M8VCOD,MLNAME,M8FROM,MLVALU,MLCFLG,M8TO,
     .                      CDUMMY,CDUMMY)
      CALL SORT
     . (M8FROM,NMUTL,5,SRTMSK,M8VCOD,MLNAME,M8TO,MLVALU,MLCFLG,M8FROM,
     .                        CDUMMY,CDUMMY)
 
C     CLEAR MUTUAL INDEX TABLES.
 
      DO 55 I=1,3
      MNUMBR(I)=0
      MSTART(I)=0
   55 CONTINUE
 
C     SCAN OUT FIRST M66.
 
      DO 65 I=1,NMUTL
   65 IF (MLFROM(2,I).GT.NCL(3)) GO TO 70
 
C     NO M66.
 
      I=NMUTL+1
      GO TO 72
   70 MSTART(3)=I
 
C      THIS CHANGE ALLOWS THIS SUBROUTINE TO SPECIFY THE CORRECT NUMBER
C      OF M36 MUTUAL INDUCTANCES AND M66 INDUCTANCES. (7/29/69)
C     MNUMBR(3)=NMUTL-I-1
 
      MNUMBR(3)=NMUTL-(I-1)
   72 ITEMP=I-1
 
C     CHECK FOR M66 ONLY.
 
      IF(ITEMP .EQ. 0) GO TO 90
 
C     SORT M33 AND M36.
 
      CALL SORT
     . (M8TO,ITEMP,5,SRTMSK,M8VCOD,MLNAME,M8FROM,MLVALU,MLCFLG,M8TO,
     .                      CDUMMY,CDUMMY)
 
C     CHECK FOR ANY M36.
 
      IF (MLTO(2,ITEMP).GT.NCL(3)) GO TO 74
 
C     M33 ONLY.
 
      MSTART(1)=1
      MNUMBR(1)=ITEMP
      GO TO 90
 
C     FIND M36 POSITIONS.
 
   74 DO 75 I=1,ITEMP
   75 IF (MLTO(2,I).GT.NCL(3)) GO TO 80
 
C     CHECK FOR M36 ONLY.
 
   80 IF (I.EQ.1) GO TO 85
      MSTART(1)=1
      MNUMBR(1)=I-1
   85 MSTART(2)=I
      MNUMBR(2)=NMUTL-MNUMBR(1)-MNUMBR(3)
   90 NERROR=NERR
      RETURN
 
      END
