CSECT   NETCMP                          71.042  11.43.38
 
      SUBROUTINE NETCMP (STMASK,NERR)
 
C     SRTMSK IS THE NECESSARY 'AND' FUNCTION FOR PROPER SORT CODE.
C     NERROR IS 2 IF EXECUTION TO BE TERMINATED--MESSAGE HAS BEEN PRINTD
C
C     NWCOMP SUBROUTINE
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'
	include 'tables.inc'
                      equivalence (iqtabl(3200),nmax)
                      character*8  vecelm(300)
                      equivalence (tablst(1601),vecelm(1))

      COMMON /BMATRX/ MAXMTX,MXCODS,NWORDS,MATRIX(1500)
         REAL         MATRIX
      COMMON /ELDATA/ EL,NELMTS,NELIMT,ELMNTS(300),FNODE(300),
     *                TNODE(300),VALUE(300),SRTCOD(300),TYPE(300),
     *                VALCOD(300),VALLO(300),VALHI(300),LIMSW
         CHARACTER*8  ELMNTS,FNODE,TNODE,SRTCOD,VALUE,VALCOD,VALLO,
     *                VALHI,TYPE
         DOUBLE PRECISION R8TYPE(300)
         EQUIVALENCE (R8TYPE,TYPE)
         DOUBLE PRECISION R8VAL(300)
         EQUIVALENCE (R8val,value)
      COMMON /SCNTBL/ NBRANS,NLINKS,LENTBL,ISTSUB(17),LNCLAS(17),
     *                MATSUB(25)
         DIMENSION    ITABLS(90)
         EQUIVALENCE (NBRANS,ITABLS(1))
      COMMON /CNTRLS/ SKIP(33),ITRQST,ABCD(5),VALSRT
         DOUBLE PRECISION ITRQST,ICRQST
         EQUIVALENCE (ICRQST,SKIP(10))
      CHARACTER*1     CODE(8)
      INTEGER         ONE
      DIMENSION       IE7SUB(4)
      CHARACTER*8     ALLMSK,CMASK,SRTMSK,STMASK,TEMP
      LOGICAL         LFIRST
 
      DATA CODE      /'K','L','M','N','A','B','C','E'/
      DATA ONE       /1/
      DATA IE7SUB    /1,2,3,5/
      DATA LFIRST    /.TRUE./
 
      IF (LFIRST) THEN
         LFIRST=.FALSE.
C     DATA ALLMSK /ZFFFFFFFFFFFFFFFF/
C     DATA CMASK            /ZFF0000/
         DO 1 I=1,8
            ALLMSK(I:I)=CHAR(255)
            CMASK (I:I)=CHAR(  0)
    1    CONTINUE
         CMASK(6:6)=CHAR(255)
      END IF
 
C     NELIMT IS THE MAX. NO. OF ENTRIES IN THE ELEMENTS TABLE.
 
      NELIMT=300
 
C     MAXMTX IS THE MAX. NO. OF WORDS AVAILABLE FOR THE PACKED MATRIX.
 
      MAXMTX=1500
 
C     MXCODS IS ONE-HALF THE NO. OF BITS PER MACHINE WORD.
 
      MXCODS=16
      NERROR=ONE
      SRTMSK=STMASK
      IF (NELIMT.lt.NELMTS) then
         WRITE (iqqout,11) NELMTS,NELIMT
   11    FORMAT ('0NETCMP: THE',I6,' ELEMENTS TO BE PROCESSED EXCEEDS',
     *           ' THE LIMIT OF',I5,'.',//)
         NERROR=2
         GO TO 90
      end if
      DO 14 I=1,90
   14 ITABLS(I)=0
 
C     LENTBL IS THE MAX. NO. OF ENTRIES IN THE TABLE OF SORT CODES.
 
      LENTBL=17
      IF (NELMTS.le.0) go to 90
 
C     SORT ELEMENTS ON VALUES IF REQUESTED BY TURNING VALSRT OFF.
C     VALSRT = 1: 'NO ELEMENT SORT'
 
      IF (nint(VALSRT).EQ.0) then

         CALL SORTN (r8val,NELMTS,8,ALLMSK,ELMNTS,FNODE,TNODE,
     *              SRTCOD,VECELM,VALCOD,VALLO,VALHI)
      
      end if
 
C     SORT TABLES ON CODES OR CLASSES OF ELEMENTS.
 

      CALL SORT (SRTCOD,NELMTS,8,SRTMSK,ELMNTS,FNODE,TNODE,
     *           VALUE,VECELM,VALCOD,VALLO,VALHI)


C     SET UP ELEMENTS IN A TREE FORM.

      CALL TREE (NERROR)
      if (nerror.eq.2) go to 90
 
C     SORT TABLES WITH BRANCHES FIRST.
 
      IF (lgt (SRTMSK,CMASK)) then
 
C     L-TREE--REARRANGE VECTOR NAMES RATHER THAN VALUES.
 
         CALL SORTN (R8TYPE,NELMTS,8,ALLMSK,ELMNTS,FNODE,TNODE,
     *              VECELM,SRTCOD,VALCOD,VALLO,VALHI)

       else
     
         CALL SORTN (R8TYPE,NELMTS,8,ALLMSK,ELMNTS,FNODE,TNODE,
     *              VALUE,SRTCOD,VALCOD,VALLO,VALHI)

      end if

C     FIND INDEX TO LAST BRANCH IN TABLE.
 
      DO 35 J=1,NELMTS
      IF (R8TYPE(J).ne. 0.0) go to 40
   35 CONTINUE
      J=NELMTS
   40 NBRANS=J-ONE
      NLINKS=NELMTS-NBRANS

C     TEST FOR J-CUT SET AND E-LOOPS

      DO 43 N=1,NBRANS
         DO 42 N1=1,4
            IF (SRTCOD(N)(6:6).NE.CODE(N1)) GO TO 42
            IF (SRTMSK.eq.CMASK) then 
               WRITE (iqqout,41) ELMNTS(N)
   41          FORMAT (1X,A8,' RESULTS IN A CURRENT SOURCE CUT SET')
             else
               WRITE (iqqout,425) ELMNTS(N)
  425          FORMAT (1X,A8,' CAUSES J-C CUT SET PREVENTING I/C ',
     *                'SOLUTION')
            end if
            NERROR=2
   42    CONTINUE
   43 CONTINUE

      DO 47 N=J,NELMTS
         DO 46 N1=5,8
            IF (SRTCOD(N)(6:6).NE.CODE(N1)) GO TO 46
            IF (SRTMSK.eq.CMASK) then 
               WRITE (iqqout,45) ELMNTS(N)
   45          FORMAT (1X,A8,' RESULTS IN A VOLTAGE SOURCE LOOP')
             else
               WRITE (iqqout,475) ELMNTS(N)
  475          FORMAT (1X,A8,' CAUSES E-L LOOP PREVENTING I/C SOLUTION')
            end if
            NERROR=2
   46    CONTINUE
   47 CONTINUE
      IF (NERROR.NE.1) GO TO 90
 
C     COMPUTE THE NUMBER OF WORDS REQUIRED FOR EACH ROW OF THE B-MATRIX.
 
      NWORDS=NBRANS/MXCODS
      IF ((NBRANS-NWORDS*MXCODS).NE.0) NWORDS=NWORDS+ONE
 
C     OBTAIN DATA FOR EACH CLASS IN TABLE.

      CALL SCNTRE (SRTMSK,NERROR)
      if (nerror.gt.1) go to 90
 
C     REVERSE NODES OF VOLTAGE SOURCES FOR SIGN CONVENTION.
 
      NWAY=ONE
   55 DO 70 N=1,4
         M=IE7SUB(N)
         IF (LNCLAS(M)) 90,70,60
   60    I=ISTSUB(M)
         J=I+LNCLAS(M)-1
         DO 65 M=I,J
            TEMP=FNODE(M)
            FNODE(M)=TNODE(M)
   65    TNODE(M)=TEMP
   70 CONTINUE

      if (nway.eq.2) go to 85
      CALL BTFORM (NERROR)
      if (nerror.eq.2) go to 90
 
C     RESET SUBSCRIPTS.
 
      NWAY=2
      GO TO 55
   85 CALL SCNMTX
      IF (lgt (SRTMSK,CMASK)) GO TO 90
      CALL SCNSRT
      IF (NMAX.LT.NELMTS) CALL VEQUIV
   90 NERR=NERROR
      IF (NERROR.NE.ONE) STOP 'NETCMP: nerror.ne.1, run aborted'
      RETURN
 
      END
