CSECT   OPTPRS
C       30 MAR 73
 
      SUBROUTINE OPTPRS
 
C     TO PROCESS OPTIMIZATION OBJECTIVE FUNCTION INPUT, AND PLACE
C     THE FUNCTION DEFINITIONS IN LABELED COMMON '/SENS' FOR PROCESSING
C     BY ADJOINT ROUTINES
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
	include 'tapes.inc'

      COMMON /ADJDTA/ ISNSDV,NSNSDV,ISNSIV,NSNSIV,ISETS,NSETS,
     .                IOPTDV,NOPTDV,IOPTIV,NOPTIV,IOPTST,NOPTST,
     .                IWCDV ,NWCDV ,IWCIV ,NWCIV ,IWCST ,NWCST ,
     .                IMCDV ,NMCDV ,IMCIV ,NMCIV ,IMCST ,NMCST
      COMMON /CHKCTL/ CKCTL(139),ICKTL,ICADJ
      COMMON /CNTRLS/ CTRL(139),AJRQST
         DIMENSION    ICTRL(320)
         EQUIVALENCE (ICTRL(1),CTRL(1)),(ICTRL(100),NERROR)
      COMMON /MONTCA/ AMONTA,NMCA,LMCA,AMCA(4,25)
         CHARACTER*8  AMCA
         DIMENSION    MCA(8,25)
         EQUIVALENCE (MCA(1,1),AMCA(1,1))
      COMMON /MONTCB/ AMONTB,NMCB,LMCB,MCB(1)
      COMMON /SENS/   ASENS,NSENS,NSRS,LINDV,LSENS,SENS(1)
         CHARACTER*8  SENS
      COMMON /SENSB/  ASNSB,NSNSB,LSNSB,SETS(4,1)
         INTEGER      SETS
      COMMON /SENSC/  ASNSC,NSNSC,LSNSC,HOLDBF(100)
         CHARACTER*8  HOLDBF
      CHARACTER*8     HOLDMC(50)
      CHARACTER*8     CMCPRS
      CHARACTER*8     CPTPRS
      CHARACTER*8     CWCPRS
      CHARACTER*8     CNSPRS
      INTEGER         CALLED
 
      DATA CALLED /0/
      DATA NH,LH /0,50/
      DATA CMCPRS /'MCPRS '/
      DATA CPTPRS /'OPTPRS'/
      DATA CWCPRS /'WCPRS'/
      DATA CNSPRS /'SNSPRS'/
 
      IF(CALLED.EQ.0) NSNSC=0
      LSNSC=100
      CALLED=1
      ICADJ=1
      AJRQST=1.D0
      CALL DVPRS(SENS(1),NSENS,LSENS,HOLDBF(1),NSNSC,LSNSC,SETS(1,1),
     .           NSNSB,LSNSB,IOPTDV,NOPTDV,IOPTIV,NOPTIV,IOPTST,
     .           NOPTST,CPTPRS)
      RETURN
 
      ENTRY WCPRS
 
C     SUBROUTINE WCPRS,
C     TO PROCESS WORST CASE OBJECTIVE FUNCTION DEFINITOIONS, AND
C     PLACE THEM IN LABELED COMMON '/SENS/'
 
      IF(CALLED.EQ.0) NSNSC=0
      LSNSC=100
      CALLED=1
      ICADJ=1
      AJRQST=1.D0
      CALL DVPRS(SENS(1),NSENS,LSENS,HOLDBF(1),NSNSC,LSNSC,SETS(1,1),
     .           NSNSB,LSNSB,IWCDV,NWCDV,IWCIV,NWCIV,IWCST,NWCST,CWCPRS)
      RETURN
 
      ENTRY SNSPRS
 
C     SUBROUTINE SNSPRS,
C     TO PROCESS 'SENSITIVITY' INPUT DATA
 
      IF(CALLED.EQ.0) NSNSC=0
      LSNSC=100
      CALLED=1
      ICADJ=1
      AJRQST=1.D0
      CALL DVPRS(SENS(1),NSENS,LSENS,HOLDBF(1),NSNSC,LSNSC,SETS(1,1),
     .           NSNSB,LSNSB,ISNSDV,NSNSDV,ISNSIV,NSNSIV,ISETS,NSETS,
     .           CNSPRS)
      RETURN
 
      ENTRY MCPRS
 
C     SUBROUTINE MCPRS,
C        TO PROCESS 'MONTE CARLO' INPUT DATA
 
      CALL DVPRS(AMCA(1,1),NMCA,LMCA,HOLDMC(1),NH,LH,MCB(1),NMCB,
     .           LMCB,IMCDV,NMCDV,IMCIV,NMCIV,IMCST,NMCST,CMCPRS)
      IF(4*NMCA+NH.LT.LMCA) GO TO 500
      WRITE(iqqout,5000) LMCA
      NERROR=NERROR+2
      GO TO 900
  500 IST=4*NMCA
      IMCIV=4*NMCA+IMCIV
      DO 550 I=1,NH
      IST=IST+1
  550 AMCA(IST,1)=HOLDMC(I)
      LMCA=IST
      IST=4*NMCA
      DO 600 I=1,NMCA
  600 MCA(3,I)=MCA(3,I)+IST
  900 RETURN
 
 5000 FORMAT('0MONTE CARLO INPUT DATA HAS CAUSED THE MAXIMUM TABLE LEN',
     .       'GTH OF ',I4,' TO BE EXCEEDED.'//)
 
      END
