CSECT   PARS2
 
      SUBROUTINE PARS2 (CARD,KTYP,KLEN,WLINE,RTERM)
 
C MODIFIED FROM THE ORIGINAL PARSER PROGRAM FOR SCEPTRE/13-JUNE-88
C
C VERSION:9.4.86
C AUTHOR :W.-R. NOVENDER
C
C THIS PARSER DISTINGUISHS BETWEEN KEYWORDS, LITERALS, NUMBERS,
C LOGICAL VALUES AND DELIMITERS.
C
C GENERAL DELIMITERS: <BLANK>, <,>, <=>, <EOL> (END OF INPUT LINE)
C SPECIAL    "      : <(>, <)>, </>, <$>, <#>, <'>, <.>
C
C THE FOLLOWING RULES APPLY TO THE SYNTAX:
C
C KEYWORDS:
C      MUST BEGIN WITH A LETTER, MAY CONTAIN NUMBERS AND SPECIAL
C      CHARACTER '-' AND '_' AND '*' (DUE TO INTEGER*2,REAL*4 !!!).
C      THEY MAY NOT BE DELIMITED BY <$>, <#>,<'> OR <.>.
C NUMBERS:
C      MAY ONLY CONTAIN DIGITS, THE EXPONENT 'D' OR 'E', A DECIMAL
C      POINT AND A SIGN.
C      THEY MAY NOT BE DELIMITED BY <$>, <#>,<'>, <.> OR <=>.
C LOGICAL VALUES:
C      1ST CHARCTER MUST BE A DOT, 2ND CHARACTER MUST BE 'T' OR 'F'.
C      THE FORMAT SHOULD BE ACCORDING TO FORTRAN RULES.
C      MAY BE DELIMITED ONLY BY <BLANK>, <,>, OR </>.
C LITERALS:
C      FIRST OCCURENCE OF A QUOTE <'> STARTS, 2ND DELIMITS THE LITERAL.
C      WITHIN THE LITERAL ALL CHARACTERS ARE ALLOWED EXCEPT THE <'>.
C      ALL DELIMITERS ARE ALLOWED.
C NOTE:
C    - NEITHER KEYWORDS, LOGICAL VALUES, LITERALS NOR NUMBERS MAY
C      SPAN MORE THAN 1 INPUT LINE.
C    - THE DELIMITERS <#> AND <$> MAY NOT DIRECTLY FOLLOW KEYWORDS,
C      NUMBERS AND LOGICAL VALUES.
C    - THE DELIMITER </> MAY DIRECTLY FOLLOW KEYWORDS, NUMBERS, LITERALS
C      AND LOGICAL VALUE (LIKE THE COMMAND FORMAT IN VMS, MS-DOS ETC.)
C EXAMPLES:
C      PRINT,X1=23,Y2=-1E-10,LEFT=.TRUE.,/SUMMARY=BRIEF
C      X3=1.2 #3 3.4 #10,4,#13,999.
C      AR(12,PY)=OMEGA
C      $NAMELIST A=2 B=-2.3D-5 LPLOT=.F. C(4,7)='TRINIDAD' $END
C NOTE: THE REPETITION OPERATION <*> WITHIN NAMELISTS IS NOT SUPPORTED
C
C EXITS:
C
C KLEN  =-99  : END OF INPUT FILE
C KTYP  = 1   : LITERAL
C KTYP  = 2   : ANY NUMBER
C KTYP  = 3   : SPECIAL CHARACTER <#>
C KTYP  = 4   : LOGICAL VALUE
C KTYP  = 5   : LEFT PARENTHESIS  <(>
C KTYP  = 6   : RIGHT PARENTHESIS <)>
C KTYP  = 7   : SPECIAL CHARACTER <$>
C KTYP  = 8   : SPECIAL CHARACTER </>
C KTYP  = 9   : KEY WORD
C KTYP  =10   : ONLY INTERMEDIATE TYPE FOR KTYP=2 OR 4
C
C   ERRORS:
C
C KTYP = -1   : INVALID SYNTAX
C KTYP = -2   : INVALID NUMBER FORMAT
C KTYP = -3   : INVALID LOGICAL FORMAT
C KTYP = -4   : INVALID KEYWORD SYNTAX
C KTYP = -5   : LOGIC ERROR IN SYNTAX CHECKER
 
      CHARACTER CARD*80,WLINE*(*),WUFFER*72
      DATA MAXCOL /72/
 
      I=0
      RTERM=0.
      KTYP=0
      KLEN=0
      WLINE(1:MAXCOL)=' '
 
   30 I=I+1
      IF (I.GT.MAXCOL) GO TO 93
 
 
      IF (KTYP.EQ.0) THEN
         IF (CARD(I:I).EQ.'''') THEN
            KTYP=1
            GO TO 30
         END IF
         IF (INDEX(' =,',CARD(I:I)).NE.0) GO TO 30
         IF (CARD(I:I).EQ.'#') THEN
            KTYP=3
            GO TO 9999
         END IF
         IF (CARD(I:I).EQ.'(') THEN
            KTYP=5
            GO TO 9999
         END IF
         IF (CARD(I:I).EQ.')') THEN
            KTYP=6
            GO TO 9999
         END IF
         IF (CARD(I:I).EQ.'$') THEN
            KTYP=7
            GO TO 9999
         END IF
         IF (CARD(I:I).EQ.'/') THEN
            KTYP=8
            GO TO 9999
         END IF
         IF (CARD(I:I).EQ.'.') THEN
            KTYP=10
            GO TO 91
         END IF
         IF (INDEX('0123456789+-',CARD(I:I)).NE.0) THEN
            KTYP=2
            GO TO 91
         END IF
         IF (INDEX('ABCDEFGHIJKLMNOPQRSTUVWXYZ',CARD(I:I)).NE.0) THEN
            KTYP=9
            GO TO 91
         END IF
         KTYP=-1
         GO TO 9999
      END IF
 
 
      IF (KTYP.EQ.1) THEN
         IF (CARD(I:I).EQ.'''') GO TO 9999
         GO TO 91
      END IF
 
 
      IF (KTYP.EQ.2) THEN
         IF (INDEX(' ,',CARD(I:I)).NE.0) GO TO 9999
         IF (INDEX('()/',CARD(I:I)).NE.0) GO TO 92
         IF (INDEX('0123456789+-.DE',CARD(I:I)).NE.0) GO TO 91
         KTYP=-2
         GO TO 9999
      END IF
 
 
      IF (KTYP.EQ.4) THEN
         IF(INDEX('TRUEFALS.',CARD(I:I)).NE.0) GO TO 91
         IF(INDEX(' ,',CARD(I:I)).NE.0) GO TO 9999
         IF (CARD(I:I).EQ.'/') GO TO 92
         KTYP=-3
         GO TO 9999
      END IF
 
 
      IF (KTYP.EQ.9) THEN
         IF (INDEX('= ,',CARD(I:I)).NE.0) GO TO 9999
         IF (INDEX('()/',CARD(I:I)).NE.0) GO TO 92
         IF (INDEX('ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_*',CARD(I:I))
     *      .NE.0) GO TO 91
         KTYP=-4
         GO TO 9999
      END IF
 
 
      IF (KTYP.EQ.10) THEN
         IF (INDEX('TF',CARD(I:I)).NE.0) THEN
            KTYP=4
            GO TO 91
         END IF
         IF (INDEX('0123456789+-DE',CARD(I:I)).NE.0) THEN
            KTYP=2
            GO TO 91
         END IF
         KTYP=-5
         GO TO 9999
      END IF
 
 
      KTYP=-9
      GO TO 9999
 
C  COPY CHARACTER INTO WLINE AND READ NEXT CHARACTER
 
   91 KLEN=KLEN+1
      WLINE(KLEN:KLEN)=CARD(I:I)
      GO TO 30
 
C BACKSPACE THE CARD POINTER
 
   92 I=I-1
      GO TO 9999
 
C END OF INPUT LINE, NOTHING FOUND --> READ NEXT LINE
 
   93 GO TO 9999
 
 9999 IF (KTYP.EQ.2) THEN
         WUFFER=WLINE(1:KLEN)
         READ(WUFFER,'(BN,E72.0)') RTERM
      END IF
      RETURN
 
      END
