CSECT   QTBLCH                          71.042  11.43.38
 
      SUBROUTINE QTBLCH (KVALUE,IERROR)
 
C      SUBROUTINE TO PROCESS EQUATION AND TABLE CHANGES SUPPLIED AS
C      MODEL ELEMENTS DATA
C                     KVALUE - 3 IMPLIES TABLE, 5 IMPLIES EQUATION
C                    IERROR - ERROR INDICATOR  1 IS NORMAL
C                                              2 IS ERROR CONDITION
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
      COMMON /BUFERS/ SPLTBF(72),BUFFER(72),PACKBF(12),START,LAST
         CHARACTER*8  SPLTBF,BUFFER,PACKBF
      COMMON /MODATA/ ANAMES(3),CKTDES(4),PRJ(62),ANODES(25,2),NMDNOD,
     *                MDPRNT,SUPRES(10),EQUCHG(15,2),TBLCHG(15,2),
     *                NTBLCH,NEQUCH,NSUPRS,MDTAPE,MDLEN,MDUSED,IALL,
     *                KCHNGE,NTEMP,NMDCHR
         CHARACTER*8  EQUCHG,TBLCHG
      INTEGER         START
      CHARACTER*8     PREFIX,PFX2,TEMP1,TEMP2,QTBL,Q,EQUALS
 
      DATA
     *   QTBL     /'QTBLCH'/,
     *   Q        /'Q'/,
     *   EQUALS   /'='/
      DATA LTBLCH,LEQUCH /15,15/
 
      K = KVALUE
      IERRS=1
 
C     CHECK VALUE OF K
 
 1000 IF (K .EQ. 3 .OR. K .EQ. 5) GO TO 1170
 1050 KERROR = 54
      GO TO 4850
 1170 PREFIX = BUFFER (START)
 
C     LOCATE EQUALS SIGN OR END OF CARD AS NAME DELIMITER
 
      CALL DLIMIT (START,LAST,LIMTER,KLAST,NWDS)
      IF (LIMTER .EQ. 5 .OR. LIMTER .EQ. 7) GO TO 1200
 1180 KERROR = 22
      GO TO 4850
 
C     COPY NAME WITHOUT A SUFFIX INTO TEMPORARY LOCATION ONE
 
 1200 CALL CPYSP (PREFIX,0,BUFFER(START),NWDS,PREFIX,0,TEMP1,NWORDS)
      IF (NWORDS .GT. 1) GO TO 4100
 
C     CHECK FOR DATA ON CARD
 
      START = KLAST + 1
      IF (START .LE. LAST) GO TO 1400
 1250 CALL GETCK (START,LAST,NOCARD)
      GO TO (1300,1180), NOCARD
 
C     IF NO EQUAL SIGN WAS FOUND, CHECK FOR ONE AND UPDATE START
 
 1300 IF (LIMTER .EQ. 5)  GO TO 1400
      IF (BUFFER (START) .EQ. EQUALS) GO TO 1350
      CALL ERROR (QTBL,1,35)
      GO TO 1400
 1350 START = START + 1
      IF (START .LE. LAST) GO TO 1400
      LIMTER = 5
      GO TO 1250
 
C     PEEL OUT USE NAME OF TABLE OR EQUATION
 
 1400 CALL DLIMIT  (START,LAST,LIMTER,KLAST,NCHARS)
      IF(LIMTER .EQ. 1 .OR. LIMTER .EQ. 4 .OR. LIMTER .EQ.7)GO TO 1700
 1500 KERROR = 22
      GO TO  4850
 
C     DETERMINE TYPE OF USE NAME
 
 1700 K = ISEQCK(START,LAST,KODE,START)
      IF(K .NE. 3 .AND. K .NE. 5) GO TO 1050
      PFX2 = BUFFER (START)
      CALL DLIMIT(START,LAST,LIMTER,KLAST,NCHARS)
 
C     COPY NAME INTO TEMPORARY LOCATION
 
 4000 CALL CPYSP (PFX2,0,BUFFER(START),NCHARS,PFX2,0,TEMP2,NWORDS)
      IF (NWORDS .LE. 1) GO TO 4300
 
C         TABLE OR EQUATION NAME EXCEEDS SIX CHARACTERS
 
 4100 KERROR=45
      GO TO 4850
 
C     CHECK FOR MATCHING CHANGES, THEN
C     DETERMINE WHICH TABLE CHANGE IS TO BE STORED IN, CHECK LENGTH
C     AND THEN STORE
 
 4300 IF (PFX2 .EQ. PREFIX) GO TO 4500
 
C         INCONSISTANT MODEL CHANGE,EQUATION AND TABLE ARE EQUATED
 
      KERROR=55
       GO TO 4850
 4500 START =KLAST
      IF (PFX2 .EQ. Q )GO TO 4600
      IF (NTBLCH .GE. LTBLCH) GO TO 4670
      IF (NTBLCH.EQ. 0) GO TO 4550
      DO 4520 I = 1, NTBLCH
 4520 IF (TBLCHG(I,1) .EQ. TEMP1) GO TO 4640
 4550 NTBLCH = NTBLCH + 1
      TBLCHG(NTBLCH,1) = TEMP1
      TBLCHG(NTBLCH,2) = TEMP2
      GO TO 5000
 4600 IF (NEQUCH .GE. LEQUCH) GO TO 4670
      IF (NEQUCH .EQ. 0) GO TO 4650
      DO 4620 I = 1, NEQUCH
 4620 IF (EQUCHG(I,1) .EQ. TEMP1) GO TO 4640
      GO TO 4650
 4640 KERROR = 73
      GO TO 4850
 4650 NEQUCH = NEQUCH + 1
      EQUCHG(NEQUCH,1) = TEMP1
      EQUCHG(NEQUCH,2) = TEMP2
      GO TO 5000
 
C         LIMIT OF FIFTEEN TABLE OR EQUATION MODEL CHANGES EXCEEDED
 
 4670 KERROR  = 56
 4850 CALL ERROR (  QTBL  ,2,KERROR)
      IERRS=2
 5000 IERROR = IERRS
      RETURN
      END
