CSECT   RCPRS                           72.110  00.39.08
 
      SUBROUTINE RCPRS (BLNKBF,LASTCR,LOWX,LSTX,LD,IXCTC,DATA)
 
C     ROUTINE TO EXTRACT RUN CONTROL INFO FROM A CARD
C     BLNKBF - DEBLANKED DATA CARD CHAR. STRING
C     LASTCR - CHAR. IN BLNKBF
C     LOWX   - INDEX IN BLNKBF SCAN START
C     LSTX   - INDEX IN BLNKBF AT WHICH DELIMITER WAS LOCATED
C     LD     - RESULTS CODE
C               1 - CONTROL BLOCK NAME
C               2 - RUN CONTROL DATA
C               3 - ERROR
C               4 - NO DATA
C     IXCTC  - CONTROL BLOCK INDEX
C     DATA   - RUN CONTROL VALUE
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
      COMMON /RUNCON/ RCTABL(6,75)
      CHARACTER*8     LIST(4),INT(4),IC(2),RCTABL
      INTEGER         RCTAB(12,75)
         EQUIVALENCE (RCTABL(1,1),RCTAB(1,1))
      DIMENSION       BLNKBF(*),IDATA(2),TFR(2),ULHN(3),DISTR(2)
         CHARACTER*8  BLNKBF,TFR,ULHN,DISTR
         EQUIVALENCE (XATA,IDATA(1)),(NATA,IDATA(2))
      CHARACTER*8     SUB ,BLANK
      CHARACTER*8     DFLT , TEMP
 
      DATA INT   /'TRAP    ','RUK     ','XPO     ','IMPLIC  '/
      DATA IC    /'MASTER  ','PRECED  '/
      DATA TFR   /'LINEAR  ','LOG     '/
      DATA ULHN  /'LOW     ','HIGH    ','NOMINA  '/
      DATA DISTR /'GAUSSI  ','UNIFOR  '/
      DATA SUB   /'RCPRS'/ ,BLANK /' '/
      DATA DFLT  /'DEFAUL'/
      DATA NTRY  /75/
 
      LD=4
    8 IF(LOWX.GT.LASTCR) GO TO 100
 
C     SCAN FOR DELIMITER
 
      LX=LOWX
      NCHAR=0
   10 CALL DLIMIT (LOWX,LASTCR,INFO,LSTX,ICHAR)
      NCHAR=NCHAR+ICHAR
      IF(INFO.NE.6) GO TO 12
      NCHAR=NCHAR+1
      LOWX=LSTX+1
      GO TO 10
   12 IF(NCHAR.GT.0) GO TO 15
 
C         EXTRANEOUS DELIMITER IGNORED
 
      CALL ERROR(SUB   ,1,34)
      LOWX=LOWX+1
      GO TO 8
   15 IF(NCHAR.GT.24) GO TO 26
 
C     CALL COPYSP TO PACK CHARACTERS FROM LOWX
C     TO LSTX SIX CHAR. PER WORD
 
      CALL CPYSP (BLNKBF(LX  ),NCHAR,' ',0,' ',0,LIST,NWORD)
      GO TO (16,26,26,26,16,26,16),INFO
   16 DO 25 I=1,NTRY
 
C     CHECK CONTROL BLOCK NAME
 
      IF(RCTABL(1,I).EQ.BLANK)GO TO 18
      TEMP=LIST(1)
      IF((NWORD.EQ.1).AND.(RCTABL(1,I).EQ.TEMP))GO TO 23
 
C     CHECK NORMAL NAME
 
   18 IF(RCTAB(11,I).NE.NWORD) GO TO 25
      DO 20 J=1,NWORD
      IF(RCTABL(J+1,I).NE.LIST(J)) GO TO 25
   20 CONTINUE
 
C     COMPARISON FOUND,RETURN WITH CONTROL BLOCK INDEX
 
   23 IXCTC=RCTAB(12,I)
      LD=1
      GO TO 100
   25 CONTINUE
      IF((INFO.EQ.1).OR.(INFO.EQ.7)) GO TO 27
 
C     SET ERROR INDICATOR
 
   26 LD=3
      GO TO 100
   27 LD=2
 
C     CHECK FOR INITIAL RANDOM NUMBER 'DEFAULT' OPTION
 
      IF(IXCTC.NE.122) GO TO 271
      IF(LIST(1).NE.DFLT) GO TO 29
      XATA=-1.D0
      GO TO 99
 
C     CHECK FOR TYPE OF DISTRIBUTION
 
  271 IF(IXCTC.NE.125) GO TO 2700
      DO 272 I=1,2
      IF(LIST(1).NE.DISTR(I)) GO TO 272
      XATA=I-1
      GO TO 99
  272 CONTINUE
 
C     ERROR ON DISTRIBUTION CONTROL CARD
 
      GO TO 26
 
C     CHECK FOR INTEGRATION ROUTINE SPECIFICATION
 
 2700 DO 30 I=1,4
      IF(LIST(1) .NE.INT(I)) GO TO 30
      XATA=I
      GO TO 99
   30 CONTINUE
 
C     CHECK FOR TYPE FREQUENCY RUN SPECIFICATION
 
      IF(IXCTC.NE.74) GO TO 28
      DO 310 I=1,2
      IF(LIST(1).NE.TFR(I)) GO TO 310
      XATA=I
      GO TO 99
  310 CONTINUE
 
C     ERROR ON TYPE FREQUENCY RUN CONTROL CARD
 
      GO TO 26
 
C     CHECK FOR RERUN I/C SPECIFICATION
 
   28 IF(IXCTC.NE.53) GO TO 282
      DO 281 I=1,2
      IF(LIST(1).NE.IC(I)) GO TO 281
      XATA = I+1
      GO TO 99
  281 CONTINUE
 
C     ERROR ON RERUN INITIAL CONDITIONS CONTROL CARD.
 
      GO TO 26
 
C     CHECK FOR RUN WORST CASE SPECIFICATION
 
  282 IF(IXCTC.NE.151) GO TO 29
      DO 283 I=1,3
      IF(LIST(1).NE.ULHN(I)) GO TO 283
      XATA=I
      GO TO 99
  283 CONTINUE
 
C     ERROR ON RUN WORST CASE CONTROL CARD
 
      GO TO 26
 
C     CONVERT BCD CHAR. STRING TO REAL NO. AND RETURN
 
   29 call BCDFP(BLNKBF(LX),NCHAR,FLANS,NUMERR)
      XATA=flans
      IF (IXCTC.EQ.45) NATA=NBCDI(BLNKBF(LX),NCHAR,NUMERR)
   99 DATA=XATA
  100 CONTINUE
      RETURN
 
      END
