CSECT   RCTRL                           72.110  00.39.08
 
      SUBROUTINE RCTRL
 
C     SUBROUTINE TO EVALUATE RUN CONTROL DATA
C     BLNKBF - DEBLANKED BCD CHARACTER STRING ON CARD
C     LASTCR - NO. OF CHARACTERS IN BLNKBF
C     IERR   - ERROR RETURN
C               0 - NORMAL RETURN
C               1 - ERROR
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'
	include 'values.inc'
                      integer      rrcode(jqqval/2)
                      real*8       rrlist(jqqval/2)
                      integer      listrr(jqqval)
                      equivalence (valist(1),listrr(1))
                      equivalence (valist(1),rrlist(1))
                      equivalence (valist(1+jqqval/2),rrcode(1))

      COMMON /BUFERS/ SPLTBF(72),BLNKBF(72),PACKBF(12)
         CHARACTER*8  SPLTBF,BLNKBF,PACKBF
      COMMON /RRCTRL/ IERR,KEY,NRERUN,NDATA,LASTCR,NEXTRR
      COMMON /CHKCTL/ ICTUSE(320)
      COMMON /CNTRLS/ CNTRL(160)
      COMMON /ADJDTA/ I1(5),NSNSTS,I2(5),NOPSTS,I3(5),NWCSTS,I4(5),
     *                NMCSTS
      DIMENSION       IRST(15),ILL(17),NORHS(6)
      CHARACTER*8     EQUAL
 
      DATA IRST/71,76,77,78,121,122,123,124,131,132,133,135,138,141,151/
      DATA NRST/15/
      DATA ILL /40,41,42,43,44,45,46,47,52,53,61,62,63,85,86,87,88/
      DATA NILL /17/
      DATA NORHS /76,77,78,124,132,133/
      DATA NNORHS /6/
      DATA DT /1.D0/
      DATA EQUAL /'='/
 
      LSTX=0
      IF(NDATA.NE.0) GO TO 21
      DO 5 I=1,NRST
      J=IRST(I)
    5 CNTRL(J)=0.D0
 
C     LOOK FOR RUN CONTROL SPECIFICATION
 
   10 LOWX=LSTX+1
      CALL RRCPRS (BLNKBF,LASTCR,LOWX,LSTX,IFIND,IXCTC,DATA)
      ISW=0
      GO TO (20,11,11,15),IFIND
   11 WRITE (iqqout,12)
   12 FORMAT(34H0ILLEGAL RUN CONTROL SPECIFICATION/1H0)
      IERR=1
      NDATA=0
      GO TO 15
 
C     IGNORE ILLEGAL RUN CONTROL SPECIFICATIONS
C     CHECK FOR ILLEGAL RERUN CONTROLS.
 
   20 DO 207 I=1,NILL
      IF(IXCTC.NE.ILL(I)) GO TO 207
      WRITE (iqqout,205)
  205 FORMAT('0ILLEGAL RERUN DESCRIPTION RUN CONTROL SPECIFICATION ',
     *       'IGNORED.'////)
      NDATA=0
      GO TO 15
  207 CONTINUE
 
C     NDATA IS THE NO. OF RERUNS - THERE MUST BE
C     RUN CONTROL DATA FOR EACH RERUN
 
  208 NDATA=NRERUN
 
C     SAVE CONTROL TABLE INDEX
 
      lvalst=lvalst+1
      LISTRR(lvalst*2)=IXCTC
      RRCODE(lvalst)=4
 
C     CHECK FOR SPECIAL CONTROL BLOCK INDEXES
 
      IF(IXCTC.EQ.122) GO TO 236
      IF(IXCTC.EQ.34.OR.IXCTC.EQ.10) GO TO 50
      IF(IXCTC.EQ.55) GO TO 30
 
C     CHECK FOR CERTAIN CONTROLS WITH NO RIGHT HAND SIDES.
 
      ISW=1
      DO 209 I=1,NNORHS
      IF(IXCTC.EQ.NORHS(I)) GO TO 50
  209 CONTINUE
 
C     CHECK FOR RUN AC.
 
      IF(IXCTC.NE.71) GO TO 211
      IF(ICTUSE(142).NE.0) GO TO 50
      WRITE (iqqout,210)
  210 FORMAT(46H0RUN AC WAS NOT SPECIFIED IN THE ORIGINAL RUN.)
      GO TO 11
 
C     CHECK RUN MONTE CARLO.
 
  211 IF(IXCTC.NE.121) GO TO 217
      IF(NMCSTS.NE.0) GO TO 215
      WRITE (iqqout,212)
  212 FORMAT(51H0MONTE CARLO WAS NOT SPECIFIED IN THE ORIGINAL RUN.)
      GO TO 11
  215 IF(BLNKBF(LSTX).EQ.EQUAL) GO TO 21
      WRITE (iqqout,216)
  216 FORMAT(41H0MONTE CARLO DEFAULT. 10 PASSES SUPPLIED.)
      DT=10.D0
      GO TO 50
 
C     CHECK RUN OPTIMIZATION.
 
  217 IF(IXCTC.NE.131) GO TO 223
      IF(NOPSTS.NE.0) GO TO 221
      WRITE (iqqout,218)
  218 FORMAT(52H0OPTIMIZATION WAS NOT SPECIFIED IN THE ORIGINAL RUN.)
      GO TO 11
  221 IF(BLNKBF(LSTX).EQ.EQUAL) GO TO 21
      WRITE (iqqout,222)
  222 FORMAT(42H0OPTIMIZATION DEFAULT. 30 PASSES SUPPLIED.)
      DT=30.D0
      GO TO 50
 
C     CHECK SENSITIVITY.
 
  223 IF(IXCTC.NE.141) GO TO 228
      IF(NSNSTS.NE.0) GO TO 50
      WRITE (iqqout,224)
  224 FORMAT(51H0SENSITIVITY WAS NOT SPECIFIED IN THE ORIGINAL RUN.)
      GO TO 11
 
C     CHECK RUN WORST CASE.
 
  228 IF(IXCTC.NE.151) GO TO 233
      IF(NWCSTS.NE.0) GO TO 232
      WRITE (iqqout,229)
  229 FORMAT(50H0WORST CASE WAS NOT SPECIFIED IN THE ORIGINAL RUN.)
      GO TO 11
  232 IF(BLNKBF(LSTX).EQ.EQUAL) GO TO 21
      DT=3.D0
      GO TO 50
 
C     CHECK FREQUENCY
 
  233 IF(IXCTC.NE.79) GO TO 21
      CNTRL(79)=0.D0
      lvalst=lvalst-1
      DO 235 I=74,75
      lvalst=lvalst+1
      LISTRR(2*lvalst)=I
      RRCODE(lvalst)=4
      DO 234 J=1,NDATA
      lvalst=lvalst+1
      RRLIST(lvalst)=1.D0
  234 RRCODE(lvalst)=3
  235 CONTINUE
      lvalst=lvalst+1
      LISTRR(2*lvalst)=72
      RRCODE(lvalst)=4
  236 ISVXRR=lvalst
 
C     SEARCH CARD FOR RUN CONTROL DATA ENTRIES
 
   21 LOWX=LSTX+1
      CALL RRCPRS (BLNKBF,LASTCR,LOWX,LSTX,IFIND,IXCTC,DATA)
      GO TO (22,25,11,15),IFIND
   22 WRITE (iqqout,23)
   23 FORMAT(25H0RUN CONTROL DATA MISSING/1H0)
      IERR=1
      GO TO 10
   25 NDATA=NDATA-1
 
C     IS GEAR TO BE THE INTEGRATION ROUTINE FOR THIS RERUN?
 
      IF(IXCTC.NE.4.OR.DATA.NE.4.) GO TO 26
      IF(CNTRL(54).EQ.-2D0) CNTRL(54)=2D0
      IF(CNTRL(54).EQ.-1D0)CNTRL(54)=1D0
   26 lvalst=lvalst+1
      RRLIST(lvalst)=DATA
      RRCODE(lvalst)=3
      IF(NDATA.NE.0) GO TO 21
      IF(IXCTC.NE.122) GO TO 237
      lvalst=lvalst+1
      LISTRR(2*lvalst)=123
      RRCODE(lvalst)=4
      DO 259 I=1,NRERUN
      lvalst=lvalst+1
      ISVXRR=ISVXRR+1
      RRCODE(lvalst)=RRCODE(ISVXRR)
      RRLIST(lvalst)=DMOD(RRLIST(ISVXRR),1.D8)
  259 RRLIST(ISVXRR)=RRLIST(ISVXRR)-RRLIST(lvalst)
      GO TO 10
  237 IF(IXCTC.NE.79) GO TO 10
      lvalst=lvalst+1
      LISTRR(2*lvalst)=73
      RRCODE(lvalst)=4
      DO 260 I=1,NRERUN
      lvalst=lvalst+1
      ISVXRR=ISVXRR+1
      RRLIST(lvalst)=RRLIST(ISVXRR)
  260 RRCODE(lvalst)=RRCODE(ISVXRR)
      GO TO 10
 
C     WRITE ERROR MESSAGE IF RUN IC VIA IMPLICIT WAS NOT SPECIFIED
C     IN THE ORIGINAL RUN
 
   30 IF(ICTUSE(55*2).NE.0) GO TO 35
      WRITE (iqqout,31)
   31 FORMAT('0RUN IC VIA IMPLICIT WAS NOT SPECIFIED IN THE ',
     *       'ORIGINAL RUN.')
      GO TO 11
 
C     TURN ON INITIAL CONDITIONS INDICATOR
 
   35 LISTRR(lvalst*2)=10
 
C     SUPPLY DATA TO TURN OFF TRANSIENT INDICATOR
 
   50 DO 60 I=1,NDATA
      lvalst=lvalst+1
      RRLIST(lvalst)=DT
   60 RRCODE(lvalst)=3
      DT=1.D0
   52 NDATA=0
      IF(ISW.EQ.1) GO TO 10
 
C     TEST IC INDICATOR,MUST BE ON FOR ORIGINAL RUN
 
      IF(ICTUSE(10*2).NE.0.) GO TO 54
  520 WRITE (iqqout,53)
   53 FORMAT('0INITIAL CONDITIONS WERE NOT SPECIFIED FOR THE ',
     *       'ORIGINALRUN')
      GO TO 11
 
C     INITIAL CONDITIONS CANNOT BE RUN IF EITHER MASTER RESULTS OR
C     PRECEDING RESULTS ARE TO BE USED FOR THE RERUNS.
 
   54 IF(CNTRL(53).EQ.1.) GO TO 10
  540 WRITE (iqqout,55)
   55 FORMAT('0RUN INITIAL CONDITIONS CANNOT BE SPECIFIED IN A ',
     *       'RERUN WHEN MASTER OR PRECEDING RESULTS ARE BEING ',
     *       'USED AS I/C VALUES.')
      GO TO 11
 
   15 RETURN
 
      END
