CSECT   RESEQS                          71.042  11.43.38
 
       SUBROUTINE RESEQS(VARRES,NERROR)
 
C      PROGRAM TO GENERATE RESISTOR CIRCUIT EQUATIONS
C      VARRES=0 , NO VARIABLE RESISTANCE
C      VARRES=1 , VAR. R IN CLASS 2 ONLY
C      VARRES=2 , VAR. R IN CLASS 5 ONLY
C      VARRES=3 , VAR. R IN BOTH CLASSES
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
      COMMON /SCNTBL/ NBRAN,IX(36),NCL(8),IY(9),IST(8),NDRC(7),
     *                NB25,NX,NSRC(6)
         EQUIVALENCE (IST(2),IST2),(IST(5),IST5),(IST(3),IST3),
     *               (IST(4),IST4),(IST(7),IST7),(IST(8),IST8)
         EQUIVALENCE (NCL(2),NCL2),(NCL(5),NCL5),(NCL(3),NCL3),
     *               (NCL(4),NCL4),(NCL(7),NCL7),(NCL(8),NCL8)
      COMMON /ELDATA/ ELM,NEL,LEL,ELNAME(300),CX(1500),IVLCOD(2,300)
         CHARACTER*8  ELNAME
 
      INTEGER         VARRES,I0(2)
      CHARACTER*8     C0
         EQUIVALENCE (I0,C0)
      CHARACTER*8
     *   C,
     *   VPRFX,
     *   IPRFX,
     *   XMRGD,
     *   XMRG
 
      DATA
     *   C      /'C'/,
     *   VPRFX  /'V'/,
     *   IPRFX  /'I'/,
     *   XMRGD  /'XMRGD'/,
     *   XMRG   /'XMRG'/
      DATA I0 /0,0/
 
       LST2=IST2+NCL2-1
       LST5=IST5+NCL5-1
       IF(NB25) 500,30,100
 
C      ANY CLASS 2 ELEMENTS
 
   30  IF(NCL2 .EQ. 0) GO TO 50
 
C      SCAN FOR V2=-B24*V4-B27*E7
 
       CALL WTSPTP(C,'V2=-B24*V4-B27*E7',17,NER)
       CALL SCNEQS(-1,IST2,LST2,VPRFX,0,IST4,NCL4,IST7,NCL7,0,0,0,0,NER)
 
C      GENERATE DO LOOP FOR I2=V2/R22,UPDATE ANY VAR. R AND TURN ON I2
C      COMPUTE FLAGS
 
       CALL DOGEN (1,1,NCL2,'I2(N)=V2(N)/XR22D(N)',20,IST2,NCL2,6,0,C0,
     *             0,NER)
 
C      ANY CLASS 5 ELEMENTS
 
   50  IF(NCL5 .EQ. 0) GO TO 1000
 
C      SCAN FOR I5=B35T*I3+B85T*J8
 
       CALL WTSPTP(C,'I5=B35T*I3+B85T*J8',18,NER)
       CALL SCNEQS(1,IST5,LST5,IPRFX,1,IST3,NCL3,IST8,NCL8,0,0,0,0,NER)
 
C      GENERATE DO LOOP FOR V5=I5*R55D, COMPUTE ANY VARIABLE R55 AND
C      TURN ON V5 COMPUTE FLAGS.
 
       CALL DOGEN (1,1,NCL5,'V5(N)=I5(N)*XR55D(N)',20,IST5,NCL5,7,0,C0,
     *             0,NER)
       GO TO 1000
 
C      MR FORMULATION
C      CHECK TO SEE IF MR IS DIAGONAL
 
  100  IF(NDRC(5) .NE. 0) GO TO 200
 
C      MR DIAGONAL FORMULATION
C      SCAN FOR V2P=-B25*R55D*(B35T*I3+B85T*J8)-B24*V4-B27*E7
 
       CALL WTSPTP(C,'V2P=-B25*R55D*(B35T*I3+B85T*J8)-B24*V4-B27*E7',
     *             45,NER)
       CALL BVPSCN(1,0)
 
C      GENERATE MR (DIAG.) MATRIX EQUATIONS IF ANY VARIABLE RESISTORS
 
       IF(VARRES .EQ. 0) GO TO 120
       CALL WTSPTP(C,'MR(DIAG)=R22D+B25*R55D*B25T',27,NER)
       CALL WTMXEQ(IST2,NCL2,IST5,NCL5,0,0,XMRGD,1,NER)
 
C      GENERATE DO LOOPS FOR I2=V2P/XMRGD AND V2=I2*R22D
 
  120  CALL DOGEN (0,1,NCL2,'I2(N)=V2P(N)/XMRGD(N)',21,IST2,NCL2,6,0,C0,
     *             0,NER)
       CALL DOGEN (0,1,NCL2,'V2(N)=I2(N)*XR22D(N)',20,IST2,NCL2,7,0,C0,
     *             0,NER)
 
C      SCAN FOR I5 B25T*I2+B35T*I34B85T*J8
 
  150  CALL WTSPTP(C,'I5=B25T*I2+B35T*I3+B85T*J8',26,NER)
       CALL SCNEQS(1,IST5,LST5,IPRFX,1,IST2,NCL2,IST3,NCL3,IST8,NCL8,
     *             0,0,NER)
 
C      GENERATE DO LOOP FOR V5=I5*R55D
 
       CALL DOGEN (1,1,NCL5,'V5(N)=I5(N)*XR55D(N)',20,IST5,NCL5,7,0,C0,
     *             0,NER)
       GO TO 1000
 
C      CHECK FOR ANY NON-SCANNABLE ROWS
 
  200  IF(NCL2 .EQ. NSRC(2)) GO TO 250
 
C      SCAN FOR V20=-B240*V4-B270*E7
 
       CALL WTSPTP(C,'V20=-B240*V4-B270*E7',20,NER)
       IST20=IST2+NSRC(2)
       NCL20=NCL2-NSRC(2)
       CALL SCNEQS(-1,IST20,LST2,VPRFX,0,IST4,NCL4,IST7,NCL7,0,0,0,0,NR)
 
C      GENERATE DO LOOP FOR I20=V20/XR22D0
 
       CALL DOGEN (1,NSRC(2)+1,NCL2,'I2(N)=V2(N)/XR22D(N)',20,IST20,
     *             NCL20,6,0,C0,0,NER)
  250  IVR=0
 
C      CHECK CLASS2' AND CLASS5 FOR ANY VARIABLE RESISTANCE
 
       LST2P=IST2+NSRC(2)-1
       IF(VARRES .EQ. 0) GO TO 300
       IF(VARRES .GE. 2) GO TO 280
       DO 260 K=IST2,LST2P
  260  IF(IVLCOD(2,K) .NE. 1) GO TO 280
       GO TO 300
 
C      GENERATE MR'=R22D'+B25'*R55D*B25T' MATRIX EQUATIONS
 
  280  CALL WTSPTP(C,'MR''=R22D''+B25''*R55D*B25T''',25,NER)
       CALL WTMXEQ(IST2,NSRC(2),IST5,NCL5,0,0,XMRG,0,NER)
       IVR=1
 
C      SCAN FOR V2P'=-B25'*R55D*(B35T*I3+B85T*J8)-B24'*V4-B27'*E7
 
  300  CALL WTSPTP(C,
     *  'V2P''=-B25''*R55D*(B35T*I3+B85T*J8)-B24''*V4-B27''*E7',49,NER)
       CALL BVPSCN(1,1)
       IF(IVR .NE. 0) GO TO 350
 
C      GENERATE DO LOOP FOR I2'=XMRGI'*V2P'
 
       CALL DOGEN (0,1,NSRC(2),'I2(N)=0.',8,IST2,NSRC(2),6,NSRC(2),
     *            'I2(N)=I2(N)+XMRGI(N,N1)*V2P(N1)',31,NER)
       GO TO 400
 
C      GENERATE CALL TO  LINEAR EQUATION SOLUTION ROUTINE
 
  350  CALL GN8INV(XMRG,4,1,NSRC(2))
 
C      GENERATE DO LOOP TO LOAD LINSOL RESULTS INTO I2'
 
       CALL DOGEN (0,1,NSRC(2),
     *    'I2(N)=V2P(N)',12,IST2,NSRC(2),6,0,C0,0,NR)
 
C      GENERATE DO LOOP FOR V2'=I2'*R22D'
 
  400  CALL DOGEN (0,1,NSRC(2),'V2(N)=I2(N)*XR22D(N)',20,IST2,NSRC(2),
     *       7,0,C0,0,NER)
       GO TO 150
 
C      MG FORMULATION
C      CHECK TO SEE IF MG IS DIAGONAL
 
  500  IF(NDRC(2) .NE. 0) GO TO 600
 
C      MG DIAGONAL FORMULATION
C      SCAN FOR I5P=-B25T*G22D*(B24*V4+B27*E7)+B35T*I3+B85T*J8
 
       CALL WTSPTP(C,
     * 'I5P=-B25T*G22D*(B24*V4+B27*E7)+B35T*I3+B85T*J8',46,NER)
       CALL BVPSCN(2,0)
 
C      GENERATE MG(DIAG) MATRIX EQUATIONS IF ANY VARIABLE RESITORS
 
       IF(VARRES .EQ. 0) GO TO 520
       CALL WTSPTP(C,'MG(DIAG)=G55D+B25T*G22D*B25',27,NER)
       CALL WTMXEQ(IST5,NCL5,IST2,NCL2,1,1,XMRGD,1,NER)
 
C      GENERATE DO LOOPS FOR V5=I5P/XMRGD AND I5=V5/R55D
 
  520  CALL DOGEN (0,1,NCL5,
     *     'V5(N)=XI5P(N)/XMRGD(N)',22,IST5,NCL5,7,0,C0,0,NER)
       CALL DOGEN (0,1,NCL5,
     *     'I5(N)=V5(N)/XR55D(N)',20,IST5,NCL5,6,0,C0,0,NER)
 
C      SCAN FOR V2=-B24*V4-B25*V5-B27*E7
 
  550  CALL WTSPTP(C,'V2=-B24*V4-B25*V5-B27*E7',24,NER)
       CALL SCNEQS(-1,IST2,LST2,VPRFX,0,IST4,NCL4,IST5,NCL5,IST7,NCL7,0,
     *             0,NER)
 
C      GENERATE DO LOOP FOR I2=V2/R22D
 
       CALL DOGEN (1,1,NCL2,
     *  'I2(N)=V2(N)/XR22D(N)',20,IST2,NCL2,6,0,C0,0,NER)
       GO TO 1000
 
C      CHECK FOR ANY NON-SCANNABLE COLUMNS
 
  600  IF(NCL5 .EQ. NSRC(5)) GO TO 650
 
C      SCAN FOR I50=B35T0*I3+B85T0*J8
 
       CALL WTSPTP(C,'I50=B35T0*I3+B85T0*J8',21,NER)
       IST50=IST5+NSRC(5)
       NCL50=NCL5-NSRC(5)
       CALL SCNEQS(1,IST50,LST5,IPRFX,1,IST3,NCL3,IST8,NCL8,0,0,0,0,NER)
 
C      GENERATE DO LOOP FOR V50=I50/R55D0
 
       CALL DOGEN (1,NSRC(5)+1,NCL5,
     *  'V5(N)=I5(N)*XR55D(N)',20,IST50,NCL50,7,0,C0,0,NER)
  650  IVR=0
 
C      CHECK FOR VARIABLE R IN CLASS2 AND CLASS5'
 
       LST5P=IST5+NSRC(5)-1
       IF(VARRES .EQ. 0) GO TO 700
       IF(VARRES .NE. 2) GO TO 680
       DO 660 K=IST5,LST5P
  660  IF(IVLCOD(2,K) .NE. 1) GO TO 680
       GO TO 700
 
C      GENERATE MG'=G55D'+B25T'*G22D*B25' MATRIX EQUATIONS
 
  680  CALL WTSPTP(C,'MG''=G55D''+B25T''*G22D*B25''',25,NER)
       CALL WTMXEQ(IST5,NSRC(5),IST2,NCL2,1,1,XMRG,0,NER)
       IVR=1
 
C      SCAN FOR I5P'=-B25T'*G22D*(B24*V4+B27*E7)+B35T'*I3+B85T'*J8
 
  700  CALL WTSPTP(C,
     * 'XI5P''=-B25T''*G22D*(B24*V4+B27*E7)+B35T''*I3+B85T''*J8',51,
     *  NER)
       CALL BVPSCN(2,1)
       IF(IVR .NE. 0) GO TO 750
 
C      GENERATE DO LOOP FOR V5'=XMRGI'*I5P'
 
       CALL DOGEN (0,1,NSRC(5),'V5(N)=0.',8,IST5,NSRC(5),7,NSRC(5),
     *             'V5(N)=V5(N)+XMRGI(N,N1)*XI5P(N1)',32,NER)
       GO TO 800
 
C      GENERATE CALL TO LINEAR EQUATION SOLUTION ROUTINE
 
  750  CALL GN8INV(XMRG,4,1,NSRC(5))
 
C      GENERATE DO LOOP TO LOAD LINSOL RESULTS INTO V5'
 
       CALL DOGEN (0,1,NSRC(5),
     *      'V5(N)=XI5P(N)',13,IST5,NSRC(5),7,0,C0,0,NER)
 
C      GENERATE DO LOOP FOR I5'=V5'/X55D'
 
  800  CALL DOGEN (0,1,NSRC(5),
     *      'I5(N)=V5(N)/XR55D(N)',20,IST5,NSRC(5),6,0,C0,0,NER)
       GO TO 550
 
 1000  RETURN
 
       END
