CSECT   RESINI                          71.042  11.43.38
 
       SUBROUTINE RESINI (VARRST,IERROR)
 
C      SUBROUTINE TO GENERATE RESISTOR EQUATION INITIALIZATION
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
       COMMON /ELDATA/ ELM,NELMTS,LELMTS,A(1800),IVLCOD(2,300)
       COMMON /SCNTBL/ NBRNCH,NLINKS,NSRTCD,ISTCOD(17),NENTRY(17),
     *                 NCLENT(8),MATSUB(9),ISTART(8),NSCAN(6),B14,
     *                 B25,B36,NSRC(6)
       INTEGER         START2,START5,VARRES,VARRST,B14,B25,B36
       EQUIVALENCE    (START2,ISTART(2)),(START5,ISTART(5))
       CHARACTER*8     XMRGD,XI5P,XMRG
       CHARACTER*8     V2P,XMRGI
 
       DATA INT1,INT0 /1,0/,VARRES /0/,NERROR /1/
       DATA XMRGD,XI5P,XMRG /'XMRGD','XI5P','XMRG'/
       DATA V2P,XMRGI /'V2P','XMRGI'/
 
C      CHECK FOR VARIABLE RESISTORS IF GROUP HAS ANY ENTRIES
 
C      VARRES = 0 IF THERE ARE NO VARIABLE RESISTORS
C             =  1 IF CLASS TWO HAS VARIABLE RESISTORS
C             =  2 IF CLASS FIVE HAS VARIABLE RESISTORS
C             =  3 IF BOTH CLASS TWO AND FIVE HAVE VARIABLE RESISTORS
 
       IF (NCLENT(2) .EQ. 0) GO TO 38
       LAST2 = START2 + NCLENT(2) - 1
       DO 30 K = START2, LAST2
   30  IF (IVLCOD(2,K) .NE. 1) VARRES = 1
   38  IF (NCLENT(5) . EQ. 0) GO TO 100
       LAST5 = START5 + NCLENT(5) - 1
       DO 40 K = START5, LAST5
   40  IF (IVLCOD(2,K) .NE. 1) GO TO 50
       GO TO 100
   50  VARRES = VARRES + 2
 
C      CHECK B25 FOR ENTRIES, THEN MR AND MG FOR DIAGONAL MATRICES
 
  100  IF (B25 .EQ. 0) GO TO 9000
       IF (NSCAN(5) .EQ. 0) GO TO 8000
       IF (NSCAN(2) .EQ. 0) GO TO 6000
 
C      CHECK FOR BRANCH OR LINK FORMULATION
 
       IF(B25 .LT. 0) GO TO 4000
 
C      DIMENSION XMRG (NROWPRIME X NROWPRIME)
 
  150  CALL DIMENS (  XMRG,INT0,NSRC(2))
       NDIMEN = NSRC(2)
 
C      CHECK FOR VARIABLE R IN NON-SCANNABLE ROWS
 
       IF (VARRES - 1) 350,250,320
  250  LAST = START2 + NDIMEN - 1
       DO 300 K = START2,LAST
       IF (IVLCOD(2,K) .NE. 1) GO TO 320
  300  CONTINUE
       GO TO 350
  320  CALL DIMENS (  V2P,INT1,NSRC(2))
       GO TO 9000
 
C      DIMENSION XMRGI (NROWPRIME X NROWPRIME)
 
  350  CALL DIMENS (  XMRGI,INT0,NDIMEN)
       CALL DIMENS (  V2P,INT1,NDIMEN)
 
C      WRITE MATRIX EQUATIONS FOR ALL NON-SCANNABLE ROWS
 
       CALL WTMXEQ (START2,NDIMEN,START5,NCLENT(5),INT0,INT0,  XMRG,
     1 INT0,NERROR)
 
C      GENERATE STATEMENT TO INVERT XMRG INTO XMRGI
 
  400  CALL GN8INV (  XMRG,4,2,NDIMEN)
       GO TO 9000
 
C      DIMENSION XMRG (NCOLPRIME X NCOLPRIME)
 
 4000  CALL DIMENS (  XMRG,INT0,NSRC(5))
       NDIMEN = NSRC(5)
 
C      CHECK FOR VARIABLE R IN NON-SCANNABLE CLASS 5
 
       IF (VARRES - 1) 4200,4100,4050
 4050  IF (VARRES .EQ. 3) GO TO 4100
       LAST = START5 + NDIMEN - 1
       DO 4080 K = START5, LAST
 4080  IF (IVLCOD(2,K) .NE. 1) GO TO 4100
       GO TO 4200
 
C      DIMENSION XI5P (NCOLPRIME)
 
 4100  CALL DIMENS (  XI5P,INT1,NDIMEN)
       GO TO 9000
 
C      DIMENSION XMRGI (NCOLPRIME X NCOLPRIME)
 
 4200  CALL DIMENS (  XMRGI,INT0,NDIMEN)
 
C      DIMENSION XI5P (NCOLPRIME)
 
       CALL DIMENS (  XI5P,INT1,NDIMEN)
 
C      WRITE MG MATRIX EQUATIONS FOR NON-SCANNABLE COLUMNS
 
       CALL WTMXEQ(START5,NSRC(5),START2,NCLENT(2),INT1,
     *              INT1,  XMRG,INT0,NERROR)
       GO TO 400
 
C      DIMENSION XMRGD (NCOL) AND I5P (NCOL)
 
 6000  CALL DIMENS (  XMRGD,INT1,NCLENT(5))
       CALL DIMENS (  XI5P,INT1,NCLENT(5))
       IF (VARRES .NE. 0) GO TO 9000
 
C      WRITE OUT MG EQUATIONS INTO XMRGD
 
 6300  CALL WTMXEQ (START5,NCLENT(5),START2,NCLENT(2),INT1,INT1,  XMRGD,
     *              INT1,NERROR)
       GO TO 9000
 
C      DIMENSION XMRGD (NROW) AND V2P (NROW)
 
 8000  CALL DIMENS (  XMRGD,INT1,NCLENT(2))
       CALL DIMENS (  V2P,INT1,NCLENT(2))
       IF (VARRES .NE. 0) GO TO 9000
 
C      WRITE MR MATRIX EQUATIONS INTO XMRGD
 
 8100  CALL WTMXEQ (START2,NCLENT(2),START5,NCLENT(5),INT0,INT0,
     *              XMRGD,INT1,NERROR)
 9000  IERROR = NERROR
       VARRST = VARRES
       RETURN
 
       END
