CSECT   RRCPRS                          72.110  00.39.08
 
      SUBROUTINE RRCPRS (BLNKBF,LASTCR,LOWX,LSTX,LD,IXCTC,DATA)
 
C     ROUTINE TO EXTRACT RUN CONTROL INFO FROM A CARD
C     BLNKBF - DEBLANKED DATA CARD CHAR. STRING
C     LASTCR - CHAR. IN BLNKBF
C     LOWX   - INDEX IN BLNKBF SCAN START
C     LSTX   - INDEX IN BLNKBF AT WHICH DELIMITER WAS LOCATED
C     LD     - RESULTS CODE
C               1 - CONTROL BLOCK NAME
C               2 - RUN CONTROL DATA
C               3 - ERROR
C               4 - NO DATA
C     IXCTC  - CONTROL BLOCK INDEX
C     DATA   - RUN CONTROL VALUE
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'

      COMMON /RUNCON/ RCTABL(6,75)
         CHARACTER*8  RCTABL
         INTEGER      RCTAB(12,75)
         EQUIVALENCE (RCTABL(1,1),RCTAB(1,1))
      COMMON /BDNUMS/ LSW,IDLMT,VNOM,BLOW,BHIGH
      CHARACTER*8     BLNKBF(72),TFR(2),ULHN(3),DISTR(2),CKNUM(13),
     *                LIST(4),INT(4)
      CHARACTER*8     COMMA , EQUAL , BLANK
      CHARACTER*8     DFLT
 
      DATA INT /'TRAP','RUK','XPO','IMPLIC'/
      DATA CKNUM /'0','1','2','3','4','5','6','7','8','9','.','+','-'/
      DATA COMMA /','/, EQUAL /'='/, BLANK /' '/
      DATA TFR /'LINEAR  ','LOG     '/
      DATA ULHN /'LOW     ','HIGH    ','NOMINA  '/
      DATA DISTR /'GAUSSI  ','UNIFOR  '/
      DATA DFLT /'DEFAUL  '/
      DATA NTRY /75/
 
C     RESET CONTROL INDEX
 
      LD=4
 
C     SCAN FOR DELIMITER
 
    8 IF(LOWX.GT.LASTCR) GO TO 40
      DO 10 I=LOWX,LASTCR
      LSTX=I
      IF(BLNKBF(I).NE.COMMA) GO TO 9
      IDLMT=1
      GO TO 12
    9 IF(BLNKBF(I).NE.EQUAL) GO TO 10
      IDLMT=5
      GO TO 12
   10 CONTINUE
 
C     SUPPLY A COMMA
 
      LSTX=LASTCR+1
      IDLMT=7
   12 NCHAR=LSTX-LOWX
      IF(NCHAR.GT.0) GO TO 15
      WRITE(iqqout,13)BLNKBF(LSTX)
   13 FORMAT(12H0EXTRANEOUS ,A1,8H IGNORED/1H0)
      LOWX=LOWX+1
      GO TO 8
 
C     CALL COPYSP TO PACK CHARACTERS FROM LOWX
C     TO LSTX SIX CHAR. PER WORD
 
   15 IF(NCHAR.GT.24) GO TO 26
      CALL PKBCD(BLNKBF(LOWX),NCHAR,LIST,NWORD)
      DO 25 I=1,NTRY
 
C     CHECK CONTROL BLOCK NAME
 
      IF(RCTABL(1,I).EQ.BLANK)GO TO 18
      IF((NWORD.EQ.1).AND.(RCTABL(1,I).EQ.LIST(1)))GO TO 23
 
C     CHECK NORMAL NAME
 
   18 IF(RCTAB(11,I).NE.NWORD) GO TO 25
      DO 20 J=1,NWORD
   20 IF(RCTABL(J+1,I).NE.LIST(J)) GO TO 25
 
C     COMPARISON FOUND,RETURN WITH CONTROL BLOCK INDEX
 
   23 IXCTC=RCTAB(12,I)
      LD=1
 
C     TEST FOR CORRECT DELIMITOR
 
      IF((LSTX.GT.LASTCR).OR.(BLNKBF(LSTX).EQ.EQUAL)) GO TO 40
      IF((IXCTC.EQ.10).OR.(IXCTC.EQ.34).OR.(IXCTC.GT.40)) GO TO 40
      WRITE(iqqout,24) (BLNKBF(L),L=LOWX,LSTX)
   24 FORMAT('0INCORRECT DELIMITOR FOR FOLLOWING RUN CONTROL ',
     *       'SPECIFICATION - ',54A1)
      WRITE(iqqout,22)
   22 FORMAT(32H0AN EQUAL SIGN HAS BEEN SUPPLIED/1H0)
      GO TO 40
   25 CONTINUE
      IF((LSTX.GT.LASTCR).OR.(BLNKBF(LSTX).EQ.COMMA)) GO TO 27
 
C     SET ERROR INDICATOR
 
   26 LD=3
      GO TO 40
   27 LD=2
 
C     CHECK FOR INTEGRATION ROUTINE SPECIFICATION
 
      DO 270 I=1,4
      DATA=I
      IF(LIST(1).EQ.INT(I)) GO TO 40
  270 CONTINUE
 
C     CHECK FOR INITIAL RANDOM NUMBER 'DEFAULT' OPTION.
 
      IF(IXCTC.NE.122) GO TO 271
      IF(LIST(1).NE.DFLT) GO TO 28
      DATA=-1.D0
      GO TO 40
 
C     CHECK FOR TYPE OF DISTRIBUTION.
 
  271 IF(IXCTC.NE.125) GO TO 273
      DO 272 I=1,2
      IF(LIST(1).NE.DISTR(I)) GO TO 272
      DATA=I-1
      GO TO 40
  272 CONTINUE
 
C     ERROR ON DISTRIBUTION CONTROL CARD.
 
      GO TO 26
 
C     CHECK FOR TYPE FREQUENCY RUN SPECIFICATION
 
  273 IF(IXCTC.NE.74) GO TO 275
      DO 274 I=1,2
      IF(LIST(1).NE.TFR(I)) GO TO 274
      DATA=I
      GO TO 40
  274 CONTINUE
 
C     ERROR ON TYPE FREQUENCY RUN CONTROL CARD.
 
      GO TO 26
 
C     CHECK FOR RUN WORST CASE SPECIFICATION.
 
  275 IF(IXCTC.NE.151) GO TO 28
      DO 276 I=1,3
      IF(LIST(1).NE.ULHN(I)) GO TO 276
      DATA=I
      GO TO 40
  276 CONTINUE
 
C     ERROR ON RUN WORST CASE CONTROL CARD.
 
      GO TO 26
 
C     CHECK LEAD CHARACTER FOR INVALID NUMBER
 
   28 DO 30 I=1,13
      IF(BLNKBF(LOWX).EQ.CKNUM(I)) GO TO 35
   30 CONTINUE
      LD=3
      GO TO 40
 
C     CONVERT BCD CHAR. STRING TO REAL NO. AND RETURN
 
   35 NCHAR=LSTX-LOWX
      DATA=B2CDFP(BLNKBF(LOWX),NCHAR,FLANS,NUMERR)
      IF(NUMERR.NE.1) LD=3
   40 RETURN
 
      END
