CSECT   RSUM                            71.042  11.43.38
 
      SUBROUTINE RSUM (IERR)
 
C       THIS SUBROUTINE CREATES THE RESISTOR SUMS.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
	include 'tables.inc'
                      equivalence (iqtabl(1295),mxcods)
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))

      COMMON /SCNTBL/ NBRAN,NLINK,NSRTCD,ISTSCL(17),NSCL(17),NCL(17),
     *                ISTCL(8)
      COMMON /CMPTAB/ ICMPFG(300)
      INTEGER         ROW,COL,TABLE(2)
 
C     ARE THERE ANY LINK RESISTORS?
 
      IF (NCL(2).EQ.0) GO TO 100
 
C     SET THE ROW POINTER TO THE FIRST CLASS 2
 
      ROW = ISTCL(2)-NBRAN
 
C     IS THIS ROW FLAGGED IN ICMPFG
 
    5 IF (ICMPFG(ROW+NBRAN).EQ.1) GO TO 20
 
C     LOOK FOR A ROW WHICH IS FLAGGED
 
   10 ROW = ROW+1
 
C     HAVE ALL OF THE LINK RESISTOR ROWS BEEN CONSIDERED?
 
      IF (ROW.EQ.ISTCL(2)+NCL(2)-NBRAN) GO TO 100
      GO TO 5
   20 ITYPE = 1
      LTAB = 2
      TABLE(1) = ROW + NBRAN
      TABLE(2) = ROW + NBRAN
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
 
C     ARE THERE ANY BRANCH REISITORS IN THIS CIRCUIT?
 
      IF (NCL(5).EQ.0) GO TO 10
 
C     SET THE COLUMN POINTER TO THE FIRST CLASS 5
 
      COL = ISTCL(5)
      NUM = 0
 
C     IS THIS LINK RESISTOR IN THE SAME LOOP AS THIS BRANCH RESISTOR?
 
   30 IF (LBITS(MATRIX,ROW,COL,MXCODS,KSIGN)) 40,50,40
 
C     ADD THIS BRANCH RESISTOR TO THE GROWING SUM FOR THIS LINK RESISTOR
 
   40 TABLE(2) = COL
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
 
C     INCLUDE ONLY 3 BRANCH RESISTORS
 
      NUM = NUM+1
      IF(NUM.EQ.3) GO TO 10
 
C     INCREMENT TO NEXT BRANCH RESISTOR
 
   50 COL = COL+1
 
C     HAVE ALL OF THE BRANCH RESISTORS BEEN CONSIDERED? YES-DO NEXT ROW
 
      IF (COL-ISTCL(5)-NCL(5)) 30,10,10
 
C     ARE THERE ANY BRANCH RESISTORS?
 
  100 IF (NCL(5).EQ.0) GO TO 200
 
C     SET THE COL POINTER TO THE FIRST CLASS 5
 
      COL = ISTCL(5)
 
C     IS THIS COL FLAGGED IN ICMPFG
 
  105 IF (ICMPFG(COL).EQ.1) GO TO 120
 
C     LOOK FOR A COL WHICH IS FLAGGED
 
  110 COL = COL+1
 
C     HAVE ALL OF THE BRANCH RESISTOR COLS BEEN CONSIDERED?
 
      IF (COL.EQ.ISTCL(5)+NCL(5)) GO TO 200
      GO TO 105
  120 ITYPE = 2
      LTAB = 2
      TABLE(1) = COL
      TABLE(2) = COL
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
 
C     ARE THERE ANY LINK RESISTORS IN THIS CIRCUIT?
 
      IF (NCL(2).EQ.0) GO TO 110
 
C     SET THE ROW POINTER TO THE FIRST CLASS 2
 
      ROW = ISTCL(2)-NBRAN
      NUM = 0
  130 IF (LBITS(MATRIX,ROW,COL,MXCODS,KSIGN)) 140,150,140
  140 TABLE(2) = ROW+NBRAN
      CALL STOEQN (ITYPE,LTAB,TABLE,IERR)
 
C     INCLUDE ONLY 3 BRANCH LINK RESISTORS
 
      NUM = NUM+1
      IF (NUM.EQ.3) GO TO 110
 
C     INCREMENT TO NEXT LINK RESISTOR
 
  150 ROW = ROW+1
 
C     HAVE ALL OF THE LINK REISITORS BEEN CONSIDERED? YES-DO NEXT COL
 
      IF (ROW-ISTCL(2)-NCL(2)+NBRAN) 130,110,110

  200 RETURN
 
      END
