CSECT   RUNCTL                          72.110  00.39.08
 
       SUBROUTINE RUNCTL
 
C      SUBROUTINE TO PROCESS ALL USER-SUPPLIED CONTROLS FOR TRANSIENT
C      AND/OR INITIAL CONDITIONS RUNS AND TERMINATION CONDITIONS
C       1) NUMBERS AND SEQUENCES MUST BE COMPLETE ON A CARD, ALTHOUGH A
C          LIMITATIONS ARE :
C            SEQUENCE REQUIRING A NUMBER MAY OCCUR ON ONE CARD WITH THE
C            CORRESPONDING NUMBER IMMEDIATELY FOLLOWING ON THE NEXT CARD
C       2) TERMIMATION CONDITIONS CANNOT BE MORE THAN 19 CARDS LONG
C       3) A MAXIMUM OF 10 TERMINATION CONDITIONS IS ALLOWED
C      ARGUMENTS ARE - ISTART - STARTING POSITION IN BUFFER
C                    - ILAST  - LAST POSITION IN BUFFER
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'values.inc'
                      character*8  valist

      COMMON /BUFERS/ SPLTBF(72),BUFFER(72),PACKBF(12),START,LAST
         CHARACTER*8  SPLTBF,BUFFER,PACKBF
      COMMON /CHKCTL/ CHKTBL(160)
         CHARACTER*8  CHKTBL
      COMMON /CNTRLS/ CNTRL(160)
         DIMENSION    ICNTRL(320)
         CHARACTER*8  C8CTRL(160)
         EQUIVALENCE  (C8CTRL,CNTRL)
         EQUIVALENCE  (ICNTRL(1),CNTRL(1))
         EQUIVALENCE  (NTRMN8,ICNTRL(95))
      COMMON /TBLES/  TABLE(200)
         CHARACTER*8  TABLE
         DIMENSION    ITABLE(400)
         EQUIVALENCE  (ITABLE(1),TABLE(1)),(XTRMN8,ITRMN8)
 
      INTEGER         START
      DIMENSION       NUNRQD(23)
      CHARACTER*8     RUNCT
      CHARACTER*8     TERMN8
      CHARACTER*8     STPSEQ(6),BCDTAB(10),SKWAY(2),TRMSEQ(11)
      CHARACTER*8     PARENL
      CHARACTER*8     EQUALS,COMMA
      CHARACTER*8     FP01
         INTEGER      IIFP01(2)
         EQUIVALENCE (FP01,IIFP01)
      CHARACTER*8  FP0
         DOUBLE PRECISION RFP0
         EQUIVALENCE (FP0,RFP0)
 
      DATA RUNCT /'RUNCTL'/
      DATA INT0,INT1,INT2 /0,1,2/
      DATA TERMN8 /'TERMN8'/
      DATA BCDTAB /'1','2','3','4','5','6','7','8','9','10'/
      DATA SKWAY /'KWAY=-  ','KWAY=+  '/
      DATA STPSEQ/'S','T','O','P','I','F'/
      DATA TRMSEQ /'T','E','R','M','I','N','A','T','E','I','F'/
      DATA PARENL /'('/
      DATA EQUALS /'='/,COMMA /','/
      DATA NUNRQD /10,34,40,43,42,41,44,46,47,52,55,61,62,63,71,76,77,
     *             78,124,85,132,133,141/,NUNREQ /23/
      DATA ILIMIT /200/
      DATA FP1 /1.0D0/,XTRMN8 /0./
      DATA IIFP01 /0,1/
      DATA RFP0 /0.D0/
 
      IERR=1
  100 IWDSZ=11
 
C     CHECK FOR -TERMINATE IF- SEQUENCE
 
      IF(ISCANS(BUFFER,START,LAST,TRMSEQ,INT1,IWDSZ,IFTERM).NE.INT0)
     *   GO TO 500
      IWDSZ=6
 
C     CHECK FOR -STOP IF- SEQUENCE
 
      IF(ISCANS(BUFFER,START,LAST,STPSEQ,INT1,IWDSZ,IFTERM).NE.INT0)
     *   GO TO 500
 
C     GET A SEQUENCE FROM CARD
 
      CALL RCPRS(BUFFER,LAST,START,LIMTER,ICODE,IXCTL,DATA)
 
C     CHECK ERROR CONDITION  (ICODE VALUE OF 2, 3, OR 4 IS AN ERROR)
 
      IF (ICODE .EQ. INT1) GO TO 200
 
C     IMPROPER RUN CONTROL FORMAT
 
  140 KERROR=31
      GO TO 2900
 
C     IF SEQUENCE IS INITIAL CONDITIONS ONLY, TURN ON I.C. INDICATOR
C     ALSO IF SEQUENCE IS RUN IC VIA IMPLICIT OR RUN SENSITIVITY.
 
  200 IF(IXCTL.NE.34.AND.IXCTL.NE.55.AND.IXCTL.NE.141) GO TO 205
      CNTRL(10) = FP1
      CHKTBL(10) = FP01
      DATA = FP1
 
C     IF SEQUENCE IS RUN IC VIA IMPLICIT TURN ON IC INDICATOR AND
C     IMPLICIT INDICATOR.
 
      IF(IXCTL.NE.55) GO TO 400
      CNTRL(55)=FP1
      CHKTBL(55)=FP01
      CNTRL(54)=FP1
      CHKTBL(54)=FP01
      GO TO 400
 
C     DETERMINE IF EQUALS SIGN AND ADDITIONAL DATA IS REQUIRED
 
  205 DO 210 L = INT1, NUNREQ
      IF (NUNRQD(L) .NE. IXCTL) GO TO 210
      DATA = FP1
      IF(IXCTL.NE.61) GO TO 208
      CNTRL(62)=RFP0
      CHKTBL(62)=FP0
      GO TO 400
  208 IF(IXCTL.NE.62) GO TO 400
      CNTRL(61)=RFP0
      CHKTBL(61)=FP0
      GO TO 400
  210 CONTINUE
 
C     IF SEQUENCE IS 'RUN MONTE CARLO' OR 'RUN OPTIMIZATION' OR
C     'RUN WORST CASE' SET IC INDICATOR.
 
      IF(IXCTL.NE.121.AND.IXCTL.NE.131.AND.IXCTL.NE.151) GO TO 230
      CNTRL(10)=FP1
      CHKTBL(10)=FP01
 
C     CHECK FOR DEFAULTS
 
      IF(LIMTER.GT.LAST) GO TO 220
      IF(BUFFER(LIMTER).NE.COMMA) GO TO 240
  220 IF(IXCTL.NE.121) GO TO 221
 
C     MONTE CARLO PASS DEFAULT. SUPPLY VALUE AND ISSUE WARNING MESSAGE.
 
      DATA=10.D0
      CALL ERROR(RUNCT,INT1,86)
      GO TO 400
  221 IF(IXCTL.NE.131) GO TO 222
 
C     OPTIMIZATION PASS DEFAULT. SUPPLY VALUE AND ISSUE WARNING MESSAGE.
 
      DATA=30.D0
      CALL ERROR(RUNCT,INT1,87)
      GO TO 400
 
C     WORST CASE DEFAULT. SUPPLY VALUE.
 
  222 DATA=3.D0
      GO TO 400
 
C     SEQUENCE REQUIRES A NUMBER OR SEQUENCE. CHECK DELIMITER AND GO ON
 
  230 IF(LIMTER.GT.LAST) GO TO 255
  240 IF(BUFFER(LIMTER).EQ.EQUALS) GO TO 250
 
C      AN ILLEGAL DELIMITER HAS OCCURRED. WRITE OUT ERROR MESSAGE,
C      SKIP OVER AND TRY TO CONTINUE
C         INCORRECT DELIMITER OR INSUFFICIENT DATA ON CARD
 
      CALL ERROR (RUNCT,INT1,22)
  250 START  = LIMTER + INT1
      IF (START  .LE. LAST) GO TO 350
 
C     DATA IS EXHAUSTED ON THIS CARD, GET MORE DATA
 
  255 CALL GETCK (START,LAST,NOCARD)
      GO TO (300,260), NOCARD
 
C         INCOMPLETE SPECIFICATION PRIOR TO GROUP OR MODE CARD
 
  260 KERROR=32
      GO TO 2900
 
C     CHECK FIRST CHARACTER FOR EQUALS SIGN AND UPDATE ACCORDINGLY
 
  300 IF (BUFFER(START) .NE. EQUALS) GO TO 350
      START = START + INT1
      IF (START .GT. LAST) GO TO 255
 
C     GET A NUMBER FROM THE CARD VIA RCPRS SUBROUTINE
 
  350 CALL RCPRS(BUFFER,LAST,START,LIMTER,ICODE,IXCTL,DATA)
 
C     CHECK ERROR CONDITION (ICODE VALUE OF 1, 3 OR 4 IS AN ERROR)
 
      IF (ICODE .NE. INT2) GO TO 140
 
C     IF INITIAL RANDOM NUMBER, SPLIT OFF 8 LEAST SIGNIFICANT DIGITS.
 
      IF(IXCTL.NE.122) GO TO 400
      CNTRL(123)=DMOD(DATA,1.D8)
      CHKTBL(123)=FP01
      DATA=DATA-CNTRL(123)
 
C     STORE NUMBER IN CONTROL TABLE
 
  400 CNTRL(IXCTL) = DATA
 
C     TURN ON ADJOINT REQUEST SWITCH FOR OPTIMIZATION, SENSITIVITY OR
C     WORST CASE.
 
      IF(IXCTL.NE.131.AND.IXCTL.NE.141.AND.IXCTL.NE.151) GO TO 410
      CNTRL(140)=FP1
      CHKTBL(140)=FP01
      IF(IXCTL.EQ.131) CNTRL(131)=DABS(DATA)
      GO TO 420
 
C     IS INTEGRATION ROUTINE GEAR?
 
  410 IF(IXCTL.NE.4.OR. nint(DATA).NE.4) GO TO 420
      CNTRL(54)=1.D0
      CHKTBL(54)=FP01
 
C     CHECK OFF CONTROLS CHECK TABLE ENTRY
 
  420 CHKTBL(IXCTL) = FP01
 
C     IF FREQUENCY SEQUENCE, SET CONTROLS TO RUN ONE FREQUENCY ONLY
 
      IF(IXCTL.NE.79) GO TO 430
      CNTRL(72)=DATA
      CNTRL(73)=DATA
      CNTRL(74)=FP1
      CNTRL(75)=FP1
      DO 425 L=72,75
  425 CHKTBL(L)=FP01
      CNTRL(79)=0.D0
 
C     CHECK FOR MORE DATA ON CARD
 
  430 START = LIMTER
  440 IF (START  .GT. LAST) GO TO 3000
 
C     CHECK LIMITING CHARACTER FOR COMMA
 
      IF (BUFFER(START) .EQ. COMMA) GO TO 450
      KERROR = 22
      GO TO 2900
  450 START = START + INT1
      IF (START .GT. LAST) GO TO 3000
      GO TO 100
 
C     PROCESS -TERMINATE IF- DATA
 
  500 START=START+IWDSZ
      IF (START .LE. LAST) GO TO 600
      CALL GETCK (START,LAST,NOCARD)
      GO TO (600,550), NOCARD
 
C      ERRONEOUS CARD READ IN CONTINUE SITUATION. WRITE OUT MESSAGE
C         INCOMPLETE SPECIFICATION PRIOR TO GROUP OR MODE CARD
 
  550 KERROR=32
      GO TO 2900
 
C     CHECK FIRST CHARACTER FOR LEFT PAREN AND PROCESS DATA WITHIN
C     PARENS
 
  600 IF (BUFFER(START) .EQ. PARENL) GO TO 700
 
C         LEFT PAREN MISSING FOR TERMINATION CONTROL
 
      KERROR=33
      GO TO 2900
 
C     HAVE EXPRESSION SCANER (EXPSCN)  PACK UP THE DATA
 
  700 IBEGIN = 3
      TABLE(2)=BCDTAB(NTRMN8+1)
      CALL EXPSCN ( IBEGIN, ILIMIT, 2, IERR )
      IF(IERR.NE.INT1) GO TO 3000
      ITABLE(4)=ITABLE(4)+INT2
      NKWAY=2
      IF(IWDSZ.EQ.6) NKWAY=1
      TABLE(ITABLE(4)+1)=SKWAY(NKWAY)
      TABLE(ITABLE(4)+2)=BCDTAB(NTRMN8+1)
 
C     CHECK THE NUMBER OF TERMINATION CONDITIONS SUPPLIED
 
      IF (NTRMN8 .LE. 9) GO TO 800
 
C     TERMINATION LIMIT EXCEEDED. SET MASTER ERROR AND SKIP
 
      KERROR=30
      GO TO 2900
 
C     STORE DATA IN VALUE LIST
 
  800 IF(IBEGIN.EQ.3) GO TO 900
      J=2
      CALL FIND (VALIST,TERMN8,KSTART,KEND,KLEN)
      DO 850 I=4,IBEGIN,2
      IF(KLEN.EQ.0) GO TO 830
      DO 820 K=KSTART,KEND,2
  820 IF (TABLE(I).EQ.VALIST(K+1)) GO TO 850
  830 J=J+2
      TABLE(J-1)=TABLE(I-1)
      TABLE(J)=TABLE(I)
  850 CONTINUE
      IF (J.LE.2) GO TO 900
      CALL STORE(VALIST,TERMN8,1,TABLE(3),(J-2),IERR)
      IF (IERR.NE.1) GO TO 3000
  900 CALL STORE(VALIST,C8CTRL(48),1,TABLE(IBEGIN),(ITABLE(4)-IBEGIN+3),
     *           IERR)
      IF(IERR.NE.1) GO TO 3000
 
C     UPDATE TERMINATION COUNT AND CHECK FOR MORE DATA
 
      NTRMN8=NTRMN8+INT1
      GO TO 440
 2900 CALL ERROR (RUNCT,INT2,KERROR)
 3000 RETURN
 
      END
