CSECT   SCNMTX                          71.042  11.43.38
 
      SUBROUTINE SCNMTX
 
C     SUBROUTINE TO SCAN ALL PASSIVE ELEMENTS OF THE B-MATRIX TO
C       DETERMINE IF THERE IS NO OR ONLY ONE NON-ZERO ELEMENT IN THE
C         ROW OR COLUMN, DIAGONAL CLASS OF EACH LINK OR BRANCH ELEMENT.
C           AN APPROPRIATE CODE OF 0, 1 OR 2 IS LEFT-ADJUSTED IN THE
C             ELMNTS(N,6) SECTION OF ELDATA.
C
C     NSCAN SHOW CLASSES WITH DOUBLE ROW ENTRIES (ON-OFF).
C
C     BNN = 0 IF THAT SUB-MATRIX IS ZERO OR COMPLETELY SCANNABLE.
C
C     BNN IS SET NEGATIVE IF A BRANCH FORMULATION IS TO BE PERFORMED
C       OR POSITIVE FOR A LINK FORMULATION IF ANY ENTRIES.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
      COMMON /ELDATA/ EL,NELMTS,NELIMT,ELMNTS(300),FNODE(300),
     *                TNODE(300),VALUE(300),SRTCOD(300),NCLASS(300)
         CHARACTER*8  ELMNTS,FNODE,TNODE,SRTCOD,NCLASS
      COMMON /BMATRX/ MAXMTX,MXCODS,NWORDS,MATRIX(1500)
         INTEGER      MATRIX
      COMMON /SCNTBL/ NBRANS,NLINKS,LENTBL,ISTART(17),LNCLAS(17),NCL(8),
     *                MATSUB(9),IST(8),NSCAN(6),B14,B25,B36
         INTEGER      B14,B25,B36
      DIMENSION       BNN(3),BALL(9)
         INTEGER      BNN,BALL
         EQUIVALENCE (BNN,B14),(NSCAN,BALL)
      CHARACTER*8     ONECOD,TWOCOD,ZERO
      LOGICAL         LFIRST
 
      DATA LFIRST /.TRUE./
 
C     DATA ONECOD,TWOCOD/Z0100000000000000,Z0200000000000000/
      IF (LFIRST) THEN
         LFIRST=.FALSE.
         DO 1 I=1,8
            ONECOD(I:I)=CHAR(0)
            TWOCOD(I:I)=CHAR(0)
            ZERO  (I:I)=CHAR(0)
    1    CONTINUE
         ONECOD(1:1)=CHAR(1)
         TWOCOD(1:1)=CHAR(2)
      END IF
 
      DO 15 I=1,NELMTS
   15 NCLASS(I)=ZERO
 
C     SCAN ALL DIAGONAL ELEMENTS.
 
      LDOWN=NBRANS+1
      DO 80 L=1,3
      N=L+3
      IF (NCL(L).EQ.0.OR.NCL(N).EQ.0) GO TO 80
      IFIRST=(IST(L)-LDOWN)*NWORDS+1
      ILAST=IFIRST+NCL(L)*NWORDS-1
      JFIRST=IST(N)
      JLAST=IST(N)+NCL(N)-1
      NC=0
      NL=0
      ICLAS=IST(L)
      DO 30 I=IFIRST,ILAST,NWORDS
      IF (1-ISCNER(MATRIX,NWORDS,MXCODS,I,I,JFIRST,JLAST,2,0,K,K,K,K,K))
     *   20,25,30
 
C     TWO OR MORE NON-ZERO ENTRIES.
 
   20 NCLASS(ICLAS)=TWOCOD
      NSCAN(L)=7
      NL=NL+1
      GO TO 30
 
C     ONE NON-ZERO ENTRY.
 
   25 NCLASS(ICLAS)=ONECOD
      NL=NL+1
   30 ICLAS=ICLAS+1
      DO 50 I=JFIRST,JLAST
      IF (1-ISCNER(MATRIX,NWORDS,MXCODS,IFIRST,ILAST,I,I,2,3,K,K,K,K,K))
     *    40,45,50
 
C     TWO OR MORE NON-ZERO ENTRIES.
 
   40 NCLASS(I)=TWOCOD
      NSCAN(N)=7
      NC=NC+1
      GO TO 50
 
C     ONE NON-ZERO ENTRY.
 
   45 NCLASS(I)=ONECOD
      NC=NC+1
   50 CONTINUE
 
C     CHECK FOR LEAST PATH OF NON-SCANNABLE ENTRIES.
 
      IF (NC+NL.GT.0) BNN(L)=7
      IF (NSCAN(L).NE.0.AND.NSCAN(N).EQ.0) GO TO 80
      IF (NSCAN(L).EQ.0.AND.NSCAN(N).NE.0.OR.NC.LT.NL) BNN(L)=-7
   80 CONTINUE
      RETURN
 
      END
