CSECT   SCNSRT                          71.042  11.43.38
 
      SUBROUTINE SCNSRT
 
C     SUBROUTINE TO SCAN EACH PASSIVE, DIAGONAL SUB-MATRIX OF THE
C       B-MATRIX FOR A C-TREE TO DETERMINE IF A ROW OR COLUMN SORT ON
C         NON-SCANNABLE ELEMNTS IS NECESSARY.  IF YES, THE ELEMENTS ARE
C           SORTED IN MATRIX AND ELEMENTS TABLE AND THE NUMBER OF
C             NON-SCANNABLES IS PLACED IN NSCNEL OF /SCNTBL/.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER(I-N)
 
      COMMON /ELDATA/ EL,NELMTS,NELIMT,ELMNTS(300),SKIP(1200),
     *                CMPFLG(2,300) ,VALCOD(300)
         CHARACTER*8  ELMNTS,VALCOD
         DIMENSION    ELTABL(300,9)
         EQUIVALENCE (ELTABL,ELMNTS)
         INTEGER      CMPFLG
      COMMON /BMATRX/ MAXMTX,MXCODS,NWORDS,MATRIX(1500)
      COMMON /SCNTBL/ NBRANS,NLINKS(2),ISTCOD(17),LENCOD(17),NCL(8),
     *                MATSUB(9),IST(8),NSCAN(6),BNN(3),NSCNEL(6)
      INTEGER         PLUS(16),OFF(16),ON(16),BNN
      CHARACTER*64    CPLUS,COFF,CON
         EQUIVALENCE (CPLUS,PLUS),(COFF,OFF),(CON,ON)
      LOGICAL         LFIRST
 
      DATA            LFIRST  /.TRUE./
 
      IF (LFIRST) THEN
         LFIRST=.FALSE.
         DO 1 I=1,64
            CPLUS(I:I)=CHAR(0)
            CON  (I:I)=CHAR(0)
            COFF (I:I)=CHAR(255)
    1    CONTINUE
 
C      DATA PLUS /Z40000000,Z10000000,Z04000000,Z01000000,Z00400000,
C       Z00100000,Z00040000,Z00010000,Z00004000,Z00001000,Z00000400,
C       Z00000100,Z00000040,Z00000010,Z00000004,Z00000001/
 
         CPLUS( 1: 1)=CHAR( 64)
         CPLUS( 5: 5)=CHAR( 16)
         CPLUS( 9: 9)=CHAR(  4)
         CPLUS(13:13)=CHAR(  1)
         CPLUS(18:18)=CHAR( 64)
         CPLUS(22:22)=CHAR( 16)
         CPLUS(26:26)=CHAR(  4)
         CPLUS(30:30)=CHAR(  1)
         CPLUS(35:35)=CHAR( 64)
         CPLUS(39:39)=CHAR( 16)
         CPLUS(43:43)=CHAR(  4)
         CPLUS(47:47)=CHAR(  1)
         CPLUS(52:52)=CHAR( 64)
         CPLUS(56:56)=CHAR( 16)
         CPLUS(60:60)=CHAR(  4)
         CPLUS(64:64)=CHAR(  1)
 
C      DATA ON   /ZC0000000,Z30000000,Z0C000000,Z03000000,Z00C00000,
C       Z00300000,Z000C0000,Z00030000,Z0000C000,Z00003000,Z00000C00,
C       Z00000300,Z000000C0,Z00000030,Z0000000C,Z00000003/
 
         CON  ( 1: 1)=CHAR(192)
         CON  ( 5: 5)=CHAR( 48)
         CON  ( 9: 9)=CHAR( 12)
         CON  (13:13)=CHAR(  3)
         CON  (18:18)=CHAR(192)
         CON  (22:22)=CHAR( 48)
         CON  (26:26)=CHAR( 12)
         CON  (30:30)=CHAR(  3)
         CON  (35:35)=CHAR(192)
         CON  (39:39)=CHAR( 48)
         CON  (43:43)=CHAR( 12)
         CON  (47:47)=CHAR(  3)
         CON  (52:52)=CHAR(192)
         CON  (56:56)=CHAR( 48)
         CON  (60:60)=CHAR( 12)
         CON  (64:64)=CHAR(  3)
 
C      DATA OFF  /Z3FFFFFFF,ZCFFFFFFF,ZF3FFFFFF,ZFCFFFFFF,ZFF3FFFFF,
C       ZFFCFFFFF,ZFFF3FFFF,ZFFFCFFFF,ZFFFF3FFF,ZFFFFCFFF,ZFFFFF3FF,
C       ZFFFFFCFF,ZFFFFFF3F,ZFFFFFFCF,ZFFFFFFF3,ZFFFFFFFC/
 
         COFF ( 1: 1)=CHAR( 63)
         COFF ( 5: 5)=CHAR(207)
         COFF ( 9: 9)=CHAR(243)
         COFF (13:13)=CHAR(252)
         COFF (18:18)=CHAR( 63)
         COFF (22:22)=CHAR(207)
         COFF (26:26)=CHAR(243)
         COFF (30:30)=CHAR(252)
         COFF (35:35)=CHAR( 63)
         COFF (39:39)=CHAR(207)
         COFF (43:43)=CHAR(243)
         COFF (47:47)=CHAR(252)
         COFF (52:52)=CHAR( 63)
         COFF (56:56)=CHAR(207)
         COFF (60:60)=CHAR(243)
         COFF (64:64)=CHAR(252)
      END IF
 
      MLAST=NLINKS(1)*NWORDS
 
C     SORT ROWS OF B14 IF NON-DIAGONAL.
 
      IF (BNN(1).EQ.0.OR.NSCAN(4).EQ.0) GO TO 70
 
C     PULL ROW SORT ON ELEMENTS OF B14 OR B25.
 
      I=1
   10 IFIRST=IST(I)
      ILAST=IFIRST+NCL(I)-1
      INDEX2=ILAST
      DO 60 INDEX1=IFIRST,ILAST
 
C     CONTINUE IF INDEX1 ELEMENT IS NON-SCANNABLE.
 
      IF(CMPFLG(1,INDEX1)) 60,15,60
 
C     EXCHANGE IF INDEX2 ELEMENT IS NON-SCANNABLE.
 
   15 IF(CMPFLG(1,INDEX2)) 25,20,25
 
C     SCANNABLE ELEMENT SO CONTINUE SEARCH.
 
   20 INDEX2=INDEX2-1
 
C     KICK OUT IF IDEXES MEET.
 
      IF (INDEX1-INDEX2) 15,65,65
 
C     EXCHANGE TABLE ITEMS.
 
   25 DO 30 J=1,9
      TEMP=ELTABL(INDEX1,J)
      ELTABL(INDEX1,J)=ELTABL(INDEX2,J)
      ELTABL(INDEX2,J)=TEMP
   30 CONTINUE
 
C     EXCHANGE ROWS OR COLUMNS OF B-MATRIX.
 
      IF (I.GT.3) GO TO 40
 
C     ROW EXCHANGE.
 
      MFIRST=(INDEX1-NBRANS-1)*NWORDS+1
      MLAST=MFIRST+NWORDS-1
      M2=(INDEX2-NBRANS-1)*NWORDS+1
      DO 35 M1=MFIRST,MLAST
      MTEMP=MATRIX(M1)
      MATRIX(M1)=MATRIX(M2)
      MATRIX(M2)=MTEMP
   35 M2=M2+1
      GO TO 60
 
C     COLUMN EXCHANGE.
 
   40 MFIRST=INDEX1/MXCODS
      M2=INDEX2/MXCODS
      J1=MOD(INDEX1,MXCODS)
      J2=MOD(INDEX2,MXCODS)
      IF (J1.NE.0) MFIRST=MFIRST+1
      IF (J2.NE.0) M2=M2+1
      IF (J1.EQ.0) J1=MXCODS
      IF (J2.EQ.0) J2=MXCODS
      DO 50 M1=MFIRST,MLAST,NWORDS
      MTEMP=MATRIX(M1)
      J=LBITS(MATRIX(M2),1,J2,MXCODS,J)
      MATRIX(M1)=IAND (MATRIX(M1),OFF(J1))
      IF (J) 41,45,43
   41 MATRIX(M1)=IOR (MATRIX(M1),ON(J1))
      GO TO 45
   43 MATRIX(M1)=IOR (MATRIX(M1),PLUS(J1))
   45 MATRIX(M2)=IAND (MATRIX(M2),OFF(J2))
      IF (LBITS(MTEMP,1,J1,MXCODS,J)) 47,50,49
   47 MATRIX(M2)=IOR (MATRIX(M2),ON(J2))
      GO TO 50
   49 MATRIX(M2)=IOR (MATRIX(M2),PLUS(J2))
   50 M2=M2+NWORDS
   60 NSCNEL(I)=NSCNEL(I)+1
 
C     ELEMENTS SORTED FOR THIS CLASS--GET REMAINING CLASSES.
C     CLASS B36 NOT INCLUDED IN ROUTINE.
 
   65 IF (I.NE.1) GO TO 90
 
C     NO B25 SORT IF MR OR MG DIAGONAL.
 
   70 IF (NSCAN(2).EQ.0.OR.NSCAN(5).EQ.0) GO TO 90
      IF (BNN(2)) 80,90,75
 
C     SAME NUMBER OF NON-SCANNABLE ROWS AND COLUMNS OR
C     FEWER NON-SCANNABLE ROWS--SORT CLASS 2 ELEMENTS FOR MINIMUM MATRIX
 
   75 I=2
      GO TO 10
 
C     FEWER NON-SCANNABLE COLUMNS.
 
   80 I=5
      GO TO 10
 
   90 RETURN
 
      END
