CSECT   SCNTRE                          71.042  11.43.38
 
      SUBROUTINE SCNTRE (SRTMSK,NERROR)
 
C     SUBROUTINE TO SCAN A TREE OF ELEMENTS FOR THE TABLE INDEX AND
C       LENGTH OF EACH CLASS FOR ALL POSSIBLE BRANCH AND LINK CLASSES
C         OF ELEMENTS.  THE NUMBER OF LINKS IS COMPUTED AND STORED IN
C           THE APPROPRIATE COMMON LOCATION.  AN INDEX TO THE FIRST
C             WORD OF THE PACKED MATRIX TO BE USED BY EACH LINK CLASS
C               IS STORED IN THE THIRD PARALLEL TABLE.
C
C     BRANCH ELEMENTS--                                LINK ELEMENTS--
C
C     CODE  TABLES INDEX                              CODE  TABLES INDEX
C       A         1                                     D         9
C       B         2                                     F        10
C       C         3                                     H        11
C       D         4                                     I        12
C       E         5                                     J        13
C       F         6                                     K        14
C       H         7                                     L        15
C       J         8                                     M        16
C                                                       N        17
C
C     NERROR = 2 IF AN ILLEGAL BRANCH OR LINK CODE IS FOUND.
C
C     ALL TABLE VALUES OF ANY CODE NOT FOUND ARE ZERO.

      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'

      COMMON /ELDATA/ EL,NELMTS,LIMIT,ELMNTS(1200),SRTCOD(300),TYPE(300)
         CHARACTER*8  ELMNTS,SRTCOD,TYPE
      COMMON /BMATRX/ LEN,MXCODS,NWORDS
      COMMON /SCNTBL/ NBRANS,NLINKS,LENTBL,ISTART(17),LNCLAS(17),
     *                MATSUB(17),ISTTRS(8)
      CHARACTER*8     SRTMSK,TEMP,DAND,TABLE
      DIMENSION       ITABLJ(34),ITEMP(2),TABLE(17)
         EQUIVALENCE (TABLE,ITABLJ),(TEMP,ITEMP)
      CHARACTER*8     STORE
      CHARACTER*8     TRSMSK
      CHARACTER*8     ENTRY, EXIT
      CHARACTER*1     CODE(17)
      INTEGER         ONE,TWO
      DIMENSION       IDXIT(6,2),JPDIT(2),INDEX(6),IDXIC(6),IDXTRS(6)
         EQUIVALENCE (IDXIT(1,1),IDXIC),(IDXIT(1,2),IDXTRS),
     *               (JPDIT,JPDIC),(JPDIT(2),JPDTRS)
      LOGICAL         LFIRST
 
      DATA LFIRST /.TRUE./
      DATA CODE /'A','B','C','D','E','F','H','J',
     *           'D','F','H','I','J','K','L','M','N'/
C     SUBSCRIPTS FOR SORT CODES OF INITIAL AND TRANSIENT CLASSES.
      DATA IDXIC  /13,11, 9,8,7,4/
      DATA IDXTRS /10,11,13,6,7,8/
      DATA JPDIC,JPDTRS /12,17/
      DATA ONE,TWO /1,2/
      DATA ENTRY /' ENTRY-'/,EXIT /' EXIT-'/
C     LINK1 IS THE INDEX TO FIRST LINK CODE IN THE CODES TABLE.
      DATA LINK1 /9/
      DATA KNTRTL /1/,IDEBUG /0/
 
      IF (LFIRST) THEN
         LFIRST=.FALSE.
         DO 3681 I=1,8
            STORE (I:I)=CHAR(0)
            TRSMSK(I:I)=CHAR(0)
 3681    CONTINUE
         TRSMSK(6:6)=CHAR(255)
      END IF
 
      IF (KNTRTL-IDEBUG) 5,5,10
    5 WRITE (iqqout,1) KNTRTL,ENTRY,
     * ichar(SRTMSK(1:1)),
     * ichar(SRTMSK(2:2)),
     * ichar(SRTMSK(3:3)),
     * ichar(SRTMSK(4:4)),
     * ichar(SRTMSK(5:5)),
     * ichar(SRTMSK(6:6)),
     * ichar(SRTMSK(7:7)),
     * ichar(SRTMSK(8:8)),
     * NELMTS,NBRANS,NLINKS
    1 FORMAT ('1SCNTRE:',I3,A,'SORT MASK IS (',8i4,')',I8,
     *        ' ELEMENTS ------',I4,' BRANCHES AND',I4,' LINKS'//)
      WRITE (iqqout,2)
    2 FORMAT (1H0,44X,4HNAME,26X,4HTYPE,13X,4HCODE//)
      WRITE (iqqout,3) (ELMNTS(I),
     * ichar(TYPE(I)(1:1)),
     * ichar(TYPE(I)(2:2)),
     * ichar(TYPE(I)(3:3)),
     * ichar(TYPE(I)(4:4)),
     * ichar(TYPE(I)(5:5)),
     * ichar(TYPE(I)(6:6)),
     * ichar(TYPE(I)(7:7)),
     * ichar(TYPE(I)(8:8)),
     * SRTCOD(I),I=1,NELMTS)
    3 FORMAT (45X,A,6X,8i4,6X,A)
 
C     MOVE APPROPRIATE CODES INTO TABLE.
 
   10 J=2
      IF (TRSMSK .NE. SRTMSK) J=1
      DO 20 I=1,LENTBL
         TABLE(I)=STORE
         TABLE(I)(J+4:J+4)=CODE(I)
   20 IF (I .LE. 6) INDEX(I)=IDXIT(I,J)
      JPDEP=JPDIT(J)
 
C     SET UP INITIAL VARIABLES FOR SCAN.
 
   35 LDOWN=NBRANS+ONE
      ITAB=ONE
      NSTART=ONE
      NEND=NBRANS
      NWAY=ONE
   45 NLITE=0
      DO 80 IELM=NSTART,NEND
         TEMP=DAND(SRTCOD(IELM),SRTMSK)
 
C     SEE IF CODE WANTED.
 
   50    IF (ITEMP(2)-ITABLJ(ITAB*2)) 800,60,55
  800    IF (TEMP.EQ.DAND(SRTCOD(IELM+1),SRTMSK)) GO TO 80
 
C     GET NEXT CODE FROM TABLE AND CONTINUE.
 
   55    NLITE=0
         ITAB=ITAB+ONE
         GO TO 50
 
C     THIS IS CODE WANTED--SEE IF THIS IS FIRST TIME CODE ENCOUNTERED.
 
   60    IF (NLITE) 80,65,80
 
C     SET INDEX OF FIRST CODE OF TREE IN TABLE.
 
   65    ISTART(ITAB)=IELM
         NLITE=ONE
 
C     SET MATRIX SUBSCRIPT IN TABLE IF LINK ELEMENT
 
         GO TO (80,70),NWAY
   70    MATSUB(ITAB)=(IELM-LDOWN)*NWORDS+ONE
 
C     UPDATE NUMBER OF ENTRIES IN THIS CLASS.
 
   80 LNCLAS(ITAB)=LNCLAS(ITAB)+ONE

      IF (NSTART.NE.ONE) GO TO 86
      NSTART=LDOWN
      NEND=NELMTS
      NWAY=TWO
      ITAB=LINK1
      GO TO 45
 
C     SET UP CLASS TABLES.
 
   86 DO 87 ITAB=1,6
         I=INDEX(ITAB)
         MATSUB(ITAB)=LNCLAS(I)
   87 ISTTRS(ITAB)=ISTART(I)
      MATSUB(7)=LNCLAS(1)+LNCLAS(2)+LNCLAS(3)+LNCLAS(5)
      MATSUB(8)=LNCLAS(14)+LNCLAS(15)+LNCLAS(16)+LNCLAS(JPDEP)
      IF (MATSUB(7).NE.0) ISTTRS(7)=ONE
      DO 88 I=14,16
   88 IF (LNCLAS(I).NE.0) GO TO 89
   89 ISTTRS(8)=ISTART(I)
      IF (ISTTRS(8).EQ.0.AND.JPDEP.EQ.JPDTRS.OR.JPDEP.EQ.JPDIC.AND.
     *    LNCLAS(JPDEP).NE.0) ISTTRS(8)=ISTART(JPDEP)
 
C     WRITE DEBUG OUTPUT IF REQUIRED.
 
   90 IF (KNTRTL-IDEBUG) 95,95,100
   95 WRITE (iqqout,1) KNTRTL,EXIT,
     * ichar(SRTMSK(1:1)),
     * ichar(SRTMSK(2:2)),
     * ichar(SRTMSK(3:3)),
     * ichar(SRTMSK(4:4)),
     * ichar(SRTMSK(5:5)),
     * ichar(SRTMSK(6:6)),
     * ichar(SRTMSK(7:7)),
     * ichar(SRTMSK(8:8)),
     * NELMTS,NBRANS,NLINKS
      WRITE (iqqout,91) NERROR
   91 FORMAT (1H0,17X,5HCODES,6X,19HINDEX TO FIRST CODE,6X,
     *        'NUMBER OF ENTRIES',6X,'NCLTRS(8),MATSUB(9),ISTTRS(8)',
     *        6X,8HNERROR =,I2//)
      WRITE (iqqout,92) (
     * ichar(TABLE(ITAB)(1:1)),
     * ichar(TABLE(ITAB)(2:2)),
     * ichar(TABLE(ITAB)(3:3)),
     * ichar(TABLE(ITAB)(4:4)),
     * ichar(TABLE(ITAB)(5:5)),
     * ichar(TABLE(ITAB)(6:6)),
     * ichar(TABLE(ITAB)(7:7)),
     * ichar(TABLE(ITAB)(8:8)),
     * ISTART(ITAB),LNCLAS(ITAB),MATSUB(ITAB),ITAB=1,LENTBL)
   92 FORMAT (1X,8i4,9X,I3,21X,I3,24X,I4)
      WRITE (iqqout,93) (ISTTRS(I),I=1,8)
   93 FORMAT (88X,I4)
      KNTRTL=KNTRTL+ONE

  100 RETURN
 
      END
