CSECT   SDEPSR
C       22 MAR 73
 
      SUBROUTINE SDEPSR
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER(I-N)
 
C     SUBROUTINE SDEPSR
C         TO INSERT SOURCES OFR J0-J9 PAIRS OF DEPENDENT CURRENT
C     SOURCES -
C      FOR EACH J0=VALUE*J9, INSERT A VOLTAGE SOURCE IN SERIES WITH
C      WITH THE J9
C
C     FOR EACH JX=VALUE*IRX, INSERT A VOLTAGE SOURCE IN SERIES WITH
C        RX,  E$DXX=FDUMMY(VALUE,VJX)
C
C     FOR EACH EY=VALUE*VRY, INSERT A CURRENT SOURCE IN PARALLEL WITH
C        RY,  J$DXX=FDUMMY(VALUE,IEY)
C
C     FDUMMY(A,B)=A*B
 
	include 'values.inc'
                      character*8  valist

      COMMON /CNTRLS/ CTRL(160)
      COMMON /ELDATA/ EL,NELMTS,NELMIT,ELMNTS(300),FNODE(300),
     .                TNODE(300),VALU(300),SRTCOD(300),CMPFLG(300),
     .                VALCOD(300),VALLO(300),VALHI(300),LIMSW
         CHARACTER*8  ELMNTS,FNODE,TNODE,SRTCOD

      INTEGER         NDS(2)
         EQUIVALENCE (NDS(1),NEADJ)

      CHARACTER*8     SRTDAT,RESIS,BUFR,J0
      CHARACTER*8     EADJ,AADJ
      CHARACTER*1     V,Y,SYSFN(2)
      CHARACTER*2     LDCOD(2),LDSC
      CHARACTER*8     SCOD(2)
      CHARACTER*8     IZLD(2),IZST
      character*3     AJSRC(3)
         INTEGER      IIIZLD(4)
         EQUIVALENCE (IZLD,IIIZLD)
      CHARACTER*8     TABLE(6)
         EQUIVALENCE (TABLE(1),IZ4),(TABLE(3),IZ16),(TABLE(5),IZ14)
      DOUBLE PRECISION IZ4,IZ14,IZ16
         INTEGER      IIIZ4(2)
         INTEGER      IIIZ14(2)
         INTEGER      IIIZ16(2)
         EQUIVALENCE (IZ4,IIIZ4),(IZ14,IIIZ14),(IZ16,IIIZ16)
      CHARACTER*8     LDTAB(8)
         INTEGER      ILDTB1(2)
         INTEGER      ILDTB3(2)
         INTEGER      ILDTB7(2)
         EQUIVALENCE (LDTAB(1),ILDTB1),(LDTAB(3),ILDTB3),
     *               (LDTAB(7),ILDTB7)
      CHARACTER*8     SDEP
      CHARACTER*8     BLANK
      CHARACTER*8     CJ9,CJ0COD,SOURC
      LOGICAL         LFIRST
 
      DATA LFIRST     /.TRUE./
      DATA NDS        /0,0/
      DATA V,Y        /'V','Y'/
      DATA LDCOD      /'KK','AA'/
      DATA AJSRC      /'E$D','J$D','A$D'/
      DATA SYSFN      /'V','I'/
      DATA TABLE(2)   /'FDUMMY  '/
      DATA SDEP       /'SDEPSR'/
      DATA BLANK      /'        '/
C     DATA IZLD /Z000000000000000E,Z000000000000000D/
      DATA IIIZLD     /0,14,0,13/
C     DATA IZ4,IZ14,IZ16 /Z0000000000000004,Z000000000000000E,
C                         Z0000000000000010/
      DATA IIIZ4      /0,4/
      DATA IIIZ14     /0,14/
      DATA IIIZ16     /0,16/
C     DATA LDTAB /Z0000000000000004,8HFDUMMY  ,Z0000000000000001,
C    .            3*8H        ,Z0000000000000000,8H        /
      DATA ILDTB1     /0,4/
      DATA LDTAB(2)   /'FDUMMY'/
      DATA ILDTB3     /0,1/
      DATA LDTAB(4)   /' '/
      DATA LDTAB(5)   /' '/
      DATA LDTAB(6)   /' '/
      DATA ILDTB7     /0,0/
      DATA LDTAB(8)   /' '/
 
      IF (LFIRST) THEN
      LFIRST=.FALSE.
C     DATA SCOD /Z00000000C2C20000,Z00000000D3D30000/
      SCOD(1)=CHAR(0)//CHAR(0)//CHAR(0)//CHAR(0)//'BB'//CHAR(0)//CHAR(0)
      SCOD(2)=CHAR(0)//CHAR(0)//CHAR(0)//CHAR(0)//'LL'//CHAR(0)//CHAR(0)
      CJ0COD =CHAR(0)//CHAR(0)//CHAR(0)//CHAR(0)//'CC'//CHAR(0)//CHAR(0)
      END IF
 
      JELMTS=NELMTS
      DO 500 I=1,JELMTS
      SRTDAT=SRTCOD(I)
      IF (srtdat(5:6).NE.'MM') GO TO 500
 
C     INSERT SOURCE FOR THIS VARIABLE
 
      J0=ELMNTS(I)
      CALL FIND (VALIST,J0,NSTART,NEND,LENGTH)
      CJ9=VALIST(NEND)
      DO 60 IC=1,NELMTS
      NEND=IC
   60 IF (ELMNTS(IC).EQ.CJ9) GO TO 70
 
C     'NEND' IS THE INDEX TO THE PRIMARY DEPENDENT CURRENT SOURCE
 
   70 NEADJ=NEADJ+1
      NELMTS=NELMTS+1
      write (eadj,'(a,i2.2)') ajsrc(1),neadj
      ELMNTS(NELMTS)=EADJ
      TNODE(NELMTS)=TNODE(NEND)
      write (aadj,'(a,i2.2)') ajsrc(3),neadj
      TNODE(NEND)=AADJ
      FNODE(NELMTS)=AADJ
      SRTCOD(NELMTS)=CJ0COD
      VALCOD(NELMTS)=IZ4
      VALU(NELMTS)=0.D0
      CMPFLG(NELMTS)=0.D0
 
C     E$DXX  ,FNODE(I) - A$DXX  =FDUMMY(Y(J0),V(J0))
 
      BUFR=BLANK
      bufr(1:1)=Y
      bufr(2:7)=j0(2:7)
      TABLE(4)=BUFR
      BUFR=BLANK
      bufr(1:1)=V
      bufr(2:7)=J0(1:6)
      TABLE(6)=BUFR
      CALL STORE (VALIST(1),EADJ,1,TABLE,6,NR)
C     print 6000,eadj,nelmts,elmnts(nelmts),srtcod(nelmts)(5:6),
C    *           fnode(nelmts),tnode(nelmts)
C6000 format (' SDEPSR: ',a,i4,4(1x,a),' -  E$DXX inserted')
  500 CONTINUE
 
C     INSERT DUMMY SOURCES FOR JX'S AND EY'S
 
      DO 1000 IS=1,2
      LDSC=LDCOD(IS)
      IZST=IZLD(IS)
      DO 900 I=1,JELMTS
      SRTDAT=SRTCOD(I)
      IF (srtdat(5:6).NE.LDSC(1:2)) GO TO 900
 
C     INSERT SOURCE FOR THIS ELEMENT
 
      SOURC=ELMNTS(I)
      CALL FIND (VALIST,SOURC,NSTART,NEND,LENGTH)
      resis=VALIST(NEND)(2:)
      DO 600 IC=1,NELMTS
      NEND=IC
  600 IF (RESIS.EQ.ELMNTS(IC)) GO TO 620
  620 NDS(IS)=NDS(IS)+1
      NELMTS=NELMTS+1
      write (ELMNTS(NELMTS),'(a,i2.2)') ajsrc(is),nds(is)
      SRTCOD(NELMTS)=SCOD(IS)
      VALU(NELMTS)=0.D0
      CMPFLG(NELMTS)=0.D0
      VALCOD(NELMTS)=IZ4
      TNODE(NELMTS)=TNODE(NEND)
      GO TO (650,680),IS
 
C     INSERTING A VOLTAGE SOURCE IN SERIES
 
  650 continue
      write (aadj,'(a,i2.2)') ajsrc(3),nds(is)
      TNODE(NEND)=AADJ
      FNODE(NELMTS)=AADJ
      GO TO 700
 
C     INSERTING A CURRENT SOURCE
 
  680 FNODE(NELMTS)=FNODE(NEND)
  700 DO 720 IX=2,4
  720 LDTAB(IX+2)=VALIST(NSTART+IX)
      LDTAB(7)=IZST
      LDTAB(8)=SYSFN(IS)(1:1)//elmnts(nend)(2:6)
      CALL STORE(VALIST(1),ELMNTS(NELMTS),1,LDTAB(1),8,NR)
C     print 6001,nelmts,elmnts(nelmts),srtcod(nelmts)(5:6),
C    *           fnode(nelmts),tnode(nelmts)
C6001 format (' SDEPSR: ',i4,4(1x,a),' inserted')

  900 CONTINUE
 1000 CONTINUE
 
C     IF DUMMY SOURCES HAVE BEEN INSERTED AND
C     'USE SYMBOLIC JACOBIAN' WAS SPECIFIED AND
C     'RUN IC BY IMPLICIT' WAS SPECIFIED
C     PRINT WARNING MESSAGE
 
      IF (NELMTS.GT.JELMTS .AND. 
     *    CTRL(62).NE.0.D0 .AND.  
     *    CTRL(55).NE.0.D0)
     *                          CALL ERROR(SDEP,1,93)
      RETURN
 
      END
