CSECT   STCONV
 
      SUBROUTINE STCONV(TAB,LEN,SPLIT,ISPLIT,ANAME,FNODE,IDERIV,IERR)
 
C *** MARCH 21  1973
C
C     SUBROUTINE TO PROCESS CONVOLUTION KERNELS - CALLED FROM ELMPRS
C     SAME CALLING SEQUENCE AS STRELM
C     TAB IS TABLE TO BE TRANSFERRED TO VALIST
C     LEN IS LENGTH OF TABLE
C     SPLIT IS SPLIT-OUT NAME
C     ISPLIT IS LENGTH OF SPLIT-OUT NAME
C     ANAME IS PACKED NAME
C     FNODE IS TO AND FROM NODE
C     IDERIV = 0 MEANS NOT DERIVATIVE
C     IERR IS ERROR INDICATOR
 
      IMPLICIT DOUBLE PRECISION (A-H,O-W,Y,Z), CHARACTER*1 (X)
 
      COMMON /CONV/   CNVTB(50)
         CHARACTER*8  CNVTB
      COMMON /CHKCTL/ ICHTBL(320)
      COMMON /CNTRLS/ SKIP(85),CNVRQS
      CHARACTER*8     TAB(2),SPLIT(1),FNODE(2),TEMP(5),CHARS(10)
      DIMENSION       XTN(6)
      CHARACTER*8     TNAME,ANAME,RNAME,SVNODE
      CHARACTER*8     YJ,YE,BLANK
         EQUIVALENCE (XTN(1),TNAME),(YJ,XJ),(YE,XE)
      CHARACTER*8     FCONVY,FCONVE,FCONVJ
      CHARACTER*8     FRZZ , FRYY , R
      CHARACTER*8     Z1
         INTEGER      IIZ1(2)
         EQUIVALENCE (Z1,IIZ1)
 
      DATA XI /'I'/,XV /'V'/,XK /'K'/
      DATA IIZ1 /0,1/
      DATA FRZZ /'FRZZ'/, FRYY /'FRYY'/, R /'R'/
      DATA FCONVY /'FCONVY'/,FCONVE /'FCONVE'/,FCONVJ /'FCONVJ'/
      DATA TEMP /'1','.','0','D','0'/
      DATA CHARS /'0','1','2','3','4','5','6','7','8','9'/
      DATA YJ /'J'/,YE /'E'/,BLANK /' '/
 
C IS IT CONVOLUTION KERNEL
 
      TNAME=ANAME
      IF(XTN(1) .NE. XK) RETURN
 
C     IS IT LEGAL
 
      LEGAL=0
      IF(TAB(2) .EQ. FCONVE) LEGAL=1
      IF(TAB(2) .EQ. FCONVJ) LEGAL=2
      IF(LEGAL .EQ. 0) RETURN
      TAB(LEN+1)=Z1
      ICHTBL(172)=1
 
C     STORE SECOND ARGUMENT IN TAB
 
      CNVRQS=CNVRQS+1.D0
      ICNV=CNVRQS
      IF(ICNV-10)10,20,30
   10 TEMP(1)=CHARS(ICNV+1)
      GO TO 40
   20 TEMP(3)=TEMP(2)
   30 ITEN=ICNV/10
      IONE=ICNV-10*ITEN
      TEMP(1)=CHARS(ITEN+1)
      TEMP(2)=CHARS(IONE+1)
   40 CALL CPYSP(TEMP,5,TAB,0,TAB,0,TAB(LEN+2),NN)
      TAB(LEN+3)=BLANK
      TAB(LEN+4)=BLANK
      LEN=LEN+4
 
C     FIX RESISTOR NAME AND NODES
 
      RNAME=R
      ITO=2
      CALL CPY(ANAME,1,RNAME,ITO,4)
      ANAME=RNAME
      SPLIT(1)=R
      IF(LEGAL .EQ. 2) GO TO 100
 
C     FORM INTERNAL NODE FOR SERIES CASE
 
      SVNODE=FNODE(2)
      FNODE(2)=TNAME
 
C     PUT IN NEW FUNCTION NAME
 
      TAB(2)=FRZZ
      GO TO 110
  100 TAB(2)=FRYY
  110 CALL STRELM(TAB,LEN,SPLIT,ISPLIT,ANAME,FNODE,IDERIV,IERR)
      IF(IERR .NE. 1) RETURN
 
C     STORE IR OR VR IN CONVOLUTION COOMMON
 
      TNAME=RNAME
      DO 115 II=1,5
      I=6-II
  115 XTN(I+1)=XTN(I)
      XTN(1)=XI
      IF(LEGAL .EQ. 2) XTN(1)=XV
      IF(ICNV .LE. 50) CNVTB(ICNV)=TNAME
 
C     FIX UP NAME,NODES, AN D FUNCTION FOR SOURCE
 
      TAB(2)=FCONVY
      TNAME=RNAME
      IF(LEGAL .EQ. 1) GO TO 130
      SPLIT(1)=YJ
      XTN(1)=XJ
  120 ANAME=TNAME
      RETURN
 
C     SERIES CASE -- FIX UP
 
  130 XTN(1)=XE
      FNODE(1)=SVNODE
      SPLIT(1)=YE
      GO TO 120
 
      END
