CSECT   STORE                           71.042  11.43.38
 
      SUBROUTINE STORE (LIST,IDXNAM,ISTORE,ITEMS,NITEMS,NERROR)
 
C     SUBROUTINE TO STORE ADDITIONAL DATA IN SOME INDEX DATA FIELD OF A
C       LIST OR TO SET UP A NEW INDEX AND DATA FIELD IN THAT LIST WHEN
C         ISTORE IS ON.  IF ISTORE IS ZERO, NEW DATA IS NOT MOVED IN
C           BUT THE LOCATIONS FOR NITEM  ARE RESERVED.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'

      CHARACTER*8     LIST,IDXNAM,ITEMS
      DIMENSION       LIST(*),ITEMS(*),LINT(6),XLINT(3),ISTART(2)
         CHARACTER*8  XLINT,START
      EQUIVALENCE     (LINT,XLINT),(START,ISTART),(NSTART,ISTART(2))
 
      DO 200 I=1,3
  200 XLINT(I)=LIST(I)
      IDXMAX=LINT(6)-2
      MAXPNT=IDXMAX+1
      NERROR=1
      MAXDAT=LINT(4)-(LINT(2)-1+NITEMS)
 
C     CHECK POSSIBLE ERROR ASSUMING INDEX IS IN THE LIST.
 
      IF (MAXDAT) 55,20,20
 
C     SEE IF THERE ARE NO INDEXES IN THE LIST.
 
   20 IF (IDXMAX-5) 75,30,30
 
C     SEARCH FOR INDEX WANTED.
 
   30 DO 50 I=5,IDXMAX,2
      IF (LIST(I).NE.IDXNAM) GO TO 50
 
C     THIS IS THE INDEX WANTED--SEE IF LAST ONE.
 
      IF (I.EQ.IDXMAX) GO TO 80
      MINPNT=I+3
      START=LIST(MINPNT)
      KSTART=NSTART
 
C     MOVE ALL DATA UP FOR NEW DATA.
 
      K=LINT(2)+NITEMS
   40 K=K-1
      J=K-NITEMS
      LIST(K)=LIST(J)
      IF (J.GT.NSTART) GO TO 40
 
C     UPDATE DATA POINTERS OF FOLLOWING INDEXES.
 
      DO 45 J=MINPNT,MAXPNT,2
      START=LIST(J)
      NSTART=NSTART+NITEMS
   45 LIST(J)=START
      GO TO 82
   50 CONTINUE
 
C     MUST INSERT NEW INDEX--SEE IF OVERFLOW WILL OCCUR.
 
      IF (MAXDAT-2) 55,60,60
   55 NERROR=2
      GO TO 90
 
C     MOVE ALL DATA UP TWO LOCATIONS.
 
   60 I=LINT(2)
   65 I=I-1
      LIST(I+2)=LIST(I)
      IF (I.GT.LINT(6)) GO TO 65
 
C     INCREMENT DATA POINTERS OF ALL INDEXES BY 2.
 
      DO 70 I=6,MAXPNT,2
      START=LIST(I)
      NSTART=NSTART+2
   70 LIST(I)=START
 
C     UPDATE DATA POINTERS FOR LIST WITH NEW INDEX.
 
   75 LINT(2)=LINT(2)+2
      LINT(6)=LINT(6)+2
 
C     INSERT NEW INDEX.
 
      LIST(IDXMAX+2)=IDXNAM
      LIST(IDXMAX+3)=XLINT(1)
 
C     SET STARTING POINT FOR NEW DATA AND UPDATE LIST POINTER.
 
   80 KSTART=LINT(2)
   82 LINT(2)=LINT(2)+NITEMS
 
C     FINISHED UNLESS NEW DATA TO BE STORED.
 
      IF (ISTORE.EQ.0) GO TO 90
 
C     MOVE IN NEW DATA.
 
      DO 85 I=1,NITEMS
      LIST(KSTART)=ITEMS(I)
   85 KSTART=KSTART+1
   90 LIST(1)=XLINT(1)
      LIST(3)=XLINT(3)
      IF (NERROR.EQ.1) GO TO 100
      WRITE (iqqout,91) LIST(4),IDXNAM
   91 FORMAT ('0PROGRAM CAPACITY HAS BEEN EXCEEDED--''',A6,
     * ''' LIST OVERFLOWED IN FILING ''',A6,1H')
      STOP 'STORE: program capacity exceeded, run aborted'
 
  100 RETURN
 
      END
