CSECT   STRELM                          71.042  11.43.38
 
      SUBROUTINE STRELM (TABLE,LENTBL,SPLIT,ISPLIT,ANAME,TNODES,IDERIV,
     *                   NERROR)
 
C      SUBROUTINE TO PROCESS AND STORE DERIVATIVE, ELEMENT AND MUTUAL
C      DATA AND ESTABLISH ELEMENT SORT CODES - MINTURN - FORTRAN 4
C      ARGUMENTS ARE-- TABLE - DATA WHICH HAS BEEN ESTABLISHED BY
C                              THE VALUE PROCESSOR
C                      LENTBL- LENGTH OF DATA TABLE
C                      SPLIT - TABLE CONTAINING SPLIT-OUT NAME
C                      ISPLIT- LENGTH OF SPLIT TABLE
C                      ANAME - PACKED NAME
C                      TNODES- TABLE OF NODES OR INDUCTORS
C                      IDERIV- INDICATES SOURCE DERIVATIVE IF NON-ZERO
C                      ERROR - ERROR INDICATOR
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'values.inc'
                      character*8  valist

      COMMON /MUTUAL/ AMUT,NMUTL,LMUTL,AMUTBL(50,6)
         CHARACTER*8  AMUTBL
      COMMON /ELDATA/ ELM,NELMTS,LELMTS,ELMNTS(300),FNODE(300),
     *       TNODE(300),VALU(300),SRTCDE(300),CMPFLG(300),VALCOD(300),
     *       VALLO(300),VALHI(300),LIMSW
         CHARACTER*8  ELMNTS,FNODE,TNODE,VALU,SRTCDE,VALCOD,VALLO,VALHI
      COMMON /SDERIV/ SDR,NSDRIV,LSDRIV,SDRVTB(50,3)
         CHARACTER*8  SDRVTB
      COMMON /MODATA/ ANAMES(3),CKTDES(4),PRJ(62),ANODES(25,2),NMDNOD,
     1 MDPRNT,SUPRES(10),EQUCHG(15,2),TBLCHG(15,2),NTBLCH,NEQUCH,NSUPRS,
     2 MDTAPE,MDLEN,MDUSED,IALL,KCHNGE,NTEMP,NMDCHR
         CHARACTER*8  CKTDES
      COMMON /BDNUMS/ LSW,IDLMT,VNOM,BLOW,BHIGH
         CHARACTER*8  BLOW,BHIGH
      CHARACTER*8     SRTCOD(11),ELPRFX(5),TABLE(*),SPLIT(*),TNODES(*)
      DIMENSION        IDC(2),IZROSC(600)
         EQUIVALENCE  (SRTCDE(1),IZROSC(1))
         EQUIVALENCE  (ACODE,IDC),(ICODE,IDC(2))
         CHARACTER*8   ACODE
      CHARACTER*8      M
      INTEGER          ZERO, ONE
      CHARACTER*8      STREL
      CHARACTER*8      FP7
         INTEGER       IIFP7(2)
         EQUIVALENCE  (IIFP7,FP7)
      CHARACTER*8      FP6
         INTEGER       IIFP6(2)
         EQUIVALENCE  (IIFP6,FP6)
      CHARACTER*8      FPONE
         INTEGER       IPONE(2)
         EQUIVALENCE  (IPONE,FPONE)
      DOUBLE PRECISION RPZERO
         CHARACTER*8   FPZERO
         EQUIVALENCE  (FPZERO,RPZERO)
      CHARACTER*8      ANAME
 
      DATA M /'M'/
      DATA IIFP7 /0,7/
      DATA IIFP6 /0,6/
      DATA IPONE /0,1/
      DATA RPZERO /0.D0/
      DATA I /0/
      DATA STREL /'STRELM'/
      DATA ZERO,ONE /0,1/
      DATA ELPRFX /'C','R','L','E','J'/
      DATA SRTCOD /'    JF','    HH','    DJ','    BB','    LL',
     *             '    EE','    IN','    CC','    MM','    AA',
     *             '    KK  '/
 
      IERROR = 1
 
C     CHECK FOR SOURCE DERIVATIVE AND PROCESS IF FOUND
 
      IF (IDERIV .EQ. ZERO) GO TO 1320
      IF(NSDRIV.EQ.0) GO TO 1305
 
C     REDUNDANT SOURCE DERIVATIVE TEST
 
      DO 1200 I=1,NSDRIV
      IF(SDRVTB(I,1).NE.ANAME) GO TO 1200
      IF((NMDCHR.EQ.0).OR.(KCHNGE.EQ.1)) GO TO 1392
      GO TO 1400
 1200 CONTINUE
 
C     CHECK CAPACITY OF SOURCE DERIVATIVE TABLE
 
      IF (NSDRIV .LT. LSDRIV) GO TO 1305
 
C         THE MAXIMUM OF FIFTY SOURCE DERIVATIVES HAS BEEN EXCEEDED
 
      KERROR=50
      GO TO 1395
 
C     INCREMENT DERIVATIVE COUNT AND STORE DATA
 
 1305 NSDRIV = NSDRIV + ONE
      SDRVTB(NSDRIV,1) = ANAME
      SDRVTB(NSDRIV,2) = FPZERO
      SDRVTB(NSDRIV,3) = TABLE(1)
 
C     IF THE DERIVATIVE VALUE IS CONSTANT, STORE FP VALUE IN TABLE
 
      IF (TABLE(1) .EQ. FPONE) SDRVTB (NSDRIV,2) = TABLE(2)
      GO TO 1385
 
C     CHECK FOR MUTUAL AND PROCESS IF LOCATED
 
 1320 IF (SPLIT(1) .NE. M) GO TO 1339
      IF(NMUTL.EQ.0) GO TO 1330
 
C     REDUNDANT MUTUAL TEST
 
      DO 1321 I = 1, NMUTL
      IF(AMUTBL(I,2).NE.ANAME) GO TO 1321
      IF((NMDCHR.EQ.0).OR.(KCHNGE.EQ.1)) GO TO 1392
      AMUTBL(I,3) = TNODES(1)
      AMUTBL(I,4) = TNODES(2)
      GO TO 1400
 1321 CONTINUE
 
C     CHECK CAPACITY OF MUTUAL TABLE
 
      IF (NMUTL .LT. LMUTL) GO TO 1330
 
C         THE MAXIMUM OF FIFTY MUTUAL INDUCTANCES HAS BEEN EXCEEDED
 
      KERROR=49
      GO TO 1395
 
C     INCREMENT MUTUAL COUNTER AND STORE DATA
 
 1330 NMUTL = NMUTL + 1
      AMUTBL(NMUTL,1) = TABLE(1)
      AMUTBL(NMUTL,2) = ANAME
      AMUTBL(NMUTL,3) = TNODES(1)
      AMUTBL(NMUTL,4) = TNODES(2)
      AMUTBL(NMUTL,5) = FPZERO
 
C     IF MUTUAL VALUE IS CONSTANT, STORE FP VALUE IN TABLE
 
      IF(TABLE(1) .EQ. FPONE) AMUTBL(NMUTL,5) = TABLE(2)
      GO TO 1385
 1339 IF(NELMTS.EQ.0) GO TO 1350
 
C     REDUNDANT ELEMENT TEST
 
      DO 1340 I = 1, NELMTS
      IF(ELMNTS(I).NE.ANAME) GO TO 1340
      IF((NMDCHR.EQ.0).OR.(KCHNGE.EQ.1)) GO TO 1392
      FNODE(I) = TNODES(1)
      TNODE(I) = TNODES(2)
      GO TO 1400
 1340 CONTINUE
 
C     CHECK CAPACITY OF ELEMENTS TABLE
 
      IF (NELMTS .LT. LELMTS) GO TO 1350
 
C     THE MAXIMUM OF 300 ELEMENTS HAS BEEN EXCEEDED
 
      KERROR=48
      GO TO 1395
 
C     INCREMENT ELEMENTS COUNTER AND STORE DATA
 
 1350 NELMTS = NELMTS + ONE
      ELMNTS(NELMTS) = ANAME
      FNODE(NELMTS) = TNODES(1)
      TNODE(NELMTS) = TNODES(2)
      VALU(NELMTS)= FPZERO
      VALLO(NELMTS)=FPZERO
      VALHI(NELMTS)=FPZERO
      VALCOD(NELMTS) = TABLE(1)
 
C     IF ELEMENT VALUE IS CONSTANT, STORE FP VALUE IN TABLE
 
      IF(TABLE(1).NE.FPONE) GO TO 1355
      VALU(NELMTS)=TABLE(2)
      IF(LSW.EQ.0) GO TO 1353
      LSW=0
      VALLO(NELMTS)=BLOW
      VALHI(NELMTS)=BHIGH
      LIMSW=1
      GO TO 1355
 1353 VALLO(NELMTS)=TABLE(2)
      VALHI(NELMTS)=TABLE(2)
 
C     DETERMINE AND STORE ELEMENT SORT CODE
 
 1355 ACODE = TABLE(1)
      DO 1360 I=1,5
 1360 IF (ELPRFX(I) .EQ. SPLIT(1)) GO TO (1380,1380,1380,1380,1380,
     *    1380,1375,1375,1370,1365),ICODE
 
C     INCORRECT ELEMENT SUPPLIED
 
      KERROR = 74
      GO TO 1395
 1365 I = I + 2
 1370 I = I + 2
 1375 I = I + 2
 1380 SRTCDE(NELMTS) = SRTCOD(I)
 
C     CHECK FOR VARIABLE ELEMENT AND STORE IN VALUE LIST IF REQUIRED
 
 1385 IF (TABLE(1) .EQ. FPONE) GO TO 1400
 
C     CHECK FOR DIODE TABLE AND GET RID OF T3 IN SECOND WORD
 
      IF (TABLE(1) .NE. FP7) GO TO 1390
      DO 1387 LQ3 = 2, LENTBL
 1387 TABLE (LQ3) = TABLE (LQ3 + 1)
      LENTBL = LENTBL - 1
 1390 CALL STORE (VALIST,ANAME,1,TABLE,LENTBL,IERROR)
      IF (ICODE .NE. 10) GO TO 1400
      IF (SRTCDE(NELMTS) .EQ. SRTCOD(11) .AND.
     *    TABLE(LENTBL-1).EQ.FP6) GO TO 1400
      IF (SRTCDE(NELMTS) .EQ. SRTCOD(10) .AND.
     *    TABLE(LENTBL-1).EQ.FP7) GO TO 1400
      KERROR = 74
      GO TO 1395
 1392 KERROR=72
 
C     SET ERROR INDICATOR
 
 1395 CALL ERROR(  STREL ,2,KERROR)
      NERROR=2
 1400 NERROR = IERROR
      IZROSC(2*NELMTS-1)=0
      RETURN
 
      END
