CSECT   TOPLGY                          71.042  11.43.38
 
      SUBROUTINE TOPLGY
 
C     SUBROUTINE TO LIST OUT CIRCUIT TOPOLOGY FOR A SCEPTRE RUN.
C        L. BISKUP      7/14/66
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'

      COMMON /ELDATA/ EL,NELMTS,LELMTS,ELMNTS(300),FNODE(300),
     *                TNODE(300)
         CHARACTER*8  ELMNTS,FNODE,TNODE
      LOGICAL         LSTFRM,LSTTO
      CHARACTER*8     DARG
 
C     IF THERE ARE NO ELEMENTS, OR IF THERE IS ONLY ONE ELEMENT, RETURN.
 
      IF (NELMTS .LE. 1) RETURN
      WRITE (iqqout,95)
   95 FORMAT ('1THE CIRCUIT TOPOLOGY IS GIVEN HERE AS AN AID IN ',
     *        'CHECKING THE INPUT DATA '/1H0)
      WRITE (iqqout,96)
   96 FORMAT (2X,4HNODE,13X,18HATTACHED COMPONENT,14X,13HADJACENT NODE/
     *        2X,4(1H-),13X,8(1H-),1X,9(1H-),14X,8(1H-),1X,4(1H-)/1H0)
      ILINES = 7
      DO 200 I=1,NELMTS
      IM1 = I - 1
      IP1 = I + 1
      LSTFRM = .TRUE.
      LSTTO = .TRUE.
 
C     FIRST ELEMENT IN THE CIRCUIT -- ALWAYS LIST BOTH NODES.
 
      IF (I .EQ. 1) GO TO 130
 
C     CHECK TO SEE IF EITHER NODE OF THIS ELEMENT HAS APPEARED PREVIOUSL
 
      DO 120 J=1,IM1
      IF (FNODE(I) .EQ. FNODE(J) .OR. FNODE(I) .EQ. TNODE(J))
     *   LSTFRM = .FALSE.
      IF (TNODE(I) .EQ. FNODE(J) .OR. TNODE(I) .EQ. TNODE(J))
     *   LSTTO = .FALSE.
  120 IF (.NOT. LSTFRM .AND. .NOT. LSTTO) GO TO 200
 
C     CHECK TO SEE IF 'FROM' NODE OF THIS ELEMENT SHOULD BE LISTED.
 
      IF (.NOT. LSTFRM) GO TO 160
 
C     'FROM' NODE OF THIS ELEMENT HAS NOT APPEARED PREVIOUSLY. LIST IT.
 
  130 CALL LSTR (3,     ILINES, FNODE(I), ELMNTS(I), TNODE(I))
 
C     SCAN REMAINDER OF ELEMENTS LIST FOR COMPONENTS CONNECTED TO THE
C        'FROM' NODE OF THIS ELEMENT.
 
      DO 140 J=IP1,NELMTS
      IF (FNODE(J) .EQ. FNODE(I))
     *    CALL LSTR (2,     ILINES, ELMNTS(J), TNODE(J),DARG)
  140 IF (TNODE(J) .EQ. FNODE(I))
     *    CALL LSTR (2,     ILINES, ELMNTS(J), FNODE(J),DARG)
      CALL LSTR (1,     ILINES,DARG,DARG,DARG)
  160 IF (.NOT. LSTTO) GO TO 200
 
C     'TO' NODE OF THIS ELEMENT HAS NOT PREVIOUSLY APPEARED. LIST IT.
 
      CALL LSTR (3,     ILINES, TNODE(I), ELMNTS(I), FNODE(I))
 
C     SCAN REMAINDER OF ELMENTS LIST FOR ELEMENTS CONNECTED TO TO THE
C        'TO' NODE OF THE CURRENT ELEMENT.
 
      DO 180 J=IP1,NELMTS
      IF (FNODE(J) .EQ. TNODE(I))
     *    CALL LSTR (2,     ILINES, ELMNTS(J), TNODE(J),DARG)
  180 IF (TNODE(J) .EQ. TNODE(I))
     *    CALL LSTR (2,     ILINES, ELMNTS(J), FNODE(J),DARG)
      CALL LSTR (1,     ILINES,DARG,DARG,DARG)
  200 CONTINUE
      WRITE(iqqout,300)
  300 FORMAT('1')
      RETURN
 
      END
