CSECT   TREE                            71.042  11.43.38
 
      SUBROUTINE TREE (NERROR)
 
C     NERROR = 2. . . .AN ELEMENT IS SHORTED OUT.
C     NELMTS IS NUMBER OF ELEMENTS IN THE TABLE.
C     FNODE IS THE TABLE OF 'FROM' NODES.
C     TNODE IS THE TABLE OF 'TO' NODES.
C     TYPE IS TABLE FOR SPECIFING ELEMENTS AS BRANCH(0.) OR LINK(7.).
C
C     TREE SUBROUTINE    JERRY PATTERSON    1/28/66
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'

      COMMON /FUNTNS/ FC,LFC,LFCTNS,FCNLST(400),FROM(300),TO(300)
         CHARACTER*8  FCNLST,FROM,TO
      COMMON /ELDATA/ EL,NELMTS,LIMIT,ELMNTS(300),FNODE(300),TNODE(300),
     *                VALUE(300),SRTCOD(300),TYPE(300)
         CHARACTER*8  ELMNTS,FNODE,TNODE,SRTCOD
      CHARACTER*8     TEMPF,TEMPT
 
C     SEARCH FOR SHORTED ELEMENT.
 
      DO 300 I=1,NELMTS
         IF (FNODE(I).eq.TNODE(I)) then
 
C     SET INDICATOR, WRITE MESSAGE AND CONTINUE SCAN.
 
            NERROR=2
            WRITE (iqqout,150)ELMNTS(I),FNODE(I),TNODE(I)
  150       FORMAT (14H0THE ELEMENT ',A6, 7H' FROM ,A6,4H TO ,A6,
     *        ' IS SHORTED OUT OF THE CIRCUIT.  EXECUTION WILL BE ',
     *        'TERMINATED AFTER COMPLETED ERROR SCAN.',/)
         end if
 
C     SEARCH FOR ANY HANGING ELEMENTS.
 
         TEMPF=FNODE(I)
         DO 220 J=1,NELMTS
  220    IF (TEMPF.EQ.FNODE(J) .AND. 
     *      I.NE.J             .OR.
     *      TEMPF.EQ.TNODE(J))       GO TO 230
 
C     'FROM' NODE IS HANGING.
 
         WRITE (iqqout,250) TEMPF,ELMNTS(I)
  250    FORMAT ('0WARNING ONLY--THE "',A6,'" NODE OF "',A6,
     *           '" IS NOT CONNECTED TO ANY OTHER ELEMENT IN THE ',
     *           'CIRCUIT--EXECUTION CONTINUES.'//)
  230    TEMPT=TNODE(I)
         DO 240 J=1,NELMTS
  240    IF (TEMPT.EQ.TNODE(J) .AND.
     *      I.NE.J             .OR.
     *      TEMPT.EQ.FNODE(J))       GO TO 300
 
C     'TO' NODE IS HANGING.
 
         WRITE (iqqout,250) TEMPT,ELMNTS(I)

  300 CONTINUE
 
C     LOAD NODE TABLES INTO INTERNAL TABLES AND CLEAR TYPE TO BRANCHES.
 
      DO 20 I=1,NELMTS
         FROM(I)=FNODE(I)
         TO(I)=TNODE(I)
   20 TYPE(I)=0.

      DO 75 I=1,NELMTS-1
 
C     SEE IF MAJOR ELEMENT IS A LINK--CONTINUE IF YES.
 
         IF (TYPE(I).ne. 0.) go to 75
         TEMPF=FROM(I)
         TEMPT=TO(I)
 
C     SCAN REMAINING MINORS FOR EACH MAJOR ELEMENT
 
         DO 70 M=i+1,NELMTS
 
C     SEE IF MINOR ELEMENT IS A LINK--CONTINUE IF YES.
 
            IF (TYPE(M).ne. 0.) go to 70
 
C     CHECK FOR PARALLEL COMBINATION.
 
            IF (((FROM(M).eq.TEMPF) .and. (TO(M).eq.TEMPT)) .or.
     *          ((FROM(M).eq.TEMPT) .and. (TO(M).eq.TEMPF))) then
 
C     ELEMENTS DIRECTLY IN PARALLEL--MAKE MINOR ELEMENT A LINK.
 
               TYPE(M)=7.
               GO TO 70
            end if
 
C     SEE IF MINOR ELEMENT CONNECTED TO 'TO' NODE OF MAJOR ELEMENT.
 
            IF (FROM(M).eq.TEMPT) then
               FROM(M)=TEMPF
               GO TO 70
            end if
            IF (TO(M).EQ.TEMPT) TO(M)=TEMPF
   70    CONTINUE
   75 CONTINUE

  100 RETURN
 
      END
