CSECT   VGENR8                          72.110  00.39.08
 
       SUBROUTINE VGENR8 (IERROR)
 
C      SUBROUTINE TO EXAMINE TABLE INDEPENDENT VARIABLES AND EQUATION
C      ARGUMENTS FOR CAPACITOR VOLTAGES. ANY RESISTOR OR INDUCTOR
C      CURRENT ARE ERROR CONDITIONS. CAPACITORS ARE CHECKED FOR PARALLEL
C      RESISTORS OR PRIMARY DEPENDENT SOURCES (DIODE), AND THE
C      APPROPRIATE VOLTAGE IS SUBSTITUTED IF FOUND.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'
	include 'values.inc'
                      character*8  valist
                      integer      ivlist(2*jqqval)
                      equivalence (ivlist(1),valist(1))
                      character*4  cvlist(2*jqqval)
                      equivalence (cvlist,ivlist)

      COMMON /ELDATA/ ELM,NELMTS,LELMTS,ELMNTS(300),FNODE(300),
     *                TNODE(300),FPVALU(300),SRTCOD(300),CMPFLG(300),
     *                IVLCOD(300)
         CHARACTER*8  ELMNTS,FNODE,TNODE,SRTCOD,CMPFLG
      COMMON /MODATA/ NUQ,NUNIQ,TABUNQ(1)
         CHARACTER*8  TABUNQ
      COMMON /ICDEPD/ DEPEND
      INTEGER         VALCOD
      CHARACTER*8     CFIRST(4)
      CHARACTER*8     PDCS , HH
      CHARACTER*8     FIRSTC,ANAME,CNAME,SORTCD
 
      DATA NFIRST /4/
      DATA CFIRST /'R       ','E       ','J       ','P       '/
      DATA PDCS /'    IN  '/, HH /'    HH  '/
 
       NERROR = 1
       DEPEND=0.D0
 
C      IF THERE ARE NO ENTRIES IN THE VALUE LIST,EXIT THIS ROUTINE
 
       IF (IVLIST(6) .EQ. 5) GO TO 9000
 
C      COMPUTE LIMIT OF DO LOOP = NUMBER OF INDEX ENTRIES
 
       NINDX = IVLIST(6) - 2
 
C      EXAMINE EACH INDEX ENTRY FOR R, I, J, P  = F(IR,IL,VC)
 
       DO 8000 KENTRY = 5,NINDX,2
 
C      MASK OFF ALL BUT FIRST CHARACTER OF INDEX ENTRY
 
       FIRSTC = VALIST(KENTRY)(1:1)
       DO 50 L = 1, NFIRST
   50  IF (FIRSTC .EQ. CFIRST(L)) GO TO 70
       GO TO 8000
 
C      CHECK THE FIRST DATA LOCATION OF THIS NAME FOR TABLE(3) OR
C      EQUATION(4)
 
   70  ANAME = VALIST(KENTRY)
 
C      FIND THE NAME IN THE VALUE LIST
 
       CALL FIND (VALIST,ANAME,ISTART,ILAST,LENGTH)
   80  VALCOD = IVLIST(ISTART*2)
       IF (IVLIST(ISTART*2) .EQ. 3 .OR. IVLIST(ISTART*2).EQ.4)GO TO 100
       IF (IVLIST(ISTART*2).NE.9) GO TO 8000
       ISTART=ISTART+1
       GO TO 80
 
C      COMPUTE VARIABLE POSITION AND CHECK FOR ELEMENT VOLTAGE
 
  100  ISTART = ISTART + 2
  150  IF (IVLIST(ISTART*2) .NE. 7) GO TO 1900
 
C      MASK OFF EVERYTHING EXCEPT 2ND CHARACTER AND CHECK FOR C
 
       IF (VALIST(ISTART+1)(2:2) .NE. 'C') GO TO 2000
 
C      SHIFT OFF V TO GET CAPACITOR NAME AND FIND IN ELEMENTS TABLE
 
       CNAME = VALIST(ISTART+1)(2:6)
       DO 200 K = 1, NELMTS
  200  IF (ELMNTS(K) .EQ. CNAME) GO TO 500
       WRITE (iqqout,250) CNAME
  250  FORMAT ('0CAPACITOR ',A6,' REFERENCED IN TABLE OR EQUATION',
     .         ' BUT NOT SUPPLIED AS ELEMENT'//)
       GO TO 1980
 
C      CHECK FOR PARALLEL RESISTORS AND PRIMARY DEPENDENT SOURCES IN
C      PARALLEL WITH THIS CAPACITOR - PRIMARY DEPENDENT SOURCES TAKE
C      PRECEDENCE
 
  500  ICODE=14
       SORTCD = PDCS
       DO 1500 M = 1, 2
       IF (M .EQ. 1) GO TO 600
       ICODE = 7
       SORTCD = HH
  600  DO 1500 L = 1, NELMTS
Cwrn  700  IF (SRTCOD(L)(6:7) .NE. SORTCD(6:7) .OR. L .EQ. K) GO TO 1500
  700  IF (SRTCOD(L)(5:6) .NE. SORTCD(5:6) .OR. L .EQ. K) GO TO 1500
       IF (FNODE(L) .NE. FNODE(K) .OR. TNODE(L) .NE. TNODE(K))GO TO 1500
       IVLIST(ISTART*2) = ICODE
       VALIST(ISTART+1)='V'
       J=2
       CALL CPY(ELMNTS(L),1,CVLIST(ISTART*2+1),J,5)
       GO TO 2000
 1500  CONTINUE
 
C      IF DP IS DEPENDENT ON VC AND REQUESTED AS OUTPUT, ASSUME I/C
C       SOLUTION WILL BE GOOD AND LET CONTINUE.
 
       IF (FIRSTC.NE.CFIRST(4)) GO TO 1550
       M=1
  510  DO 520 L=1,NUNIQ
  520  IF (VALIST(KENTRY).EQ.TABUNQ(L)) GO TO 2000
       GO TO (1550,1920),M
 1550  WRITE (iqqout,1600) ANAME,CNAME
 1600  FORMAT (9H0ELEMENT ,A6,26H IS FUNCTION OF CAPACITOR ,A6//
     . ' VOLTAGE FOR WHICH VOLTAGE SUBSTUTION CANNOT BE PERFORMED ',
     . '(INITIAL CONDITIONS)'//)
       NERROR = 2
       GO TO 8000
 
C      CHECK FOR INDUCTOR AND RESISTOR CURRENTS
 
 1900  IF (IVLIST(ISTART*2) .NE. 6) GO TO 2000
       IF (VALIST(ISTART+1)(2:2) .EQ. 'C') GO TO 2000
       M=2
 1920  DEPEND=1.D0
       GO TO 2000
 1980  NERROR = 2
 
C      IF THIS IS AN EQUATION, ESTABLISH NEW ARGUMENT IF AVAILABLE
 
 2000  IF (VALCOD .EQ. 3) GO TO 8000
       IF (IVLIST(ISTART*2) .EQ. 17) GO TO 2100
       IF (IVLIST(ISTART*2) .EQ.1) GO TO 2050
       ISTART = ISTART + 2
       GO TO 2200
 2050  ISTART = ISTART + 4
       GO TO 2200
 2100  ISTART = ISTART + IVLIST(ISTART*2+1) + 2
 2200  IF (ISTART .LT. ILAST) GO TO 150
 8000  CONTINUE
 9000  IERROR = NERROR
       RETURN
 
       END
