CSECT   VMUTUL                          71.042  11.43.38
 
      SUBROUTINE VMUTUL (ITYPE)
 
C     THIS SUBROUTINE WILL UPDATE ALL ELEMENT VOLTAGES OF V3P(N) OR
C       V6(N) WITH SOME PRODUCT OF MUTUAL INDUCTANCE.  THE TYPES OF
C         EQUATIONS FOLLOW.
C
C     ITYPE   EQUATION OBTAINED
C
C         1   V3P(N)=V3P(N)-M36*(B86T*J8DOT)
C         2   V3P(N)=V3P(N)-(B36*M66)*(B86T*J8DOT)
C         3   V6(N)=V6(N)+M66*(B86T*J8DOT)
C         4   V6(N)=V6(N)+M66*(B36T*I3DOT)
C         5   V6(N)=V6(N)+M63*I3DOT
C
C     VMUTUL SUBROUTINE    JERRY PATTERSON    7/29/66
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'
	include 'tables.inc'
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(2797),ndep)

      COMMON /ELDATA/ EL,NELMTS,NELIMT,ELMNTS(300),SKIP(1200),
     *                CMPFLG(300)
         CHARACTER*8  ELMNTS,CMPFLG
      COMMON /SCNTBL/ NBRANS,NN(36),NCL(17),IST(8),NSCAN(8),B36,
     *                NSRC(6),MSTR33,MSTR36,MSTR66,MNUM33,MNUM36,MNUM66,
     *                MCLS3,MCLS6
         EQUIVALENCE (IST(3),IST3),(IST(6),IST6),
     *               (NCL(3),NCL3),(NCL(6),NCL6)
      COMMON /MUTUAL/ AU,NMUTL,LMUTL,MLVCOD(2,50),MLNAME(50),
     *                MLFROM(2,50),MLTO(2,50),MLVALU(50),MLCFLG(50)
         CHARACTER*8  MLNAME,MLVALU,MLCFLG
      COMMON /BUFERS/ BUFF,BUFFER(220)
         CHARACTER*4  BUFFER
      COMMON /SDERIV/ SDR,NSDRIV
      INTEGER         B36
      CHARACTER*8     BLANK,D,PR2,ASTLP
      CHARACTER*4     XIBCD
      CHARACTER*4     V36(2),V3P,V6,PR36(4),PRV3P(2),
     *                PRV6(2),PRL36(2),PRMPL,PRPPL,ASTPL,BLNK
         EQUIVALENCE (V36,V3P),(V36(2),V6),(PR36,PRV3P),(PR36(3),PRV6),
     *               (PRL36,PRMPL),(PRL36(2),PRPPL),(ASTPL,ASTLP)
 
      DATA
     *   V3P   /'V3P('/,
     *   V6    /'V6('/,
     *   PRV3P /')=V3','P('/,
     *   PRV6  /')=V6','('/,
     *   D     /'D'/,
     *   BLNK  /' '/,
     *   PRMPL /')-('/,
     *   PRPPL /')+('/,
     *   ASTLP /'*('/,
     *   PR2   /'))'/,
     *   BLANK /' '/
 
      MTYPE=ITYPE
 
C     CHECK FOR IMPROPER TYPE OF EQUATION.
 
      IF (MTYPE.GT.0.AND.MTYPE.LT.6) GO TO 10
      WRITE (iqqout,6) MTYPE
    6 FORMAT (1H0, 32HTHE VMUTUL SUBROUTINE SUPPLIED ',I6,''' FOR TYPE',
     *        ' OF MUTUAL TERM TO BE ADDED TO V3P(N) OR V6(N)--MUST BE',
     *        ' IN RANGE OF 1 - 5.'//)
      STOP 'VMUTUL: improper type of equation, run aborted'
 
   10 IF (((MTYPE.GT.0.AND.MTYPE.LT.4).AND.
     *    (NSDRIV.EQ.0.OR.NCL(8).EQ.0.OR.NCL(6).EQ.0)).OR.
     *   ((MTYPE.EQ.1.OR.MTYPE.EQ.5).AND.MNUM36.EQ.0).OR.
     *    (MTYPE.GT.1.AND.MTYPE.LT.5.AND.MNUM66.EQ.0).OR.
     *   ((MTYPE.EQ.2.OR.MTYPE.EQ.4).AND.B36.EQ.0).OR.
     *    (MTYPE.EQ.5.AND.NCL(3).EQ.0))                  GO TO 90
 
C     LOAD SKELETON BUFFER.
 
      I=1
      IF (MTYPE.GT.2) I=2
      BUFFER(1)=V36(I)
      J=I
      IF (I.NE.1) J=3
      BUFFER(3)=PR36(J)
      BUFFER(4)=PR36(J+1)
      BUFFER(6)=PRL36(I)
      BUFFER(9)=ASTPL
      ISTMUT=25
      ISTCHR=35
 
C     GET LIMITS OF PORTION OF MUTUAL TABLE TO BE SCANNED AND DETERMINE
C       WHETHER ONE OR TWO (FOR M66) WILL BE REQUIRED AND THE FACTOR BY
C         WHICH MLFROM(I) MUST BE DECREMENTED FOR ELEMENTS TABLE.
 
      IF (MTYPE.EQ.1.OR.MTYPE.EQ.5) GO TO 12
 
C     M66 SCAN.
 
      IDECMF=NCL3
      MSTART=MSTR66
      MLAST=NMUTL
      GO TO 15
 
C     M36 SCAN.
 
   12 IDECMF=0
      MSTART=MSTR36
      MLAST=MSTART+MNUM36-1
 
C     COMPUTE ANY CONSTANTS REQUIRED IN LOOPS.
 
   15 ILAST3=IST3+NCL3-1
 
C     SCAN APPROPRIATE SECTION OF MUTUAL TABLE.
 
      DO 85 M=MSTART,MLAST
      IF (MTYPE.NE.5) GO TO 23
 
C     V6(N)=V6(N)+M63*I3DOT FOR THIS M63 TERM.
 
      BUFFER(2)=XIBCD(MLTO(2,M)-NCL3,3,1,N)
      BUFFER(5)=BUFFER(2)
      NDEP=0
 
C     DO NOT NEED PARENS AROUND I3DOT.
 
      ITOCHR=23
      CALL CPYDP(0,BLANK,MLNAME,M,ASTLP,0,MLCFLG,BUFFER,ITOCHR,N,N)
      CALL CPYDP(0,D,ELMNTS,MCLS3+MLFROM(2,M),BLANK,0,CMPFLG,BUFFER,
     *           ITOCHR,N,N)
      CALL WTEQTN(BLANK,0,BUFFER,ITOCHR-1,BLANK,N)
      BUFFER(9)=ASTPL
      GO TO 85
   23 MLF=MLFROM(2,M)
      MLT=MLTO(2,M)
      KWAY=1
 
C     SCAN OUT EQUATION.
 
   20 KSIGN=1
 
C     SCAN EQUATIONS FOR TYPES 1 THROUGH 4.
 
      GO TO (50,35,50,30),MTYPE
   30 NDEP=0
 
C     B36T*I3DOT SECTION FOR M66 TERM.
 
      ITOCHR=ISTCHR
      CALL BVSCAN(1,D,IST3,NCL(3),BLANK,1,0,MCLS6+MLT,ITOCHR,NCHAR,N)
 
C     IGNORE EQUATION FOR PRODUCT IF NOTHING ENTERED.
 
      GO TO 53
 
C     TYPE 2 EQUATION WITH B36 TIMES REMAINING PRODUCT.
 
   35 I=MCLS3
      JCL6=MCLS6+MLF
 
C     GET B36 TERM FOR EACH CLASS 3 AND 6 (MLT) INTERSECTION.
 
   40 I=I+1
      IF (LBITS(MATRIX,I-NBRANS,JCL6,NBRANS,KSIGN)) 45,60,45
   45 BUFFER(2)=XIBCD(I-MCLS3,3,1,N)
 
C     GET B86T*J8DOT FOR THIS M-TERM.
 
   50 ITOCHR=ISTCHR
      NDEP=0
      CALL BVDSCN(KSIGN,IST(8),NCL(8),MCLS6+MLT,1,ITOCHR,NCHAR,N)
   53 IF (NCHAR) 55,70,55
 
C     COMPLETE EQUATION AND ENTER MUTUAL NAME.
 
   55 CALL CPY(PR2,1,BUFFER,ITOCHR,2)
      IF (MTYPE.NE.2) BUFFER(2)=XIBCD(MLF-IDECMF,3,1,N)
      BUFFER(5)=BUFFER(2)
      BUFFER(7)=BLNK
      BUFFER(8)=BLNK
      NCHAR=ISTMUT
      CALL CPYDP(0,BLANK,MLNAME,M,BLANK,0,MLCFLG,BUFFER,NCHAR,N,N)
      CALL WTEQTN(BLANK,0,BUFFER,ITOCHR-1,BLANK,N)
 
C     GET OTHER B36 TERMS IF TYPE 2.
 
   60 IF (MTYPE.EQ.2.AND.I.LT.ILAST3) GO TO 40
 
C     GET OTHER M66 TERM IF NECESSARY.
 
   70 IF (IDECMF.EQ.0.OR.KWAY.EQ.2) GO TO 85
      KWAY=2
      MLT=MLTO(2,M)
      MLT=MLFROM(2,M)
      GO TO 20
   85 CONTINUE
   90 RETURN
 
      END
