CSECT   WTEQTN                          71.042  11.43.38
 
       SUBROUTINE WTEQTN (TERM,KODE,BUFFER,NCHARS,FRSTWD,NERROR)
 
C      PROGRAM TO WRITE AN EQUATION ON TAPE AFTER ANY DEPENDENCIES HAVE
C              BEEN RESOLVED AND THIER EQUATIONS GENERATED AND WRITTEN
C              OUT ON TAPE.
C      J. SENTS    5/9/66
C
C
C      TERM   - IS THE DEPENDENT VARIABLE OF THE EQUATION(IN BUFFER) TO
C                  BE WRITTEN ON SOURCE PROGRAM TAPE.
C      KODE   - IS THE ARGUMENT TYPE CODE OF TERM. CODE=0 SIGNIFIES THAT
C                  TERM IS A CIRCUIT VARIABLE AND COMPUTE FLAG IS NOT TO
C                  BE CHECKED OR SET. CODE=21 MEANS I/C MODE.
C      BUFFER - IS THE LOCATION OF THE EQUATION TO BE WRITTEN-OUT.
C      NCHARS - IS THE NO. OF CHARACTERS IN THE EQUATION IN BUFFER.
C      FRSTWD - IS THE FIRST WORD (COL. 1 TO 6) OF THE FORTRAN STATEMENT
C                  CONTAINING THE EQUATION.
C      NERROR - ERROR INDICATOR.
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tapes.inc'
	include 'values.inc'
                       character*8  valist
	include 'tables.inc'
                       equivalence (iqtabl(2797),ndep)
                       equivalence (iqtabl(2798),ldep)
                       character*8  deptab(100)
                       equivalence (tablst(1400),deptab(1))
                       integer      typcod(100)
                       character*4  type(100)
                       equivalence (tablst(1500),typcod(1))
                       equivalence (tablst(1500),type(1))

       CHARACTER*4     BUFFER(*),BLANK
       INTEGER         CODE,STSUB1
       CHARACTER*8     TERMA,TERM1,X,TERM2,TERM,FRSTWD

	external getarg
 
       DATA BLANK      /' '/

       NERROR=1
       KTIME=0
       LOCDEP=0
       ICMODE=0
       CODE=KODE
       IF (KODE .eq. 21) then
          ICMODE=1
          CODE=0
       end if
       IF (NDEP .EQ. 0) GO TO 500
   50  MODE1 = 0
       LOCDEP=LOCDEP+1
       IF (LOCDEP .GT. NDEP) GO TO 400
       IF (TYPE(LOCDEP) .EQ. BLANK) GO TO 50
       TERMA=DEPTAB(LOCDEP)
       KODEA=TYPCOD(LOCDEP)
       GO TO (100,100,70,70,100,50,50,280,50,100,100,100,100,100,100,
     *         70, 70,260,260,100) , KODEA
   70  WRITE (iqqout ,80)
   80  FORMAT('- PROGRAM ERROR IN ''WTEQTN''. ILLEGAL ARGUMENT TYPE ',
     *        'CODE FOUND IN DEPENDENCY TABLE.'///)
       NERROR=2
   90  STOP 'WTEQTN: illegal argument type code, run aborted'
 
  100  CALL FIND (VALIST,TERMA,STSUB1,NDSUB1,LEN)
       IF (LEN .NE. 0) GO TO 150
       IF(  KODEA.LT. 13 .OR. KODEA.GT. 14) GO TO 110
       CALL SCANEQ (TERMA,KODEA)
       GO TO 100
  110  WRITE (iqqout,115) TERMA
  115  FORMAT('-THE VARIABLE ''',A6,''' COULD NOT BE FOUND IN',
     *        ' THE VALUE LIST BY ''WTEQTN'' - PROGRAM ERROR.'//)
       NERROR=2
       GO TO 90

  150  NADDED=0
       MODE1=0
  155  CALL GETARG (STSUB1,NDSUB1,TERM1,KODE1,LOC1,MODE1)
 
C         ANY MORE ARGUMENTS LEFT TO PROCESS.
 
       IF( MODE1 .EQ. 0) GO TO 300
  158  IF (CODE .EQ. 0) GO TO 170
 
C         CHECK FOR DEPENDENCY LOOP.
 
       IF (TERMA.NE. TERM1) GO TO 170
       WRITE (iqqout, 160) TERMA
  160  FORMAT('- THE VARIABLE ''',A6,''' IS DEPENDENT UPON ITSELF.',
     *        ' THE RUN CANNOT BE CONTINUED.'/// )
       NERROR=3
       GO TO 90
 
C          ANY ROOM FOR ANOTHER DEPENDENCY ON THE TABLE
 
  170  IF (NDEP .LT. LDEP) GO TO 230
  175  N=1
  180  IF (N .GE. NDEP) GO TO 210
       IF (TYPE(N) .NE. BLANK) GO TO 200
       K=NDEP-1
       DO 190 M= N,K
          DEPTAB(M)= DEPTAB(M+1)
  190  TYPCOD(M)= TYPCOD(M+1)
       NDEP=NDEP-1
  200  N=N+1
       GO TO 180

  210  IF(NDEP .LT. LDEP) GO TO 230
 
C      ELIMINATE ALL REDUNDANT ENTRIES N TIMES TO AID NON-REDUNDANT SIT
 
       KTIME=KTIME+1
       IF (KTIME.GT.2) GO TO 800
       NLESS=0
       K=LDEP-1
       DO 700 N=1,K
          J=N+1
          DO 650 M=J,LDEP
            IF (DEPTAB(N).NE.DEPTAB(M)) GO TO 650
            NLESS=2
            TYPE(M)=BLANK
  650     CONTINUE
  700  CONTINUE
       IF (NLESS) 175,800,175
  800  WRITE (iqqout,220)
       NERROR=3
  220  FORMAT('-THE DEPENDENCY TABLE HAS OVERFLOWED IN ''WTEQTN''',
     *        ' - PROGRAM ERROR.' /// )
       GO TO 90
 
C          ADD THE DEPENDENCY TO THE TABLE IF NOT LAST ONE THERE
 
  230  NADDED=NADDED+1
       IF (TERM1 .EQ. DEPTAB(NDEP)) GO TO 240
       NDEP=NDEP+1
       DEPTAB(NDEP)=TERM1
       TYPCOD(NDEP)=KODE1
 
C          GO GET NEXT ARGUMENT IF IN CONTINUE MODE
 
  240  IF (MODE1 - 1) 50,50,155
  260  X=TERMA
       TERMA=X(2:6)
       GO TO 100
  280  KODE2=5
       MODE1=0
       TERM2=TERMA(2:6)
       CALL COMPCK (TERM2,KODE2,0,IOUT)
       IF (IOUT .NE. 0) GO TO 300
       TERM1=TERM2
       KODE1=KODE2
       GO TO 158
  300  IF (NADDED .NE. 0) GO TO 50
       CALL EQFORM (TERMA, ICMODE, KODEA)
       CALL COMPCK (TERMA,KODEA,1,IOUT)
       IF (KODEA.EQ.20 .AND. ICMODE.EQ.0) CALL COMPCK (TERMA,11,1,IOUT)   
 
C      BLANK-OUT EACH OCCURANCE OF TERMA IN DEPTAB.
 
       DO 330 N=1,NDEP
  330  IF (DEPTAB(N) .EQ. TERMA) TYPE(N)=BLANK
       GO TO 50
  400  K=NDEP
       DO 450 N=1,NDEP
          IF (TYPE(K) .EQ. BLANK)  GO TO 450
          IF (TYPCOD(K).EQ.6 .OR. TYPCOD(K).EQ.7 .OR. TYPCOD(K).EQ.9)
     *       GO TO 405
          CALL EQFORM (DEPTAB(K),ICMODE,TYPCOD(K))
          CALL COMPCK (DEPTAB(K),TYPCOD(K),1,IOUT)
          IF (TYPCOD(K).EQ.20 .AND. ICMODE.EQ.0)
     *       CALL COMPCK(DEPTAB(K),11,1,IOUT)
          GO TO 410
  405     WRITE (iqqout,406) DEPTAB(K)
  406     FORMAT ('- THE TERM ''',A6,''' WILL CAUSE A COMPUTATIONAL',
     *         ' DELAY.'///)
  410     DO 440 J=1,K
  440     IF (DEPTAB(J).EQ.DEPTAB(K)) TYPE(J) = BLANK
  450  K=K-1
  500  IF (NCHARS.ne.0) then
          CALL WTSPTP (FRSTWD,BUFFER,NCHARS,NERR)
          IF (CODE.NE.0) CALL COMPCK (TERM,CODE,1,IOUT)
       end if
  520  RETURN
 
       END
