CSECT   WTMXEQ                          71.042  11.43.38
 
      SUBROUTINE WTMXEQ (IELROW,NROWS,IELCOL,NCOLS,TRANSP,RECIP,NAME,
     *                  DIAGL,NERROR)
 
C     SUBROUTINE TO SCAN AND SET UP THE MATRIX EQUATIONS FOR CLASS B14,
C       B25 OR B36 OF THE B-MATRIX.
C
C     IELROW - ELEMENTS TABLE INDEX FOR FIRST ROW ENTRY.
C     NROWS  - NUMBER OF ROW ELEMENTS.
C     IELCOL - ELEMENTS TABLE INDEX FOR FIRST COLUMN ENTRY.
C     NCOLS  - NUMBER OF COLUMN ELEMENTS.
C     TRANSP - ON FOR SCANNING DOWN ROWS FOR COLUMN ELEMENT SOLUTION.
C     RECIP  - ON FOR ENTRY OF RECIPROCAL OF ELEMENTS.
C     NAME   - BCD NAME OF MATRIX TO BE ESTABLISHED.
C     DIAG   - TYPE OF MATRIX--
C            - ON FOR DIAGONAL EQUATIONS ONLY.
C            -  0 FOR NON-DIAGONAL MATRIX OF ALL ELEMENTS.
C     NERROR - NOT 1 FOR ANY ERROR ENCOUNTERED.
C
C     WTMXEQ SUBROUTINE    JERRY PATTERSON    6/28/66
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tables.inc'
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(2797),ndep)

      COMMON /ELDATA/ ELM,NELMTS,LELMTS,ELMNTS(300),EE(1200),CMPFLG(300)
         CHARACTER*8  ELMNTS,CMPFLG
      COMMON /SCNTBL/ NBRANS
      COMMON /BUFERS/ BUFF,BUFFER(220)
         CHARACTER*4  BUFFER
      COMMON /CNTRLS/ SKIP(48),ISTNUM
      CHARACTER*(*)   NAME
      CHARACTER*8     NSTATE,MSTATE(4)
      CHARACTER*4     XIBCD,XSUB
      INTEGER         DIAG,DIAGL,TRANSP,TRNSP,RECIP,RECP
      CHARACTER*2     STATE(9)
         EQUIVALENCE (NSTATE,STATE(1))
      CHARACTER*8
     *  BLANK    ,
     *  PARENL   ,
     *  BLNKBF   ,
     *  DO       ,
     *  NEQ1C    ,
     *  N1EQNC(2)
 
      DATA
     *  BLANK     /' '/,
     *  PARENL    /'('/,
     *  BLNKBF    /' '/,
     *  DO        /'DO'/,
     *  NEQ1C     /'N=1,'/,
     *  N1EQNC    /'N1=N',','/
      DATA STATE  /4*' ','(N',',N','1)','=0','.'/
      DATA
     *  MSTATE(2) /'(N1,N)='/,
     *  MSTATE(4) /'(N,N1)'/
 
      ITABLS=IELROW
      JTABLS=IELCOL
      TRNSP=TRANSP
      NROW=NROWS
      NCOL=NCOLS
      RECP=RECIP
      DIAG=DIAGL
 
C     RETURN IF NOTHING TO SCAN.
 
      IF (NROW+NCOL) 4,90,4
 
C     GET APPROPRIATE MATRIX BOUNDARIES.
 
    4 IF (TRNSP) 10,5,10
 
C     NORMAL SCAN.
 
    5 ITABLE=NBRANS
      JTABLE=0
      GO TO 15
 
C     TRANSPOSE SCAN.
 
   10 ITABLE=0
      JTABLE=NBRANS
   15 IFIRST=ITABLS-ITABLE
      ILAST=IFIRST+NROW-1
      JFIRST=JTABLS-JTABLE
      JLAST=JFIRST+NCOL-1
 
C     CLEAR MATRIX IF NON-DIAGONAL.
 
      IF (DIAG) 152,151,152
  151 NSTATE=NAME
      NWAY=0
  155 ISTNUM=ISTNUM+10
      BUFFER(1)=DO
      BUFFER(2)=XIBCD(ISTNUM,3,1,N)
      BUFFER(3)=NEQ1C
      BUFFER(4)=XIBCD(NROW,3,1,N)
      CALL WTSPTP(BLANK,BUFFER,15,N)
      BUFFER(5)=BUFFER(4)
      BUFFER(3)=N1EQNC(1)
      BUFFER(4)=N1EQNC(2)
      CALL WTSPTP(BLANK,BUFFER,19,N)
      ISTCHR=3
      CALL CPY (BUFFER(2),1,BLNKBF,ISTCHR,3)
      IF (NWAY.NE.0) GO TO 80
      CALL WTSPTP(BLNKBF,NSTATE,17,N)
 
C     SET UP SKELETON INFORMATION IN BUFFER.
 
  152 ISTCHR=1
      CALL COPY(0,BLANK,NAME,PARENL,BUFFER,ISTCHR,N)
 
C     SAVE POSITIONS OF SUBSCRIPTS.
 
      ISUB1=ISTCHR
 
C     SINGLE-DIMENSIONED ARRAY IF DIAGONAL IS ON.
 
      IF (DIAG) 111,112,111
  111 CALL CPY('DDD)=',1,BUFFER,ISTCHR,5)
      GO TO 113
  112 CALL CPY('DDD,DDD)=',1,BUFFER,ISTCHR,9)
  113 ISUB=1
      DO 50 I=IFIRST,ILAST
 
C     ENTER TERMS FOR DIAGONAL ENTRY.
 
      XSUB=XIBCD(ISUB,3,1,N)
      ITOCHR=ISUB1
      CALL CPY(XSUB,1,BUFFER,ITOCHR,3)
      IF (DIAG.EQ.0) CALL CPY(XSUB,1,BUFFER,ITOCHR+1,3)
      ITOCHR=ISTCHR
      NDEP=0
 
C     INSERT ROW ELEMENT.
 
      CALL CPYDP(0,BLANK,ELMNTS,I+ITABLE,BLANK,RECP,CMPFLG,BUFFER,
     *           ITOCHR,N,N)
      IF (NCOL) 115,200,115
  115 ITABLS=I
      JTABLS=I
 
C     SCAN OUT COLUMN ENTRIES.
 
      DO 20 J=JFIRST,JLAST
      IF (TRNSP) 162,161,162
  161 JTABLS=J
      GO TO 20
  162 ITABLS=J
   20 IF (LBITS(MATRIX,ITABLS,JTABLS,NBRANS,N).NE.0)
     *   CALL CPYDP(1,BLANK,ELMNTS,J+JTABLE,BLANK,RECP,CMPFLG,BUFFER,
     *              ITOCHR,N,N)
  200 CALL WTEQTN(BLANK,0,BUFFER,ITOCHR-1,BLANK,N)
 
C     SCAN NON-DIAGONALS IF NECESSARY.
 
      IF (DIAG.NE.0.OR.NCOL.EQ.0) GO TO 50
 
C     FINISHED IF LAST VECTOR TO BE SCANNED.
 
   25 IF (ISUB.EQ.NROW) GO TO 60
      KSUB=ISUB+1
 
C     SCAN REMAINING COLUMNS FOR OFF-DIAGONAL ENTRIES WITH SIGN.
 
      KDOWN=I+1
      DO 40 K=KDOWN,ILAST
      NDEP=0
      KWAY=1
      KKTBLS=K
      JJTBLS=K
 
C     SCAN COLUMNS FOR ANDED (WITH SIGN) ENTRIES.
 
      DO 30 J=JFIRST,JLAST
      IF (TRNSP) 262,261,262
  261 JTABLS=J
      JJTBLS=J
      GO TO 263
  262 ITABLS=J
      KKTBLS=J
  263 KSIGN=LBITS(MATRIX,ITABLS,JTABLS,NBRANS,N)*LBITS(MATRIX,KKTBLS,
     *      JJTBLS,NBRANS,N)
      IF (KSIGN) 26,30,26
 
C     ENTRY FOUND--ESTABLISH SUBSCRIPTS IF FIRST ONE.
 
   26 GO TO (27,28),KWAY
   27 ITOCHR=ISUB1
      CALL CPY(XSUB,1,BUFFER,ITOCHR,3)
      CALL CPY(XIBCD(KSUB,3,1,NERROR),1,BUFFER,ITOCHR+1,3)
      ITOCHR=ISTCHR
      KWAY=2
   28 CALL CPYDP(KSIGN,BLANK,ELMNTS,J+JTABLE,BLANK,RECP,CMPFLG,
     *           BUFFER,ITOCHR,N,N)
   30 CONTINUE
      GO TO (40,35),KWAY
   35 INDEX=ITOCHR-1
      CALL WTEQTN(BLANK,0,BUFFER,INDEX,BLANK,N)
   40 KSUB=KSUB+1
   50 ISUB=ISUB+1
   60 NWAY=1
      IF (DIAG)90,155,90
   80 MSTATE(1)=NSTATE
      MSTATE(3)=NSTATE
      CALL WTSPTP(BLNKBF,MSTATE,30,N)
   90 RETURN
 
      END
