CSECT   XMLMUT                          71.042  11.43.38
 
      SUBROUTINE XMLMUT (M3ONLY)
 
C     THIS SUBROUTINE WILL COMPLETE THE XML(M,N) MATRIX FOR ALL MUTUAL
C       INDUCTANCES.  IF 'M3ONLY' IS ON, THEN EQUATIONS OF THE FORM
C         XML(M,N)=XML(M,N)+M33 ARE GENERATED.  IF 'M3ONLY' IS 0, THEN
C           XML(M,N)=XML(M,N)+M33+B36*M63+B36T*M36+B36*M66*B36T.
C
C     XMLMUT SUBROUTINE    JERRY PATTERSON    7/30/66
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
	include 'tables.inc'
                      integer      matrix(1500)
                      equivalence (iqtabl(1297),matrix(1))
                      equivalence (iqtabl(2797),ndep)

      COMMON /ELDATA/ ELM,NELMTS,NELIMT,ELMNTS(300),SKIP(1200),
     *                CMPFLG(300)
         CHARACTER*8  ELMNTS,CMPFLG
      COMMON /SCNTBL/ NBRANS,NN(36),NCL(17),IST(8),NSCAN(8),B36,NSRC(6),
     *                MSTART(3),MNUMBR(3),MCLS3,MCLS6
         INTEGER      B36
         EQUIVALENCE (MSTR33,MSTART),(MSTR36,MSTART(2)),
     *               (MSTR66,MSTART(3)),
     *               (IST(3),IST3),(IST(6),IST6),
     *               (NCL(3),NCL3),
     *               (MLST33,MNUMBR)
      COMMON /MUTUAL/ AU,NMUTL,LMUTL,MLVCOD(2,50),MLNAME(50),
     *                MLFROM(2,50),MLTO(2,50),MLVALU(50),MLCFLG(50)
         CHARACTER*8  MLNAME,MLVALU,MLCFLG
      COMMON /BUFERS/ BUFF,BUFFER(220)
         CHARACTER*4  BUFFER
      CHARACTER*4     XIBCD
      EQUIVALENCE    (TEMP,ITEMP)
      CHARACTER*8     COMENT,BLANK
 
      DATA COMENT /'C'/,BLANK /' '/
 
C     SET UP SKELETON BUFFER IF NECESSARY.
 
    5 IF (NMUTL.EQ.0) GO TO 90
 
C     TECHNIQUE FOR NOT EXCEEDING 100 EXECUTABLE FORTRAN STATEMENTS.
 
      ISTCHR=1
      CALL CPY('XML(    ,       )=XML(      ,       )',1,
     *         BUFFER,ISTCHR,37)
 
C     UPDATE XML WITH M33.
 
      IF (MNUMBR(1).EQ.0) GO TO 20
      CALL WTSPTP(COMENT,'UPDATE XML WITH M33',19,N)
      DO 15 I=MSTR33,MLST33
      BUFFER(2)=XIBCD(MLFROM(2,I),3,1,N)
      BUFFER(4)=XIBCD(MLTO(2,I),3,1,N)
      ITOCHR=ISTCHR
      NDEP=0
      CALL CPYDP(1,BLANK,MLNAME,I,BLANK,0,MLCFLG,BUFFER,ITOCHR,N,N)
      BUFFER(7)=BUFFER(2)
      BUFFER(9)=BUFFER(4)
      ITEMP=ITOCHR-1
      CALL WTEQTN(BLANK,0,BUFFER,ITEMP,BLANK,N)
 
C     REVERSE SUBSCRIPTS FOR SYMMETRICAL MATRIX.
 
      BUFFER(9)=BUFFER(2)
      BUFFER(7)=BUFFER(4)
      BUFFER(4)=BUFFER(2)
      BUFFER(2)=BUFFER(7)
   15 CALL WTSPTP(BLANK,BUFFER,ITEMP,N)
   20 IF (B36.EQ.0.OR.M3ONLY.NE.0) GO TO 90
      ILAST3=IST3+NCL(3)-1
      ILAST6=IST6+NCL(6)-1
      IF (MNUMBR(2).EQ.0) GO TO 40
      CALL WTSPTP(COMENT,'UPDATE XML WITH B36*M63 AND M36*B36T',36,N)
      MLAST=MSTR36+MNUMBR(2)-1
 
C     SCAN EACH COLUMN OF SIMULATED M-MATRIX WITH ROW OF B-MATRIX.
 
      NCL31=NCL3+1
      DO 35 ISCNRW=IST3,ILAST3
      IF (CMPFLG(ISCNRW)(1:1).EQ.CHAR(0)) GO TO 35
      IMAT=ISCNRW-NBRANS
      DO 30 JMUT=1,NCL3
 
C     SCAN B-ROW FOR ENTRIES.
 
      KWAY=1
      IMTHRW=NCL31
      NDEP=0
      DO 25 J=IST6,ILAST6
      IF (LBITS(MATRIX,IMAT,J,NBRANS,ITEMP).EQ.0) GO TO 25
 
C     FIND MUTUAL TERM FOR THIS B-MATRIX ROW IN SIMULATED M63 IF ANY.
 
      DO 24 I=MSTR36,MLAST
   24 IF (MLFROM(2,I).EQ.JMUT.AND.MLTO(2,I).EQ.IMTHRW) GO TO 240
 
C     NO MUTUAL TERM FOR THIS ENTRY.
 
      GO TO 25
 
C     NON-ZERO ENTRY--GET SUBSCRIPTS IF FIRST PASS.
 
  240 GO TO (245,250),KWAY
  245 KWAY=2
      ITOCHR=ISTCHR
      BUFFER(2)=XIBCD(ISCNRW-MCLS3,3,1,N)
      BUFFER(4)=XIBCD(JMUT,3,1,N)
      BUFFER(7)=BUFFER(2)
      BUFFER(9)=BUFFER(4)
  250 CALL CPYDP(ITEMP,BLANK,MLNAME,I,BLANK,0,MLCFLG,BUFFER,ITOCHR,N,N)
   25 IMTHRW=IMTHRW+1
 
C     WRITE EQUATION IF ANY.
 
      GO TO (30,26),KWAY
   26 ITEMP=ITOCHR-1
      CALL WTEQTN(BLANK,0,BUFFER,ITEMP,BLANK,N)
      BUFFER(9)=BUFFER(2)
      BUFFER(7)=BUFFER(4)
      BUFFER(4)=BUFFER(2)
      BUFFER(2)=BUFFER(7)
      CALL WTSPTP(BLANK,BUFFER,ITEMP,N)
   30 CONTINUE
   35 CONTINUE
 
C     B36*M66*B36T IF NECESSARY.
 
   40 IF (MNUMBR(3).EQ.0) GO TO 90
      CALL WTSPTP(COMENT,'UPDATE XML WITH B36*M66*B36T',28,N)
      DO 80 ISCNRW=IST3,ILAST3
 
C     CONTINUE IF NO ENTRIES IN SCAN ROW.
 
      IF (CMPFLG(ISCNRW)(1:1).EQ.CHAR(0)) GO TO 80
 
C     MATCH ROW IS NEVER LESS THAN SCAN ROW BECAUSE OF SYMMETRY.
 
      DO 75 IMTHRW=ISCNRW,ILAST3
      IF (CMPFLG(IMTHRW)(1:1).EQ.CHAR(0)) GO TO 75
      KWAY=1
 
C     EXAMINE SCAN ROW FOR ENTRIES.
 
      DO 70 J=IST6,ILAST6
      IF (LBITS(MATRIX,ISCNRW-NBRANS,J,NBRANS,ITEMP)) 45,70,45
 
C     SCAN MUTUAL TABLE FOR ANY ENTRIES IN THIS COLUMN.
 
   45 JMUT=J-MCLS6
      DO 65 I=MSTR66,NMUTL
      IF (MLFROM(2,I).NE.JMUT) GO TO 46
      JMATCH=MLTO(2,I)+MCLS6
      GO TO 47
   46 IF (MLTO(2,I).NE.JMUT) GO TO 65
      JMATCH=MLFROM(2,I)+MCLS6
 
C     SEE IF B36T TERM IS NON-ZERO.
 
   47 IF (LBITS(MATRIX,IMTHRW-NBRANS,JMATCH,NBRANS,JTEMP)) 50,65,50
 
C     COPY SUBSCRIPTS IF NECESSARY.
 
   50 GO TO (55,60),KWAY
   55 KWAY=2
      ITOCHR=ISTCHR
      BUFFER(2)=XIBCD(ISCNRW-MCLS3,3,1,N)
      BUFFER(4)=XIBCD(IMTHRW-MCLS3,3,1,N)
      BUFFER(7)=BUFFER(2)
      BUFFER(9)=BUFFER(4)
      NDEP=0
   60 CALL CPYDP(ITEMP*JTEMP,BLANK,MLNAME,I,BLANK,0,MLCFLG,BUFFER,
     *           ITOCHR,N,N)
   65 CONTINUE
   70 CONTINUE
 
C     WRITE EQUATION IF ANY TERMS ENTERED.
 
      GO TO (75,71),KWAY
   71 ITEMP=ITOCHR-1
      CALL WTEQTN(BLANK,0,BUFFER,ITEMP,BLANK,N)
      IF (ISCNRW.EQ.IMTHRW) GO TO 75
 
C     SWITCH SUBSCRIPTS FOR SYMETRICAL TERM.
 
      BUFFER(9)=BUFFER(2)
      BUFFER(7)=BUFFER(4)
      BUFFER(4)=BUFFER(2)
      BUFFER(2)=BUFFER(7)
      CALL WTSPTP(BLANK,BUFFER,ITEMP,N)
   75 CONTINUE
   80 CONTINUE
   90 RETURN
 
      END
