CSECT   ADJNT
C       9 APR 73
 
      SUBROUTINE ADJNT (IDEP,NIND,IIND,KWAY)
 
C     SUBROUTINE AJJNT, TO COMPLETE ALL ADJOINT CALCULATIONS
C     ARGUMENT LIST-
C        IDEP(1)- INDEX TO A LIST OF INDICIES TO ADJOINT SOURCES TO BE
C                 SET FOR ADJOINT RUN
C        IDEP(2)- LENGTH OF LIST OF INDICIES (NUMBER OF SOURCES TO BE
C                 SET)
C        IDEP(3)-INDEX TO LIST OF ADDITIVE TERMS IN ARRAY 'IADD'
C        IDEP(4)-LENGTH OF ADDITIVE TERMS (IF ANY)
C
C        NIND-    NUMBER OF 'INDEPENDENT VARIABLES', I.E. NUMBER OF
C                 PLACES TO MONITOR IN ADJOINT CALCULATIONS
C
C        IIDN(4,NIND)-
C        IIND(1,NIND)-INDEX TO PLACE TO MONITOR IN ORIGIONAL IC RUN
C        IIND(2,NIND)- WHAT SYSTEM FUNCTION TO MONITOR
C                    =0, NO MONITOR FROM INITIAL CONDITIONS RUN
C                    =1, MONITOR VOLTAGE
C                    =2, MONITOR CURRENT
C                    =3, MONITOR ELEMENT VALUE
C        IIND(3,NIND)- PLACE TO MONITOR IN ADJOINT CALCULATION
C        IIND(4,NIND)- SYSTEM FUNCTION TYPE (SAME AS IIND(2,NIND))
C        IIND(5,NIND)-INDEX TO INDEPENDENT VARIABLE (NOT USED BY
C                     'ADJNT')
C        IIND(6,NIND)-INDEPENDENT VARIABLE TYPE (3=ELEMENT, 4=DEFINED
C                     PARAMETER) (NOT USED BY 'ADJNT')
C
C        KWAY-    ERROR INDICATOR
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
      COMMON /ADJADD/ IADD(1)
      COMMON /ADJDAT/ NIS
      COMMON /EBACK/  EHOLD(3,1)
      COMMON /CNTRLS/ CTRLS(144)
         EQUIVALENCE (CTRLS(55),XTRNIC),(CTRLS(108),XDP),
     *               (CTRLS(110),XELMTS),(CTRLS(142),XADJ),
     *               (CTRLS(143),XSTORD),(CTRLS(144),XRESET),
     *               (CTRLS(61),XDIFF)
      COMMON /ISRCE/  KIS(1)
      COMMON /VOLTGS/ VLTS(1)
      COMMON /CURNTS/ CUR(1)
      COMMON /NAMES/  VAL(1)
      COMMON /DFRTL/  KASRC(2,1)
      COMMON /GEARTG/ GW(1)
      COMMON /PBACK/  PHOLD(1)
      COMMON /PRMTRS/ PRAMTR(1)
      COMMON /GRADNT/ GRDNT(1)
      COMMON /TAPES/  NOUTTP
      DIMENSION       IDEP(4),IIND(6,1)
 
C     SAVE VALUES,CURRENTS,AND VOLTAGES, IF REQUIRED
 
      NELMTS=nint(XELMTS)
      NDP=nint(XDP)
      IF (nint(XSTORD).NE.0) GO TO 50
      IF (NELMTS.LE.0) GO TO 43
      DO 40 I=1,NELMTS
      EHOLD(1,I)=VLTS(I)
      EHOLD(2,I)=CUR(I)
      EHOLD(3,I)=VAL(I)
   40 CONTINUE
   43 IF (NDP.LE.0) GO TO 48
      DO 45 I=1,NDP
      PHOLD(I)=PRAMTR(I)
   45 CONTINUE
   48 XSTORD=1.D0
 
C     SET INDEPENDENT SOURCES TO ZERO
 
   50 IF (NIS.LE.0) GO TO 100
      DO 90 I=1,NIS
      INDX=KIS(I)
      VAL(INDX)=0.D0
   90 CONTINUE
 
C     ZERO OUT ALL VOLTAGES AND CURRENTS
 
  100 DO 120 I=1,NELMTS
      VLTS(I)=0.D0
  120 CUR(I)=0.D0
 
C     IF 'RUN IC BY IMPLICIT' AND 'USE SYMBOLIC JACIBIAN' WAS
C     SPECIFIED, ZERO OUT GW MATRIX
 
      IF (nint(XTRNIC).EQ.0.OR.nint(XDIFF).EQ.1) GO TO 200
      NSTOP=NELMTS+1
      DO 140 I=1,NSTOP
  140 GW(I)=0.D0
 
C     SET ADJOINT SOURCES TO VALUES REQUIRED
 
  200 KSRCE=IDEP(1)
      NSRCE=IDEP(2)
      IF (NSRCE.LE.0) GO TO 250
      ISTOP=KSRCE+NSRCE-1
      DO 240 I=KSRCE,ISTOP
      INDX=KASRC(1,I)
      NDX=KASRC(2,I)
 
C     NDX=0, SET SOURCE VALUE TO -1.
C     NDX.NE.0, SET SOURCE VALUE TO -PHOLD(NDX)
 
      XVAL=-1.D0
      IF (NDX.GT.0) XVAL=-PHOLD(NDX)
      VAL(INDX)=XVAL
  240 CONTINUE
 
C     INITIAL CONDITIONS SOLUTION
 
  250 XADJ=1.D0
      KWAY=0
      CALL SIMDC(KWAY)
      IF (KWAY.NE.0) RETURN
 
C     TURN ADJOINT SWITCH OFF
 
      XADJ=0.D0
 
C     MONITOR REQUIRED SYSTEM FUNCTIONS FOR GRADIENTS
 
      DO 500 I=1,NIND
      INDX=IIND(1,I)
      NDX=IIND(2,I)
      IINDX=IIND(3,I)
      NNDX=IIND(4,I)
      FSTVAL=1.D0
      SNDVAL=1.D0
      PLUS=0.D0
 
C     GET INITIAL CONDITIONS RUN VALUE IF REQUIRED
 
      IF (NDX) 320,340,330
  320 NDX=-NDX
      FSTVAL=-EHOLD(NDX,INDX)
      GO TO 340
  330 FSTVAL=EHOLD(NDX,INDX)
 
C     GET ADJOINT RUN VALUE
 
  340 IF (NNDX) 350,350,360
  350 NNDX=-NNDX
      SNDVAL=-1.D0
  360 GO TO (370,380,390),NNDX
  370 SNDVAL=SNDVAL*VLTS(IINDX)
      GO TO 400
  380 SNDVAL=SNDVAL*CUR(IINDX)
      GO TO 400
  390 SNDVAL=SNDVAL*VAL(IINDX)
 
C     SEE IF ADDITIVE TERM IS NEEDED
 
  400 IF (IDEP(3).LE.0) GO TO 420
      IAD=IDEP(3)+I-1
      ITEMP=IADD(IAD)
      IF (ITEMP.LE.0) GO TO 420
      PLUS=PHOLD(ITEMP)
  420 GRDNT(I)=FSTVAL*SNDVAL+PLUS
  500 CONTINUE
 
C     SET ADJOINT SOURCES TO ZERO
 
      DO 520 I=KSRCE,ISTOP
      INDX=KASRC(1,I)
      VAL(INDX)=0.D0
  520 CONTINUE
 
C     RESET OLD VALUES IF REQUIRED
 
      IF (nint(XRESET).NE.0) GO TO 600
      IF (NELMTS.LE.0) GO TO 550
      DO 540 I=1,NELMTS
      VLTS(I)=EHOLD(1,I)
      CUR(I)=EHOLD(2,I)
      VAL(I)=EHOLD(3,I)
  540 CONTINUE
  550 IF (NDP.LE.0) GO TO 580
      DO 560 I=1,NDP
      PRAMTR(I)=PHOLD(I)
  560 CONTINUE
  580 XSTORD=0.D0
  600 RETURN
 
      END
