CSECT   AGEXT
C     REVISED 4/25/73
 
      SUBROUTINE AGEXT(CDPR,XMRG,H,A,G,HK,B35,B24,B27,B85,B2Y,BX5,B25)
 
C  COMPUTES NEW A AND G MATRICES  TAKING INTO ACCOUNT DEPENDENT
C   SOURCES
C  CDPR IS WORK SPACE USED FOR C PRIME AND D PRIME AND IS
C   DIMENSIONED CDPR(N2+N5,MAX(N2+N5,N7+N8))
C    MRG INVERSE WILL BE STORED IN XMRG
C  H IS DIMENSIONED H(N3+N4,NX+NY)
C   A,G ARE AS CALCULATED BY AGCALC AND ARE MODIFIED HERE
C   HK IS WORKING STORAGE DIMENSIONED (N3+N4,N2+N5)
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
      COMMON /TAPES/  NOUTTP
      COMMON /CNTRLS/ CTROLS(160)
      COMMON /CLASNO/ NY,N7,N4,N5,N6,N1,NOT2,N3,NOTX,NDC8,N0,N9,N8,
     *                N3P4,NSIND,NXPY,I2P5,JSK(5),N2,NX
      COMMON /START/  JSK1(3),IBR
      COMMON /CAY13/  CAY13(1)
      COMMON /NR13/   NR13(1)
      COMMON /R29/    R22(1)
      COMMON /NAMES/  V(1)
      DIMENSION       CDPR(I2P5,*),XMRG(I2P5,I2P5),HK(N3P4,I2P5)
      DIMENSION       B35(*),B24(*),B27(*),B85(*),B2Y(*),BX5(*),B25(*)
      DIMENSION       H(N3P4,NXPY),A(N3P4,N3P4),G(N3P4,1)
 
C   COMPUTE MRG AND GET ITS INVERSE
 
      CALL XMRGI
     * (XMRG,I2P5,B2Y,CAY13,NR13,CAY13(NY+1),NR13(NY+1),BX5,B25,CDPR)
 
C   COMPUTE A PRIME= A+(H)(K)(CPRIME)
C   WHERE CPRIME=MRGI*(0,-B24//B35T,0)
 
C   FORM C PRIME
 
      N2P1=N2+1
      if (i2p5.ne.0 .and. n3.ne.0)
     *   CALL AB(CDPR,XMRG(1,N2P1),N5,B35,N3,N5,1,0)
      if (i2p5.ne.0 .and. n2.ne.0)
     *   CALL AB(CDPR(1,N3+1),XMRG,N2,B24,N2,N4,0,1)
 
C   FORM (H)(K)  WHERE K IS (K1)(R22),K2//K3,(K4)/R55
 
      DO 6 I=1,N3P4
      IF(N2 .EQ. 0) GO TO 102
      DO 3 J=1,N2
      SUM=0.D0
      IF(NY .EQ. 0) GO TO 101
      DO 1 K=1,NY
    1 IF(NR13(K) .EQ. J) SUM=SUM+H(I,K)*CAY13(K)*R22(J)
  101 IF(NX .EQ. 0) GO TO 3
      DO 2 KK=1,NX
      K=KK+NY
    2 IF(NR13(K) .EQ. J) SUM=SUM+H(I,K)*CAY13(K)
    3 HK(I,J)=SUM
  102 IF(N2P1 .GT. I2P5) GO TO 104
      DO 6 J=N2P1,I2P5
      JJ=J-N2
      JK=IBR+JJ-1
      SUM=0.D0
      IF(NY .EQ. 0) GO TO 103
      DO 4 K=1,NY
    4 IF(NR13(K) .EQ. J) SUM=SUM+H(I,K)*CAY13(K)
  103 IF(NX .EQ. 0) GO TO 6
      DO 5 KK=1,NX
      K=KK+NY
    5 IF(NR13(K) .EQ. J) SUM=SUM+H(I,K)*CAY13(K)/V(JK)
    6 HK(I,J)=SUM
 
C   COMPUTE A=A+(HK)*CPRIME
 
  104 CALL MMPYAD(A,N3P4,HK,N3P4,I2P5,CDPR,N3P4)
 
C   FORM D PRIME=MRGI*(-B27,0//0,B85T)
 
      if (i2p5.ne.0 .and. n2.ne.0)
     *   CALL AB(CDPR,XMRG,N2,B27,N2,N7,0,1)
      if (i2p5.ne.0 .and. n8.ne.0)
     *   CALL AB(CDPR(1,N7+1),XMRG(1,N2P1),N5,B85,N8,N5,1,0)
 
C   COMPUTE  G=G+(HK)*DPRIME
 
      CALL MMPYAD(G,N3P4,HK,N3P4,I2P5,CDPR,NSIND)
      IF (CTROLS(76).EQ.0.D0)  GO TO 1000
      WRITE (NOUTTP,500)
  500 FORMAT (1H1,/,5X,'EXTENDED A MATRIX - INCLUDES DEPENDENT SOURCES')
      CALL OURMAT (A,N3P4,N3P4,N3P4,N3P4)
      WRITE (NOUTTP,505)
  505 FORMAT (1H1,/,5X,'EXTENDED G MATRIX - INCLUDES DEPENDENT SOURCES')
      CALL OURMAT(G,N3P4,NSIND,N3P4,NSIND)
 1000 RETURN
 
      END
