CSECT   DIFFUN                          72.110  00.39.08
 
      SUBROUTINE DIFFUN (CURNS,NCL3,VOLTS,NCL4,P,NDPD,IGO)
 
C  THE PARAMETERS TO THE SUBROUTINE DIFFUN HAVE THE FOLLOWING
C  MEANINGS:
C
C  CURNS-    STORAGE FOR THE INDUCTIVE STATE VARIABLE VALUES.
C  NCL3-     THE NUMBER OF INDUCTIVE STATE VARIABLES
C  VOLTS-    STORAGE FOR THE CAPACITIVE STATE VARIABLE VALUES.
C  NCL4-     THE NUMBER OF CAPACITIVE STATE VARIABLES.
C  P-        STORAGE FOR THE DEFINED PARAMETER DERIVATIVE VALUES.
C  NDPD-     THE NUMBER OF DEFINED PARAMETER DERIVATIVES
C  IGO-      A SWITCH WHOSE VALUE IS:
C               =1   - CALULATE DERIVATIVES
C               =2   - DO NOT CALCULATE  THE DERIVATIVES.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
      COMMON /UTILTY/ Y
      COMMON /DERIVS/ DERIV(1)
      COMMON /CNTRLS/ CTRL(70)
      DIMENSION       CURNS(*),VOLTS(*),P(*),Y(8,1)
 
C COPY INDUCTOR STATE VARIABLE VALUES TO CURNS VECTOR.
 
      ICOUNT=0
      IF (NCL3.ne.0) then
         DO 100 J=1,NCL3
            ICOUNT=ICOUNT+1
            CURNS(J)=Y(1,ICOUNT)
  100    CONTINUE
      end if
 
C COPY CAPACITOR STATE VARIABLE VALUES TO VOLTS VECTOR
 
      IF (NCL4.ne.0) then
         DO 250 J=1,NCL4
            ICOUNT=ICOUNT+1
            VOLTS(J)=Y(1,ICOUNT)
  250    CONTINUE
      end if  
 
C COPY DEFINED PARAMETER DERIVATIVE VALUES TO P VECTOR
 
  300 IF (NDPD.ne.0) then
         DO 350 J=1,NDPD
            ICOUNT=ICOUNT+1
            P(J)=Y(1,ICOUNT)
  350    CONTINUE
      end if
 
C CALCULATE DERIVATIVES?
 
  400 IF (IGO.EQ.2) GO TO 700
 
C REPLACE TIME WITH START TIME IF GENERATING DC SOLUTION.
 
      IF (nint(CTRL(59)).ne.0) then
         TIME=CTRL(1)
         CTRL(1)=CTRL(60)
      end if
 
C DERIVATIVES ARE CALCULATED.
 
      CALL SIMTR (K1,1)
 
C REPLACE RUNNING TIME IF GENERATING DC SOLUTION.
 
      IF (nint(CTRL(59)).ne.0) CTRL(1)=TIME

  700 RETURN
 
      END
