CSECT   DIOQ                            71.042  11.43.38
 
      FUNCTION DIOQ (PIO,PK,V,GJ,J,B,VD)

C PIO: Is
C PK : \Theta
C V  : diode voltage VJ
C GJ : slope of diode curve @ V/J
C J  : diode current
C B  :
C VD :
C explanation see vol. 2 appendix C

      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)

C rmax:   maximum floating point number =0.9d308
C expmax: ln(rmax) = 709.09d0
C         parameter (expmax=709D0,rmax=0.82184D+308)
 
      COMMON /TAPES/  NOUTTP
      COMMON /CNTRLS/ SKIP1(21),XICPAS,SKIP2(119),XADJ
      DOUBLE PRECISION J
 
      DATA C1         /.000001D0/,
     *     C3         /.001D0/,
     *     C4         /1.D6/,
     *     ONEPT      /1.D0/
 
      IF (nint(XADJ) .ne. 0) then
         B    = 0.D0
         J    = GJ*V
         DIOQ = GJ
         RETURN
      end if
 
      IF (nint(XICPAS).GT.1) GO TO 10

      IF (V) 2,3,4

C V < 0:

    2 continue
      temp = pk*v
      J  = PIO*EXP(temp)
      GJ = PK*J
      J  = J-PIO
      B  = J-GJ*V
      GO TO 30

C V = 0:

    3 J = 0.d0
      GJ = PK*PIO
      B = 0.d0
      GO TO 30

C V > 0:

    4 continue
      temp = pk*v
      GJ = PK*PIO*EXP(temp)
      J  = GJ*V
      V  = LOG(J/PIO+ONEPT)/PK
      B  = J-GJ*V
      GO TO 30

C Newton-Raphson pass counter > 1:

   10 J = GJ*VD+J

      IF (V) 12,14,16

C V > 0:

   16 IF (V-C3) 19,20,20
   19 IF (J.gt.0.d0) then
         X = LOG(J/PIO+ONEPT)/PK
       else
         J = PIO/C4
         X = LOG(ONEPT+C1)/PK
      end if
      GJ = PK*J
      B = J-GJ*X
      GO TO 30
   20 IF (J.LE.0.d0) GO TO 15
      V = LOG(J/PIO+ONEPT)/PK
      go to 22

C V < 0:

   12 continue
      temp = pk*v
      J  = PIO*EXP(temp)
      GJ = PK*J
      J  = J-PIO
      GO TO 25

C V = 0:

   14 IF (J.GT.0.d0) GO TO 12
   15 J = PIO*C1
      V = LOG(ONEPT+C1)/PK
      GO TO 22

   22 GJ = PK*J
   25 continue
      temp=gj*v
      B = J-temp

   30 DIOQ = GJ
      RETURN
 
      END
