CSECT   DOLPEQ                          72.110  00.39.08
 
      SUBROUTINE DOLPEQ (NDXTAB,KQDAT,W,NROWS,NCOLS)
 
C     THIS SUBROUTINE SOLVES THE JACOBIAN DO-LOOP EQUATIONS ,IF THE
C     THE W MATRIX IS GENERATED NOT USING THE SPARSE TECHNIQUE.
C     ARGUMENTS ARE :
C         NDXTAB - HALF-WORD INTEGER TABLE; SPECIFIES WHAT DO-LOOPS
C                  ARE TO BE EXECUTED.
C         KQDAT  - HALF-WORD INTEGER TABLE; THE EQUATION DATA TABLE
C         W      - DOUBLE-WORD ARRAY; JACOBIAN MATRIX
C         NROWS  - SINGLE-WORD INTEGER; ROW DIMENSION OF MATRIX W
C         NCOLS  - SINGLE-WORD INTEGER, COLUMN DIMENSION OF MATRIX W
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
      COMMON /NAMES/  X(1)
      COMMON /GEARTG/ GX(1)
      COMMON /XMUTL/  XM(1)
      INTEGER*2       NDXTAB(*),KQDAT (1)
      DOUBLE PRECISION W(NROWS,NCOLS),MEQTNF
 
      MEQTNF(A,B,C,D)=(A/(B*C-D**2))
 
      IF (NDXTAB(1).LE.0) GO TO 250
 
C     GENERATE VALUES TO TYPE 1 EQUATIONS
 
      NSTRT=NDXTAB(1)
      IEND=NDXTAB(2)
      DO 200 N=1,IEND
         NEND=NSTRT+1+KQDAT(NSTRT)
         N1=KQDAT(NSTRT+1)
         NSTRT=NSTRT+2
         GX(N1)=0.D0
         DO 100 N2=NSTRT,NEND
  100    GX(N1)=GX(N1)+X(KQDAT(N2))
         GX(N1)=1/GX(N1)
  200 NSTRT=NEND+1
 
C     GENERATE THE SOLUTION FOR THE TYPE 2 EQUATIONS.
 
  250 IF (NDXTAB(3).LE.0) GO TO 450
      NSTRT=NDXTAB(3)
      IEND=NDXTAB(4)
      DO 400 N=1,IEND
         NEND=NSTRT+1+KQDAT(NSTRT)
         N1=KQDAT(NSTRT+1)
         NSTRT=NSTRT+2
         GX(N1)=0.D0
         DO 300 N2=NSTRT,NEND
  300    GX(N1)=GX(N1)+1/X(KQDAT(N2))
         GX(N1)=1/GX(N1)
  400 NSTRT=NEND+1
 
C     GENERATE SOLUTION TO TYPE 3 EQUATIONS
 
  450 IF (NDXTAB(5).LE.0) GO TO 650
      NSTRT=NDXTAB(5)
      IEND=NDXTAB(6)
      DO 600 N=1,IEND
         NEND=NSTRT+1+KQDAT(NSTRT)*3
         N1=KQDAT(NSTRT+1)
         NSTRT=NSTRT+2
         DO 500 N2=NSTRT,NEND,3
            NROW=KQDAT(N2)
            ASIGN=SIGN(1,NROW)
            NROW=ABS(NROW)
  500    W(NROW,KQDAT(N2+1))=
     *   W(NROW,KQDAT(N2+1))+ASIGN*GX(N1)*GX(KQDAT(N2+2))
  600 NSTRT=NEND+1
 
C     GENERATE SOLUTION TO TYPE 4 EQUATIONS
 
  650 IF (NDXTAB(7).LE.0) GO TO 850
      NSTRT=NDXTAB(7)
      IEND=NDXTAB(8)
      DO 800 N=1,IEND
         NEND=NSTRT+1+KQDAT(NSTRT)*2
         N1=KQDAT(NSTRT+1)
         NSTRT=NSTRT+2
         DO 700 N2=NSTRT,NEND,2
            NROW=KQDAT(N2)
            ASIGN=SIGN(1,NROW)
            NROW=ABS(NROW)
  700    W(NROW,KQDAT(N2+1))=W(NROW,KQDAT(N2+1))+ASIGN*GX(N1)
  800 NSTRT=NEND+1
 
C     GENERATE SOLUTION TO TYPE 5 EQUATIONS
 
  850 IF (NDXTAB(9).LE.0) GO TO 1050
      NSTRT=NDXTAB(9)
      IEND=NDXTAB(10)
      DO 1000 N=1,IEND
         NEND=NSTRT+1+KQDAT(NSTRT)*4
         N1=KQDAT(NSTRT+1)
         NSTRT=NSTRT+2
         DO 900 N2=NSTRT,NEND,4
            NROW=KQDAT(N2)
            ASIGN=SIGN(1,NROW)
            NROW=ABS(NROW)
  900    W(NROW,KQDAT(N2+1))=
     *      W(NROW,KQDAT(N2+1))+
     *      ASIGN*GX(N1)*GX(KQDAT(N2+2))*GX(KQDAT(N2+3))
 1000 NSTRT=NEND+1
 
C     GENERATE SOLUTIONS FOR TYPE 6 EQUATIONS
 
 1050 IF (NDXTAB(11).LE.0) GO TO 1350
      NSTRT=NDXTAB(11)
      IEND=NDXTAB(12)
      DO 1300 N=1,IEND
         NEND=NSTRT+1+KQDAT(NSTRT)*5
         N1=KQDAT(NSTRT+1)
         NSTRT=NSTRT+2
         DO 1200 N2=NSTRT,NEND,5
            NROW=KQDAT(N2)
            ASIGN=SIGN(1,NROW)
            NROW=ABS(NROW)
            IF (KQDAT(N2+2).GT.0) GO TO 1100
            ANSR=MEQTNF(X(KQDAT(N2+3)),
     *            X(KQDAT(N2+3)),
     *            X(KQDAT(N2+4)),
     *            XM(-KQDAT(N2+2)))
            GO TO 1200
 1100       ANSR=MEQTNF(XM(KQDAT(N2+2)),
     *             X(KQDAT(N2+3)),
     *             X(KQDAT(N2+4)),
     *             XM(KQDAT(N2+2)))
 1200    W(NROW,KQDAT(N2+1))=W(NROW,KQDAT(N2+1))+ASIGN*GX(N1)*ANSR
 1300 NSTRT=NEND+1
 
C     GENERATE SOLUTIONS FOR TYPE 7 EQUATIONS
 
 1350 IF (NDXTAB(13).LE.0) GO TO 1650
      NSTRT=NDXTAB(13)
      IEND=NDXTAB(14)
      DO 1600 N=1,IEND
         NEND=NSTRT+1+KQDAT(NSTRT)*4
         N1=KQDAT(NSTRT+1)
         NSTRT=NSTRT+2
         DO 1500 N2=NSTRT,NEND,4
            NROW=KQDAT(N2)
            ASIGN=SIGN(1,NROW)
            NROW=ABS(NROW)
            IF (KQDAT(N2+2).GT.0)GO TO 1400
            ANSR=MEQTNF(X(KQDAT(N2+3)),
     *                  X(KQDAT(N2+3)),
     *                  X(N1),
     *                  XM(-KQDAT(N2+2)))
            GO TO 1500
 1400       ANSR=MEQTNF(XM(KQDAT(N2+2)),
     *                  X(N1),
     *                  X(KQDAT(N2+3)),
     *                  XM(KQDAT(N2+2)))
 1500    W(NROW,KQDAT(N2+1))=W(NROW,KQDAT(N2+1))+ASIGN*ANSR
 1600 NSTRT=NEND+1
 1650 RETURN
 
      END
