CSECT   EXEC2 
C     REVISED 6/4/73 
 
      PROGRAM      E X E C 2 
 
C S C E P T R E, Copyright 1990-2000 by WRNovender, all rights reserved

C      SCEPTRE SOLUTION CONTROL EXECUTIVE ROUTINE. 
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N) 
 
      COMMON /TAPES/  NOUTTP,INTAPE,LIBTP,INOUTP,NEDITP,NSAVTP, 
     *                IP,IX,IUT1,npunch,nactpe,iqqtmp,imonte
      COMMON /CNTRLS/ CTROLS(160) 
         EQUIVALENCE (XTMON,CTROLS(36)) 
         EQUIVALENCE (XMCPUT,CTROLS(40)),(XMXSLT,CTROLS(37)) 
      COMMON /SAVERN/ KRAND 

C     THESE COMMONS REQUIRED  TO PREVENT LINK EDIT ERROR*** 

      COMMON /NAMES/  ZNAM 
      COMMON /VOLTGS/ ZVOLT 
      COMMON /CURNTS/ ZCURN 
      COMMON /SAVEIC/ ZSAVIC 
      COMMON /SAVICT/ ZSVICT 
      COMMON /DERIVS/ ZDERIV 
      COMMON /ELNAMS/ ZELNAM 
      COMMON /EBACK/  ZEBAC 
      COMMON /PBACK/  ZPBAC 
      COMMON /ELIMIT/ ZELIM 
      COMMON /PLIMIT/ ZPLIMT 
      COMMON /OSTATS/ ZOSTT 
      COMMON /OPTEMP/ ZOPTM 
      COMMON /SAVEDC/ ZSVDC 
      COMMON /GVALUE/ ZGVAL 
      COMMON /YVALUE/ ZYVAL 
      COMMON /PRMTRS/ ZPRM 
      COMMON /DPNAMS/ ZDPNMS 
      COMMON /OUTPUT/ ZOUTPT
      logical ldirac,lpost,lerror,ltotal
      data    ldirac /.false./

      print *, 'EXEC2: execution begins ...'      

      ltotal=.false.
      KRAND = 0 
      INOUTP=10
      IP    = 4 
      NEDITP= 3 
      INTAPE= 5 
      NOUTTP=16 
      NSAVTP= 8 
      npunch=18
      nactpe=11
      iqqtmp=13
      imonte=20
 
      call qqqopn ('acsave',nactpe,lerror)
      ltotal=lerror.or.ltotal
      call qqqopn ('liste',nouttp,lerror)
      ltotal=lerror.or.ltotal
      call qqqopn ('datasave',nsavtp,lerror)
      ltotal=lerror.or.ltotal
      call qqqopn ('scratch-unformatted',inoutp,lerror)
      ltotal=lerror.or.ltotal
      call qqqopn ('scratch',neditp,lerror)
      ltotal=lerror.or.ltotal
      call qqqopn ('scratch-unformatted',ip,lerror)
      ltotal=lerror.or.ltotal
      call qqqopn ('scratch-unformatted',20,lerror)
      ltotal=lerror.or.ltotal
      call qqqopn ('scratch-unformatted',iqqtmp,lerror)
      ltotal=lerror.or.ltotal
      call qqqopn ('scratch-unformatted',imonte,lerror)
      ltotal=lerror.or.ltotal
      if (ltotal) stop 'EXEC2: initialisation failed'
  
C IBM:
C     THIS ELIMINATES TERMINATION BECAUSE OF UNDERFLOW AND ALIGNMENT 
C     ERRORS. 
C       CALL ERRSET(208,300,-1,2)
C       CALL ERRSET(210,300,10,2)
C     AN OVERFLOW OR DIVIDE CHECK ERROR CAN OCCUR WITHOUT BEING 
C     TERMINATED BY THE OPERATING SYSTEM. 
C       CALL ERRSET(207,300,10,2)
C       CALL ERRSET(209,300,10,2)
C     THIS CALL TO ERRSET ELIMINATES TERMINATION BECAUSE AN 
C     EXPONENT IS GREATER THAN 174.D0. 
C       CALL ERRSET(262,300,10,2)
CVAX:
C      call errset (72,.false.,.false.,.false.,255)
 
  10  KWAY=0 
      READ (NSAVTP,7   ) CTROLS 
    7 FORMAT (1P,5D14.7)
 
C TEST FOR LAST RUN 
 
      IF (nint(CTROLS(28)).EQ. -1) GO TO 12 
 
C TEST FOR DUMMY CONTROL BLOCK (ELIMINATED RERUN) 
 
      IF (nint(CTROLS(28)).EQ.0) GO TO 10 
 
C CHECK SOLUTION TIME 
 
      CPUTIM=RTIMER(X) 
      IF (CPUTIM .GT.XMXSLT .AND. XMXSLT.GT.0.D0) GO TO 100 
      SAVE=XMXSLT 
 
C TERMINATE IF 90% OF CPU TIME IS USED, 
C ALLOWING 10% OF SOLUTION TIME FOR OUTPUT 
 
      XMXSLT=0.9d0*CPUTIM 
      IF (SAVE.EQ.0.D0) GO TO 100 
 
C     ENTER ROUTINE TO PERFORM SIMULATION 
 
      WRITE(NOUTTP,9) XMXSLT 
    9 FORMAT('0SOLUTION TIME LIMIT USED    ',G14.2//) 
  100 XMCPUT=CPUTIM 
      XTMON=CLOCKF(X) 
      CALL SIMUL8 (KWAY) 
 
C     TEST FOR INITIAL CONDITIONS ONLY RUN 
 
      IF (KWAY.EQ.4) GO TO 10 
 
C     TEST FOR ERROR RETURN 
 
      IF (KWAY.EQ.10 .OR. KWAY.GT.12)  GO TO 15 
      REWIND INOUTP 
 
C     ENTER POST PROCESSOR 
 
       CALL POST (lpost) 
       ldirac=ldirac.or.lpost
 
C     READ IN TYPE OF OUTPUT 
 
      REWIND INOUTP 
      READ (INOUTP)  CTROLS(71) 
      IF (nint(CTROLS(71)) .EQ. 0)  THEN
 
C     ENTER ROUTINE TO PRODUCE RESULTS PRINT OUT 
 
         CALL LISTR 
 
C     ENTER ROUTINE TO PRODUCE TIME PLOTS AND PRINTS 
 
         CALL MULPLT 
 
C     ENTER ROUTINE TO PRODUCE PRINTER PLOT 
 
         CALL PLOT 
 
       ELSE
  
C     AC OUTPUT:

         CALL ACLIST 
         CALL ACPLOT 
 
      END IF

C     TEST FOR OPERATOR TERMINATION 
 
      IF (KWAY.EQ.5 .OR. KWAY.EQ.11)  GO TO 13 
 
C     TEST FOR RE-OUTPUT RUN 
 
      IF (KWAY .EQ. 8) GO TO 20 
      GO TO 10 
   12 WRITE (NEDITP,70) CTROLS 
   70 FORMAT(1P,5D14.7,10X)
 
C     ENTER ROUTINE TO SAVE PROGRAM AND DATA 
 
   13 CALL SAVEPD(0) 
   15 continue
      if (ldirac) call pos000 ('DIRECTORY',lpost)
      WRITE (NOUTTP,'(''0SIMULATION PROGRAM HAS TERMINATED'')') 

      call qqqcls ('acsave',nactpe,lerror)
      call qqqcls ('liste',nouttp,lerror)
      call qqqcls ('datasave',nsavtp,lerror)
      call qqqcls ('scratch-unformatted',inoutp,lerror)
      call qqqcls ('scratch',neditp,lerror)
      call qqqcls ('scratch-unformatted',20,lerror)
      call qqqcls ('scratch-unformatted',iqqtmp,lerror)
      call qqqcls ('scratch-unformatted',ip,lerror)
      call qqqcls ('scratch-unformatted',imonte,lerror)

      STOP 'EXEC2: ended normally'

   20 WRITE (NOUTTP,22) 
   22 FORMAT(24H1RE-OUTPUT RUN COMPLETE.) 
      STOP 'EXEC2: re-output run complete'
 
      END 
