CSECT   GEAR                            71.207  11.29.31
C       19 APR 73
 
      SUBROUTINE   GEAR (CURNS,NCL3,VOLTS,NCL4,P,NDPD)
 
C  THE PARAMETERS TO THE SUBROUTINE GEAR   HAVE THE FOLLOWING
C  MEANINGS:
C
C  CURNS     STORAGE FOR THE INDUCTIVE STATE VARIABLE VALUES.
C  NCL3      THE NUMBER OF INDUCTIVE STATE VARIABLES
C  VOLTS     STORAGE FOR THE CAPACITIVE STATE VARIABLE VALUES.
C  NCL4      THE NUMBER OF CAPACITIVE STATE VARIABLES.
C  P         STORAGE FOR THE DEFINED PARAMETER DERIVATIVE VALUES.
C  NDPD      THE NUMBER OF DEFINED PARAMETER DERIVATIVES
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
Cwrn  parameter (rmax=709d0) 

      COMMON /TAPES/  NOUTTP,INTAPE,LIBTP,INOUTP,NEDITP,NSAVTP
      COMMON /UTILTY/ Y
      COMMON /GEARTA/ SAVE
      COMMON /CNTRLS/ CTRL(40)
         EQUIVALENCE (T,CTRL(1)),(CTRL(6),HMIN),(CTRL(7),HMAX),
     *               (EPS,CTRL(8)),(CTRL(31),XPASS),(CTRL(30),XSTEP)
      COMMON /DERIVS/ DERIV(1)
      COMMON /GEARTF/ PSAVE
      COMMON /GEARDT/ BND,H,N,NQ,IWEVAL,N7,K
      DIMENSION       VOLTS(*),CURNS(*),P(*)
      DIMENSION       Y(8,2),SAVE(12,1),PSAVE(2,2)
      DIMENSION       PERTST(6,3),A(7,6)
 
CIBM: DATA TMAX /Z7FFFFFFFFFFFFFFF/
CVAX: DATA TMAX /ZFFFFFFFFFFFF7FFF/
CFTN77/386      DATA TMAX /Z'7FFFFFFFFFFFFFFF'/
      data tmax /1.d38/
      DATA MAXDER /6/
 
C  THE COEFFICIENTS IN PERTST ARE USED IN SELECTING THE STEP AND
C  ORDER, THERFORE ONLY ABOUT ONE PERCENT ACCURACY IS NEEDED.
      DATA PERTST /2.0d0,4.5d0,7.333d0,10.42d0,13.7d0,17.15d0,
     1             3.0d0,6.0d0,9.167d0,12.5d0,15.98d0,1.0d0,
     2             1.0d0,1.0d0,0.5d0,0.1667d0,0.04133d0,0.008267d0/
 
C  THE FOLLOWING COEFFICIENTS SHOULD BE DEFINED TO THE MAXIMUM
C  ACCURACY PERMITTED BY THE MACHINE.  THEY ARE IN THE ORDER USED.
C  -1,-1
C  -2/3,-1,-1/3
C  -6/11,-1,-6/11,-1/11
C  -12/25,-1,-7/10,-1/5,-1/50
C  -120/274,-1,-225/274,-85/274,-15/274,-1/274
C  -180/441,-1,-58/63,-15/36,-25/252,-3/252,-1/1764
      DATA A/
     1 -1.0d0,-1.0d0,0.0d0,0.0d0,0.0d0,0.0d0,0.0d0,
     2 -0.6666666666666667d0,-1.0d0,
     2 -0.3333333333333333d0,0.0d0,0.0d0,0.0d0,0.0d0,
     3 -0.5454545454545455d0,-1.0d0,-0.5454545454545455d0,
     3 -0.09090909090909091d0,0.0d0,0.0d0,0.0d0,
     4 -0.48d0,-1.0d0,-0.7d0,-0.2d0,-0.02d0,0.0d0,0.0d0,
     5 -0.437956204379562d0,-1.0d0,-0.8211678832116788d0,
     5 -0.3102189781021898d0,
     5 -0.05474452554744526d0,-0.0036496350364963504d0,0.0d0,
     6 -0.4081632653061225d0,-1.0d0,-0.9206349206349206d0,
     6 -0.4166666666666667d0,
     6 -0.0992063492063492d0,-0.0119047619047619d0,
     6 -0.000566893424036282d0/
 
    1 IRET=1
      KFLAG=1
      IF (nint(XSTEP).GT.1)  GO TO 120
 
C  ON THE FIRST CALL, THE ORDER IS SET TO 1 AND THE PROGRAM
C  VARIABLES ARE INITIALIZED.
 
      NQ = 1
      N=nint(CTRL(26))
      
      if (n.le.0) then
         write (nouttp,'(''0GEAR: subroutine lacks class 3 and 4 '',
     *         ''elements and DP derivatives, '',
     *         ''IMPLICIT integration cancelled'')')
         stop 'GEAR: simulation cancelled'
      end if

      H=CTRL(5)
      DO 10 I=1,10
         DO 10 J=1,N
   10 SAVE(I,J)=0.D0
      DO 20 I=1,8
         DO 20 J=1,N
   20 Y(I,J)=0.0D0
      ICOUNT=0
      IF (NCL3.ne.0) then
         DO 30 J=1,NCL3
            ICOUNT=ICOUNT+1
   30    Y(1,ICOUNT)=CURNS(J)
      end if
   40 IF (NCL4.ne.0) then
         DO 50 J=1,NCL4
            ICOUNT=ICOUNT+1
   50    Y(1,ICOUNT)=VOLTS(J)
      end if
      IF (NDPD.ne.0) then
         DO 70 J=1,NDPD
            ICOUNT=ICOUNT+1
   70    Y(1,ICOUNT)=P(J)
      end if
      DO  90 I=1,N
   90 SAVE(12,I)=1.D0
      DO 100 I=1,N
  100 Y(2,I)=DERIV(I)*H

      HNEW=H
      K=2
 
C  E IS A COMPARISON FOR ERRORS OF THE CURRENT ORDER NQ.  EUP IS
C  TO TEST FOR INCREASING THE ORDER, EDWN FOR DECREASING THE ORDER.
C  HNEW IS THE STEP SIZE THAT WAS USED ON THE LAST CALL.
 
  120 DO 130 I=1,N
         DO 130 J=1,K
  130 SAVE(J,I)=Y(J,I)
      HOLD = HNEW
      IF (H.EQ.HOLD) GO TO 150
  140 RACUM = H/HOLD
      IRET1=1
      GO TO 750
  150 NQOLD = NQ
      TOLD = T
      RACUM = 1.0D0
      IF (nint(XSTEP).GT.1) GO TO 250
 
C  SET THE COEFFICIENTS THAT DETERMINE THE ORDER.
C  CHECK FOR EXCESSIVE ORDER.  THE LAST TWO STATEMENTS OF
C  THIS SECTION SET IWEVAL .GT.0 IF PSAVE IS TO BE RE-EVALUATED
C  BECAUSE OF THE ORDER CHANGE, AND THEN REPEAT THE INTEGRATION
C  SCALING BEFORE EXIT IF IT HAS BEEN COMPLETED (IRET=2).
 
  170 IF (NQ.LE.MAXDER) GO TO 220
      KFLAG=-2
      GO TO 800
  220 N7=NQ
  230 K=NQ+1
      IDOUB=K
      ENQ2=0.5d0/dble(NQ+1)
      ENQ3=0.5d0/dble(NQ+2)
      ENQ1=0.5d0/dble(NQ)
      EUP=(PERTST(NQ,2)*EPS)**2
      E=(PERTST(NQ,1)*EPS)**2
      EDWN=(PERTST(NQ,3)*EPS)**2
      BND=EPS*ENQ3/dble(N)
  240 IWEVAL=1
      GO TO (250,680) ,IRET
  250 CALL PRDCOR (CURNS,NCL3,VOLTS,NCL4,P,NDPD,PSAVE,N,A,IGO)
      GO TO (440,490),IGO
 
C  THE CORRECTOR ITERATION FAILED TO CONVERGE IN 3 TRIES.  VARIOUS
C  POSSIBILITIES ARE CHECKED FOR.  IF H IS ALREADY HMIN AND
C  MATRIX PSAVE HAS ALREADY BEEN RE-EVALUATED, A NO CONVERGENCE EXIT
C  IS TAKEN.  OTHERWISE THE MATRIX PSAVE IS RE-EVALUATED, AND/OR THE
C  STEP IS REDUCED TO TRY AND GET CONVERGENCE.
 
  440 T=T-H
      IF ((H.LE.(HMIN*1.00001d0)) .AND. (IWEVAL.LT.0)) GO TO 460
      IF (IWEVAL.NE.0) RACUM=RACUM*.25d0
      IWEVAL=1
      IRET1=2
      GO TO 750
  460 KFLAG=-3
  470 DO 480 I=1,N
         DO 480 J=1,K
  480 Y(J,I)=SAVE(J,I)
      H=HOLD
      NQ=NQOLD
      GO TO 800
  490 D=0.0d0
      DO 500 I=1,N
  500 D=D+(SAVE(11,I)/SAVE(12,I))**2
      IWEVAL = 0
      IF (D.GT.E) GO TO 540
      IF (K.LT.3) GO TO 520
      DO 510 J=3,K
         DO 510 I=1,N
  510 Y(J,I)=Y(J,I)+A(J,N7)*SAVE(11,I)
  520 KFLAG=+1
      HNEW=H
      IF (IDOUB.LE.1) GO TO 550
      IDOUB=IDOUB-1
      IF (IDOUB.GT.1) GO TO 700
      DO 530 I=1,N
  530 SAVE(10,I)=SAVE(11,I)
      GO TO 700
  540 KFLAG=KFLAG-2
      IF (H.LE.(HMIN*1.00001d0)) GO TO 740
      T=TOLD
      IF (KFLAG .LE.-25) GO TO 720
  550 PR2=(D/E)**ENQ2*1.2d0
      PR3=1.d+20
      IF ((NQ.GE.MAXDER) .OR. (KFLAG.LE.-1)) GO TO 570
      D=0.0d0
      DO 560 I=1,N
  560 D=D+((SAVE(11,I)-SAVE(10,I))/SAVE(12,I))**2
      PR3=(D/EUP)**ENQ3*1.4d0
  570 PR1=1.d+20
      IF (NQ.LE.1) GO TO 590
      D=0.0d0
      DO 580 I=1,N
  580 D=D+(Y(K,I)/SAVE(12,I))**2
      PR1=(D/EDWN)**ENQ1*1.3d0
  590 CONTINUE
      IF (PR2.LE.PR3) GO TO 650
      IF (PR3.LT.PR1) GO TO 660
  600 R=1.0d0/MAX(PR1,1.D-4)
      NEWQ=NQ-1
  610 IDOUB=10
      IF ((KFLAG.EQ.1) .AND. (R.LT.(1.1))) GO TO 700
      IF (NEWQ.LE.NQ) GO TO 630
      DO 620 I=1,N
  620 Y(NEWQ+1,I)=SAVE(11,I)*A(K,N7)/dble(K)
  630 K=NEWQ+1
      IF (KFLAG.EQ.1) GO TO 670
      RACUM=RACUM*R
      IRET1=3
      IWEVAL=1
      GO TO 750
  640 IF (NEWQ.EQ.NQ) GO TO 250
      NQ=NEWQ
      GO TO 170
  650 IF (PR2.GT.PR1) GO TO 600
      NEWQ=NQ
      R=1.0d0/MAX(PR2,1.D-4)
      GO TO 610
  660 R=1.0d0/MAX(PR3,1.D-4)
      NEWQ=NQ+1
      GO TO 610
  670 IRET=2
      IF (R*ABS(H).GT.HMAX) R=HMAX/ABS(H)
      H=H*R
      HNEW=H
      IF (NQ.EQ.NEWQ) GO TO 680
      NQ=NEWQ
      GO TO 170
  680 IF (R .EQ. 1.d0) GO TO 691
      R1=1.0d0
      DO 690 J=2,K
      R1=R1*R
      DO 690 I=1,N
  690 Y(J,I)=Y(J,I)*R1
  691 IDOUB=K
  700 DO 710 I=1,N
  710 SAVE(12,I)=MAX(SAVE(12,I),ABS(Y(1,I)))
      GO TO 800
  720 IF (NQ.EQ.1) GO TO 780
      CALL DIFFUN (CURNS,NCL3,VOLTS,NCL4,P,NDPD,1)
      R=H/HOLD
      DO 730 I=1,N
         Y(1,I)=SAVE(1,I)
         SAVE(2,I)=HOLD*DERIV(I)
  730 Y(2,I)=SAVE(2,I)*R
      NQ=1
      KFLAG=1
      GO TO 170
  740 KFLAG=-1
      HNEW=H
      GO TO 800
 
C  THIS SECTION SCALES ALL VARIABLES CONNECTED WITH H AND RETURNS
C  TO THE ENTERING SECTION.
 
  750 RACUM=MAX(ABS(HMIN/HOLD),RACUM)
Cwrn  if ((log(hmax)-log(hold)).le.rmax)
      RACUM=MIN(RACUM,ABS(HMAX/HOLD))
      IF (RACUM .EQ. 1. .AND. KFLAG .NE. 1) RACUM= .25d0*RACUM
      R1=1.0d0
      DO 760 J=2,K
         R1=R1*RACUM
         DO 760 I=1,N
  760 Y(J,I)=SAVE(J,I)*R1
      H=HOLD*RACUM
      DO 770 I=1,N
  770 Y(1,I)=SAVE(1,I)
      IDOUB=K
      GO TO (150,250,640),IRET1
  780 KFLAG=-4
      GO TO 470
  800 CALL DIFFUN (CURNS,NCL3,VOLTS,NCL4,P,NDPD,2)
      IF (KFLAG.NE.1) T=TMAX
  900 RETURN
 
      END
