CSECT   INVERS                          71.042  11.43.38
 
      SUBROUTINE INVERS (NAMMAT,AMAT,NR,NC,IERROR)
 
C                  NAMMAT = NAME OF MATRIX TO BE OPERATED ON
C                    AMAT = THE MATRIX TO BE SOLVED OR INVERTED
C                      NR = THE NUMBER OF ROWS IN AMAT
C                      NC = THE NUMBER OF COLUMNS IN AMAT
C                                A( NC = NR + 1 FOR EQUATION SOULUION
C                                B( NC = 2 * NR FOR MATRIX INVERSION
C                  IERROR = 11 IF THE MATRIX IS SINGULAR,OTHERWISE ZERO
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
      character*(*)   NAMMAT
      COMMON /TAPES/  NOUTTP,INTAPE,LIBTP,INOUTP,NEDITP,NSAVTP
      COMMON /CNTRLS/ TIME  ,XSTOPT,XMXERT,XIR   ,XTISSS,XMNISS,XMXISS,
     *                XMNAIE,XMXAIE,XIC   ,XRERNO,XMXPAS,XMNRIE,XMXRIE,
     *                XMNISO,XMXICP,XICRER,XICAER,XMXOTP,XXDIMS,XYDIMS,
     *                XICPAS,XNOPRQ,XNTNDX,XNHEAD,XNDFEQ,XERT,  XNRERN,
     *                XCNTNU,XSTPNO,XPASNO,XRUNNO,XSTPSZ
      DIMENSION       AMAT(NR,NC)
      EQUIVALENCE    (NOUTTP,OUTAPE)
      INTEGER         OUTAPE
 
       IF (XICPAS.gt.XMXICP) then
          IERROR=10
          WRITE (NOUTTP,8043) nint(XMXICP), ierror
          print 8043, nint(XMXICP), ierror
 8043     FORMAT('0INVERS: THE NEWTON-RAPHSON PASS LIMIT OF ',I5,
     *        ' HAS BEEN EXCEEDED WITHOUT ATTAINING CONVERGENCE,',
     *        ' ERROR CONDITION =',I4/)
          GO TO 105
       end if
 8050  IERROR=0
 
C      CHECK FOR 1X1 MATRIX AND SOLVE IF FOUND
 
       IF (NR.eq.1) then
          AMAT(1,2)=AMAT(1,2)/AMAT(1,1)
          GO TO 105
       end if

C      IF MATRIX INVERSION DESIRED, GENERATE IDENTITY MATRIX
 
       IF (NC.LT.(2*NR)) GO TO 21
       JINC=NR+1
       DO 20 INCR=1,NR
          INCROW=INCR+NR
          DO 20 INCOLM=JINC,NC
                IF (INCOLM.EQ.INCROW) GO TO 19
                AMAT(INCR,INCOLM)=0.d0
                GO TO 20
   19           AMAT(INCR,INCOLM)=1.d0
   20  CONTINUE
   21  DO 100 I=1,NR
          M=I+1
          J=I
 
C      CHECK FOR LAST DIAGONAL ELEMENT
 
          IF (I.EQ.NR)GO TO 35
 
C      FIND THE LARGEST VALUE BELOW DIAGONAL ELEMENT IN THIS COLUMN
 
          DO 30 N=M,NR
             IF (ABS(AMAT(J,I))-ABS(AMAT(N,I))) 27,30,30
   27        J=N
   30     CONTINUE
 
C      SEE IF THE LARGEST ELEMENT IN ROW IS ZERO
 
   35     IF (AMAT(J,I).eq.0d0) then
 
C      INDICATES THAT MATRIX IS SINGULAR
 
   40        IERROR=11
             WRITE (NOUTTP,8056) NAMMAT,ierror
             print 8056, nammat,ierror
 8056        FORMAT ('0INVERS: MATRIX ',A,' IS SINGULAR,',
     *               ' ERROR CONDITION =',I3)
             GO TO 105
          end if
 
C      SEE IF ROW INTERCHANGE IS NEEDED TO GET LARGEST ELEMENT ON DIAG.
 
   50     IF (J-I) 60,60,52
 
C      INTERCHANGE ROWS OF DIAGONAL AND THOSE TO THE RIGHT OF IT
 
   52     DO 55 N=I,NC
             SAVE=AMAT(I,N)
             AMAT(I,N)=AMAT(J,N)
   55     AMAT(J,N)=SAVE
   60     DIAG=AMAT(I,I)
 
C      DIVIDE ALL ELEMENTS TO RIGHT OF DIAG. IN DIAG. ROW BY DIAG. ELEM.
 
          DO 65 J=M,NC
   65     AMAT(I,J)=AMAT(I,J)/DIAG
          AMAT(I,I)=0.d0
          DO 90 K=1,NR
             IF (AMAT(K,I).EQ.0.) GO TO 90
             IP=I+1
             DO 80 J=IP,NC
   80        AMAT(K,J)=AMAT(K,J)-AMAT(K,I)*AMAT(I,J)
   90     CONTINUE
  100  CONTINUE

  105  CONTINUE
       RETURN
 
       END
