CSECT   INVRT
C     REVISED 4/25/73
 
      SUBROUTINE INVRT ( A,AI, NR, NC, IERR, NRDIM)
 
C     THIS PROGRAM SOLVES FOR THE INVERSE OF A COMPLEX MATRIX
C
C     NRDIM IS THE NUMBER OF ROWS IN THE MAIN PROGRAM DIMENSION STATEMEN
C     NR IS THE NUMBER OF ROWS IN THE ACTUAL MATRIX
C     NC IS THE NUMBER OF COLUMNS IN THE ACTUAL MATRIX
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
      common /tapes/  nouttp
 
      DIMENSION    A(NRDIM,1),AI(NRDIM,1)
      COMPLEX*16   A,DIAG,SAVE,AI
 
      DO 20 INCR=1,NR
      DO 20 INCOLM= 1  ,NC
      IF (INCOLM .EQ. INCR   ) GO TO 19
      AI(INCR,INCOLM) = DCMPLX(0.0D0,0.0D0)
      GO TO 20
   19 AI(INCR,INCOLM) = DCMPLX(1.0D0,0.0D0)
   20 CONTINUE
      DO 100 I=1,NR
      M=I+1
      J=I
 
C     CHECK FOR LAST DIAGONAL ELEMENT
 
      IF( I .EQ. NR ) GO TO 35
 
C     FIND THE LARGEST MAGNITUDE BELOW THE DIAGONAL
 
      DO 30 N=M,NR
      IF(CDABS(A(J,I))-CDABS(A(N,I))) 27,30,30
   27 J=N
   30 CONTINUE
 
C     SEE IF LARGEST ELEMENT IN ROW IS ZERO
 
   35 IF(CDABS(A(J,I)).GT.1.0D-35) GO TO 50
      IERR=1
      write (nouttp,45)
   45 FORMAT (32H0 EIGENVECTOR MATRIX IS SINGULAR)
      print *,'INVRT: eigenvector matrix is singular'
      RETURN
 
   50 IF (J-I) 60,60,52
   52 DO 55 N=I,NR
      SAVE=A(I,N)
      A(I,N)=A(J,N)
   55 A(J,N)=SAVE
      DO 56 N= 1  ,NC
      SAVE=AI(I,N)
      AI(I,N)=AI(J,N)
   56 AI(J,N)=SAVE
   60 DIAG=A(I,I)
      IF (I .EQ. NR) GO TO 101
      DO 65 J=M,NR
   65 A(I,J)=A(I,J)/DIAG
  101 DO 66 J= 1  ,NC
   66 AI(I,J)=AI(I,J)/DIAG
      A(I,I) = DCMPLX(0.0D0,0.0D0)
      DO 90 K=1,NR
      IF(CDABS(A(K,I)).LT.1.0D-35) GO TO 90
      IP=I+1
      IF (I .EQ. NR) GO TO 102
      DO 80 J=IP,NR
   80 A(K,J)=A(K,J)-A(K,I)*A(I,J)
  102 DO 81 J= 1  ,NC
   81 AI(K,J)=AI(K,J)-A(K,I)*AI(I,J)
   90 CONTINUE
  100 CONTINUE
      RETURN
 
      END
