CSECT   LIBMUX
 
      SUBROUTINE LIBMUX(X,IXZERO,NRX,NCX,Y,IYZERO,IYTRNS,IYDIAG,NRY,NCY,
     *                                   Z,IZZERO,IZTRNS,IZDIAG,NRZ,NCZ)
 
C     THIS SUBROUTINE CALCULATES THE FOLLOWING MATRIX PRODUCTS
C     WHERE THE LEFT  HAND SIDE INVOLVES AN INTEGER*2 B-MATRIX
C                  CASE 1    X = Y *ZD
C                  CASE 5    X = YT*ZD
C                  CASE 6    X = Y * Z
C                  CASE 7    X = YT*Z
C     SEE MXMULT FOR THE DEFINITIONS OF THE ARGUMENTS USED
 
      DOUBLE PRECISION X,  Z
      INTEGER*2        Y
      common /tapes/   nouttp
 
C     DIMENSION        X(NRX,  1),Y(NRY,  1),Z(NRZ,  1)
      DIMENSION        X(  1,  1),Y(  1,  1),Z(  1,  1)
 
      IYT = IYTRNS
      IYD = IYDIAG
      IZT = IZTRNS
      IZD = IZDIAG
 
C     IF EITHER MATRIX Y OR Z IS ZERO, THEN SET IXZERO TO ZERO & RETURN
 
      IF(IYZERO.EQ.0.OR.IZZERO.EQ.0) GO TO 1000
      IXZERO=1
 
C     TEST TO SEE WHICH CASE IS REQUIRED
 
      IF(IYT.EQ.0.AND.IYD.EQ.0.AND.IZT.EQ.0.AND.IZD.EQ.1) GO TO 1
      IF (IYT.EQ.1 .AND. IYD.EQ.0.AND.IZT.EQ.0.AND.IZD.EQ.1) GO TO 5
      IF(IYT.EQ.0 .AND.IYD.EQ.0.AND.IZT.EQ.0.AND.IZD.EQ.0) GO TO 6
      IF(IYT.EQ.1.AND.IYD.EQ.0.AND.IZT.EQ.0.AND.IZD.EQ.0) GO TO 7
 
C     WRITE AN ERROR MESSAGE IF THIS POINT REACHED
 
      write (nouttp,13)
   13 FORMAT (1X,' ILLEGAL CALL TO SUBROUTINE LIBMUX...CHECK THE FOUR ',
     * 'ARGUMENTS IYTRNS,IYDIAG,IZTRNS,IZDIAG IN THE CALLING SEQUENCE ')
      STOP 'LIBMUX: illegal call to this subroutine; abnormal end'
 
C     CASE 1       X = Y *ZD
 
    1 NRX = NRY
      NCX = NCZ
      CALL YY21(X,NRX,Y,NRY,Z,NRZ,NCZ)
      GO TO 2000
 
C      CASE 5  X = YT * ZD
 
   5  NRX=NCY
      NCX=NCZ
      CALL YY22(X,NRX,Y,NRY,Z,NRZ,NCY,NCZ)
      GO TO 2000
 
C      CASE 6  X= Y * Z
 
  6   MRX=NRY
      MCX=NCZ
      CALL YY23(X,NRX,Y,NRY,Z,NRZ,NCY,NCZ)
      GO TO 2000
 
C     CASE 7       X = YT*Z
 
    7   NRX = NCY
        NCX = NCZ
      CALL YY24(X,NRX,Y,NRY,Z,NRZ,NCY,NCZ)
      GO TO 2000
 1000 IXZERO=0
      IF (IYT.EQ.1  .AND.  IZT.EQ.0 )  GO TO 1110
      IF ( IYT.EQ.0 .AND. IZT.EQ.1 ) GO TO 1120
      IF ( IYT.EQ.1 .AND.  IZT.EQ.1 ) GO TO 1130
 
C     IYT=0,IZT=0
 
      NRX=NRY
      NCX=NCZ
      GO TO 1200
 1110 NRX=NCY
      NCX=NCZ
      GO TO 1200
 1120 NRX=NRY
      NCX=NRZ
      GO TO 1200
 1130 NRX=NCY
      NCX=NRZ
 1200 IF (NRX.EQ.0 .OR. NCX.EQ.0 )  GO TO 2000
      CALL YY25(X,NRX,NCX)
 2000 CONTINUE
      RETURN
 
      END
 
      SUBROUTINE YY21(X,NRX,Y,NRY,Z,NRZ,NCZ)
      DOUBLE PRECISION X,  Z
      INTEGER*2      Y
      DIMENSION    X(NRX,  1),Y(NRY,  1),Z(NRZ,  1)
      DO 10 I = 1,NRY
      DO 10 J = 1,NCZ
  10  X(I,J)=Y(I,J)*Z(J,1)
      RETURN
      END
 
      SUBROUTINE YY22(X,NRX,Y,NRY,Z,NRZ,NCY,NCZ)
      DOUBLE PRECISION X,  Z
      INTEGER*2      Y
      DIMENSION    X(NRX,  1),Y(NRY,  1),Z(NRZ,  1)
      DO 50 I=1,NCY
      DO 50 J=1,NCZ
  50  X(I,J)=Y(J,I)* Z(J,1)
      RETURN
      END
 
      SUBROUTINE YY23(X,NRX,Y,NRY,Z,NRZ,NCY,NCZ)
      DOUBLE PRECISION X,  Z,  SUM
      INTEGER*2      Y
      DIMENSION    X(NRX,  1),Y(NRY,  1),Z(NRZ,  1)
      DO 60 I=1,NRY
      DO 60 J=1,NCZ
      SUM =0.0D0
      DO 61 K=1,NCY
  61  SUM=SUM + Y(I,K)*Z(K,J)
  60  X(I,J) = SUM
      RETURN
      END
 
      SUBROUTINE YY24(X,NRX,Y,NRY,Z,NRZ,NCY,NCZ)
      DOUBLE PRECISION X,  Z,  SUM
      INTEGER*2      Y
      DIMENSION    X(NRX,  1),Y(NRY,  1),Z(NRZ,  1)
      DO 70 I = 1,NCY
      DO 70 J = 1,NCZ
         SUM  = 0.0D0
      DO 71 K = 1,NRY
  71  SUM=SUM+Y(K,I)*Z(K,J)
  70  X(I,J) = SUM
      RETURN
      END
 
      SUBROUTINE YY25(X,NRX,NCX)
      DOUBLE PRECISION X
      DIMENSION    X(NRX,  1)
      DO 1250 I=1,NRX
      DO 1250 J=1,NCX
 1250 X(I,J)=0.D0
      RETURN
      END
