CSECT   LSNEW
C     REVISED 4/2/73
 
      SUBROUTINE LSNEW (A,AC,LAMBDA,INDIC,ATEMP)
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
      common /tapes/  nouttp
      COMMON /CLASNO/ ISKIP(13),N
      COMMON /CNTRLS/ CTROLS(160)
      COMPLEX*16      TEMP
      COMPLEX*16      LAMBDA,SUMLAM,ERROR
      COMPLEX*16      AC
      DIMENSION       A(N,N),AC(N,N),LAMBDA(N),INDIC(N),ATEMP(N,1)
      DIMENSION       T(2)
      EQUIVALENCE    (TEMP,T(1))
 
C     'TMANTS' IS THE NUMBER OF BITS REPRESENTING THE MANTISSE
C     SEE DESCRIPTION OF THE PARAMETER 'T' IN SUBROUTINE 'EIGEN1'
C     IBM STANDARD (ORIGINAL): 56D0
 
      DATA TMANTS /55.D0/
 
CNOTE:  CALCULATE THE TRACE OF A, TRANSFER A MATRIX TO ATEMP
 
      DO 1 I=1,N
      DO 1 J=1,N
   1  ATEMP(I,J)=A(I,J)
      ATRACE = 0.0D0
      DO 210 I = 1,N
  210 ATRACE = ATRACE + A(I,I)
 
CNOTE         CALCULATE THE EIGENVALUES AND EIGENVECTORS
 
      NRDIM = N

      CALL EIGF1 (N,NRDIM,A,TMANTS,LAMBDA,AC,INDIC)

      EMAX=0.d0
      DO 47 K100=1,N
      IF (INDIC(K100)-1)41,42,45
c .lt.1:
   41 write (nouttp,444)
  444 FORMAT('0'/1X,120(1H*)/' EIGENVALUES NOT FOUND'/1X,120(1H*))
      print *,'LSNEW: eigenvalues not found'
      GO TO 3060
c .eq.1:
   42 write (nouttp,46)
   46 FORMAT('0'/1X,120(1H*)/' EIGENVECTOR NOT FOUND'/1X,120(1H*))
      print *,'LSNEW: eigenvector not found'
      GO TO 3060
c .gt.1:
   45 IF (CDABS(LAMBDA(K100)).GT. EMAX)  EMAX=CDABS(LAMBDA(K100))
   47 CONTINUE
      EMIN=EMAX*1.D-8
      IF (EMIN.EQ.0.D0)  EMIN=1.D0
      DO 55 K100=1,N
         RE=LAMBDA(K100)
         RMAG=CDABS(LAMBDA(K100))
         IF (RMAG.GE.EMIN .AND. RE.LT.0.d0)  GO TO 55
         IF (RMAG.LT.EMIN) then
            TEMP=LAMBDA(K100)
            T(1)=0.D0
            LAMBDA(K100) = TEMP
            go to 55
         end if
         WRITE (nouttp,654)  (I,LAMBDA(I),I=1,N)
  654    FORMAT (1X,I5,D15.6,D15.6)
         write (nouttp,656)
  656    FORMAT('0LSNEW: EIGENVALUE FOUND WITH POSITIVE REAL PART ')
         print *,'LSNEW: eigenvalue found with positive real part'
         GO TO 3060
   55 CONTINUE
      CALL CHECKS (AC,ATEMP,LAMBDA,ERROR)
 
CNOTE         PRINT SECTION
 
      IF (nint(CTROLS(77)).EQ.0)  RETURN
      WRITE (nouttp,501)
  501 FORMAT ('0LSNEW: COMPLEX EIGENVALUES')
      WRITE  (nouttp,502)
  502 FORMAT ('0    I     REAL             IMAGINARY       MAGNITUDE'/)
      DO 551 I=1,N
      RMAG=CDABS(LAMBDA(I))
  551 WRITE (nouttp,553) I,LAMBDA(I) ,RMAG
  553 FORMAT (1X,I5,2X,3(E13.5,4X))
      write (nouttp,971) ATRACE
  971 FORMAT ('0 ATRACE = ',D24.16)
 
C   CALCULATE THE SUM OF THE EIGENVALUES AND COMPARE WITH THE TRACE OF A
 
      SUMLAM=DCMPLX(0.D0,0.D0)
      DO 24 I=1,N
   24 SUMLAM=SUMLAM+LAMBDA(I)
      write (nouttp,972) SUMLAM
  972 FORMAT('0 EIGENVALUE SUM = ',2D24.16)
 
C   THE DETERMINANT OF A IS GIVEN BY THE PRODUCT OF THE EIGENVALUES.
C   TO AVOID OVERFLOW THE CALCULATION INVOLVES THE LOG10(DET(A))
 
      WRITE (nouttp,250) ERROR
  250 FORMAT ('0 WHEN COMPARING A*S WITH S*LAMBDA, THE WORST ERROR',
     *        ' OBTAINED WAS (',E12.5,1H,,E12.5,1H) )
      GO TO 3073
 
 3060 STOP 'LSNEW: simulation aborted'
 
 3073 RETURN
 
      END
