CSECT   OPINOT
C       13 APR 73
 
      SUBROUTINE OPINOT (NIV,H,X,G,S,XP,GP,T,GB,MSW)
 
C     ARGUMENT LIST
C
C     MSW- TYPE OF TERMINATION INDICATOR
C     MSW=1, CONVERGENCE IN LESS THAN OR EQUAL TO MAXIMUM NUMBER OF PASS
C     MSW=2, NO CONVERGENCE, MAXIMUM NUMBER OF PASSES EXHAUSTED
C     MSW=3, NO CONVERGENCE, FLOATING POINT OVERFLOW
C     MSW=4, INITIAL VALUES
C
C     H(NIV,NIV)- INVERSE HESSIAN MATRIX
C
C     X(NIV)=TRANSFORMED INDEPENDENT VARIABLES
C
C     G(NIV)- TRANSFORMED GRADIENT COMPONENT VECTOR
C
C     COMMON INFORMATION
C
C     IT- FINAL PASS NUMBER
C     MXPS- MAXIMUM NUMBER OF PASSES SPECIFIED
C     N- NUMBER OF INDEPENDENT VARIABLES
C     F- FINAL OBJECTIVE FUNCTION VALUE
C     DVNAM- OBJECTIVE FUNCTION NAME
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
      COMMON /ELNAMS/ ELS(1)
      COMMON /DPNAMS/ DPS(1)
      COMMON /GRADNT/ GD(1)
      COMMON /OPDVCM/ M,N,L,LS,M1,MS,NS,IT,GS,GSP,GTP,GSS,GTT,GSB,F,FP,
     *                FB,FO,E,P,TO,RS,SL,Z,Q,A,EL,DELTA,FAC,DVNAM,D,
     *                MXPS,IDV,K,ISW1,ISW2,IVSET
      COMMON /OPTIMA/ ISET(4,1)
      COMMON /OPTIMB/ DV(6,1)
      COMMON /OPTIMC/ IV(6,1)
      COMMON /IVBNDS/ B(3,1)
      COMMON /TAPES/  NOUTTP
 
      DOUBLE PRECISION NAME
      DIMENSION H(NIV,NIV),X(1),G(1)
      CHARACTER TERM(3)*32
 
      DATA TERM /
     1 'OPTIMIZATION RUN COMPLETED      ',
     2 'MAXIMUM PASSES EXCEEDED         ',
     3 'FLOATING POINT OVERFLOW         '/
 
      XFM(R,S,T)=R-S*COS(T)
 
      IF (MSW.GE.4) GO TO 300
      WRITE (NOUTTP,5000) TERM(MSW),DVNAM,F
      IF (MS.GT.0) WRITE (NOUTTP,5050) MS
      WRITE (NOUTTP,5100) IT,MXPS
      WRITE (NOUTTP,5200)
      LC=IVSET-1
      DO 100 I=1,N
      LB=LC+I
      L1=IV(5,LB)
      IF (IV(6,LB).EQ.4) GO TO 20
      NAME=ELS(L1)
      GO TO 30
   20 NAME=DPS(L1)
   30 VALUE=XFM(B(2,I),B(3,I),X(I))
      WRITE (NOUTTP,5300) NAME,VALUE,GD(I),X(I),G(I)
  100 CONTINUE
      IF (ISW1.EQ.0) GO TO 500
      WRITE (NOUTTP,5400)
      DO 200 I=1,N
  200 WRITE (NOUTTP,5500) I,(H(I,J),J=1,N)
      GO TO 500
  300 WRITE (NOUTTP,5600) DVNAM,N,K,FAC,E,P,D,DELTA
      WRITE (NOUTTP,5800)
      LC=IVSET-1
      DO 350 I=1,N
      LB=LC+I
      L1=IV(5,LB)
      IF(IV(6,LB).EQ.4) GO TO 320
      NAME=ELS(L1)
      GO TO 330
  320 NAME=DPS(L1)
  330 VALUE=XFM(B(2,I),B(3,I),X(I))
      BLOW=B(2,I)-B(3,I)
      BHI=B(2,I)+B(3,I)
      WRITE (NOUTTP,5300) NAME,VALUE,BLOW,BHI
  350 CONTINUE
  500 RETURN
 5000 FORMAT ('0____________________',/,
     *        '+OPTIMIZATION RESULTS:',//,
     *        '0TERMINATION CONDITION',24X,A,/,
     *        '0OBJECTIVE FUNCTION',27X,A6,/,
     *        '0VALUE OF OBJECTIVE FUNCTION AT TERMINATION',3X,1P,D15.8)
 5050 FORMAT ('0RANDOM STEP NUMBER',27X,I4)
 5100 FORMAT ('0OPTIMIZATION PASS COUNTER',20X,I4,/,
     *        '0MAXIMUM PASSES SPECIFIED',21X,I4,/)
 5200 FORMAT ('0__________________________________________'/,
     *        '+INDEPENDENT VARIABLE VALUES AT TERMINATION:',/,
     *        '0',33X,'GRADIENT',8X,'TRANSFORMED',7X,'TRANSFORMED',/,
     *        ' VARIABLE',7X,'VALUE',13X,'COMPONENT',6X,
     *        'VALUE (RADIANS)',5X,'GRADIENT',/)
 5300 FORMAT (' ',A6,2X,5(3X,1P,D15.8))
 5400 FORMAT ('0H(ERROR) MATRIX ',//)
 5500 FORMAT (1X,I4,'. ',8P,D15.8,/,(7X,8P,D15.8))
 5600 FORMAT ('1_________________________________________',/,
     *        '+INITIAL VALUES OF OPTIMIZATION PARAMETERS:',//,
     *        '0OBJECTIVE FUNCTION',18X,A6,/,
     *        '0NUMBER OF INDEPENDENT VARIABLES',5X,I4,/,
     *        '0NUMBER OF RANDOM STEPS',14X,I4,/,
     *        '0INITIAL H MATRIX FACTOR',12X,1P,D15.8,/,
     *        '0CONVERGENCE CRITERION',14X,1P,D15.8,/,
     *        '0RANDOM STEP SIZE CONTROL',11X,1P,D15.8,/,
     *        '0MINIMUM FUNCTION ESTIMATE',10X,1P,D15.8,/,
     *        '0H MATRIX DETERMINANT',15X,1P,D15.8,/)
 5800 FORMAT ('0_______________________________________',/,
     *        '+INITIAL VALUES OF INDEPENDENT VARIABLES:',//
     *        '0',14X,'NOMINAL',12X,'LOWER',13X,'UPPER',/,
     *        ' VARIABLE',7X,'VALUE',13X,'BOUND',13X,'BOUND',/)
 
      END
