CSECT   OPTIM
C      6 SEPT 73
 
      SUBROUTINE OPTIM (KWAY)
 
C     SUBROUTINE TO SET UP TEMPORARY STORAGE AND DRIVE OPTIMIZATION
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I-N)
 
      INTEGER         DV
      DOUBLE PRECISION IVNAM
      COMMON /CNTRLS/ CT(160)
      COMMON /ADJDAT/ NIS,NSST,NOPST
      COMMON /ELNAMS/ ELS(1)
      COMMON /DPNAMS/ DPS(1)
      COMMON /OPTIMA/ ISET(4,1)
      COMMON /OPTIMB/ DV(6,1)
      COMMON /OPTIMC/ IV(6,1)
      COMMON /IVBNDS/ B(3,1)
      COMMON /OPTEMP/ T(1)
      COMMON /OPDVCM/ IS1,N1,IS2(6),SKP1(10),E,P,SKP2(7),DELTA,FAC,
     *                DVNAM,FMINES,MXPS,IDV,K1,ISW1,ISW2,IVSET
      common /tapes/  nout
      DIMENSION       NZERO(59)
      EQUIVALENCE    (IS1,NZERO(1))
      EQUIVALENCE    (TEMP,T(1))
      CHARACTER*8     CENAM,CVNAM
      DOUBLE PRECISION ENAM,RVNAM
         EQUIVALENCE (CENAM,ENAM),(CVNAM,RVNAM)
      logical         lprint
 
      DATA NZ /59/
 
      lprint=(nint(ct(132)).gt.0)
 
C     LOOP OVER NUMBER OF SETS.

      DO 125 III=1,NOPST
 
C     N = NUMBER OF INDEPENDENT VARIABLES.
 
         N=ISET(4,III)
 
C     NDV = NUMBER OF DEPENDENT VARIABLES.
 
         NDV=ISET(2,III)
 
C     IVSET = BASE INDEX TO INDEPENDENT VARIABLES.
 
         IVSET=ISET(3,III)
 
C     CALCULATE STARTING INDICES FOR VARIOUS ARRAYS IN TEMPORARY
C     STORAGE.
 
         LL=N*N
         LX=LL+1
         LG=LX+N
         LS=LG+N
         LXP=LS+N
         LGP=LXP+N
         LT=LGP+N
         LGB=LT+N
         LZ=LGB+N-1
 
C     PACK INDEPENDENT VARIABLES AND BOUNDS IN IVBNDS COMMON.
 
         CALL BLOAD (IVSET,N,IV,NS)
 
C     SEE IF AND INDEPENDENT VARIABLES HAVE BOUNDS
 
         IF (NS.ge.N) then
            WRITE (NOUT,4) III
    4       FORMAT ('0OPTIMIZATION CALCULATION ON SET ',I4,
     *       ' TERMINATED DUE TO NO INDEPENDENT VARIABLE BOUNDS.'//)
            GO TO 125
         end if
 
C     TRANSFORM BOUNDS, TRANSFORM INITIAL (NOMINAL) INDEPENDENT
C     VARIABLE VECTOR, AND LIST OPTIMIZATION INDEPENDENT VARIABLE NAMES.
 
         IF (lprint) WRITE (NOUT,10)
   10    FORMAT (1H0,40X,
     *      'VECTOR  NOTATIONS  FOR  INDEPENDENT  VARIABLE  NAMES'//)
         LC=IVSET-1
         DO 50 I=1,N
            TEMP=0.5D0*(B(3,I)-B(2,I))
            B(2,I)=0.5D0*(B(3,I)+B(2,I))
            B(3,I)=TEMP
            IF (TEMP.ne.0.D0) then
               TEMP=(B(2,I)-B(1,I))/B(3,I)
               IF (TEMP.GT.1.D0) TEMP=1.D0
            end if
            B(1,I)=ACOS(TEMP)
            LB=LC+I
            L1=IV(5,LB)
            IF (IV(6,LB).EQ.4) then
               IVNAM=DPS(L1)
             else
               IVNAM=ELS(L1)
            end if
            IF (lprint) WRITE (NOUT,40) IVNAM,I
   40       FORMAT (1H ,58X,A6,4X,2HX(,I3,1H))
   50    CONTINUE
 
C     LOOP ON OPTIMIZATION DEPENDENT VARIABLES.
 
         LC=ISET(1,III)-1
         DO 120 II=1,NDV
 
C     RESTORE SAVED INITIAL VALUES TO VARIOUS COMMONS.
 
            CALL EPRST
 
C     ZERO OUT /OPTEMP/ AND /OPDVCM/ COMMONS.
 
            DO 55 J=1,LZ
   55       T(J)=0.D0
            DO 56 J=1,NZ
   56       NZERO(J)=0
            IDV=LC+II
 
C     SET INITIAL INDEPENDENT VARIABLE VECTOR IN TEMPORARY COMMON.
 
            DO 60 I=1,N
               L1=LL+I
   60       T(L1)=B(1,I)
 
C     SET VARIOUS PARAMETERS INTO OPTIMIZATION COMMON
 
            N1=N
            MXPS=nint(CT(131))
            ISW1=nint(CT(132))
            ISW2=nint(CT(133))
            E=CT(134)
            K1=nint(CT(135))
            P=CT(136)
            FAC=CT(137)
            FMINES=CT(138)
            DELTA=FAC**N
 
C     SET OBJECTIVE FUNCTION (THE DEPENDENT VARIABLE) NAME IN
C     OPTIMIZATION COMMON.
 
            L1=DV(1,IDV)
            L2=DV(2,IDV)
            ENAM=ELS(L1)
            CVNAM(2:)=CENAM(1:)
            GO TO (70,80,90,100),L2
   70       CVNAM(1:1)='V'
            DVNAM=RVNAM
            GO TO 110
   80       CVNAM(1:1)='I'
            DVNAM=RVNAM
            GO TO 110
   90       DVNAM=ENAM
            GO TO 110
  100       DVNAM=DPS(L1)
 
C     ENTER OPTIMIZATION SUBROUTINE.
 
  110       CALL OPDVDN 
     * (N,T(1),T(LX),T(LG),T(LS),T(LXP),T(LGP),T(LT),T(LGB),KWAY)
 
C     CHECK FOR DC SOLUTION FAILURE.
 
            IF (KWAY.NE.0) GO TO 130

  120    CONTINUE
  125 CONTINUE

  130 RETURN
 
      END
