CSECT   OUTP                            71.042  11.43.38
 
      SUBROUTINE OUTP (KWAY)
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
C KWAY: 0
C       1  optional termination
C       2  maximum integration passes exceeded
C       3  stop time execeeded (normal stop)
C       4  initial conditions only
C       5  operator request
C       6  solution time limit exceeded
C       7  TIME=TMAX (smaller minimum step size required)
C       8  re-outpu run
C       9  elapsed time limit exceeded
C      10  no DC solution convergence ?
C      11
C      12  XTBLFL .ne. 0. ?
 
      COMMON /TAPES/  NOUTTP,INTAPE,LIBTP,INOUTP,NEDITP,NSAVTP
      COMMON /CNTRLS/ TIME  ,XSTOPT,XMXERT,XIR   ,XTISSS,XMNISS,XMXISS,
     *                XMNAIE,XMXAIE,XIC   ,XRERNO,XMXPAS,XMNRIE,XMXRIE,
     *                XMNISO,XMXICP,XICRER,XICAER,XMXOTP,XXDIMS,XYDIMS,
     *                XICPAS,XNOPRQ,XNTNDX,XNHEAD,XNDFEQ,XERT,  XNRERN,
     *                XCNTNU,XSTPNO,XPASNO,XRUNNO,XSTPSZ,XTRANS,
     *                XSAVE,XTMON,XMXSLT,SKIP(2),XMCPUT,SKP(30),XAC,
     *                PIKS(11),XTBLFL
         DIMENSION    CNTRL(160)
         EQUIVALENCE (CNTRL,TIME)
      COMMON /BUFFRS/ BUFFER(3000)
         REAL         BUFFER
         COMPLEX      CBUF
         DIMENSION    CBUF(1500)
         EQUIVALENCE (CBUF(1),BUFFER(1))
      COMMON /HDCRDS/ HEADNG ( 9,11)
      COMMON /OUTPUT/ TPINDX(2)
      COMMON /OUTDTA/ OUTBFR(2)
         COMPLEX *16  OUTPAC
         DIMENSION    OUTPAC(1)
         EQUIVALENCE (OUTPAC(1),OUTBFR(1))
      COMMON /OUTPTS/ OTRQST(5,1)
 
      DIMENSION LOOKC(7),LOOKI(7)
      CHARACTER TERM (10)*40
      CHARACTER ROUTNE (4)*8
      CHARACTER CTNAME (7)*40
      CHARACTER ICTRAN (3)*20
      character wtime*8,wday*10
      real*8    rbegin(100),rlast(100)
      logical   lac,ltr,lic
 
      DATA TERM
     *  /'OPTIONAL TERMINATION CONDITION MET      ',
     *   'MAXIMUM INTEGRATION PASSES EXCEEDED     ',
     *   'STOP TIME EXCEEDED (NORMAL STOP)        ',
     *   'INITIAL CONDITIONS ONLY RUN COMPLETED   ',
     *   'MANUAL TERMINATION FROM CONSOLE         ',
     *   'COMPUTER TIME LIMIT EXCEEDED            ',
     *   'SMALLER MINIMUM STEP SIZE REQUIRED      ',
     *   'SOLUTION TIME LIMIT EXCEEDED            ',
     *   'CONVOLUTION UNIT BUFFER SIZE EXCEEDED   ',
     *   'AC  RUN TERMINATED                      '/
      DATA ROUTNE
     *  /'TRAP    ',
     *   'RUK     ',
     *   'XPO     ',
     *   'IMPLICIT'/
      DATA CTNAME
     *  /'XIR     INTEGRATION ROUTINE             ',
     *   'TIME    CURRENT SIMULATION TIME         ',
     *   'XSTPNO  INTEGRATION STEP COUNTER        ',
     *   'XPASNO  INTEGRATION PASS COUNTER        ',
     *   'XICPAS  NEWTON-RAPHSON PASS COUNTER     ',
     *   'XERT    COMPUTER (ELAPSED) TIME   (MIN):',
     *   'XMXSLT  SOLUTION (CPU) TIME       (SEC):'/
      DATA ICTRAN
     *  /'  INITIAL CONDITION ',
     *   '          TRANSIENT ',
     *   '                 AC '/

C     SENSE SWITCH SELECTOR

      DATA  LOOKC /4,3*2,1,3,5/,
     *      LOOKI /4,1,30,31,22,27,37/

      DATA NOUTAC /0/
      DATA NOUT   /0/
      data NGRPS  /0/
      DATA XSVTM  /0./

C VAX:DATA TMAX /Z'FFFFFFFFFFFF7FFF'/
C IBM:
CFTN77/386:      DATA TMAX /Z'7FFFFFFFFFFFFFFF'/
      DATA TMAX /1.d38/
 
      lac=nint(xac).ne.0
      lic=nint(xic).ne.0
      ltr=nint(xtrans).eq.0

      LWAY=0
      NORQST = nint(XNTNDX)
      XERT=CLOCKF(X)-XTMON
      TEMCPU=XMCPUT-RTIMER(X)
 
C     INITIAL CONDITION ONLY RUN
 
      IF ((lic).AND.(.not.ltr).AND.(.not.lac)) then
         LOOK=1
         KWAY=4
         GO TO 5678
      end if

      if (.not.lac) then

C     TIME = 'HIGH-VALUE'

         IF (TIME.eq.TMAX) then
            TIME=XLSTM
            KWAY=7
            GO TO 9090
         end if

         XLSTM=TIME
         XSTPNO=XSTPNO+1.d0
      end if
      NGRPS = NGRPS +1
 
C     LOAD OUTPUT REQUESTS INTO BUFFER
 
      nstpno = nint (xstpno)
      DO 9000 I=1,NORQST
      if (nstpno.eq.1) then
         rbegin(i)=outbfr(i)
       else
         rlast(i)=outbfr(i)
      end if
      IF (.not.lac) THEN
         NOUT=NOUT+1
         BUFFER(NOUT)= real(OUTBFR(I))
       ELSE
         NOUTAC=NOUTAC + 1
         CBUF(NOUTAC)= cmplx(OUTPAC(I))
      END IF
 9000 CONTINUE

C     CALL IMMEDIATE OUTPUT

      CALL INTPLT (nstpno)
 
C     STANDARD STOP CONDITIONS
 
      JWAY=KWAY
      IF (.not.lac) then
         IF (KWAY.NE.0)          KWAY=1
         IF (nint(XTBLFL).NE.0)  KWAY=12
         IF (XPASNO.GT.XMXPAS)   KWAY=2
         IF (TIME.GE.XSTOPT)     KWAY=3
      end if
      IF (KWAY.NE.0) GO TO 9090
 
C     SEE IF OPERATOR WANTS TO STOP THE RUN
 
      NTEST=0
      IF (NTEST.EQ.1) KWAY=5
 
CHANGE 1 ALLOW FOR ENOUGH CPU TIME FOR OUTPUTS. (8/20/69)
 
      IF(TEMCPU.ge.XMXSLT) then
         KWAY=6
         LWAY=8
      end if
 
C     COMPUTE ELAPSED COMPUTER TIME 
 
      IF (XERT.GT.XMXERT) KWAY=6
      
C     COMPUTER SAVE INTERVAL EXPIRED?
      
      IF ((XERT-XSVTM).gt.XSAVE) then
         call qqqdte (wday)
         call qqqclk (wtime)
         print *,'OUTP: save interval expired - ',wday,', ',wtime
         XSVTM=XERT
         KWAY=9
      end if
 
C     IS OUTPUT BUFFER FULL
 
      IF ((KWAY.eq.0)              .and.
     *   ((NOUT+NORQST).LE.3000)   .AND.
     *   ((NOUTAC+NORQST).LE.1500))     RETURN
 
C     OUTPUT BUFFER LOAD
 
 9090 IF ((NOUT+NOUTAC).ne.0) then
         WRITE (INOUTP) NGRPS
         IF (lac) then
            WRITE (INOUTP) (CBUF(M),M=1,NOUTAC)
            NOUTAC =0
          else
            WRITE (INOUTP) (BUFFER(M),M=1,NOUT)
            NOUT=0
         end if
      end if
      NGRPS=0

      IF (KWAY.eq.0 .or. KWAY.eq.9) return

      WRITE (INOUTP) Ngrps
      END FILE INOUTP
      REWIND INOUTP
      LOOK=2
      IF (lac) LOOK =3

C     SIGNAL IMMEDIATE OUTPUT 'END OF RUN'

      CALL INTPLT (0)
 
C     SPACE THE PAGE ON OUTPUT TAPE
 
 5678 CONTINUE
      call qqqdte (wday)
      call qqqclk (wtime)
      WRITE (NOUTTP,5555) ICTRAN(LOOK),wday,wtime
 5555 FORMAT('1',A,'SOLUTION CONTROLS AFTER SIMULATION',7x,a,' - ',a,
     &  /,'0')
      NHEADS=nint(XNHEAD)
      IF (NHEADS.GT.0)
     *  WRITE(NOUTTP,8030)((HEADNG(I,J),I=1, 9),J=1,NHEADS)
      NRERN=nint(XRUNNO)-1
      WRITE (NOUTTP,'(''0RUN/RERUN NUMBER'',17X,I7)') NRERN
      DO 5600 I=1,7
         IT=LOOKC(I)
         GO TO (5100,5100,5300,5000,5250),IT
 5000    IF (LOOK.NE.2) GO TO 5600
            INDEX=nint(CNTRL(4))
            WRITE (NOUTTP,5200) CTNAME(1)(9:40),ROUTNE(INDEX)
 5200       FORMAT (1H0,A,7X,A)
            GO TO 5600
 5250    WRITE (NOUTTP,5400) CTNAME(I)(9:40),TEMCPU
            GO TO 5600
 5100    IF (LOOK.NE.IT) GO TO 5600
 5300    INDEX=LOOKI(I)
            WRITE (NOUTTP,5400) CTNAME(I)(9:40),CNTRL(INDEX)
 5400       FORMAT(1H0,A,6X,1P,D14.7)
 5600 CONTINUE
      IF (LWAY.EQ.8.AND.KWAY.EQ.6) GO TO 5700
      LWAY=KWAY
      IF (KWAY.EQ.12) LWAY =9
      IF (lac) then
         WRITE (NOUTTP,1939) TERM(10)
		print 1939,term(10)
         go to 5722
      end if
 5700 WRITE (NOUTTP,1939) TERM(LWAY)
C     print 1939,term(lway)
 1939 FORMAT('0TERMINATION CONDITION   ',13X,A,//)
 5722 IF (KWAY.eq.1) then
         IWAY=IABS(JWAY)
         WRITE (NOUTTP,1940) IWAY
         IF (JWAY.LT.0) KWAY=11
 1940    FORMAT('0OPTIONAL TERMINATION CODE IS ',I3)
      end if

      if (look.eq.2) then
         write (nouttp,2002)
 2002    format (/,'0____________________________________________',/,
     *             '+INITIAL AND FINAL VALUES OF OUTPUT VARIABLES:',//)
         do 2001 i=1,norqst
            write (nouttp,2003) tpindx(i),rbegin(i),rlast(i)
 2003       format (1x,a,1p,2e17.5)
 2001    continue
      end if

      IF (KWAY.NE.4) RETURN
      IF (nint(XNOPRQ).EQ.0) RETURN
      WRITE (NOUTTP,8010)
 8010 FORMAT('0_________________________________________',/,
     *       '+RESULTS OF INITIAL CONDITION COMPUTATIONS',//)
      IF (nint(XRERNO).ne.0) then
         NRERN=nint(XRUNNO)-1
         WRITE (NOUTTP,8024) NRERN
 8024    FORMAT(' RERUN ',I6,/,1H0)
      end if
      NHEADS=nint(XNHEAD)
      IF (NHEADS.GT.0)
     *  WRITE(NOUTTP,8030)((HEADNG(I,J),I=1, 9),J=1,NHEADS)
 8030 FORMAT (1X,9A8)
      NOPRQ=nint(XNOPRQ)
      DO 8050 I=2,NORQST
         DO 8040 J=1,NOPRQ
            IF (OTRQST(1,J).NE.TPINDX(I)) GO TO 8040
            TEMP=OTRQST(2,J)
            GO TO 8050
 8040    IF (OTRQST(3,J).EQ.TPINDX(I)) GO TO 8045
 8045    TEMP=OTRQST(4,J)
 8050 WRITE (NOUTTP,8020) TEMP,OUTBFR(I)
 8020 FORMAT(1H0,A8,5X,1P,D14.7)
      RETURN
 
      END
