CSECT   PLTSCL                          71.042  11.43.38
 
      SUBROUTINE PLTSCL (YMAX, YMIN, GMIN, DY, LINES)
 
      common /tapes/  nouttp
 
      YLINES=LINES
      TDY=(YMAX-YMIN)/YLINES
 
C     THIS IS A MAGNITUDE PLOT.  DETERMINE THE RANGE, AND THEN DETERMINE
C     THE MINIMUM AS AN INTEGER MULTIPLE OF 1/10 TH OF THE TOTAL
C     PLOT RANGE.
 
      IF (TDY) 101,101,102
 
C     YMAX AND YMIN ARE EQUAL. SET SCALE SO GRAPH WILL BE THE CENTER
C     LINE OF THE PLOT, AND RETURN.
 
  101 GMIN=YMIN-.5
      DY=.01
      RETURN
 
C     INCREASE GRAPH RANGE BY FACTORS OF 10 UNTIL THE GRAPH WILL FIT
C     ON THE PAGE.
 
  102 DO 110 K=1,61
      DY1=10.0**(K-31)
      IF (DY1-TDY) 110,111,112
  111 LSV=10
      DY1=DY1/10.0
      DY=TDY
      GO TO 129
 
C     BACK OFF BY A FACTOR OF 10.
 
  112 DY1=DY1/10.0
      GO TO 119
  110 CONTINUE
 
C     INCREASE GRAPH RANGE BY INTEGER FACTORS UNTIL THE GRAPH WILL
C        AGAIN FIT ON THE PAGE.
 
  119 DO 120 L=2,10
      DY=FLOAT(L)*DY1
      IF (DY-TDY) 120,120,121
  121 LSV=L
      GO TO 129
  120 CONTINUE
  129 IF (YMAX) 151,152,151
  152 GMIN=-YLINES*DY
      RETURN
 
  151 IF (YMIN .GT. 1.E8 * DY .OR. YMAX .LT. -1.E8 * DY) GO TO 160
      IF (YMIN .GT. -2.*DY .AND. YMIN .LT. 0.) GO TO 170
  155 IF (YMIN) 126,127,128
  127 GMIN=0.
      RETURN
 
C     'TENLNS' IS THE INCREMENT PER 10 PRINTER LINES ON THE PLOT. TO
C     MAKE THE SCALE EASIER TO INTERPRET, THE MIN FOR THE PLOT WILL BE
C     CHOSEN AS AN INTEGER MULTIPLE OF 'TENLNS'.
C     YMIN IS NEGATIVE. DIVIDE YMIN BY TENLNS TO FIND OUT HOW MANY
C     MULTIPLES OF TENLNS ARE CONTAINED IN YMIN. TRUNCATE THIS TO AN
C     INTEGER, AND SUBTRACT 1 FROM IT SO THAT THE PLOT MIN WILL BE
C     LESS THAN YMIN.
 
  126 TENLNS = 10.0 * DY
      MULTP = IFIX(YMIN/TENLNS) - 1
      GMIN = FLOAT(MULTP) * TENLNS
      GO TO 180
 
C     YMIN IS POSITIVE. DIVIDE YMIN BY TENLNS TO FIND OUT HOW MANY
C     MULTILPLES OF TENLNS ARE CONTAINED IN YMIN. TRUNCATE THIS TO AN
C     INTEGER, AND USE THIS INTEGER MULTIPLE OF TENLNS AS THE PLOT MIN
 
  128 TENLNS = 10.0 * DY
      MULTP = IFIX(YMIN/TENLNS)
      GMIN = FLOAT(MULTP) * TENLNS
      GO TO 180
  160 WRITE (nouttp,165)
  165 FORMAT ('0A TRACE ON ONE OF THE PLOTS IS DISPLACED FROM ZERO BY',
     *        ' MORE THAN 10**6 TIMES ITS TOTAL RANGE.',/
     *        '0    LOSS OF SIGNIFICANCE IS POSSIBLE IN THESE RESULTS.')
      GMIN = YMIN
      RETURN
 
  170 GMIN = 0.
      RETURN
 
C     WILL THE PLOT STILL FIT ON THE PAGE...
 
  180 IF (GMIN + YLINES * DY .LT. YMAX) GO TO 190
 
C     YES. RETURN TO PRPLT PROGRAM.
 
      RETURN
 
C     NO. INCREASE LSV -THE INTEGER MULTIPLIER- BY 1, AND RECALCULATE
C     DY. ALSO, RECALCULATE GMIN SO THAT IT WILL BE AN INTEGER MUL-
C     TIPLE OF 10 TIMES DY (THIS MAKES THE PLOT EASIER TO READ).
 
  190 IF (LSV - 10) 191,191,192
  191 LSV = LSV + 1
      GO TO 195
  192 LSV = 1
      DY1 = DY1 * 10.0
  195 DY = FLOAT(LSV) * DY1
      GO TO 155
 
      END
