CSECT   RIBMUX
 
      SUBROUTINE RIBMUX(X,IXZERO,NRX,NCX,Y,IYZERO,IYTRNS,IYDIAG,NRY,NCY,
     *                                   Z,IZZERO,IZTRNS,IZDIAG,NRZ,NCZ)
 
C     THIS SUBROUTINE CALCULATES THE FOLLOWING MATRIX PRODUCTS
C     WHERE THE RIGHT HAND SIDE INVOLVES AN INTEGER*2 B-MATRIX
C                  CASE 6    X = Y *Z
C                  CASE 8    X = Y *ZT
C     SEE MXMULT FOR THE DEFINITIONS OF THE ARGUMENTS USED
 
      DOUBLE PRECISION X,Y
 
      common /tapes/  nouttp
 
      INTEGER*2    Z
      DIMENSION    X(1,  1),Y(1,  1),Z(1,  1)
 
      IYT = IYTRNS
      IYD = IYDIAG
      IZT = IZTRNS
      IZD = IZDIAG
 
C     IF EITHER MATRIX Y OR Z IS ZERO, THEN SET IXZERO TO ZERO & RETURN
 
      IF(IYZERO.EQ.0.OR.IZZERO.EQ.0) GO TO 1000
      IXZERO=1
 
C     TEST TO SEE WHICH CASE IS REQUIRED
 
      IF(IYT.EQ.0.AND.IYD.EQ.0.AND.IZT.EQ.0.AND.IZD.EQ.0) GO TO 6
      IF(IYT.EQ.0.AND.IYD.EQ.0.AND.IZT.EQ.1.AND.IZD.EQ.0) GO TO 8
 
C     WRITE AN ERROR MESSAGE IF THIS POINT REACHED
 
      write (nouttp,13)
   13 FORMAT (1X,' ILLEGAL CALL TO SUBROUTINE MXMULT...CHECK THE FOUR ',
     * 'ARGUMENTS IYTRNS,IYDIAG,IZTRNS,IZDIAG IN THE CALLING SEQUENCE ')
      STOP 'RIBMUX: illegal call to this subroutine; abnormal end'
 
C     CASE 6       X = Y *Z
 
    6 CALL YY60(X,NRX,NCX,Y,NRY,NCY,Z,NRZ,NCZ)
      GO TO 2000
 
C     CASE 8       X = Y *ZT
 
    8 CALL YY61(X,NRX,NCX,Y,NRY,NCY,Z,NRZ,NCZ)
      GO TO 2000
 
 1000 IXZERO=0
      IF (IYT.EQ.1  .AND.  IZT.EQ.0 )  GO TO 1110
      IF ( IYT.EQ.0 .AND. IZT.EQ.1 ) GO TO 1120
      IF ( IYT.EQ.1 .AND.  IZT.EQ.1 ) GO TO 1130
 
C     IYT=0,IZT=0
 
      NRX=NRY
      NCX=NCZ
      GO TO 1200
 1110 NRX=NCY
      NCX=NCZ
      GO TO 1200
 1120 NRX=NRY
      NCX=NRZ
      GO TO 1200
 1130 NRX=NCY
      NCX=NRZ
 1200 IF (NRX.EQ.0 .OR. NCX.EQ.0 )  GO TO 2000
      DO 1250 I=1,NRX
      DO 1250 J=1,NCX
 1250 X(I,J)=0.D0
 2000 CONTINUE
      RETURN
 
      END
 
