CSECT   SIMDC
C       2 MAY 73   (WNR)
      SUBROUTINE SIMDC (KWAY)
 
C     SUBROUTINE TO CALCULATE A DC SOLUTION VIA IMPLICIT INTEGRATION
 
      IMPLICIT DOUBLE PRECISION (A-H,J,L-M,O-Z), INTEGER (K,I,N)
 
      DOUBLE PRECISION I
      COMMON /CNTRLS/ CTROL(160)
         EQUIVALENCE (CTROL(55),XTRNIC),(CTROL(142),XADJ)
      COMMON /SAVEDC/ SAVDC(1)
      COMMON /SAVEIC/ C(1)
      COMMON /SAVICT/ T(1)
      COMMON /VOLTGS/ V(1)
      COMMON /CURNTS/ I(1)
      COMMON /PRMTRS/ P(1)
      COMMON /DERIVS/ D(1)
      COMMON /ELNAMS/ ELS(1)
      COMMON /DPNAMS/ DPS(1)
      DIMENSION       NC(20)
         EQUIVALENCE (NC(6),NCL1C),(NC(8),NCL3C),(NC(3),NCL4C),
     .               (NC(5),NCL6C),(NC(19),NDPD)
      EQUIVALENCE (I3DC,N3),(I4DC,N4),(I6DC,N6),(IPDC,NP)
 
      DATA I1DC /1/
 
      IF (nint(CTROL(113)).NE.0) GO TO 20
      CTROL(113)=1.D0
      DO 10 N=1,20
   10 NC(N)=nint(CTROL(N+90))
      N3=NC(6)+1
      N4=NC(8)+N3
      N6=NC(3)+N4
      NP=NC(5)+N6
      K4=NC(1)+NC(2)+1
      K6=NC(3)+NC(4)+K4
      K1=NC(5)+K6
      K3=NC(6)+NC(7)+K1
      K4D=NC(8)+1
      KPD=NC(3)+K4D
 
C     IS 'RUN IC BY IMPLICIT'
 
   20 IF (nint(XTRNIC).EQ.0) GO TO 400
 
C     'RUN IC VIA IMPLICIT'
C     IS THIS AN ADJOINT CALCULATION
 
      IF (nint(XADJ).NE.0) GO TO 30
 
C     RESTORE INITIAL VALUES FOR DC SOLUTION
 
      CALL XLOAD ( SAVDC(I1DC), T(I1DC), V(K1), NCL1C,
     .             SAVDC(I3DC), T(I3DC), I(K3), NCL3C,
     .             SAVDC(I4DC), T(I4DC), V(K4), NCL4C,
     .             SAVDC(I6DC), T(I6DC), I(K6), NCL6C,
     .             SAVDC(IPDC), T(IPDC), P(1),  NDPD,  4,NWAY)
 
C     DC SOLUTION,  VIA IMPLICIT
 
   30 CALL SIMTR (KWAY,0)
      CTROL(114)=1.D0
      CALL TRANIC (I(K3),D(1),ELS(K3),NC(8),V(K4),D(K4D),ELS(K4),NC(3),
     *            P(1),D(KPD),DPS(1),NC(19),KWAY)
      IF (KWAY.NE.0) GO TO 40
 
C     DC PRINTING,  IF REQUESTED
 
      CALL OUTIC (NC(3),ELS(K4),V(K4),NC(8),ELS(K3),I(K3),NC(19),
     *            DPS(1),P(1))
      CTROL(114)=0.D0
   40 RETURN
 
C     RUN IC BY 'SIMIC'
C     IS THIS AN ADJOINT CALCULATION
 
  400 IF (nint(XADJ).NE.0) GO TO 460
 
C     RESTORE INITIAL CAPACITOR VOLTAGES AND INDUCTOR CURRENTS FOR
C     'SIMIC' CALCULATION
 
      CALL XLOAD ( SAVDC(I1DC),T(I1DC),V(K1),NCL1C,
     .             SAVDC(I3DC),T(I3DC),I(K3),NCL3C,
     .             SAVDC(I4DC),T(I4DC),V(K4),NCL4C,
     .             SAVDC(I6DC),T(I6DC),I(K6),NCL6C,
     .             SAVDC(IPDC),T(IPDC),P(1),NDPD,  4,NWAY)
 
C     INITIAL CONDITIONS SOLUTION
 
  460 CALL SIMIC (KWAY)
  600 RETURN
 
      END
