CSECT   WORST
C     MAY 9, 1973
 
      SUBROUTINE WORST(KWAY)
 
C     SUBROUTINE WORST, TO SET UP WORST CASE CALCULATIONS
C
C     NWCSTS = NUMBER OF WORST CASE SETS (OF INDEPENDENT VARIABLES)
C
C     KWCSTS(4,NWCSTS) - WORST CASE SET TABLE
C     KWCSTS(1,I) = INDEX TO OBJECTIVE FUNCTION TABLE 'KWCDEP'
C     KWCSTS(2,I) = NUMBER OF OBJECTIVE FUNCTIONS FOR SET 'I'
C     KWCSTS(3,I) = INDEX TO INDEPENDENT VARIABLE TABLE 'KWCIND'
C     KWCSTS(4,I) = NUMBER OF INDEPENDENT VARIABLES FOR SET 'I'
C
C     KWCDEP(4,NDEP)-OBJECTIVE FUNCTION TABLE
C     KWCDEP(1,I)=INDEX TO OBJECTIVE FUNCTION NAME IN NAMES TABLE
C     KWCDEP(2,I)=FUNCTION TYPE  1=VOLTAGE,2=CURRENT,3=VALUE,4=DEF PARAM
C     KWCDEP(3,I)=INDEX TO LIST OF ADJOINT SOURCES 'KASRC'
C     KWCDEP(4,I)=LENGTH OF ADJOINT SOURCE LIST FOR OBJ. FCN. 'I'
C     KWCDEP(5,I)=INDEX TO DEFINDE PARAMETER DEFFERENTIAL CONTRIBUTIONS
C     KXCDEP(5,I)=LINGTH OF DIFFERENTIAL CONTRIBUTIONS
C
C     KWCIND(6,NIND)-INDEPENDENT VARIABLE TABLE
C     KWCIND(1,I)=PLACE TO MONITOR IN INITIAL CONDITIONS CALCULATION
C     KWCIND(2,I)=SYSTEM FUNCTION (1=VOLT,2=CURRENT,3=VALUE)
C     KWCIND(3,I)=PLACE TO MONITOR IN ADJOINT CALCULATION
C     KWCIND(4,I)=SYSTEM FUNCTION (1=VOLT,2=CURRENT,3=VALUE)
C     KWCIND(5,I)=INDEX TO INDEP. VARIABLE IN ELEMENT OR DEF. PAR. TABLE
C     KWCIND(6,I)=TYPE (3=ELEMENT, 4=DEFINED PARAMETER)
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
      COMMON /ADJDAT/ NIS,NSETS,NOPSTS,NWCSTS
      COMMON /CNTRLS/ CTRLS(160)
      COMMON /DPNAMS/ DPS(1)
      COMMON /ELNAMS/ ELNAMS(1)
      COMMON /GRADNT/ GRDNT(1)
      COMMON /WSTCA/  KWCSTS(4,1)
      COMMON /WSTCB/  KWCDEP(6,1)
      COMMON /WSTCC/  KWCIND(6,1)
      COMMON /NAMES/  VAL(1)
      COMMON /PRMTRS/ PRAMTR(1)
      COMMON /IVBNDS/ BOUNDS(3,1)
      COMMON /VOLTGS/ VLTS(1)
      COMMON /CURNTS/ CUR(1)
      COMMON /OPTEMP/ U(1)
      COMMON /TAPES/  NOUTTP
         EQUIVALENCE (CTRLS(143),XSTORD),(CTRLS(144),XRESET),
     *               (CTRLS(151),XWCLHN),(XTRNIC,CTRLS(55)),
     *               (XICPRT,CTRLS(115)),(XICDBG,CTRLS(116)),
     *               (DLOW,DIST(1)),(DHIGH,DIST(2)),
     *               (ILOW,IBND(1)),(IHIGH,IBND(2))
      DIMENSION       TYPE(3),DIST(2),NSEQV(3),IBND(2),TBND(2)
      DIMENSION       PBOUND(4),PBUF(4)
      CHARACTER*1     SFN(4)
 
      DATA SFN /'V','I',' ',' '/
      DATA TYPE/8H     LOW,8H    HIGH,8H NOMINAL/,NSEQV(1)/3/
      DATA PBOUND /8HLOWER BO,3HUND,8HUPPER BO,3HUND/
      DATA BLANK /8H        /
      DATA TBND/5HLOWER,5HUPPER/
 
C     TURN OFF NORMAL IC OUTPUT UNLESS IC DEBUG REQUESTED
 
      XICPRT = 1.D0
      IF (nint(XICDBG) .NE. 0) XICPRT = 0.D0
 
C     TURN RESET INDICATOR ON SO 'ADJNT' WILL RESET
 
      XRESET = 0.D0
      DO 1000 ISET = 1,NWCSTS
      IDEP = KWCSTS(1,ISET)
      NDEP = KWCSTS(2,ISET)
 
C     CHECK OBJECTIVE FUNCTIONS
 
      IF (NDEP .LT. 1) GO TO 1100
      ISTOP=IDEP+NDEP-1
      INDPV = KWCSTS(3,ISET)
      NINDV = KWCSTS(4,ISET)
 
C     CHECK INDEPENDENT VARIABLES
 
      IF (NINDV .LT. 1) GO TO 1200
 
C     LOAD BOUNDS AREA FOR CURRENT SET OF INDEPENDENT VARIABLES
 
      CALL BLOAD (INDPV,NINDV,KWCIND,NS)
 
C     CHECK FOR VALID INDEPENDENT VAIABLES
 
      IF (NS.EQ.0) GO TO 180
      WRITE (NOUTTP,4400) ISET
      GO TO 1000
 4400 FORMAT('0WORST CASE CALCULATION ON SET ',I4,
     *       ' TERMINATED DUE TO INDEPENDENT VARIABLES WITHOUT',
     *       ' BOUNDS.'//)
 
C     ASSUME LOW VALUES USED FIRST
 
  180 NSEQV(2) = 1
 
C     REVERSE IF USER REQUESTED
 
      IF (nint(XWCLHN) .GT. 1) NSEQV(2) = 2
 
      NSEQV(3) = 3 - NSEQV(2)
      DO 900 IDX=IDEP,ISTOP
      WRITE (NOUTTP,4410)
 4410 FORMAT ('1______________________')
 
C     GET OBJECTIVE FUNCTION NAME
 
      IX=KWCDEP(1,IDX)
      IY=KWCDEP(2,IDX)
      WRIT1=ELNAMS(IX)
      IF (IY.EQ.4) WRIT1=DPS(IX)
 
C     RESTORE NOMINAL VALUES PRIOR TO RUNNING EACH OBJECTIVE FUNCTION
 
      CALL EPRST
      DO 190 KP=1,4
  190 PBUF(KP)=PBOUND(KP)
      DO 800 K = 1,3
 
C     NSEQ INDICATES VALUES BEING USED - 1 = LOW, 2 = HIGH, 3 = NOMINAL
 
      NSEQ = NSEQV(K)
      WRITE (NOUTTP,4500) TYPE(NSEQ)
 4500 FORMAT (26H+WORST CASE COMPUTATION -  ,A8,6H VALUE)
      IF (K .EQ. 1) GO TO 280
 
C     SELECT VALUES USING SIGNED DISTANCE
C      (INDICATES MAGNITUDE AND SENSE ALONG GRADIENT)
 
      CALL WCSET (INDPV,NINDV,DIST(NSEQ))
 
C     DC SOLUTION - TURN OFF ERROR INDICATOR
 
      KWAY = 0
      CALL SIMDC (KWAY)
 
C     CHECK FOR NORMAL RETURN - ERROR RETURN IF NOT
 
      IF (KWAY.NE.0) GO TO 1300
  280 GO TO (300,320,340,360),IY
  300 WRIT3 = VLTS(IX)
      GO TO 380
  320 WRIT3 = CUR(IX)
      GO TO 380
  340 WRIT3 = VAL(IX)
      GO TO 380
  360 WRIT3 = PRAMTR(IX)
  380 WRITE (NOUTTP,4510) SFN(IY),WRIT1,WRIT3
 4510 FORMAT ('0OBJECTIVE FUNCTION ',A1,A6,' = ',1P,E15.8)
 
C     COMPUTE GRADIENT
 
      CALL ADJNT (KWCDEP(3,IDX),NINDV,KWCIND(1,INDPV),KWAY)
 
C     CHECK FOR NORMAL RETURN - ERROR RETURN IF NOT
 
      IF (KWAY .NE. 0) GO TO 1400
      IZZ=INDPV-1
      G2 = 0.D0
      WRITE (NOUTTP,4520) PBUF
 4520 FORMAT ('0INDEPENDENT VARIABLE',8X,'VALUE',8X,
     *       'GRADIENT COMPONENT',6X,A8,A3,9X,A8,A3/)
      DO 500 IG = 1,NINDV
      G2 = G2 + GRDNT(IG)**2
      IZZ=IZZ+1
      IZ=KWCIND(5,IZZ)
      JZ=KWCIND(6,IZZ)
      IF (JZ .EQ. 4) GO TO 400
      WRIT2 = ELNAMS(IZ)
      WRIT4 = VAL(IZ)
      GO TO 420
  400 WRIT2 = DPS(IZ)
      WRIT4 = PRAMTR(IZ)
  420 IF (K.GT.1) GO TO 440
      WRITE (NOUTTP,4530) 
     *      WRIT2,WRIT4,GRDNT(IG),BOUNDS(2,IG),BOUNDS(3,IG)
      GO TO 500
  440 WRITE (NOUTTP,4530) WRIT2,WRIT4,GRDNT(IG)
 4530 FORMAT (8X,A6,10X,1P,E15.8,5X,E15.8,2(5X,1P,E15.8))
  500 CONTINUE
      WRITE (NOUTTP,4545)
 4545 FORMAT (1H0,/)
 
C     CHECK FOR ZERO GRADIENT
 
      IF (G2 .GT. 0.D0) GO TO 520
      WRITE (NOUTTP,4950) TYPE(NSEQ)
 4950 FORMAT ('1 ',A8,' VALUE ZERO LENGTH GRADIENT ')
      IF (K .EQ. 1) GO TO 1500
  520 IF (K .GT. 1) GO TO 800
      DHIGH = 1.D10
      DLOW = - 1.D10
      ILOW = 0
      IHIGH = 0
 
C     DHIGH WILL BE SET TO DISTANCE FROM NOMINAL POINT TO
C     NEAREST BOUNDARY SURFACE IN DIRECTION OF GRADIENT
C
C     DLOW WILL BE SET TO NEGATIVE OF CORRESPONDING DISTANCE
C     IN DIRECTION OPPOSITE TO GRADIENT
 
      GMAG = SQRT(G2)
      DO 700 I = 1,NINDV
      U(I) = GRDNT(I)/GMAG
      IF (U(I)) 620,700,640
  620 IS = - I
      DH = (BOUNDS(2,I) - BOUNDS(1,I))/U(I)
      DL = (BOUNDS(3,I) - BOUNDS(1,I))/U(I)
      GO TO 660
  640 IS = I
      DH = (BOUNDS(3,I) - BOUNDS(1,I))/U(I)
      DL = (BOUNDS(2,I) - BOUNDS(1,I))/U(I)
  660 IF (DH .GE. DHIGH) GO TO 680
      IHIGH = IS
      DHIGH = DH
  680 IF (DL .LE. DLOW) GO TO 700
      ILOW = IS
      DLOW = DL
  700 CONTINUE
      IF ((ILOW .EQ. 0) .OR. (IHIGH .EQ. 0)) GO TO 1600
      DO 760 I = 1,2
 
C     SELECT INDEPENDENT VARIABLE WHOSE BOUND GIVES LOW/HIGH VALUE
 
      IB = IBND(I)
 
C     SELECT LOWER/UPPER BOUND OF THIS VARIABLE AS APPROPRIATE
 
      IT = 1
      IF (((I .EQ. 1) .AND. (IB .LT. 0)) .OR.
     *    ((I .EQ. 2) .AND. (IB .GT. 0))) IT = 2
      JB = ABS(IB)
      IZ = KWCIND(5,JB)
      JZ = KWCIND(6,JB)
      IF (JZ .EQ. 4) GO TO 720
      WRIT2 = ELNAMS(IZ)
      GO TO 740
  720 WRIT2 = DPS(IZ)
  740 WRITE (NOUTTP,4550)
     *      TYPE(I),DIST(I),TBND(IT),BOUNDS(IT + 1,JB),WRIT2
 4550 FORMAT(1H ,A8,
     *       ' VALUE LOCATED AT DISTANCE ',1P,E15.8,
     *       ' ALONG GRADIENT = ',A5,
     *       ' BOUND ',E15.8,
     *       ' OF INDEPENDENT VARIABLE ',A6/)
  760 CONTINUE
      WRITE (NOUTTP,4545)
      DO 780 KP=1,4
  780 PBUF(KP)=BLANK
  800 CONTINUE
 
C     RESTORE NOMINAL VALUES BEFORE RETURN IF USER REQUESTED
 
      IF ((IDX .EQ. ISTOP) .AND. (ISET .EQ. NWCSTS) .AND.
     * (nint(XWCLHN) .EQ. 3)) CALL EPRST
  900 CONTINUE
 1000 CONTINUE
      GO TO 6000
 1100 WRITE (NOUTTP,4910)
 4910 FORMAT ('1NO OBJECTIVE FUNCTION SPECIFIED')
      GO TO 6000
 1200 WRITE (NOUTTP,4920)
 4920 FORMAT ('1NO INDEPENDENT VARIABLE SPECIFIED')
      GO TO 6000
 1300 WRITE (NOUTTP,4930)TYPE(NSEQ)
 4930 FORMAT ('1 ',A8,' VALUE INITIAL CONDITIONS FAILURE')
      WRITE (NOUTTP,4540)
 4540 FORMAT ('0INDEPENDENT VARIABLE',8X,'VALUE',/)
      IZZ = INDPV - 1
      DO 1360 IG  = 1,NINDV
      IZZ = IZZ + 1
      IZ = KWCIND(5,IZZ)
      JZ = KWCIND(6,IZZ)
      IF (JZ .EQ. 4) GO TO 1320
      WRIT2 = ELNAMS(IZ)
      WRIT4 = VAL(IZ)
      GO TO 1340
 1320 WRIT2 = DPS(IZ)
      WRIT4 = PRAMTR(IZ)
 1340 WRITE (NOUTTP,4530)WRIT2,WRIT4
 1360 CONTINUE
      GO TO 5000
 1400 WRITE (NOUTTP,4940)TYPE(NSEQ)
 4940 FORMAT ('1 ',A8,' VALUE ADJOINT FAILURE')
      GO TO 6000
 1500 WRITE (NOUTTP,4900)
 4900 FORMAT ('0ERROR EXIT FROM WORST CASE CALCULATION')
      GO TO 6000
 1600 WRITE (NOUTTP,4960)
 4960 FORMAT ('0FAILURE IN BOUNDING VALUE SELECTION PROCESS')
      WRITE (NOUTTP,4570)
 4570 FORMAT ('0INDEPENDENT VARIABLE',2X,'DIRECTION COSINE',/)
      IZZ = INDPV - 1
      DO 1660 IG  = 1,NINDV
      IZZ = IZZ + 1
      IZ = KWCIND(5,IZZ)
      JZ = KWCIND(6,IZZ)
      IF (JZ .EQ. 4) GO TO 1620
      WRIT2 = ELNAMS(IZ)
      GO TO 1640
 1620 WRIT2 = DPS(IZ)
 1640 WRITE (NOUTTP,4530)WRIT2,U(IG)
 1660 CONTINUE
 5000 CALL EPRST
 6000 CONTINUE
 
C     TURN ON NORMAL IC OUTPUT
 
      XICPRT = 0.D0
      RETURN
 
      END
