CSECT   XLOAD                           72.110  00.39.08
 
      SUBROUTINE XLOAD (V1IC,V1ICT,V1,NCL1C,I3IC,I3ICT,I3,NCL3C,V4IC,
     * V4ICT,V4,NCL4C,I6IC,I6ICT,I6,NCL6C,XPIC,XPICT,P,NDPD,NCTRL,NWAY)
 
C     THIS SUBROUTINE WILL LOAD THE COMPUTED INITIAL CONDITIONS INTO THE
C       SAVE AREA FOR A CONTINUE RUN OR LOAD THE SAVED I/C VALUES INTO
C         THE TRANSIENT AREA FOR A RERUN IN WHICH A NEW SET OF I/C
C           VALUES IS NOT REQUESTED.
C
C     IF AN I/C SOLUTION IS NOT REQUESTED AND THIS IS THE ORIGINAL RUN
C       OR THIS IS SECOND ENTRY INTO SUBROUTINE AFTER AN I/C SOLUTION
C         HAS BEEN OBTAINED, THE TRANSIENT VALUES ARE LOADED INTO THE
C           I/C SAVE AREA.
C
C     VNIC OR INIC--SAVE AREA FOR C AND L CLASSES.
C     VNICT OR INICT--AREA WITH LAST COMPUTED VALUES.
C     VN OR IN--AREA FOR TRANSIENT VALUES.
C     NCLNC--NUMBER OF ENTRIES IN EACH (TRANSIENT) CLASS.
C     NWAY NOT EQUAL TO ZERO IMPLIES THAT NO I/C SOLUTION IS REQUIRED.
C     NCTRL EQUAL TO TWO IMPLIES THAT I/C VALUES MUST BE LOADED FROM THE
C       TRANSIENT AREA INTO THE SAVE AREA AS SUPPLIED BY THE USER WHEN
C         NO I/C SOLUTION IS REQUIRED.
C
C     LOAD SUBROUTINE    JERRY PATTERSON    6/1/66

C 94.160:      *               (CTRL(86),CNVRQS),
C		if (nint(CNVRQS).ne.0) FCVY=FCONVY (1.D0,0.D0)
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
      DOUBLE PRECISION  I3IC,I3ICT,I3,I6IC,I6ICT,I6
      DOUBLE PRECISION  MCRQST
      COMMON /CNTRLS/ CTRL(151)
         EQUIVALENCE (CTRL(10),XIC),(CTRL(29),XCNTNU),
     *               (CTRL(32),XRUNNO),(CTRL(34),XIR),
     *               (CTRL(53),XSAVIC),(CTRL(55),XTRNIC),
     *               (CTRL(86),CNVRQS),
     *               (CTRL(121),MCRQST),(CTRL(131),OPRQST),
     *               (CTRL(151),WCRQ)
      DIMENSION      V1IC(2),V1ICT(2),V1(2),I3IC(2),I3ICT(2),I3(2),
     *               V4IC(2),V4ICT(2),V4(2),I6IC(2),I6ICT(2),I6(2)
      DIMENSION      XPIC(2),XPICT(2),P(2)
 
      NWAY=0
      NDP=NDPD
      IF (nint(XTRNIC).EQ.0) NDP=0
      U1=MCRQST+OPRQST+WCRQ
 
C     IS THIS SAVE INITIAL VALUES FOR DC OPTIONS
 
      IF (NCTRL.NE.3) GO TO 2
      IF (nint(U1).EQ.0) RETURN
      GO TO 90
 
C     IS THIS RESTORE INITIAL VALUES FOR DC OPTIONS
 
    2 IF (NCTRL.NE.4) GO TO 4
      IF (nint(U1).EQ.0) RETURN
      GO TO 54
    4 IF (NCTRL .NE. 0) GO TO 87
 
C     LOAD COMPUTED INITIAL CONDITIONS INTO SAVE AREA IF CONTINUE RUN
 
      IF (nint(XCNTNU).EQ.0) GO TO 50

      if (nint(CNVRQS).ne.0) FCVY=FCONVY (1.D0,0.D0)
 
C     RESET CONTINUE INDICATOR AND LOAD VALUES
 
      XCNTNU=0.d0
      NWAY=7
      IF (NCL1C.ne.0) then
         DO 5 N=1,NCL1C
    5    V1IC(N)=V1ICT(N)
      end if
      IF (NCL3C.ne.0) then
         DO 15 N=1,NCL3C
   15    I3IC(N)=I3ICT(N)
      end if
      IF (NCL4C.ne.0) then
         DO 25 N=1,NCL4C
   25    V4IC(N)=V4ICT(N)
      end if
      IF (NCL6C.ne.0) then
         DO 35 N=1,NCL6C
   35    I6IC(N)=I6ICT(N)
      end if
      IF (NDP.ne.0) then
         DO 45 N=1,NDP
   45    XPIC(N)=XPICT(N)
      end if
      RETURN
 
C     LOAD USER TRANSIENT INITIAL VALUES INTO SAVE AREA IF ORIGINAL
C     RUN AND I/C SOLUTION NOT REQUESTED.
 
   50 IF (nint(XTRNIC).EQ.0 .OR. nint(XIR).EQ.0) GO TO 53
      IF (nint(XRUNNO).EQ.1 .OR. nint(XSAVIC).EQ.1) RETURN
      GO TO 54
   53 IF (nint(XIC).NE.0 .OR.
     *   (nint(XSAVIC).EQ.4 .AND. nint(XRUNNO).NE.1)) RETURN
      IF (nint(XRUNNO).EQ.1) GO TO 90
      NWAY=7
 
C     LOAD SAVED I/C VALUES INTO TRANSIENT AREA.
 
   54 IF (NCL1C.ne.0) then
         DO 55 N=1,NCL1C
   55    V1(N)=V1IC(N)
      end if
      IF (NCL3C.ne.0) then
         DO 65 N=1,NCL3C
   65    I3(N)=I3IC(N)
      end if
      IF (NCL4C.ne.0) then
         DO 75 N=1,NCL4C
   75    V4(N)=V4IC(N)
      end if
      IF (NCL6C.ne.0) then
         DO 85 N=1,NCL6C
   85    I6(N)=I6IC(N)
      end if
   86 IF (NDP.ne.0) then
         DO 861 N=1,NDP
  861    P(N)=XPIC(N)
      end if
      RETURN

   87 IF (NCTRL.EQ.1) GO TO 88
      ISAVIC = nint(XSAVIC)
      GO TO (89,88,90,88) ,ISAVIC
   88 IF (nint(XRUNNO).EQ.1) GO TO 90
   89 RETURN
 
C     LOAD INITIAL TRANSIENT VALUES INTO SAVE AREA.
 
   90 NWAY=7
      IF (NCL1C.ne.0) then
         DO 91 N=1,NCL1C
   91    V1IC(N)=V1(N)
      end if
      IF (NCL3C.ne.0) then
         DO 93 N=1,NCL3C
   93    I3IC(N)=I3(N)
      end if
      IF (NCL4C.ne.0) then
         DO 95 N=1,NCL4C
   95    V4IC(N)=V4(N)
      end if
      IF (NCL6C.ne.0) then
         DO 97 N=1,NCL6C
   97    I6IC(N)=I6(N)
      end if
      IF (NDP.ne.0) then
         DO 120 N=1,NDP
  120    XPIC(N)=P(N)
      end if
      RETURN
 
      END
