CSECT   XSAVDC                          72.110  00.39.08
C       1 MAY 73   (WNR)
 
      SUBROUTINE XSAVDC(V2IC,V2,NCL2C,V5IC,V5,NCL5C,V8IC,V8,NCL8C,NCTRL)
 
C     THIS SUBROUTINE WILL LOAD THE COMPUTED INITIAL CONDITIONS INTO
C     THE SAVE AREA FOR FUTURE RERUN(S) OR LOAD THE SAVED I/C VALUES
C     INTO THE TRANSIENT AREA TO BE USED AS I/C FOR AN IC RERUN.
C
C     THE SUBROUTINE ARGUMENTS ARE:
C          VNIC-   SAVE AREA FOR R AND J CLASSES
C          VN  -   AREA FOR TRANSIENT VALUES
C          NCLNC-  NUMBER OF ENTRIES IN EACH(TRANSIENT) CLASS.
C          NCTRL-  EQUAL TO TWO IMPLIES THAT I/C VALUES BE LOADED FROM
C                       THE TRANSIENT AREA INTO THE SAVE AREA IF I/C
C                       VALUES REQUESTED AS I/C FOR RERUN(S).
C                  EQUAL TO ONE IMPLIES THAT I/C VALUES BE LOADED FROM
C                       THE SAVE AREA INTO THE TRANSIENT AREA IF THE
C                       I/C VALUES ARE TO BE USED AS I/C FOR RERUNS.
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
 
      COMMON /CNTRLS/ CTRL(142)
         EQUIVALENCE (CTRL(32),XRUNNO),(CTRL(53),XSAVIC)
      DIMENSION V2IC(1),V2(1),V5IC(1),V5(1),V8IC(1),V8(1)
 
C     RETURN IF THIS IS AN ADJOINT CALCULATION
 
      IF (nint(CTRL(142)).NE.0) RETURN
 
C     ARE I/C RESULTS TO BE SAVED?
 
      IF (nint(XSAVIC).EQ.1) RETURN
 
C     HAS I/C SOLUTION FOR THIS RUN BEEN RESOLVED?
 
      IF (NCTRL.EQ.1) GO TO 500
 
C     IS THIS THE MASTER RUN?
 
      IF (nint(XRUNNO).EQ.1) RETURN
 
C     LOAD SAVED I/C VALUES INTO TRANSIENT AREA.
 
      IF (NCL2C.ne.0) then
         DO 100 N=1,NCL2C
  100    V2(N)=V2IC(N)
      end if
      IF (NCL5C.ne.0) then
         DO 200 N=1,NCL5C
  200    V5(N)=V5IC(N)
      end if
      IF (NCL8C.ne.0) then
         DO 300 N=1,NCL8C
  300    V8(N)=V8IC(N)
      end if

      RETURN
 
C     IS THIS THE MASTER RUN?
 
  500 IF (nint(XRUNNO).EQ.1) GO TO 600
 
C     ARE MASTER I/C RESULTS USED AS I/C FOR RERUNS?
 
      IF (nint(XSAVIC).EQ.2) RETURN
 
C     SAVE I/C VALUES FROM THE TRANSIENT AREA.
 
  600 IF (NCL2C.ne.0) then
         DO 650 N=1,NCL2C
  650    V2IC(N)=V2(N)
      end if
      IF (NCL5C.ne.0) then
         DO 750 N=1,NCL5C
  750    V5IC(N)=V5(N)
      end if
      IF (NCL8C.ne.0) then
         DO 850 N=1,NCL8C
  850    V8IC(N)=V8(N)
      end if

      RETURN
 
      END
